// A Bison parser, made by GNU Bison 3.7.5.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

// "%code top" blocks.
#line 30 "DynareBison.yy"

class ParsingDriver;

#line 43 "DynareBison.cc"




#include "DynareBison.hh"


// Unqualified %code blocks.
#line 48 "DynareBison.yy"

/* Little hack: we redefine the macro which computes the locations, because
   we need to access the location from within the parsing driver for error
   and warning messages. */
#define YYLLOC_DEFAULT(Current, Rhs, N)                         \
  do {                                                          \
    if (N)                                                      \
      {                                                         \
        (Current).begin = YYRHSLOC(Rhs, 1).begin;               \
        (Current).end   = YYRHSLOC(Rhs, N).end;                 \
      }                                                         \
    else                                                        \
      {                                                         \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;	\
      }                                                         \
    driver.location = (Current);                                \
  } while(false)

#include "ParsingDriver.hh"

/* this "connects" the bison parser in the driver to the flex scanner class
 * object. it defines the yylex() function call to pull the next token from the
 * current lexer object of the driver context. */
#undef yylex
#define yylex driver.lexer->lex

#line 79 "DynareBison.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 25 "DynareBison.yy"
namespace Dynare {
#line 172 "DynareBison.cc"

  /// Build a parser object.
  parser::parser (ParsingDriver &driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.copy< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.copy< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.copy< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.copy< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.copy< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.copy< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_named_var_elem: // named_var_elem
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.copy< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_list: // vec_value_list
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
      case symbol_kind::S_vec_value_1_w_inf: // vec_value_1_w_inf
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
      case symbol_kind::S_symbol: // symbol
        value.copy< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.copy< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.copy< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.copy< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.copy< vector<pair<int, int>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_named_var_1: // named_var_1
      case symbol_kind::S_named_var: // named_var
        value.copy< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_change_type_var_list: // change_type_var_list
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
        value.copy< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.copy< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_named_var_elem: // named_var_elem
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_list: // vec_value_list
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
      case symbol_kind::S_vec_value_1_w_inf: // vec_value_1_w_inf
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
      case symbol_kind::S_symbol: // symbol
        value.move< string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.move< vector<expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<pair<int, int>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_named_var_1: // named_var_1
      case symbol_kind::S_named_var: // named_var
        value.move< vector<pair<string,string>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_change_type_var_list: // change_type_var_list
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
        value.move< vector<string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  parser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  parser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  parser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.YY_MOVE_OR_COPY< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.YY_MOVE_OR_COPY< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.YY_MOVE_OR_COPY< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.YY_MOVE_OR_COPY< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.YY_MOVE_OR_COPY< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.YY_MOVE_OR_COPY< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_named_var_elem: // named_var_elem
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.YY_MOVE_OR_COPY< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_list: // vec_value_list
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
      case symbol_kind::S_vec_value_1_w_inf: // vec_value_1_w_inf
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
      case symbol_kind::S_symbol: // symbol
        value.YY_MOVE_OR_COPY< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.YY_MOVE_OR_COPY< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.YY_MOVE_OR_COPY< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.YY_MOVE_OR_COPY< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.YY_MOVE_OR_COPY< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.YY_MOVE_OR_COPY< vector<pair<int, int>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_named_var_1: // named_var_1
      case symbol_kind::S_named_var: // named_var
        value.YY_MOVE_OR_COPY< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_change_type_var_list: // change_type_var_list
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
        value.YY_MOVE_OR_COPY< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.YY_MOVE_OR_COPY< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_named_var_elem: // named_var_elem
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_list: // vec_value_list
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
      case symbol_kind::S_vec_value_1_w_inf: // vec_value_1_w_inf
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
      case symbol_kind::S_symbol: // symbol
        value.move< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.move< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<pair<int, int>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_named_var_1: // named_var_1
      case symbol_kind::S_named_var: // named_var
        value.move< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_change_type_var_list: // change_type_var_list
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
        value.move< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.copy< PriorDistributions > (that.value);
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.copy< SymbolType > (that.value);
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.copy< expr_t > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.copy< map<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.copy< pair<expr_t,expr_t> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.copy< pair<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_named_var_elem: // named_var_elem
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.copy< pair<string,string> > (that.value);
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_list: // vec_value_list
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
      case symbol_kind::S_vec_value_1_w_inf: // vec_value_1_w_inf
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
      case symbol_kind::S_symbol: // symbol
        value.copy< string > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.copy< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (that.value);
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (that.value);
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.copy< vector<expr_t> > (that.value);
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.copy< vector<int> > (that.value);
        break;

      case symbol_kind::S_period_list: // period_list
        value.copy< vector<pair<int, int>> > (that.value);
        break;

      case symbol_kind::S_named_var_1: // named_var_1
      case symbol_kind::S_named_var: // named_var
        value.copy< vector<pair<string,string>> > (that.value);
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_change_type_var_list: // change_type_var_list
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
        value.copy< vector<string> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.copy< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (that.value);
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (that.value);
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_named_var_elem: // named_var_elem
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (that.value);
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_list: // vec_value_list
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
      case symbol_kind::S_vec_value_1_w_inf: // vec_value_1_w_inf
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
      case symbol_kind::S_symbol: // symbol
        value.move< string > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > (that.value);
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (that.value);
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        value.move< vector<expr_t> > (that.value);
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (that.value);
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<pair<int, int>> > (that.value);
        break;

      case symbol_kind::S_named_var_1: // named_var_1
      case symbol_kind::S_named_var: // named_var
        value.move< vector<pair<string,string>> > (that.value);
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_change_type_var_list: // change_type_var_list
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
        value.move< vector<string> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 43 "DynareBison.yy"
{
  // Initialize the locations' filenames to the filename maintained by the lexer
  yyla.location.begin.filename = yyla.location.end.filename = &(driver.lexer->filename);
}

#line 1380 "DynareBison.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        yylhs.value.emplace< PriorDistributions > ();
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        yylhs.value.emplace< SymbolType > ();
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        yylhs.value.emplace< expr_t > ();
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        yylhs.value.emplace< map<string, expr_t> > ();
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        yylhs.value.emplace< pair<expr_t,expr_t> > ();
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        yylhs.value.emplace< pair<string, expr_t> > ();
        break;

      case symbol_kind::S_named_var_elem: // named_var_elem
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        yylhs.value.emplace< pair<string,string> > ();
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATES: // DATES
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_str: // date_str
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_list: // vec_value_list
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
      case symbol_kind::S_vec_value_1_w_inf: // vec_value_1_w_inf
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
      case symbol_kind::S_symbol: // symbol
        yylhs.value.emplace< string > ();
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        yylhs.value.emplace< tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > ();
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        yylhs.value.emplace< tuple<string,string,string,string> > ();
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
        yylhs.value.emplace< vector<expr_t> > ();
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        yylhs.value.emplace< vector<int> > ();
        break;

      case symbol_kind::S_period_list: // period_list
        yylhs.value.emplace< vector<pair<int, int>> > ();
        break;

      case symbol_kind::S_named_var_1: // named_var_1
      case symbol_kind::S_named_var: // named_var
        yylhs.value.emplace< vector<pair<string,string>> > ();
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_change_type_var_list: // change_type_var_list
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
        yylhs.value.emplace< vector<string> > ();
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        yylhs.value.emplace< vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 125: // dsample: DSAMPLE INT_NUMBER ';'
#line 348 "DynareBison.yy"
          { driver.dsample(yystack_[1].value.as < string > ()); }
#line 1659 "DynareBison.cc"
    break;

  case 126: // dsample: DSAMPLE INT_NUMBER INT_NUMBER ';'
#line 350 "DynareBison.yy"
          { driver.dsample(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 1665 "DynareBison.cc"
    break;

  case 127: // rplot: RPLOT symbol_list ';'
#line 353 "DynareBison.yy"
                              { driver.rplot(); }
#line 1671 "DynareBison.cc"
    break;

  case 128: // $@1: %empty
#line 355 "DynareBison.yy"
                                              { driver.begin_trend(); }
#line 1677 "DynareBison.cc"
    break;

  case 129: // trend_var: TREND_VAR '(' GROWTH_FACTOR EQUAL $@1 hand_side ')' trend_var_list ';'
#line 356 "DynareBison.yy"
            { driver.end_trend_var(yystack_[3].value.as < expr_t > ()); }
#line 1683 "DynareBison.cc"
    break;

  case 130: // trend_var_list: trend_var_list symbol
#line 360 "DynareBison.yy"
                 { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1689 "DynareBison.cc"
    break;

  case 131: // trend_var_list: trend_var_list COMMA symbol
#line 362 "DynareBison.yy"
                 { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1695 "DynareBison.cc"
    break;

  case 132: // trend_var_list: symbol
#line 364 "DynareBison.yy"
                 { driver.declare_trend_var(false, yystack_[0].value.as < string > ()); }
#line 1701 "DynareBison.cc"
    break;

  case 133: // trend_var_list: trend_var_list symbol TEX_NAME
#line 366 "DynareBison.yy"
                 { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1707 "DynareBison.cc"
    break;

  case 134: // trend_var_list: trend_var_list COMMA symbol TEX_NAME
#line 368 "DynareBison.yy"
                 { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1713 "DynareBison.cc"
    break;

  case 135: // trend_var_list: symbol TEX_NAME
#line 370 "DynareBison.yy"
                 { driver.declare_trend_var(false, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1719 "DynareBison.cc"
    break;

  case 136: // $@2: %empty
#line 373 "DynareBison.yy"
                                                          { driver.begin_trend(); }
#line 1725 "DynareBison.cc"
    break;

  case 137: // log_trend_var: LOG_TREND_VAR '(' LOG_GROWTH_FACTOR EQUAL $@2 hand_side ')' log_trend_var_list ';'
#line 374 "DynareBison.yy"
                { driver.end_trend_var(yystack_[3].value.as < expr_t > ()); }
#line 1731 "DynareBison.cc"
    break;

  case 138: // log_trend_var_list: log_trend_var_list symbol
#line 378 "DynareBison.yy"
                     { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1737 "DynareBison.cc"
    break;

  case 139: // log_trend_var_list: log_trend_var_list COMMA symbol
#line 380 "DynareBison.yy"
                     { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1743 "DynareBison.cc"
    break;

  case 140: // log_trend_var_list: symbol
#line 382 "DynareBison.yy"
                     { driver.declare_trend_var(true, yystack_[0].value.as < string > ()); }
#line 1749 "DynareBison.cc"
    break;

  case 141: // log_trend_var_list: log_trend_var_list symbol TEX_NAME
#line 384 "DynareBison.yy"
                     { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1755 "DynareBison.cc"
    break;

  case 142: // log_trend_var_list: log_trend_var_list COMMA symbol TEX_NAME
#line 386 "DynareBison.yy"
                     { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1761 "DynareBison.cc"
    break;

  case 143: // log_trend_var_list: symbol TEX_NAME
#line 388 "DynareBison.yy"
                     { driver.declare_trend_var(true, yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1767 "DynareBison.cc"
    break;

  case 145: // $@3: %empty
#line 392 "DynareBison.yy"
                             { driver.begin_trend(); }
#line 1773 "DynareBison.cc"
    break;

  case 146: // var: VAR '(' DEFLATOR EQUAL $@3 hand_side ')' nonstationary_var_list ';'
#line 393 "DynareBison.yy"
      { driver.end_nonstationary_var(false, yystack_[3].value.as < expr_t > ()); }
#line 1779 "DynareBison.cc"
    break;

  case 147: // $@4: %empty
#line 394 "DynareBison.yy"
                                 { driver.begin_trend(); }
#line 1785 "DynareBison.cc"
    break;

  case 148: // var: VAR '(' LOG_DEFLATOR EQUAL $@4 hand_side ')' nonstationary_var_list ';'
#line 395 "DynareBison.yy"
      { driver.end_nonstationary_var(true, yystack_[3].value.as < expr_t > ()); }
#line 1791 "DynareBison.cc"
    break;

  case 149: // var_model: VAR_MODEL '(' var_model_options_list ')' ';'
#line 398 "DynareBison.yy"
                                                         { driver.var_model(); }
#line 1797 "DynareBison.cc"
    break;

  case 155: // trend_component_model: TREND_COMPONENT_MODEL '(' trend_component_model_options_list ')' ';'
#line 410 "DynareBison.yy"
                                                                                              { driver.trend_component_model(); }
#line 1803 "DynareBison.cc"
    break;

  case 161: // $@5: %empty
#line 422 "DynareBison.yy"
                          { driver.begin_pac_model(); }
#line 1809 "DynareBison.cc"
    break;

  case 162: // pac_model: PAC_MODEL '(' $@5 pac_model_options_list ')' ';'
#line 422 "DynareBison.yy"
                                                                                       { driver.pac_model(); }
#line 1815 "DynareBison.cc"
    break;

  case 169: // var_expectation_model: VAR_EXPECTATION_MODEL '(' var_expectation_model_options_list ')' ';'
#line 435 "DynareBison.yy"
                        { driver.var_expectation_model(); }
#line 1821 "DynareBison.cc"
    break;

  case 172: // var_expectation_model_option: VARIABLE EQUAL symbol
#line 444 "DynareBison.yy"
                               { driver.option_str("variable", yystack_[0].value.as < string > ()); }
#line 1827 "DynareBison.cc"
    break;

  case 173: // $@6: %empty
#line 445 "DynareBison.yy"
                                                { driver.begin_model(); }
#line 1833 "DynareBison.cc"
    break;

  case 174: // var_expectation_model_option: EXPRESSION EQUAL $@6 hand_side
#line 446 "DynareBison.yy"
                               {
                                 driver.var_expectation_model_expression = yystack_[0].value.as < expr_t > ();
                                 driver.reset_data_tree();
                               }
#line 1842 "DynareBison.cc"
    break;

  case 175: // var_expectation_model_option: AUXILIARY_MODEL_NAME EQUAL symbol
#line 451 "DynareBison.yy"
                               { driver.option_str("auxiliary_model_name", yystack_[0].value.as < string > ()); }
#line 1848 "DynareBison.cc"
    break;

  case 176: // var_expectation_model_option: HORIZON EQUAL INT_NUMBER
#line 453 "DynareBison.yy"
                               { driver.option_num("horizon", yystack_[0].value.as < string > ()); }
#line 1854 "DynareBison.cc"
    break;

  case 177: // var_expectation_model_option: HORIZON EQUAL integer_range_w_inf
#line 455 "DynareBison.yy"
                               { driver.option_num("horizon", "[ " + yystack_[0].value.as < pair<string,string> > ().first + ' ' + yystack_[0].value.as < pair<string,string> > ().second + " ]"); }
#line 1860 "DynareBison.cc"
    break;

  case 178: // var_expectation_model_option: MODEL_NAME EQUAL symbol
#line 457 "DynareBison.yy"
                               { driver.option_str("model_name", yystack_[0].value.as < string > ()); }
#line 1866 "DynareBison.cc"
    break;

  case 179: // var_expectation_model_option: DISCOUNT EQUAL expression
#line 459 "DynareBison.yy"
                               { driver.var_expectation_model_discount = yystack_[0].value.as < expr_t > (); }
#line 1872 "DynareBison.cc"
    break;

  case 180: // var_expectation_model_option: TIME_SHIFT EQUAL signed_integer
#line 461 "DynareBison.yy"
                               { driver.option_num("time_shift", yystack_[0].value.as < string > ()); }
#line 1878 "DynareBison.cc"
    break;

  case 181: // nonstationary_var_list: nonstationary_var_list symbol
#line 465 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1884 "DynareBison.cc"
    break;

  case 182: // nonstationary_var_list: nonstationary_var_list COMMA symbol
#line 467 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1890 "DynareBison.cc"
    break;

  case 183: // nonstationary_var_list: symbol
#line 469 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[0].value.as < string > ()); }
#line 1896 "DynareBison.cc"
    break;

  case 184: // nonstationary_var_list: nonstationary_var_list symbol named_var
#line 471 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1902 "DynareBison.cc"
    break;

  case 185: // nonstationary_var_list: nonstationary_var_list COMMA symbol named_var
#line 473 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1908 "DynareBison.cc"
    break;

  case 186: // nonstationary_var_list: symbol named_var
#line 475 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1914 "DynareBison.cc"
    break;

  case 187: // nonstationary_var_list: nonstationary_var_list symbol TEX_NAME
#line 477 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1920 "DynareBison.cc"
    break;

  case 188: // nonstationary_var_list: nonstationary_var_list COMMA symbol TEX_NAME
#line 479 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1926 "DynareBison.cc"
    break;

  case 189: // nonstationary_var_list: symbol TEX_NAME
#line 481 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 1932 "DynareBison.cc"
    break;

  case 190: // nonstationary_var_list: nonstationary_var_list symbol TEX_NAME named_var
#line 483 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1938 "DynareBison.cc"
    break;

  case 191: // nonstationary_var_list: nonstationary_var_list COMMA symbol TEX_NAME named_var
#line 485 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1944 "DynareBison.cc"
    break;

  case 192: // nonstationary_var_list: symbol TEX_NAME named_var
#line 487 "DynareBison.yy"
                         { driver.declare_nonstationary_var(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 1950 "DynareBison.cc"
    break;

  case 198: // named_var_elem: symbol EQUAL QUOTED_STRING
#line 503 "DynareBison.yy"
                 { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), yystack_[0].value.as < string > () }; }
#line 1956 "DynareBison.cc"
    break;

  case 199: // named_var_1: '(' named_var_elem
#line 506 "DynareBison.yy"
              { yylhs.value.as < vector<pair<string,string>> > () = { yystack_[0].value.as < pair<string,string> > () }; }
#line 1962 "DynareBison.cc"
    break;

  case 200: // named_var_1: '(' COMMA named_var_elem
#line 508 "DynareBison.yy"
              { yylhs.value.as < vector<pair<string,string>> > () = { yystack_[0].value.as < pair<string,string> > () }; }
#line 1968 "DynareBison.cc"
    break;

  case 201: // named_var_1: named_var_1 named_var_elem
#line 510 "DynareBison.yy"
              {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 1977 "DynareBison.cc"
    break;

  case 202: // named_var_1: named_var_1 COMMA named_var_elem
#line 515 "DynareBison.yy"
              {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 1986 "DynareBison.cc"
    break;

  case 203: // named_var: named_var_1 ')'
#line 521 "DynareBison.yy"
            { yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > (); }
#line 1992 "DynareBison.cc"
    break;

  case 204: // named_var: named_var_1 COMMA ')'
#line 522 "DynareBison.yy"
            { yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > (); }
#line 1998 "DynareBison.cc"
    break;

  case 205: // var_list: var_list symbol
#line 526 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 2004 "DynareBison.cc"
    break;

  case 206: // var_list: var_list COMMA symbol
#line 528 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 2010 "DynareBison.cc"
    break;

  case 207: // var_list: symbol
#line 530 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[0].value.as < string > ()); }
#line 2016 "DynareBison.cc"
    break;

  case 208: // var_list: var_list symbol named_var
#line 532 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2022 "DynareBison.cc"
    break;

  case 209: // var_list: var_list COMMA symbol named_var
#line 534 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2028 "DynareBison.cc"
    break;

  case 210: // var_list: symbol named_var
#line 536 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2034 "DynareBison.cc"
    break;

  case 211: // var_list: var_list symbol TEX_NAME
#line 538 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2040 "DynareBison.cc"
    break;

  case 212: // var_list: var_list COMMA symbol TEX_NAME
#line 540 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2046 "DynareBison.cc"
    break;

  case 213: // var_list: symbol TEX_NAME
#line 542 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2052 "DynareBison.cc"
    break;

  case 214: // var_list: var_list symbol TEX_NAME named_var
#line 544 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2058 "DynareBison.cc"
    break;

  case 215: // var_list: var_list COMMA symbol TEX_NAME named_var
#line 546 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2064 "DynareBison.cc"
    break;

  case 216: // var_list: symbol TEX_NAME named_var
#line 548 "DynareBison.yy"
           { driver.declare_endogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2070 "DynareBison.cc"
    break;

  case 217: // varexo_list: varexo_list symbol
#line 552 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2076 "DynareBison.cc"
    break;

  case 218: // varexo_list: varexo_list COMMA symbol
#line 554 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2082 "DynareBison.cc"
    break;

  case 219: // varexo_list: symbol
#line 556 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[0].value.as < string > ()); }
#line 2088 "DynareBison.cc"
    break;

  case 220: // varexo_list: varexo_list symbol named_var
#line 558 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2094 "DynareBison.cc"
    break;

  case 221: // varexo_list: varexo_list COMMA symbol named_var
#line 560 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2100 "DynareBison.cc"
    break;

  case 222: // varexo_list: symbol named_var
#line 562 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2106 "DynareBison.cc"
    break;

  case 223: // varexo_list: varexo_list symbol TEX_NAME
#line 564 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2112 "DynareBison.cc"
    break;

  case 224: // varexo_list: varexo_list COMMA symbol TEX_NAME
#line 566 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2118 "DynareBison.cc"
    break;

  case 225: // varexo_list: symbol TEX_NAME
#line 568 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2124 "DynareBison.cc"
    break;

  case 226: // varexo_list: varexo_list symbol TEX_NAME named_var
#line 570 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2130 "DynareBison.cc"
    break;

  case 227: // varexo_list: varexo_list COMMA symbol TEX_NAME named_var
#line 572 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2136 "DynareBison.cc"
    break;

  case 228: // varexo_list: symbol TEX_NAME named_var
#line 574 "DynareBison.yy"
              { driver.declare_exogenous(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2142 "DynareBison.cc"
    break;

  case 229: // varexo_det_list: varexo_det_list symbol
#line 578 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2148 "DynareBison.cc"
    break;

  case 230: // varexo_det_list: varexo_det_list COMMA symbol
#line 580 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2154 "DynareBison.cc"
    break;

  case 231: // varexo_det_list: symbol
#line 582 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[0].value.as < string > ()); }
#line 2160 "DynareBison.cc"
    break;

  case 232: // varexo_det_list: varexo_det_list symbol named_var
#line 584 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2166 "DynareBison.cc"
    break;

  case 233: // varexo_det_list: varexo_det_list COMMA symbol named_var
#line 586 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2172 "DynareBison.cc"
    break;

  case 234: // varexo_det_list: symbol named_var
#line 588 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2178 "DynareBison.cc"
    break;

  case 235: // varexo_det_list: varexo_det_list symbol TEX_NAME
#line 590 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2184 "DynareBison.cc"
    break;

  case 236: // varexo_det_list: varexo_det_list COMMA symbol TEX_NAME
#line 592 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2190 "DynareBison.cc"
    break;

  case 237: // varexo_det_list: symbol TEX_NAME
#line 594 "DynareBison.yy"
                   { driver.declare_exogenous_det(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2196 "DynareBison.cc"
    break;

  case 238: // varexo_det_list: varexo_det_list symbol TEX_NAME named_var
#line 596 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2202 "DynareBison.cc"
    break;

  case 239: // varexo_det_list: varexo_det_list COMMA symbol TEX_NAME named_var
#line 598 "DynareBison.yy"
                  { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2208 "DynareBison.cc"
    break;

  case 240: // varexo_det_list: symbol TEX_NAME named_var
#line 600 "DynareBison.yy"
                   { driver.declare_exogenous_det(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2214 "DynareBison.cc"
    break;

  case 241: // parameter_list: parameter_list symbol
#line 604 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2220 "DynareBison.cc"
    break;

  case 242: // parameter_list: parameter_list COMMA symbol
#line 606 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2226 "DynareBison.cc"
    break;

  case 243: // parameter_list: symbol
#line 608 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[0].value.as < string > ()); }
#line 2232 "DynareBison.cc"
    break;

  case 244: // parameter_list: parameter_list symbol named_var
#line 610 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2238 "DynareBison.cc"
    break;

  case 245: // parameter_list: parameter_list COMMA symbol named_var
#line 612 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2244 "DynareBison.cc"
    break;

  case 246: // parameter_list: symbol named_var
#line 614 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2250 "DynareBison.cc"
    break;

  case 247: // parameter_list: parameter_list symbol TEX_NAME
#line 616 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2256 "DynareBison.cc"
    break;

  case 248: // parameter_list: parameter_list COMMA symbol TEX_NAME
#line 618 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2262 "DynareBison.cc"
    break;

  case 249: // parameter_list: symbol TEX_NAME
#line 620 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2268 "DynareBison.cc"
    break;

  case 250: // parameter_list: parameter_list symbol TEX_NAME named_var
#line 622 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2274 "DynareBison.cc"
    break;

  case 251: // parameter_list: parameter_list COMMA symbol TEX_NAME named_var
#line 624 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2280 "DynareBison.cc"
    break;

  case 252: // parameter_list: symbol TEX_NAME named_var
#line 626 "DynareBison.yy"
                 { driver.declare_parameter(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()); }
#line 2286 "DynareBison.cc"
    break;

  case 253: // predetermined_variables_list: predetermined_variables_list symbol
#line 630 "DynareBison.yy"
                               { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2292 "DynareBison.cc"
    break;

  case 254: // predetermined_variables_list: predetermined_variables_list COMMA symbol
#line 632 "DynareBison.yy"
                               { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2298 "DynareBison.cc"
    break;

  case 255: // predetermined_variables_list: symbol
#line 634 "DynareBison.yy"
                               { driver.add_predetermined_variable(yystack_[0].value.as < string > ()); }
#line 2304 "DynareBison.cc"
    break;

  case 256: // model_local_variable_list: model_local_variable_list symbol
#line 638 "DynareBison.yy"
                            { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2310 "DynareBison.cc"
    break;

  case 257: // model_local_variable_list: model_local_variable_list COMMA symbol
#line 640 "DynareBison.yy"
                            { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2316 "DynareBison.cc"
    break;

  case 258: // model_local_variable_list: symbol
#line 642 "DynareBison.yy"
                            { driver.declare_model_local_variable(yystack_[0].value.as < string > ()); }
#line 2322 "DynareBison.cc"
    break;

  case 259: // model_local_variable_list: model_local_variable_list symbol TEX_NAME
#line 644 "DynareBison.yy"
                            { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2328 "DynareBison.cc"
    break;

  case 260: // model_local_variable_list: model_local_variable_list COMMA symbol TEX_NAME
#line 646 "DynareBison.yy"
                            { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2334 "DynareBison.cc"
    break;

  case 261: // model_local_variable_list: symbol TEX_NAME
#line 648 "DynareBison.yy"
                            { driver.declare_model_local_variable(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 2340 "DynareBison.cc"
    break;

  case 262: // change_type: CHANGE_TYPE '(' change_type_arg ')' change_type_var_list ';'
#line 652 "DynareBison.yy"
              { driver.change_type(yystack_[3].value.as < SymbolType > (), yystack_[1].value.as < vector<string> > ()); }
#line 2346 "DynareBison.cc"
    break;

  case 263: // change_type_arg: PARAMETERS
#line 656 "DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::parameter; }
#line 2352 "DynareBison.cc"
    break;

  case 264: // change_type_arg: VAR
#line 658 "DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::endogenous; }
#line 2358 "DynareBison.cc"
    break;

  case 265: // change_type_arg: VAREXO
#line 660 "DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::exogenous; }
#line 2364 "DynareBison.cc"
    break;

  case 266: // change_type_arg: VAREXO_DET
#line 662 "DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::exogenousDet; }
#line 2370 "DynareBison.cc"
    break;

  case 267: // change_type_var_list: symbol
#line 666 "DynareBison.yy"
                       { yylhs.value.as < vector<string> > () = { yystack_[0].value.as < string > () }; }
#line 2376 "DynareBison.cc"
    break;

  case 268: // change_type_var_list: change_type_var_list symbol
#line 668 "DynareBison.yy"
                       {
                         yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                         yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                       }
#line 2385 "DynareBison.cc"
    break;

  case 269: // change_type_var_list: change_type_var_list COMMA symbol
#line 673 "DynareBison.yy"
                       {
                         yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                         yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                       }
#line 2394 "DynareBison.cc"
    break;

  case 270: // periods: PERIODS INT_NUMBER ';'
#line 680 "DynareBison.yy"
          { driver.periods(yystack_[1].value.as < string > ()); }
#line 2400 "DynareBison.cc"
    break;

  case 271: // periods: PERIODS EQUAL INT_NUMBER ';'
#line 682 "DynareBison.yy"
          { driver.periods(yystack_[1].value.as < string > ()); }
#line 2406 "DynareBison.cc"
    break;

  case 272: // init_param: symbol EQUAL expression ';'
#line 685 "DynareBison.yy"
                                         { driver.init_param(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2412 "DynareBison.cc"
    break;

  case 273: // expression: '(' expression ')'
#line 688 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > ();}
#line 2418 "DynareBison.cc"
    break;

  case 274: // expression: namespace_qualified_symbol
#line 690 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_expression_variable(yystack_[0].value.as < string > ()); }
#line 2424 "DynareBison.cc"
    break;

  case 275: // expression: non_negative_number
#line 692 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 2430 "DynareBison.cc"
    break;

  case 276: // expression: expression PLUS expression
#line 694 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2436 "DynareBison.cc"
    break;

  case 277: // expression: expression MINUS expression
#line 696 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2442 "DynareBison.cc"
    break;

  case 278: // expression: expression DIVIDE expression
#line 698 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2448 "DynareBison.cc"
    break;

  case 279: // expression: expression TIMES expression
#line 700 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2454 "DynareBison.cc"
    break;

  case 280: // expression: expression POWER expression
#line 702 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2460 "DynareBison.cc"
    break;

  case 281: // expression: expression LESS expression
#line 704 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2466 "DynareBison.cc"
    break;

  case 282: // expression: expression GREATER expression
#line 706 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2472 "DynareBison.cc"
    break;

  case 283: // expression: expression LESS_EQUAL expression
#line 708 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2478 "DynareBison.cc"
    break;

  case 284: // expression: expression GREATER_EQUAL expression
#line 710 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2484 "DynareBison.cc"
    break;

  case 285: // expression: expression EQUAL_EQUAL expression
#line 712 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2490 "DynareBison.cc"
    break;

  case 286: // expression: expression EXCLAMATION_EQUAL expression
#line 714 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2496 "DynareBison.cc"
    break;

  case 287: // expression: MINUS expression
#line 716 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 2502 "DynareBison.cc"
    break;

  case 288: // expression: PLUS expression
#line 718 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2508 "DynareBison.cc"
    break;

  case 289: // expression: EXP '(' expression ')'
#line 720 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 2514 "DynareBison.cc"
    break;

  case 290: // expression: LOG '(' expression ')'
#line 722 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2520 "DynareBison.cc"
    break;

  case 291: // expression: LN '(' expression ')'
#line 724 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2526 "DynareBison.cc"
    break;

  case 292: // expression: LOG10 '(' expression ')'
#line 726 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 2532 "DynareBison.cc"
    break;

  case 293: // expression: SIN '(' expression ')'
#line 728 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 2538 "DynareBison.cc"
    break;

  case 294: // expression: COS '(' expression ')'
#line 730 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 2544 "DynareBison.cc"
    break;

  case 295: // expression: TAN '(' expression ')'
#line 732 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 2550 "DynareBison.cc"
    break;

  case 296: // expression: ASIN '(' expression ')'
#line 734 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 2556 "DynareBison.cc"
    break;

  case 297: // expression: ACOS '(' expression ')'
#line 736 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 2562 "DynareBison.cc"
    break;

  case 298: // expression: ATAN '(' expression ')'
#line 738 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 2568 "DynareBison.cc"
    break;

  case 299: // expression: SQRT '(' expression ')'
#line 740 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 2574 "DynareBison.cc"
    break;

  case 300: // expression: CBRT '(' expression ')'
#line 742 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 2580 "DynareBison.cc"
    break;

  case 301: // expression: ABS '(' expression ')'
#line 744 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 2586 "DynareBison.cc"
    break;

  case 302: // expression: SIGN '(' expression ')'
#line 746 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 2592 "DynareBison.cc"
    break;

  case 303: // expression: MAX '(' expression COMMA expression ')'
#line 748 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2598 "DynareBison.cc"
    break;

  case 304: // expression: MIN '(' expression COMMA expression ')'
#line 750 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2604 "DynareBison.cc"
    break;

  case 305: // $@7: %empty
#line 751 "DynareBison.yy"
                                        { driver.push_external_function_arg_vector_onto_stack(); }
#line 2610 "DynareBison.cc"
    break;

  case 306: // expression: namespace_qualified_symbol $@7 '(' comma_expression ')'
#line 752 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), false); }
#line 2616 "DynareBison.cc"
    break;

  case 307: // expression: NORMCDF '(' expression COMMA expression COMMA expression ')'
#line 754 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2622 "DynareBison.cc"
    break;

  case 308: // expression: NORMCDF '(' expression ')'
#line 756 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 2628 "DynareBison.cc"
    break;

  case 309: // expression: NORMPDF '(' expression COMMA expression COMMA expression ')'
#line 758 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2634 "DynareBison.cc"
    break;

  case 310: // expression: NORMPDF '(' expression ')'
#line 760 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 2640 "DynareBison.cc"
    break;

  case 311: // expression: ERF '(' expression ')'
#line 762 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 2646 "DynareBison.cc"
    break;

  case 312: // expression: NAN_CONSTANT
#line 764 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2652 "DynareBison.cc"
    break;

  case 313: // expression: INF_CONSTANT
#line 766 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_inf_constant(); }
#line 2658 "DynareBison.cc"
    break;

  case 314: // comma_expression: expression
#line 770 "DynareBison.yy"
                   { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2664 "DynareBison.cc"
    break;

  case 315: // comma_expression: comma_expression COMMA expression
#line 772 "DynareBison.yy"
                   { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2670 "DynareBison.cc"
    break;

  case 316: // expression_or_empty: %empty
#line 776 "DynareBison.yy"
                      { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2676 "DynareBison.cc"
    break;

  case 317: // expression_or_empty: expression
#line 777 "DynareBison.yy"
                      { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2682 "DynareBison.cc"
    break;

  case 318: // initval: INITVAL ';' initval_list END ';'
#line 781 "DynareBison.yy"
          { driver.end_initval(false); }
#line 2688 "DynareBison.cc"
    break;

  case 319: // initval: INITVAL '(' ALL_VALUES_REQUIRED ')' ';' initval_list END ';'
#line 783 "DynareBison.yy"
          { driver.end_initval(true); }
#line 2694 "DynareBison.cc"
    break;

  case 320: // histval_file: HISTVAL_FILE '(' h_options_list ')' ';'
#line 787 "DynareBison.yy"
              { driver.histval_file();}
#line 2700 "DynareBison.cc"
    break;

  case 321: // initval_file: INITVAL_FILE '(' h_options_list ')' ';'
#line 790 "DynareBison.yy"
              { driver.initval_file();}
#line 2706 "DynareBison.cc"
    break;

  case 334: // endval: ENDVAL ';' initval_list END ';'
#line 809 "DynareBison.yy"
         { driver.end_endval(false); }
#line 2712 "DynareBison.cc"
    break;

  case 335: // endval: ENDVAL '(' ALL_VALUES_REQUIRED ')' ';' initval_list END ';'
#line 811 "DynareBison.yy"
         { driver.end_endval(true); }
#line 2718 "DynareBison.cc"
    break;

  case 338: // initval_elem: symbol EQUAL expression ';'
#line 818 "DynareBison.yy"
                                           { driver.init_val(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2724 "DynareBison.cc"
    break;

  case 339: // histval: HISTVAL ';' histval_list END ';'
#line 821 "DynareBison.yy"
          { driver.end_histval(false); }
#line 2730 "DynareBison.cc"
    break;

  case 340: // histval: HISTVAL '(' ALL_VALUES_REQUIRED ')' ';' histval_list END ';'
#line 823 "DynareBison.yy"
          { driver.end_histval(true); }
#line 2736 "DynareBison.cc"
    break;

  case 343: // histval_elem: symbol '(' signed_integer ')' EQUAL expression ';'
#line 830 "DynareBison.yy"
                                                                  { driver.hist_val(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2742 "DynareBison.cc"
    break;

  case 344: // $@8: %empty
#line 832 "DynareBison.yy"
                        { driver.begin_epilogue(); }
#line 2748 "DynareBison.cc"
    break;

  case 345: // epilogue: EPILOGUE ';' $@8 epilogue_equation_list END ';'
#line 833 "DynareBison.yy"
                                          { driver.end_epilogue(); }
#line 2754 "DynareBison.cc"
    break;

  case 348: // $@9: %empty
#line 840 "DynareBison.yy"
                         { driver.add_epilogue_variable(yystack_[0].value.as < string > ()); }
#line 2760 "DynareBison.cc"
    break;

  case 349: // epilogue_equation: NAME $@9 EQUAL expression ';'
#line 841 "DynareBison.yy"
                    { driver.add_epilogue_equal(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2766 "DynareBison.cc"
    break;

  case 350: // compilation_setup: COMPILATION_SETUP '(' compilation_setup_options_list ')' ';'
#line 844 "DynareBison.yy"
                                                                                 { }
#line 2772 "DynareBison.cc"
    break;

  case 353: // compilation_setup_option: SUBSTITUTE_FLAGS EQUAL QUOTED_STRING
#line 851 "DynareBison.yy"
                           { driver.compilation_setup_substitute_flags(yystack_[0].value.as < string > ()); }
#line 2778 "DynareBison.cc"
    break;

  case 354: // compilation_setup_option: ADD_FLAGS EQUAL QUOTED_STRING
#line 853 "DynareBison.yy"
                           { driver.compilation_setup_add_flags(yystack_[0].value.as < string > ()); }
#line 2784 "DynareBison.cc"
    break;

  case 355: // compilation_setup_option: SUBSTITUTE_LIBS EQUAL QUOTED_STRING
#line 855 "DynareBison.yy"
                           { driver.compilation_setup_substitute_libs(yystack_[0].value.as < string > ()); }
#line 2790 "DynareBison.cc"
    break;

  case 356: // compilation_setup_option: ADD_LIBS EQUAL QUOTED_STRING
#line 857 "DynareBison.yy"
                           { driver.compilation_setup_add_libs(yystack_[0].value.as < string > ()); }
#line 2796 "DynareBison.cc"
    break;

  case 357: // compilation_setup_option: COMPILER EQUAL QUOTED_STRING
#line 859 "DynareBison.yy"
                           { driver.compilation_setup_compiler(yystack_[0].value.as < string > ()); }
#line 2802 "DynareBison.cc"
    break;

  case 358: // $@10: %empty
#line 862 "DynareBison.yy"
                                      { driver.begin_matched_moments(); }
#line 2808 "DynareBison.cc"
    break;

  case 359: // matched_moments: MATCHED_MOMENTS ';' $@10 matched_moments_list END ';'
#line 863 "DynareBison.yy"
                                               { driver.end_matched_moments(yystack_[2].value.as < vector<expr_t> > ()); }
#line 2814 "DynareBison.cc"
    break;

  case 360: // matched_moments_list: hand_side ';'
#line 867 "DynareBison.yy"
                       { yylhs.value.as < vector<expr_t> > () = { yystack_[1].value.as < expr_t > () }; }
#line 2820 "DynareBison.cc"
    break;

  case 361: // matched_moments_list: matched_moments_list hand_side ';'
#line 869 "DynareBison.yy"
                       {
                         yylhs.value.as < vector<expr_t> > () = yystack_[2].value.as < vector<expr_t> > ();
                         yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
                       }
#line 2829 "DynareBison.cc"
    break;

  case 362: // $@11: %empty
#line 875 "DynareBison.yy"
                                            { driver.begin_occbin_constraints(); }
#line 2835 "DynareBison.cc"
    break;

  case 363: // occbin_constraints: OCCBIN_CONSTRAINTS ';' $@11 occbin_constraints_regimes_list END ';'
#line 876 "DynareBison.yy"
                                                             { driver.end_occbin_constraints(yystack_[2].value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ()); }
#line 2841 "DynareBison.cc"
    break;

  case 364: // occbin_constraints_regimes_list: occbin_constraints_regime
#line 881 "DynareBison.yy"
                                  { yylhs.value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > () = { yystack_[0].value.as < tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > () }; }
#line 2847 "DynareBison.cc"
    break;

  case 365: // occbin_constraints_regimes_list: occbin_constraints_regimes_list occbin_constraints_regime
#line 883 "DynareBison.yy"
                                  {
                                    yylhs.value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > () = yystack_[1].value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ();
                                    yylhs.value.as < vector<tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t>> > ().push_back(yystack_[0].value.as < tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > ());
                                  }
#line 2856 "DynareBison.cc"
    break;

  case 366: // occbin_constraints_regime: NAME QUOTED_STRING ';' occbin_constraints_regime_options_list
#line 890 "DynareBison.yy"
                            {
                              BinaryOpNode *bind = dynamic_cast<BinaryOpNode *>(yystack_[0].value.as < map<string, expr_t> > ()["bind"]);
                              if (bind && !(bind->op_code == BinaryOpcode::less
                                            || bind->op_code == BinaryOpcode::greater
                                            || bind->op_code == BinaryOpcode::lessEqual
                                            || bind->op_code == BinaryOpcode::greaterEqual))
                                driver.error("The 'bind' expression must be an inequality constraint");
                              BinaryOpNode *relax = dynamic_cast<BinaryOpNode *>(yystack_[0].value.as < map<string, expr_t> > ()["relax"]);
                              if (relax && !(relax->op_code == BinaryOpcode::less
                                             || relax->op_code == BinaryOpcode::greater
                                             || relax->op_code == BinaryOpcode::lessEqual
                                             || relax->op_code == BinaryOpcode::greaterEqual))
                                driver.error("The 'relax' expression must be an inequality constraint");
                              yylhs.value.as < tuple<string, BinaryOpNode *, BinaryOpNode *, expr_t, expr_t> > () = { yystack_[2].value.as < string > (), bind, relax, yystack_[0].value.as < map<string, expr_t> > ()["error_bind"], yystack_[0].value.as < map<string, expr_t> > ()["error_relax"] };
                            }
#line 2876 "DynareBison.cc"
    break;

  case 367: // occbin_constraints_regime_options_list: occbin_constraints_regime_option
#line 908 "DynareBison.yy"
                                         { yylhs.value.as < map<string, expr_t> > () = { yystack_[0].value.as < pair<string, expr_t> > () }; }
#line 2882 "DynareBison.cc"
    break;

  case 368: // occbin_constraints_regime_options_list: occbin_constraints_regime_options_list occbin_constraints_regime_option
#line 910 "DynareBison.yy"
                                         {
                                           yylhs.value.as < map<string, expr_t> > () = yystack_[1].value.as < map<string, expr_t> > ();
                                           yylhs.value.as < map<string, expr_t> > ().insert(yystack_[0].value.as < pair<string, expr_t> > ());
                                         }
#line 2891 "DynareBison.cc"
    break;

  case 369: // occbin_constraints_regime_option: BIND hand_side ';'
#line 917 "DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = { "bind", yystack_[1].value.as < expr_t > () }; }
#line 2897 "DynareBison.cc"
    break;

  case 370: // occbin_constraints_regime_option: RELAX hand_side ';'
#line 919 "DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = { "relax", yystack_[1].value.as < expr_t > () }; }
#line 2903 "DynareBison.cc"
    break;

  case 371: // occbin_constraints_regime_option: ERROR_BIND hand_side ';'
#line 921 "DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = { "error_bind", yystack_[1].value.as < expr_t > () }; }
#line 2909 "DynareBison.cc"
    break;

  case 372: // occbin_constraints_regime_option: ERROR_RELAX hand_side ';'
#line 923 "DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = { "error_relax", yystack_[1].value.as < expr_t > () }; }
#line 2915 "DynareBison.cc"
    break;

  case 373: // model_options: BLOCK
#line 926 "DynareBison.yy"
                      { driver.block(); }
#line 2921 "DynareBison.cc"
    break;

  case 376: // model_options: BYTECODE
#line 929 "DynareBison.yy"
                         { driver.bytecode(); }
#line 2927 "DynareBison.cc"
    break;

  case 377: // model_options: USE_DLL
#line 930 "DynareBison.yy"
                        { driver.use_dll(); }
#line 2933 "DynareBison.cc"
    break;

  case 378: // model_options: NO_STATIC
#line 931 "DynareBison.yy"
                          { driver.no_static();}
#line 2939 "DynareBison.cc"
    break;

  case 379: // model_options: DIFFERENTIATE_FORWARD_VARS
#line 932 "DynareBison.yy"
                                           { driver.differentiate_forward_vars_all(); }
#line 2945 "DynareBison.cc"
    break;

  case 380: // model_options: DIFFERENTIATE_FORWARD_VARS EQUAL '(' symbol_list ')'
#line 933 "DynareBison.yy"
                                                                     { driver.differentiate_forward_vars_some(); }
#line 2951 "DynareBison.cc"
    break;

  case 383: // model_options: BALANCED_GROWTH_TEST_TOL EQUAL non_negative_number
#line 936 "DynareBison.yy"
                                                                   { driver.balanced_growth_test_tol(yystack_[0].value.as < string > ()); }
#line 2957 "DynareBison.cc"
    break;

  case 386: // $@12: %empty
#line 943 "DynareBison.yy"
                  { driver.begin_model(); }
#line 2963 "DynareBison.cc"
    break;

  case 387: // model: MODEL ';' $@12 equation_list END ';'
#line 944 "DynareBison.yy"
                              { driver.end_model(); }
#line 2969 "DynareBison.cc"
    break;

  case 388: // $@13: %empty
#line 945 "DynareBison.yy"
                                             { driver.begin_model(); }
#line 2975 "DynareBison.cc"
    break;

  case 389: // model: MODEL '(' model_options_list ')' ';' $@13 equation_list END ';'
#line 946 "DynareBison.yy"
                              { driver.end_model(); }
#line 2981 "DynareBison.cc"
    break;

  case 394: // equation: hand_side EQUAL hand_side ';'
#line 956 "DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2987 "DynareBison.cc"
    break;

  case 395: // equation: hand_side ';'
#line 958 "DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > ()); }
#line 2993 "DynareBison.cc"
    break;

  case 396: // equation: '[' tags_list ']' hand_side EQUAL hand_side ';'
#line 960 "DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2999 "DynareBison.cc"
    break;

  case 397: // equation: '[' tags_list ']' hand_side ';'
#line 962 "DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > ()); }
#line 3005 "DynareBison.cc"
    break;

  case 400: // tag_pair: symbol EQUAL QUOTED_STRING
#line 970 "DynareBison.yy"
           { driver.add_equation_tags(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 3011 "DynareBison.cc"
    break;

  case 401: // tag_pair: symbol
#line 972 "DynareBison.yy"
           { driver.add_equation_tags(yystack_[0].value.as < string > (), ""); }
#line 3017 "DynareBison.cc"
    break;

  case 402: // hand_side: '(' hand_side ')'
#line 976 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > ();}
#line 3023 "DynareBison.cc"
    break;

  case 403: // hand_side: namespace_qualified_symbol
#line 978 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_model_variable(yystack_[0].value.as < string > ()); }
#line 3029 "DynareBison.cc"
    break;

  case 404: // hand_side: symbol PIPE_E
#line 980 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::endogenous, yystack_[1].value.as < string > ()); }
#line 3035 "DynareBison.cc"
    break;

  case 405: // hand_side: symbol PIPE_X
#line 982 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::exogenous, yystack_[1].value.as < string > ()); }
#line 3041 "DynareBison.cc"
    break;

  case 406: // hand_side: symbol PIPE_P
#line 984 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::parameter, yystack_[1].value.as < string > ()); }
#line 3047 "DynareBison.cc"
    break;

  case 407: // hand_side: non_negative_number
#line 986 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 3053 "DynareBison.cc"
    break;

  case 408: // hand_side: hand_side PLUS hand_side
#line 988 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3059 "DynareBison.cc"
    break;

  case 409: // hand_side: hand_side MINUS hand_side
#line 990 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3065 "DynareBison.cc"
    break;

  case 410: // hand_side: hand_side DIVIDE hand_side
#line 992 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3071 "DynareBison.cc"
    break;

  case 411: // hand_side: hand_side TIMES hand_side
#line 994 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3077 "DynareBison.cc"
    break;

  case 412: // hand_side: hand_side LESS hand_side
#line 996 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3083 "DynareBison.cc"
    break;

  case 413: // hand_side: hand_side GREATER hand_side
#line 998 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3089 "DynareBison.cc"
    break;

  case 414: // hand_side: hand_side LESS_EQUAL hand_side
#line 1000 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3095 "DynareBison.cc"
    break;

  case 415: // hand_side: hand_side GREATER_EQUAL hand_side
#line 1002 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3101 "DynareBison.cc"
    break;

  case 416: // hand_side: hand_side EQUAL_EQUAL hand_side
#line 1004 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3107 "DynareBison.cc"
    break;

  case 417: // hand_side: hand_side EXCLAMATION_EQUAL hand_side
#line 1006 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3113 "DynareBison.cc"
    break;

  case 418: // hand_side: hand_side POWER hand_side
#line 1008 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3119 "DynareBison.cc"
    break;

  case 419: // hand_side: EXPECTATION '(' signed_integer ')' '(' hand_side ')'
#line 1010 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_expectation(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3125 "DynareBison.cc"
    break;

  case 420: // hand_side: VAR_EXPECTATION '(' symbol ')'
#line 1012 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_var_expectation(yystack_[1].value.as < string > ()); }
#line 3131 "DynareBison.cc"
    break;

  case 421: // hand_side: PAC_EXPECTATION '(' symbol ')'
#line 1014 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_pac_expectation(yystack_[1].value.as < string > ()); }
#line 3137 "DynareBison.cc"
    break;

  case 422: // hand_side: MINUS hand_side
#line 1016 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 3143 "DynareBison.cc"
    break;

  case 423: // hand_side: PLUS hand_side
#line 1018 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 3149 "DynareBison.cc"
    break;

  case 424: // hand_side: EXP '(' hand_side ')'
#line 1020 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 3155 "DynareBison.cc"
    break;

  case 425: // hand_side: DIFF '(' hand_side ')'
#line 1022 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_diff(yystack_[1].value.as < expr_t > ()); }
#line 3161 "DynareBison.cc"
    break;

  case 426: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING ')'
#line 1024 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < string > (), "1"); }
#line 3167 "DynareBison.cc"
    break;

  case 427: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING COMMA INT_NUMBER ')'
#line 1026 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 3173 "DynareBison.cc"
    break;

  case 428: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING COMMA vec_int ')'
#line 1028 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < vector<int> > ()); }
#line 3179 "DynareBison.cc"
    break;

  case 429: // hand_side: LOG '(' hand_side ')'
#line 1030 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3185 "DynareBison.cc"
    break;

  case 430: // hand_side: LN '(' hand_side ')'
#line 1032 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3191 "DynareBison.cc"
    break;

  case 431: // hand_side: LOG10 '(' hand_side ')'
#line 1034 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 3197 "DynareBison.cc"
    break;

  case 432: // hand_side: SIN '(' hand_side ')'
#line 1036 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 3203 "DynareBison.cc"
    break;

  case 433: // hand_side: COS '(' hand_side ')'
#line 1038 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 3209 "DynareBison.cc"
    break;

  case 434: // hand_side: TAN '(' hand_side ')'
#line 1040 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 3215 "DynareBison.cc"
    break;

  case 435: // hand_side: ASIN '(' hand_side ')'
#line 1042 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 3221 "DynareBison.cc"
    break;

  case 436: // hand_side: ACOS '(' hand_side ')'
#line 1044 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 3227 "DynareBison.cc"
    break;

  case 437: // hand_side: ATAN '(' hand_side ')'
#line 1046 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 3233 "DynareBison.cc"
    break;

  case 438: // hand_side: SQRT '(' hand_side ')'
#line 1048 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 3239 "DynareBison.cc"
    break;

  case 439: // hand_side: CBRT '(' hand_side ')'
#line 1050 "DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 3245 "DynareBison.cc"
    break;

  case 440: // hand_side: ABS '(' hand_side ')'
#line 1052 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 3251 "DynareBison.cc"
    break;

  case 441: // hand_side: SIGN '(' hand_side ')'
#line 1054 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 3257 "DynareBison.cc"
    break;

  case 442: // hand_side: MAX '(' hand_side COMMA hand_side ')'
#line 1056 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3263 "DynareBison.cc"
    break;

  case 443: // hand_side: MIN '(' hand_side COMMA hand_side ')'
#line 1058 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3269 "DynareBison.cc"
    break;

  case 444: // $@14: %empty
#line 1059 "DynareBison.yy"
                                       { driver.push_external_function_arg_vector_onto_stack(); }
#line 3275 "DynareBison.cc"
    break;

  case 445: // hand_side: namespace_qualified_symbol $@14 '(' comma_hand_side ')'
#line 1060 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), true); }
#line 3281 "DynareBison.cc"
    break;

  case 446: // hand_side: NORMCDF '(' hand_side COMMA hand_side COMMA hand_side ')'
#line 1062 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3287 "DynareBison.cc"
    break;

  case 447: // hand_side: NORMCDF '(' hand_side ')'
#line 1064 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 3293 "DynareBison.cc"
    break;

  case 448: // hand_side: NORMPDF '(' hand_side COMMA hand_side COMMA hand_side ')'
#line 1066 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3299 "DynareBison.cc"
    break;

  case 449: // hand_side: NORMPDF '(' hand_side ')'
#line 1068 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 3305 "DynareBison.cc"
    break;

  case 450: // hand_side: ERF '(' hand_side ')'
#line 1070 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 3311 "DynareBison.cc"
    break;

  case 451: // hand_side: STEADY_STATE '(' hand_side ')'
#line 1072 "DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_steady_state(yystack_[1].value.as < expr_t > ()); }
#line 3317 "DynareBison.cc"
    break;

  case 452: // comma_hand_side: hand_side
#line 1076 "DynareBison.yy"
                  { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3323 "DynareBison.cc"
    break;

  case 453: // comma_hand_side: comma_hand_side COMMA hand_side
#line 1078 "DynareBison.yy"
                  { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3329 "DynareBison.cc"
    break;

  case 454: // pound_expression: '#' symbol EQUAL hand_side ';'
#line 1082 "DynareBison.yy"
                  { driver.declare_and_init_model_local_variable(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3335 "DynareBison.cc"
    break;

  case 455: // shocks: SHOCKS ';' shock_list END ';'
#line 1084 "DynareBison.yy"
                                       { driver.end_shocks(false); }
#line 3341 "DynareBison.cc"
    break;

  case 456: // shocks: SHOCKS '(' OVERWRITE ')' ';' shock_list END ';'
#line 1085 "DynareBison.yy"
                                                         { driver.end_shocks(true); }
#line 3347 "DynareBison.cc"
    break;

  case 457: // shocks: SHOCKS '(' OVERWRITE ')' ';' END ';'
#line 1086 "DynareBison.yy"
                                               { driver.end_shocks(true); }
#line 3353 "DynareBison.cc"
    break;

  case 458: // shocks: SHOCKS '(' SURPRISE ')' ';' surprise_shock_list END ';'
#line 1087 "DynareBison.yy"
                                                                 { driver.end_shocks_surprise(false); }
#line 3359 "DynareBison.cc"
    break;

  case 459: // shocks: SHOCKS '(' SURPRISE COMMA OVERWRITE ')' ';' surprise_shock_list END ';'
#line 1088 "DynareBison.yy"
                                                                                 { driver.end_shocks_surprise(true); }
#line 3365 "DynareBison.cc"
    break;

  case 460: // shocks: SHOCKS '(' OVERWRITE COMMA SURPRISE ')' ';' surprise_shock_list END ';'
#line 1089 "DynareBison.yy"
                                                                                 { driver.end_shocks_surprise(true); }
#line 3371 "DynareBison.cc"
    break;

  case 464: // shock_elem: VAR symbol ';' STDERR expression ';'
#line 1098 "DynareBison.yy"
             { driver.add_stderr_shock(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3377 "DynareBison.cc"
    break;

  case 465: // shock_elem: VAR symbol EQUAL expression ';'
#line 1100 "DynareBison.yy"
             { driver.add_var_shock(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3383 "DynareBison.cc"
    break;

  case 466: // shock_elem: VAR symbol COMMA symbol EQUAL expression ';'
#line 1102 "DynareBison.yy"
             { driver.add_covar_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3389 "DynareBison.cc"
    break;

  case 467: // shock_elem: CORR symbol COMMA symbol EQUAL expression ';'
#line 1104 "DynareBison.yy"
             { driver.add_correl_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3395 "DynareBison.cc"
    break;

  case 468: // det_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 1108 "DynareBison.yy"
                 { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), false); }
#line 3401 "DynareBison.cc"
    break;

  case 471: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS ';' heteroskedastic_shock_list END ';'
#line 1116 "DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(false); }
#line 3407 "DynareBison.cc"
    break;

  case 472: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS '(' OVERWRITE ')' ';' heteroskedastic_shock_list END ';'
#line 1118 "DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(true); }
#line 3413 "DynareBison.cc"
    break;

  case 473: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS '(' OVERWRITE ')' ';' END ';'
#line 1120 "DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(true); }
#line 3419 "DynareBison.cc"
    break;

  case 476: // heteroskedastic_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 1128 "DynareBison.yy"
                             { driver.add_heteroskedastic_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), false); }
#line 3425 "DynareBison.cc"
    break;

  case 477: // heteroskedastic_shock_elem: VAR symbol ';' PERIODS period_list ';' SCALES value_list ';'
#line 1130 "DynareBison.yy"
                             { driver.add_heteroskedastic_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), true); }
#line 3431 "DynareBison.cc"
    break;

  case 478: // $@15: %empty
#line 1133 "DynareBison.yy"
                                          {driver.begin_svar_identification();}
#line 3437 "DynareBison.cc"
    break;

  case 479: // svar_identification: SVAR_IDENTIFICATION $@15 ';' svar_identification_list END ';'
#line 1134 "DynareBison.yy"
                      { driver.end_svar_identification(); }
#line 3443 "DynareBison.cc"
    break;

  case 482: // svar_identification_elem: EXCLUSION LAG INT_NUMBER ';' svar_equation_list
#line 1142 "DynareBison.yy"
                           { driver.combine_lag_and_restriction(yystack_[2].value.as < string > ()); }
#line 3449 "DynareBison.cc"
    break;

  case 483: // svar_identification_elem: EXCLUSION CONSTANTS ';'
#line 1144 "DynareBison.yy"
                           { driver.add_constants_exclusion(); }
#line 3455 "DynareBison.cc"
    break;

  case 484: // $@16: %empty
#line 1146 "DynareBison.yy"
                         { driver.add_restriction_equation_nbr(yystack_[1].value.as < string > ());}
#line 3461 "DynareBison.cc"
    break;

  case 485: // $@17: %empty
#line 1148 "DynareBison.yy"
                                {driver.add_restriction_equal();}
#line 3467 "DynareBison.cc"
    break;

  case 487: // svar_identification_elem: UPPER_CHOLESKY ';'
#line 1151 "DynareBison.yy"
                           { driver.add_upper_cholesky(); }
#line 3473 "DynareBison.cc"
    break;

  case 488: // svar_identification_elem: LOWER_CHOLESKY ';'
#line 1153 "DynareBison.yy"
                           { driver.add_lower_cholesky(); }
#line 3479 "DynareBison.cc"
    break;

  case 489: // svar_equation_list: svar_equation_list EQUATION INT_NUMBER COMMA svar_var_list ';'
#line 1157 "DynareBison.yy"
                     { driver.add_restriction_in_equation(yystack_[3].value.as < string > ()); }
#line 3485 "DynareBison.cc"
    break;

  case 490: // svar_equation_list: EQUATION INT_NUMBER COMMA svar_var_list ';'
#line 1159 "DynareBison.yy"
                     { driver.add_restriction_in_equation(yystack_[3].value.as < string > ()); }
#line 3491 "DynareBison.cc"
    break;

  case 491: // svar_var_list: svar_var_list COMMA symbol
#line 1163 "DynareBison.yy"
                { driver.add_in_svar_restriction_symbols(yystack_[0].value.as < string > ()); }
#line 3497 "DynareBison.cc"
    break;

  case 492: // svar_var_list: symbol
#line 1165 "DynareBison.yy"
                { driver.add_in_svar_restriction_symbols(yystack_[0].value.as < string > ()); }
#line 3503 "DynareBison.cc"
    break;

  case 493: // restriction_expression: expression
#line 1168 "DynareBison.yy"
                                    {driver.check_restriction_expression_constant(yystack_[0].value.as < expr_t > ());}
#line 3509 "DynareBison.cc"
    break;

  case 497: // restriction_elem_expression: COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1177 "DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3515 "DynareBison.cc"
    break;

  case 498: // restriction_elem_expression: PLUS COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1179 "DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3521 "DynareBison.cc"
    break;

  case 499: // restriction_elem_expression: MINUS COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1181 "DynareBison.yy"
                                 { driver.add_negative_restriction_element(yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3527 "DynareBison.cc"
    break;

  case 500: // restriction_elem_expression: expression TIMES COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1183 "DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[7].value.as < expr_t > (),yystack_[3].value.as < string > (),yystack_[1].value.as < string > ());}
#line 3533 "DynareBison.cc"
    break;

  case 501: // svar_global_identification_check: SVAR_GLOBAL_IDENTIFICATION_CHECK ';'
#line 1187 "DynareBison.yy"
                                  { driver.add_svar_global_identification_check(); }
#line 3539 "DynareBison.cc"
    break;

  case 502: // markov_switching: MARKOV_SWITCHING '(' ms_options_list ')' ';'
#line 1191 "DynareBison.yy"
                   { driver.markov_switching(); }
#line 3545 "DynareBison.cc"
    break;

  case 511: // svar: SVAR '(' svar_options_list ')' ';'
#line 1207 "DynareBison.yy"
       { driver.svar(); }
#line 3551 "DynareBison.cc"
    break;

  case 518: // mshocks: MSHOCKS ';' mshock_list END ';'
#line 1220 "DynareBison.yy"
                                          { driver.end_mshocks(false); }
#line 3557 "DynareBison.cc"
    break;

  case 519: // mshocks: MSHOCKS '(' OVERWRITE ')' ';' mshock_list END ';'
#line 1221 "DynareBison.yy"
                                                            { driver.end_mshocks(true); }
#line 3563 "DynareBison.cc"
    break;

  case 522: // period_list: period_list COMMA INT_NUMBER
#line 1229 "DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[2].value.as < vector<pair<int, int>> > ();
                int p = stoi(yystack_[0].value.as < string > ());
                yylhs.value.as < vector<pair<int, int>> > ().push_back({ p, p });
              }
#line 3573 "DynareBison.cc"
    break;

  case 523: // period_list: period_list INT_NUMBER
#line 1235 "DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[1].value.as < vector<pair<int, int>> > ();
                int p = stoi(yystack_[0].value.as < string > ());
                yylhs.value.as < vector<pair<int, int>> > ().push_back({ p, p });
              }
#line 3583 "DynareBison.cc"
    break;

  case 524: // period_list: period_list COMMA INT_NUMBER ':' INT_NUMBER
#line 1241 "DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[4].value.as < vector<pair<int, int>> > ();
                int p1 = stoi(yystack_[2].value.as < string > ()), p2 = stoi(yystack_[0].value.as < string > ());
                if (p1 > p2)
                  driver.error("Can't have first period index greater than second index in range specification");
                yylhs.value.as < vector<pair<int, int>> > ().push_back({ p1, p2 });
              }
#line 3595 "DynareBison.cc"
    break;

  case 525: // period_list: period_list INT_NUMBER ':' INT_NUMBER
#line 1249 "DynareBison.yy"
              {
                yylhs.value.as < vector<pair<int, int>> > () = yystack_[3].value.as < vector<pair<int, int>> > ();
                int p1 = stoi(yystack_[2].value.as < string > ()), p2 = stoi(yystack_[0].value.as < string > ());
                if (p1 > p2)
                  driver.error("Can't have first period index greater than second index in range specification");
                yylhs.value.as < vector<pair<int, int>> > ().push_back({ p1, p2 });
              }
#line 3607 "DynareBison.cc"
    break;

  case 526: // period_list: INT_NUMBER ':' INT_NUMBER
#line 1257 "DynareBison.yy"
              {
                int p1 = stoi(yystack_[2].value.as < string > ()), p2 = stoi(yystack_[0].value.as < string > ());
                if (p1 > p2)
                  driver.error("Can't have first period index greater than second index in range specification");
                yylhs.value.as < vector<pair<int, int>> > () = { { p1, p2 } };
              }
#line 3618 "DynareBison.cc"
    break;

  case 527: // period_list: INT_NUMBER
#line 1264 "DynareBison.yy"
              {
                int p = stoi(yystack_[0].value.as < string > ());
                yylhs.value.as < vector<pair<int, int>> > () = { { p, p } };
              }
#line 3627 "DynareBison.cc"
    break;

  case 528: // sigma_e: SIGMA_E EQUAL '[' triangular_matrix ']' ';'
#line 1270 "DynareBison.yy"
                                                      { driver.do_sigma_e(); }
#line 3633 "DynareBison.cc"
    break;

  case 529: // value_list: value_list COMMA '(' expression ')'
#line 1273 "DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[4].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
             }
#line 3642 "DynareBison.cc"
    break;

  case 530: // value_list: value_list '(' expression ')'
#line 1278 "DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[3].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
             }
#line 3651 "DynareBison.cc"
    break;

  case 531: // value_list: '(' expression ')'
#line 1283 "DynareBison.yy"
             { yylhs.value.as < vector<expr_t> > () = { yystack_[1].value.as < expr_t > () }; }
#line 3657 "DynareBison.cc"
    break;

  case 532: // value_list: value_list COMMA signed_number
#line 1285 "DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[2].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[0].value.as < string > ().at(0) == '-' ?
                            driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1))) :
                            driver.add_non_negative_constant(yystack_[0].value.as < string > ()));
             }
#line 3668 "DynareBison.cc"
    break;

  case 533: // value_list: value_list signed_number
#line 1292 "DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[1].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[0].value.as < string > ().at(0) == '-' ?
                            driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1))) :
                            driver.add_non_negative_constant(yystack_[0].value.as < string > ()));
             }
#line 3679 "DynareBison.cc"
    break;

  case 534: // value_list: signed_number
#line 1299 "DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = { yystack_[0].value.as < string > ().at(0) == '-' ?
                      driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1))) :
                      driver.add_non_negative_constant(yystack_[0].value.as < string > ()) };
             }
#line 3689 "DynareBison.cc"
    break;

  case 535: // triangular_matrix: triangular_matrix ';' triangular_row
#line 1307 "DynareBison.yy"
                    { driver.end_of_row(); }
#line 3695 "DynareBison.cc"
    break;

  case 536: // triangular_matrix: triangular_row
#line 1309 "DynareBison.yy"
                    { driver.end_of_row(); }
#line 3701 "DynareBison.cc"
    break;

  case 537: // triangular_row: triangular_row COMMA '(' expression ')'
#line 1313 "DynareBison.yy"
                 { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3707 "DynareBison.cc"
    break;

  case 538: // triangular_row: triangular_row COMMA signed_number
#line 1315 "DynareBison.yy"
                 { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3713 "DynareBison.cc"
    break;

  case 539: // triangular_row: triangular_row '(' expression ')'
#line 1317 "DynareBison.yy"
                 { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3719 "DynareBison.cc"
    break;

  case 540: // triangular_row: triangular_row signed_number
#line 1319 "DynareBison.yy"
                 { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3725 "DynareBison.cc"
    break;

  case 541: // triangular_row: '(' expression ')'
#line 1321 "DynareBison.yy"
                 { driver.add_to_row(yystack_[1].value.as < expr_t > ()); }
#line 3731 "DynareBison.cc"
    break;

  case 542: // triangular_row: signed_number
#line 1323 "DynareBison.yy"
                 { driver.add_to_row_const(yystack_[0].value.as < string > ()); }
#line 3737 "DynareBison.cc"
    break;

  case 543: // steady: STEADY ';'
#line 1327 "DynareBison.yy"
         { driver.steady(); }
#line 3743 "DynareBison.cc"
    break;

  case 544: // steady: STEADY '(' steady_options_list ')' ';'
#line 1329 "DynareBison.yy"
         { driver.steady(); }
#line 3749 "DynareBison.cc"
    break;

  case 555: // check: CHECK ';'
#line 1347 "DynareBison.yy"
        { driver.check(); }
#line 3755 "DynareBison.cc"
    break;

  case 556: // check: CHECK '(' check_options_list ')' ';'
#line 1349 "DynareBison.yy"
        { driver.check(); }
#line 3761 "DynareBison.cc"
    break;

  case 561: // model_info: MODEL_INFO ';'
#line 1361 "DynareBison.yy"
             { driver.model_info(); }
#line 3767 "DynareBison.cc"
    break;

  case 562: // model_info: MODEL_INFO '(' model_info_options_list ')' ';'
#line 1363 "DynareBison.yy"
              { driver.model_info(); }
#line 3773 "DynareBison.cc"
    break;

  case 566: // perfect_foresight_setup: PERFECT_FORESIGHT_SETUP ';'
#line 1372 "DynareBison.yy"
                          { driver.perfect_foresight_setup(); }
#line 3779 "DynareBison.cc"
    break;

  case 567: // perfect_foresight_setup: PERFECT_FORESIGHT_SETUP '(' perfect_foresight_setup_options_list ')' ';'
#line 1374 "DynareBison.yy"
                          { driver.perfect_foresight_setup(); }
#line 3785 "DynareBison.cc"
    break;

  case 572: // perfect_foresight_solver: PERFECT_FORESIGHT_SOLVER ';'
#line 1386 "DynareBison.yy"
                          { driver.perfect_foresight_solver(); }
#line 3791 "DynareBison.cc"
    break;

  case 573: // perfect_foresight_solver: PERFECT_FORESIGHT_SOLVER '(' perfect_foresight_solver_options_list ')' ';'
#line 1388 "DynareBison.yy"
                          { driver.perfect_foresight_solver(); }
#line 3797 "DynareBison.cc"
    break;

  case 590: // perfect_foresight_with_expectation_errors_setup: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP ';'
#line 1412 "DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_setup(); }
#line 3803 "DynareBison.cc"
    break;

  case 591: // perfect_foresight_with_expectation_errors_setup: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP '(' perfect_foresight_with_expectation_errors_setup_options_list ')' ';'
#line 1414 "DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_setup(); }
#line 3809 "DynareBison.cc"
    break;

  case 596: // perfect_foresight_with_expectation_errors_solver: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER ';'
#line 1426 "DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_solver(); }
#line 3815 "DynareBison.cc"
    break;

  case 597: // perfect_foresight_with_expectation_errors_solver: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER '(' perfect_foresight_with_expectation_errors_solver_options_list ')' ';'
#line 1428 "DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_solver(); }
#line 3821 "DynareBison.cc"
    break;

  case 602: // method_of_moments: METHOD_OF_MOMENTS ';'
#line 1440 "DynareBison.yy"
                    { driver.method_of_moments(); }
#line 3827 "DynareBison.cc"
    break;

  case 603: // method_of_moments: METHOD_OF_MOMENTS '(' method_of_moments_options_list ')' ';'
#line 1442 "DynareBison.yy"
                    { driver.method_of_moments(); }
#line 3833 "DynareBison.cc"
    break;

  case 661: // prior_function: PRIOR_FUNCTION '(' prior_posterior_function_options_list ')' ';'
#line 1507 "DynareBison.yy"
                { driver.prior_posterior_function(true); }
#line 3839 "DynareBison.cc"
    break;

  case 662: // posterior_function: POSTERIOR_FUNCTION '(' prior_posterior_function_options_list ')' ';'
#line 1511 "DynareBison.yy"
                    { driver.prior_posterior_function(false); }
#line 3845 "DynareBison.cc"
    break;

  case 667: // simul: SIMUL ';'
#line 1523 "DynareBison.yy"
        { driver.simul(); }
#line 3851 "DynareBison.cc"
    break;

  case 668: // simul: SIMUL '(' simul_options_list ')' ';'
#line 1525 "DynareBison.yy"
        { driver.simul(); }
#line 3857 "DynareBison.cc"
    break;

  case 673: // external_function: EXTERNAL_FUNCTION '(' external_function_options_list ')' ';'
#line 1537 "DynareBison.yy"
                    { driver.external_function(); }
#line 3863 "DynareBison.cc"
    break;

  case 680: // stoch_simul: STOCH_SIMUL ';'
#line 1551 "DynareBison.yy"
              { driver.stoch_simul(); }
#line 3869 "DynareBison.cc"
    break;

  case 681: // stoch_simul: STOCH_SIMUL '(' stoch_simul_options_list ')' ';'
#line 1553 "DynareBison.yy"
              { driver.stoch_simul(); }
#line 3875 "DynareBison.cc"
    break;

  case 682: // stoch_simul: STOCH_SIMUL symbol_list ';'
#line 1555 "DynareBison.yy"
              { driver.stoch_simul(); }
#line 3881 "DynareBison.cc"
    break;

  case 683: // stoch_simul: STOCH_SIMUL '(' stoch_simul_options_list ')' symbol_list ';'
#line 1557 "DynareBison.yy"
              { driver.stoch_simul(); }
#line 3887 "DynareBison.cc"
    break;

  case 742: // symbol_list: symbol_list symbol
#line 1625 "DynareBison.yy"
               { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3893 "DynareBison.cc"
    break;

  case 743: // symbol_list: symbol_list COMMA symbol
#line 1627 "DynareBison.yy"
               { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3899 "DynareBison.cc"
    break;

  case 744: // symbol_list: symbol
#line 1629 "DynareBison.yy"
               { driver.add_in_symbol_list(yystack_[0].value.as < string > ()); }
#line 3905 "DynareBison.cc"
    break;

  case 746: // symbol_list_ext: ':'
#line 1634 "DynareBison.yy"
                  { driver.add_in_symbol_list(":"); }
#line 3911 "DynareBison.cc"
    break;

  case 747: // signed_integer: PLUS INT_NUMBER
#line 1638 "DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3917 "DynareBison.cc"
    break;

  case 748: // signed_integer: MINUS INT_NUMBER
#line 1640 "DynareBison.yy"
                 {
                   yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                   yylhs.value.as < string > ().insert(0, "-");
                 }
#line 3926 "DynareBison.cc"
    break;

  case 749: // signed_integer: INT_NUMBER
#line 1644 "DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3932 "DynareBison.cc"
    break;

  case 750: // non_negative_number: INT_NUMBER
#line 1647 "DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3938 "DynareBison.cc"
    break;

  case 751: // non_negative_number: FLOAT_NUMBER
#line 1648 "DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3944 "DynareBison.cc"
    break;

  case 752: // signed_number: PLUS non_negative_number
#line 1652 "DynareBison.yy"
               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3950 "DynareBison.cc"
    break;

  case 753: // signed_number: MINUS non_negative_number
#line 1654 "DynareBison.yy"
               {
                 yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                 yylhs.value.as < string > ().insert(0, "-");
               }
#line 3959 "DynareBison.cc"
    break;

  case 754: // signed_number: non_negative_number
#line 1658 "DynareBison.yy"
                { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3965 "DynareBison.cc"
    break;

  case 755: // signed_inf: PLUS INF_CONSTANT
#line 1662 "DynareBison.yy"
             { yylhs.value.as < string > () = "Inf"; }
#line 3971 "DynareBison.cc"
    break;

  case 756: // signed_inf: MINUS INF_CONSTANT
#line 1664 "DynareBison.yy"
             { yylhs.value.as < string > () = "-Inf"; }
#line 3977 "DynareBison.cc"
    break;

  case 757: // signed_inf: INF_CONSTANT
#line 1666 "DynareBison.yy"
             { yylhs.value.as < string > () = "Inf"; }
#line 3983 "DynareBison.cc"
    break;

  case 758: // signed_number_w_inf: signed_inf
#line 1669 "DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3989 "DynareBison.cc"
    break;

  case 759: // signed_number_w_inf: signed_number
#line 1670 "DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 3995 "DynareBison.cc"
    break;

  case 760: // boolean: TRUE
#line 1673 "DynareBison.yy"
          { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4001 "DynareBison.cc"
    break;

  case 761: // boolean: FALSE
#line 1674 "DynareBison.yy"
          { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4007 "DynareBison.cc"
    break;

  case 762: // estimated_params: ESTIMATED_PARAMS ';' estimated_list END ';'
#line 1677 "DynareBison.yy"
                                                               { driver.estimated_params(); }
#line 4013 "DynareBison.cc"
    break;

  case 763: // estimated_list: estimated_list estimated_elem
#line 1680 "DynareBison.yy"
                 { driver.add_estimated_params_element(); }
#line 4019 "DynareBison.cc"
    break;

  case 764: // estimated_list: estimated_elem
#line 1682 "DynareBison.yy"
                 { driver.add_estimated_params_element(); }
#line 4025 "DynareBison.cc"
    break;

  case 767: // estimated_elem1: STDERR symbol
#line 1689 "DynareBison.yy"
                  {
                    driver.estim_params.type = 1;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 4034 "DynareBison.cc"
    break;

  case 768: // estimated_elem1: symbol
#line 1694 "DynareBison.yy"
                  {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 4043 "DynareBison.cc"
    break;

  case 769: // estimated_elem1: CORR symbol COMMA symbol
#line 1699 "DynareBison.yy"
                  {
                    driver.estim_params.type = 3;
                    driver.estim_params.name = yystack_[2].value.as < string > ();
                    driver.estim_params.name2 = yystack_[0].value.as < string > ();
                  }
#line 4053 "DynareBison.cc"
    break;

  case 770: // estimated_elem1: DSGE_PRIOR_WEIGHT
#line 1705 "DynareBison.yy"
                  {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = "dsge_prior_weight";
                  }
#line 4062 "DynareBison.cc"
    break;

  case 771: // estimated_elem2: prior_pdf COMMA estimated_elem3
#line 1712 "DynareBison.yy"
                  {
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4070 "DynareBison.cc"
    break;

  case 772: // estimated_elem2: expression_or_empty COMMA prior_pdf COMMA estimated_elem3
#line 1716 "DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4079 "DynareBison.cc"
    break;

  case 773: // estimated_elem2: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA prior_pdf COMMA estimated_elem3
#line 1721 "DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4090 "DynareBison.cc"
    break;

  case 774: // estimated_elem2: expression
#line 1728 "DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[0].value.as < expr_t > ();
                  }
#line 4098 "DynareBison.cc"
    break;

  case 775: // estimated_elem2: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1732 "DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[0].value.as < expr_t > ();
                  }
#line 4108 "DynareBison.cc"
    break;

  case 776: // estimated_elem3: expression_or_empty COMMA expression_or_empty
#line 1740 "DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[0].value.as < expr_t > ();
                  }
#line 4117 "DynareBison.cc"
    break;

  case 777: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1745 "DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[0].value.as < expr_t > ();
                  }
#line 4127 "DynareBison.cc"
    break;

  case 778: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1751 "DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[0].value.as < expr_t > ();
                  }
#line 4138 "DynareBison.cc"
    break;

  case 779: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression
#line 1758 "DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.jscale = yystack_[0].value.as < expr_t > ();
                  }
#line 4150 "DynareBison.cc"
    break;

  case 780: // estimated_params_init: ESTIMATED_PARAMS_INIT ';' estimated_init_list END ';'
#line 1768 "DynareBison.yy"
                        { driver.estimated_params_init(); }
#line 4156 "DynareBison.cc"
    break;

  case 781: // estimated_params_init: ESTIMATED_PARAMS_INIT '(' USE_CALIBRATION ')' ';' END ';'
#line 1770 "DynareBison.yy"
                        { driver.estimated_params_init(true); }
#line 4162 "DynareBison.cc"
    break;

  case 782: // estimated_params_init: ESTIMATED_PARAMS_INIT '(' USE_CALIBRATION ')' ';' estimated_init_list END ';'
#line 1772 "DynareBison.yy"
                        { driver.estimated_params_init(true); }
#line 4168 "DynareBison.cc"
    break;

  case 783: // estimated_init_list: estimated_init_list estimated_init_elem
#line 1776 "DynareBison.yy"
                      { driver.add_estimated_params_element(); }
#line 4174 "DynareBison.cc"
    break;

  case 784: // estimated_init_list: estimated_init_elem
#line 1778 "DynareBison.yy"
                      { driver.add_estimated_params_element(); }
#line 4180 "DynareBison.cc"
    break;

  case 785: // estimated_init_elem: STDERR symbol COMMA expression ';'
#line 1782 "DynareBison.yy"
                      {
                        driver.estim_params.type = 1;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4190 "DynareBison.cc"
    break;

  case 786: // estimated_init_elem: CORR symbol COMMA symbol COMMA expression ';'
#line 1788 "DynareBison.yy"
                      {
                        driver.estim_params.type = 3;
                        driver.estim_params.name = yystack_[5].value.as < string > ();
                        driver.estim_params.name2 = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4201 "DynareBison.cc"
    break;

  case 787: // estimated_init_elem: symbol COMMA expression ';'
#line 1795 "DynareBison.yy"
                      {
                        driver.estim_params.type = 2;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4211 "DynareBison.cc"
    break;

  case 788: // estimated_params_bounds: ESTIMATED_PARAMS_BOUNDS ';' estimated_bounds_list END ';'
#line 1803 "DynareBison.yy"
                          { driver.estimated_params_bounds(); }
#line 4217 "DynareBison.cc"
    break;

  case 789: // estimated_bounds_list: estimated_bounds_list estimated_bounds_elem
#line 1806 "DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4223 "DynareBison.cc"
    break;

  case 790: // estimated_bounds_list: estimated_bounds_elem
#line 1808 "DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4229 "DynareBison.cc"
    break;

  case 791: // estimated_bounds_elem: STDERR symbol COMMA expression COMMA expression ';'
#line 1812 "DynareBison.yy"
                        {
                          driver.estim_params.type = 1;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4240 "DynareBison.cc"
    break;

  case 792: // estimated_bounds_elem: CORR symbol COMMA symbol COMMA expression COMMA expression ';'
#line 1819 "DynareBison.yy"
                        {
                          driver.estim_params.type = 3;
                          driver.estim_params.name = yystack_[7].value.as < string > ();
                          driver.estim_params.name2 = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4252 "DynareBison.cc"
    break;

  case 793: // estimated_bounds_elem: symbol COMMA expression COMMA expression ';'
#line 1827 "DynareBison.yy"
                        {
                          driver.estim_params.type = 2;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4263 "DynareBison.cc"
    break;

  case 794: // osr_params_bounds: OSR_PARAMS_BOUNDS ';' osr_bounds_list END ';'
#line 1836 "DynareBison.yy"
                    { driver.osr_params_bounds(); }
#line 4269 "DynareBison.cc"
    break;

  case 795: // osr_bounds_list: osr_bounds_list osr_bounds_elem
#line 1839 "DynareBison.yy"
                  { driver.add_osr_params_element(); }
#line 4275 "DynareBison.cc"
    break;

  case 796: // osr_bounds_list: osr_bounds_elem
#line 1841 "DynareBison.yy"
                  { driver.add_osr_params_element(); }
#line 4281 "DynareBison.cc"
    break;

  case 797: // osr_bounds_elem: symbol COMMA expression COMMA expression ';'
#line 1845 "DynareBison.yy"
                  {
                    driver.osr_params.name = yystack_[5].value.as < string > ();
                    driver.osr_params.low_bound = yystack_[3].value.as < expr_t > ();
                    driver.osr_params.up_bound = yystack_[1].value.as < expr_t > ();
                  }
#line 4291 "DynareBison.cc"
    break;

  case 798: // prior_distribution: BETA
#line 1853 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4297 "DynareBison.cc"
    break;

  case 799: // prior_distribution: GAMMA
#line 1855 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4303 "DynareBison.cc"
    break;

  case 800: // prior_distribution: NORMAL
#line 1857 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4309 "DynareBison.cc"
    break;

  case 801: // prior_distribution: INV_GAMMA
#line 1859 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4315 "DynareBison.cc"
    break;

  case 802: // prior_distribution: INV_GAMMA1
#line 1861 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4321 "DynareBison.cc"
    break;

  case 803: // prior_distribution: UNIFORM
#line 1863 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4327 "DynareBison.cc"
    break;

  case 804: // prior_distribution: INV_GAMMA2
#line 1865 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4333 "DynareBison.cc"
    break;

  case 805: // prior_distribution: DIRICHLET
#line 1867 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::dirichlet; }
#line 4339 "DynareBison.cc"
    break;

  case 806: // prior_distribution: WEIBULL
#line 1869 "DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4345 "DynareBison.cc"
    break;

  case 807: // prior_pdf: BETA_PDF
#line 1873 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4351 "DynareBison.cc"
    break;

  case 808: // prior_pdf: GAMMA_PDF
#line 1875 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4357 "DynareBison.cc"
    break;

  case 809: // prior_pdf: NORMAL_PDF
#line 1877 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4363 "DynareBison.cc"
    break;

  case 810: // prior_pdf: INV_GAMMA_PDF
#line 1879 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4369 "DynareBison.cc"
    break;

  case 811: // prior_pdf: INV_GAMMA1_PDF
#line 1881 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4375 "DynareBison.cc"
    break;

  case 812: // prior_pdf: UNIFORM_PDF
#line 1883 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4381 "DynareBison.cc"
    break;

  case 813: // prior_pdf: INV_GAMMA2_PDF
#line 1885 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4387 "DynareBison.cc"
    break;

  case 814: // prior_pdf: WEIBULL_PDF
#line 1887 "DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4393 "DynareBison.cc"
    break;

  case 815: // date_str: DATES
#line 1890 "DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4399 "DynareBison.cc"
    break;

  case 816: // date_expr: date_str
#line 1892 "DynareBison.yy"
            { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4405 "DynareBison.cc"
    break;

  case 817: // date_expr: date_expr PLUS INT_NUMBER
#line 1894 "DynareBison.yy"
            { yylhs.value.as < string > () = yystack_[2].value.as < string > () + '+' + yystack_[0].value.as < string > (); }
#line 4411 "DynareBison.cc"
    break;

  case 818: // set_time: SET_TIME '(' date_expr ')' ';'
#line 1898 "DynareBison.yy"
           { driver.set_time(yystack_[2].value.as < string > ()); }
#line 4417 "DynareBison.cc"
    break;

  case 819: // data: DATA '(' data_options_list ')' ';'
#line 1902 "DynareBison.yy"
       { driver.estimation_data(); }
#line 4423 "DynareBison.cc"
    break;

  case 829: // subsamples: subsamples_eq_opt '(' subsamples_name_list ')' ';'
#line 1919 "DynareBison.yy"
             { driver.set_subsamples(yystack_[4].value.as < pair<string,string> > ().first, yystack_[4].value.as < pair<string,string> > ().second); }
#line 4429 "DynareBison.cc"
    break;

  case 830: // subsamples_eq: subsamples_eq_opt EQUAL subsamples_eq_opt ';'
#line 1923 "DynareBison.yy"
                { driver.copy_subsamples(yystack_[3].value.as < pair<string,string> > ().first, yystack_[3].value.as < pair<string,string> > ().second, yystack_[1].value.as < pair<string,string> > ().first, yystack_[1].value.as < pair<string,string> > ().second); }
#line 4435 "DynareBison.cc"
    break;

  case 831: // subsamples_eq_opt: symbol '.' SUBSAMPLES
#line 1927 "DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), "" }; }
#line 4441 "DynareBison.cc"
    break;

  case 832: // subsamples_eq_opt: STD '(' symbol ')' '.' SUBSAMPLES
#line 1929 "DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = { yystack_[3].value.as < string > (), "" }; }
#line 4447 "DynareBison.cc"
    break;

  case 833: // subsamples_eq_opt: CORR '(' symbol COMMA symbol ')' '.' SUBSAMPLES
#line 1931 "DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = { yystack_[5].value.as < string > (), yystack_[3].value.as < string > () }; }
#line 4453 "DynareBison.cc"
    break;

  case 836: // $@18: %empty
#line 1938 "DynareBison.yy"
                         { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4459 "DynareBison.cc"
    break;

  case 837: // prior: symbol '.' PRIOR $@18 '(' prior_options_list ')' ';'
#line 1939 "DynareBison.yy"
        { driver.set_prior(yystack_[7].value.as < string > (), ""); }
#line 4465 "DynareBison.cc"
    break;

  case 838: // $@19: %empty
#line 1940 "DynareBison.yy"
                                    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4471 "DynareBison.cc"
    break;

  case 839: // prior: symbol '.' symbol '.' PRIOR $@19 '(' prior_options_list ')' ';'
#line 1941 "DynareBison.yy"
        { driver.set_prior(yystack_[9].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4477 "DynareBison.cc"
    break;

  case 840: // $@20: %empty
#line 1942 "DynareBison.yy"
                             { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4483 "DynareBison.cc"
    break;

  case 841: // prior: SYMBOL_VEC '.' PRIOR $@20 '(' joint_prior_options_list ')' ';'
#line 1943 "DynareBison.yy"
        { driver.set_joint_prior(yystack_[7].value.as < vector<string> > ()); }
#line 4489 "DynareBison.cc"
    break;

  case 842: // $@21: %empty
#line 1944 "DynareBison.yy"
                                     { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4495 "DynareBison.cc"
    break;

  case 843: // prior: STD '(' symbol ')' '.' PRIOR $@21 '(' prior_options_list ')' ';'
#line 1945 "DynareBison.yy"
        { driver.set_std_prior(yystack_[8].value.as < string > (), ""); }
#line 4501 "DynareBison.cc"
    break;

  case 844: // $@22: %empty
#line 1946 "DynareBison.yy"
                                                { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4507 "DynareBison.cc"
    break;

  case 845: // prior: STD '(' symbol ')' '.' symbol '.' PRIOR $@22 '(' prior_options_list ')' ';'
#line 1947 "DynareBison.yy"
        { driver.set_std_prior(yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4513 "DynareBison.cc"
    break;

  case 846: // $@23: %empty
#line 1948 "DynareBison.yy"
                                                   { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4519 "DynareBison.cc"
    break;

  case 847: // prior: CORR '(' symbol COMMA symbol ')' '.' PRIOR $@23 '(' prior_options_list ')' ';'
#line 1949 "DynareBison.yy"
        { driver.set_corr_prior(yystack_[10].value.as < string > (), yystack_[8].value.as < string > (), ""); }
#line 4525 "DynareBison.cc"
    break;

  case 848: // $@24: %empty
#line 1950 "DynareBison.yy"
                                                              { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 4531 "DynareBison.cc"
    break;

  case 849: // prior: CORR '(' symbol COMMA symbol ')' '.' symbol '.' PRIOR $@24 '(' prior_options_list ')' ';'
#line 1951 "DynareBison.yy"
        { driver.set_corr_prior(yystack_[12].value.as < string > (), yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 4537 "DynareBison.cc"
    break;

  case 874: // prior_eq: prior_eq_opt EQUAL prior_eq_opt ';'
#line 1987 "DynareBison.yy"
           { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                               get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 4544 "DynareBison.cc"
    break;

  case 875: // prior_eq_opt: symbol '.' PRIOR
#line 1992 "DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[2].value.as < string > (), "", "" }; }
#line 4550 "DynareBison.cc"
    break;

  case 876: // prior_eq_opt: symbol '.' symbol '.' PRIOR
#line 1994 "DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4556 "DynareBison.cc"
    break;

  case 877: // prior_eq_opt: STD '(' symbol ')' '.' PRIOR
#line 1996 "DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[3].value.as < string > (), "", "" }; }
#line 4562 "DynareBison.cc"
    break;

  case 878: // prior_eq_opt: STD '(' symbol ')' '.' symbol '.' PRIOR
#line 1998 "DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4568 "DynareBison.cc"
    break;

  case 879: // prior_eq_opt: CORR '(' symbol COMMA symbol ')' '.' PRIOR
#line 2000 "DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "" }; }
#line 4574 "DynareBison.cc"
    break;

  case 880: // prior_eq_opt: CORR '(' symbol COMMA symbol ')' '.' symbol '.' PRIOR
#line 2002 "DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > () }; }
#line 4580 "DynareBison.cc"
    break;

  case 881: // options: symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2006 "DynareBison.yy"
          { driver.set_options(yystack_[6].value.as < string > (), ""); }
#line 4586 "DynareBison.cc"
    break;

  case 882: // options: symbol '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2008 "DynareBison.yy"
          { driver.set_options(yystack_[8].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4592 "DynareBison.cc"
    break;

  case 883: // options: STD '(' symbol ')' '.' OPTIONS '(' options_options_list ')' ';'
#line 2010 "DynareBison.yy"
          { driver.set_std_options(yystack_[7].value.as < string > (), ""); }
#line 4598 "DynareBison.cc"
    break;

  case 884: // options: STD '(' symbol ')' '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2012 "DynareBison.yy"
          { driver.set_std_options(yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4604 "DynareBison.cc"
    break;

  case 885: // options: CORR '(' symbol COMMA symbol ')' '.' OPTIONS '(' options_options_list ')' ';'
#line 2014 "DynareBison.yy"
          { driver.set_corr_options(yystack_[9].value.as < string > (), yystack_[7].value.as < string > (), ""); }
#line 4610 "DynareBison.cc"
    break;

  case 886: // options: CORR '(' symbol COMMA symbol ')' '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2016 "DynareBison.yy"
          { driver.set_corr_options(yystack_[11].value.as < string > (), yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 4616 "DynareBison.cc"
    break;

  case 892: // options_eq: options_eq_opt EQUAL options_eq_opt ';'
#line 2029 "DynareBison.yy"
             { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                                 get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 4623 "DynareBison.cc"
    break;

  case 893: // options_eq_opt: symbol '.' OPTIONS
#line 2034 "DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[2].value.as < string > (), "", "" }; }
#line 4629 "DynareBison.cc"
    break;

  case 894: // options_eq_opt: symbol '.' symbol '.' OPTIONS
#line 2036 "DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = { "par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4635 "DynareBison.cc"
    break;

  case 895: // options_eq_opt: STD '(' symbol ')' '.' OPTIONS
#line 2038 "DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[3].value.as < string > (), "", "" }; }
#line 4641 "DynareBison.cc"
    break;

  case 896: // options_eq_opt: STD '(' symbol ')' '.' symbol '.' OPTIONS
#line 2040 "DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = { "std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > () }; }
#line 4647 "DynareBison.cc"
    break;

  case 897: // options_eq_opt: CORR '(' symbol COMMA symbol ')' '.' OPTIONS
#line 2042 "DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "" }; }
#line 4653 "DynareBison.cc"
    break;

  case 898: // options_eq_opt: CORR '(' symbol COMMA symbol ')' '.' symbol '.' OPTIONS
#line 2044 "DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = { "corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > () }; }
#line 4659 "DynareBison.cc"
    break;

  case 899: // estimation: ESTIMATION ';'
#line 2048 "DynareBison.yy"
             { driver.run_estimation(); }
#line 4665 "DynareBison.cc"
    break;

  case 900: // estimation: ESTIMATION '(' estimation_options_list ')' ';'
#line 2050 "DynareBison.yy"
             { driver.run_estimation(); }
#line 4671 "DynareBison.cc"
    break;

  case 901: // estimation: ESTIMATION symbol_list ';'
#line 2052 "DynareBison.yy"
             { driver.run_estimation(); }
#line 4677 "DynareBison.cc"
    break;

  case 902: // estimation: ESTIMATION '(' estimation_options_list ')' symbol_list ';'
#line 2054 "DynareBison.yy"
             { driver.run_estimation(); }
#line 4683 "DynareBison.cc"
    break;

  case 1034: // name_value_pair: QUOTED_STRING COMMA QUOTED_STRING
#line 2193 "DynareBison.yy"
                  { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'',''" + yystack_[0].value.as < string > () + "''"; }
#line 4689 "DynareBison.cc"
    break;

  case 1035: // name_value_pair: QUOTED_STRING COMMA signed_number
#line 2195 "DynareBison.yy"
                  { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 4695 "DynareBison.cc"
    break;

  case 1036: // name_value_pair_list: name_value_pair
#line 2198 "DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4701 "DynareBison.cc"
    break;

  case 1037: // name_value_pair_list: name_value_pair_list COMMA name_value_pair
#line 2200 "DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 4707 "DynareBison.cc"
    break;

  case 1038: // name_value_pair_with_boolean: name_value_pair
#line 2203 "DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4713 "DynareBison.cc"
    break;

  case 1039: // name_value_pair_with_boolean: QUOTED_STRING COMMA boolean
#line 2205 "DynareBison.yy"
                               { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 4719 "DynareBison.cc"
    break;

  case 1040: // name_value_pair_with_boolean_list: name_value_pair_with_boolean
#line 2208 "DynareBison.yy"
                                    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4725 "DynareBison.cc"
    break;

  case 1041: // name_value_pair_with_boolean_list: name_value_pair_with_boolean_list COMMA name_value_pair_with_boolean
#line 2210 "DynareBison.yy"
                                    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 4731 "DynareBison.cc"
    break;

  case 1042: // name_value_pair_with_suboptions: name_value_pair
#line 2214 "DynareBison.yy"
                                  { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4737 "DynareBison.cc"
    break;

  case 1043: // name_value_pair_with_suboptions: QUOTED_STRING COMMA vec_str
#line 2216 "DynareBison.yy"
                                  {
                                    yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'',{";
                                    for (auto &it : yystack_[0].value.as < vector<string> > ())
                                      {
                                        if (&it != &(yystack_[0].value.as < vector<string> > ()).front())
                                          yylhs.value.as < string > () += ",";
                                        yylhs.value.as < string > () += "''" + it + "''";
                                      }
                                    yylhs.value.as < string > () += '}';
                                  }
#line 4752 "DynareBison.cc"
    break;

  case 1044: // name_value_pair_with_suboptions: QUOTED_STRING COMMA '(' name_value_pair_list ')'
#line 2227 "DynareBison.yy"
                                  { yylhs.value.as < string > () = "''" + yystack_[4].value.as < string > () + "'',''(" + yystack_[1].value.as < string > () + ")''"; }
#line 4758 "DynareBison.cc"
    break;

  case 1045: // name_value_pair_with_suboptions_list: name_value_pair_with_suboptions
#line 2230 "DynareBison.yy"
                                       { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4764 "DynareBison.cc"
    break;

  case 1046: // name_value_pair_with_suboptions_list: name_value_pair_with_suboptions_list COMMA name_value_pair_with_suboptions
#line 2232 "DynareBison.yy"
                                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 4770 "DynareBison.cc"
    break;

  case 1047: // $@25: %empty
#line 2235 "DynareBison.yy"
                { driver.check_varobs(); }
#line 4776 "DynareBison.cc"
    break;

  case 1049: // varobs_list: varobs_list symbol
#line 2238 "DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4782 "DynareBison.cc"
    break;

  case 1050: // varobs_list: varobs_list COMMA symbol
#line 2240 "DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4788 "DynareBison.cc"
    break;

  case 1051: // varobs_list: symbol
#line 2242 "DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 4794 "DynareBison.cc"
    break;

  case 1052: // $@26: %empty
#line 2245 "DynareBison.yy"
                    { driver.check_varexobs(); }
#line 4800 "DynareBison.cc"
    break;

  case 1054: // varexobs_list: varexobs_list symbol
#line 2248 "DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4806 "DynareBison.cc"
    break;

  case 1055: // varexobs_list: varexobs_list COMMA symbol
#line 2250 "DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4812 "DynareBison.cc"
    break;

  case 1056: // varexobs_list: symbol
#line 2252 "DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 4818 "DynareBison.cc"
    break;

  case 1057: // deterministic_trends: DETERMINISTIC_TRENDS ';' trend_list END ';'
#line 2255 "DynareBison.yy"
                                                                   { driver.set_deterministic_trends(); }
#line 4824 "DynareBison.cc"
    break;

  case 1058: // observation_trends: OBSERVATION_TRENDS ';' trend_list END ';'
#line 2256 "DynareBison.yy"
                                                               { driver.set_trends(); }
#line 4830 "DynareBison.cc"
    break;

  case 1061: // trend_element: symbol '(' expression ')' ';'
#line 2262 "DynareBison.yy"
                                               { driver.set_trend_element(yystack_[4].value.as < string > (), yystack_[2].value.as < expr_t > ()); }
#line 4836 "DynareBison.cc"
    break;

  case 1062: // filter_initial_state: FILTER_INITIAL_STATE ';' filter_initial_state_list END ';'
#line 2264 "DynareBison.yy"
                                                                                  { driver.set_filter_initial_state(); }
#line 4842 "DynareBison.cc"
    break;

  case 1065: // filter_initial_state_element: symbol '(' signed_integer ')' EQUAL expression ';'
#line 2270 "DynareBison.yy"
                                                                                  { driver.set_filter_initial_state_element(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4848 "DynareBison.cc"
    break;

  case 1066: // unit_root_vars: UNIT_ROOT_VARS symbol_list ';'
#line 2272 "DynareBison.yy"
                                                { driver.set_unit_root_vars(); }
#line 4854 "DynareBison.cc"
    break;

  case 1067: // optim_weights: OPTIM_WEIGHTS ';' optim_weights_list END ';'
#line 2274 "DynareBison.yy"
                                                             { driver.optim_weights(); }
#line 4860 "DynareBison.cc"
    break;

  case 1068: // optim_weights_list: optim_weights_list symbol expression ';'
#line 2277 "DynareBison.yy"
                     { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4866 "DynareBison.cc"
    break;

  case 1069: // optim_weights_list: optim_weights_list symbol COMMA symbol expression ';'
#line 2279 "DynareBison.yy"
                     { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4872 "DynareBison.cc"
    break;

  case 1070: // optim_weights_list: symbol expression ';'
#line 2281 "DynareBison.yy"
                     { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4878 "DynareBison.cc"
    break;

  case 1071: // optim_weights_list: symbol COMMA symbol expression ';'
#line 2283 "DynareBison.yy"
                     { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4884 "DynareBison.cc"
    break;

  case 1072: // osr_params: OSR_PARAMS symbol_list ';'
#line 2286 "DynareBison.yy"
                                        { driver.set_osr_params(); }
#line 4890 "DynareBison.cc"
    break;

  case 1082: // osr: OSR ';'
#line 2303 "DynareBison.yy"
      { driver.run_osr(); }
#line 4896 "DynareBison.cc"
    break;

  case 1083: // osr: OSR '(' osr_options_list ')' ';'
#line 2305 "DynareBison.yy"
      { driver.run_osr(); }
#line 4902 "DynareBison.cc"
    break;

  case 1084: // osr: OSR symbol_list ';'
#line 2307 "DynareBison.yy"
      { driver.run_osr(); }
#line 4908 "DynareBison.cc"
    break;

  case 1085: // osr: OSR '(' osr_options_list ')' symbol_list ';'
#line 2309 "DynareBison.yy"
      {driver.run_osr(); }
#line 4914 "DynareBison.cc"
    break;

  case 1086: // dynatype: DYNATYPE '(' filename ')' ';'
#line 2313 "DynareBison.yy"
           { driver.run_dynatype(yystack_[2].value.as < string > ()); }
#line 4920 "DynareBison.cc"
    break;

  case 1087: // dynatype: DYNATYPE '(' filename ')' symbol_list ';'
#line 2315 "DynareBison.yy"
           { driver.run_dynatype(yystack_[3].value.as < string > ()); }
#line 4926 "DynareBison.cc"
    break;

  case 1088: // dynasave: DYNASAVE '(' filename ')' ';'
#line 2319 "DynareBison.yy"
           { driver.run_dynasave(yystack_[2].value.as < string > ()); }
#line 4932 "DynareBison.cc"
    break;

  case 1089: // dynasave: DYNASAVE '(' filename ')' symbol_list ';'
#line 2321 "DynareBison.yy"
           { driver.run_dynasave(yystack_[3].value.as < string > ()); }
#line 4938 "DynareBison.cc"
    break;

  case 1090: // load_params_and_steady_state: LOAD_PARAMS_AND_STEADY_STATE '(' filename ')' ';'
#line 2325 "DynareBison.yy"
                               { driver.run_load_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 4944 "DynareBison.cc"
    break;

  case 1091: // save_params_and_steady_state: SAVE_PARAMS_AND_STEADY_STATE '(' filename ')' ';'
#line 2329 "DynareBison.yy"
                               { driver.run_save_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 4950 "DynareBison.cc"
    break;

  case 1092: // identification: IDENTIFICATION ';'
#line 2333 "DynareBison.yy"
                 { driver.run_identification(); }
#line 4956 "DynareBison.cc"
    break;

  case 1093: // identification: IDENTIFICATION '(' identification_options_list ')' ';'
#line 2335 "DynareBison.yy"
                 { driver.run_identification(); }
#line 4962 "DynareBison.cc"
    break;

  case 1132: // model_comparison: MODEL_COMPARISON mc_filename_list ';'
#line 2381 "DynareBison.yy"
                   { driver.run_model_comparison(); }
#line 4968 "DynareBison.cc"
    break;

  case 1133: // model_comparison: MODEL_COMPARISON '(' o_marginal_density ')' mc_filename_list ';'
#line 2383 "DynareBison.yy"
                   { driver.run_model_comparison(); }
#line 4974 "DynareBison.cc"
    break;

  case 1134: // filename: symbol
#line 2386 "DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4980 "DynareBison.cc"
    break;

  case 1135: // filename: QUOTED_STRING
#line 2387 "DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4986 "DynareBison.cc"
    break;

  case 1136: // namespace_qualified_symbol: symbol
#line 2390 "DynareBison.yy"
                             { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4992 "DynareBison.cc"
    break;

  case 1137: // namespace_qualified_symbol: namespace_qualified_symbol '.' symbol
#line 2392 "DynareBison.yy"
                             { yylhs.value.as < string > () = yystack_[2].value.as < string > () + "." + yystack_[0].value.as < string > (); }
#line 4998 "DynareBison.cc"
    break;

  case 1138: // namespace_qualified_filename: namespace_qualified_symbol
#line 2395 "DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5004 "DynareBison.cc"
    break;

  case 1139: // namespace_qualified_filename: QUOTED_STRING
#line 2396 "DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5010 "DynareBison.cc"
    break;

  case 1140: // parallel_local_filename_list: filename
#line 2400 "DynareBison.yy"
                               { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 5016 "DynareBison.cc"
    break;

  case 1141: // parallel_local_filename_list: parallel_local_filename_list COMMA filename
#line 2402 "DynareBison.yy"
                               { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 5022 "DynareBison.cc"
    break;

  case 1142: // mc_filename_list: filename
#line 2406 "DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5028 "DynareBison.cc"
    break;

  case 1143: // mc_filename_list: filename '(' non_negative_number ')'
#line 2408 "DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5034 "DynareBison.cc"
    break;

  case 1144: // mc_filename_list: mc_filename_list filename
#line 2410 "DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5040 "DynareBison.cc"
    break;

  case 1145: // mc_filename_list: mc_filename_list filename '(' non_negative_number ')'
#line 2412 "DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5046 "DynareBison.cc"
    break;

  case 1146: // mc_filename_list: mc_filename_list COMMA filename
#line 2414 "DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5052 "DynareBison.cc"
    break;

  case 1147: // mc_filename_list: mc_filename_list COMMA filename '(' non_negative_number ')'
#line 2416 "DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5058 "DynareBison.cc"
    break;

  case 1148: // $@27: %empty
#line 2419 "DynareBison.yy"
                                      { driver.begin_planner_objective(); }
#line 5064 "DynareBison.cc"
    break;

  case 1149: // $@28: %empty
#line 2420 "DynareBison.yy"
                              { driver.end_planner_objective(yystack_[0].value.as < expr_t > ()); }
#line 5070 "DynareBison.cc"
    break;

  case 1151: // ramsey_model: RAMSEY_MODEL ';'
#line 2423 "DynareBison.yy"
                { driver.ramsey_model(); }
#line 5076 "DynareBison.cc"
    break;

  case 1152: // ramsey_model: RAMSEY_MODEL '(' ramsey_model_options_list ')' ';'
#line 2425 "DynareBison.yy"
                { driver.ramsey_model(); }
#line 5082 "DynareBison.cc"
    break;

  case 1153: // ramsey_policy: RAMSEY_POLICY ';'
#line 2429 "DynareBison.yy"
                { driver.ramsey_policy(); }
#line 5088 "DynareBison.cc"
    break;

  case 1154: // ramsey_policy: RAMSEY_POLICY '(' ramsey_policy_options_list ')' ';'
#line 2431 "DynareBison.yy"
                { driver.ramsey_policy(); }
#line 5094 "DynareBison.cc"
    break;

  case 1155: // ramsey_policy: RAMSEY_POLICY symbol_list ';'
#line 2433 "DynareBison.yy"
                { driver.ramsey_policy(); }
#line 5100 "DynareBison.cc"
    break;

  case 1156: // ramsey_policy: RAMSEY_POLICY '(' ramsey_policy_options_list ')' symbol_list ';'
#line 2435 "DynareBison.yy"
                { driver.ramsey_policy(); }
#line 5106 "DynareBison.cc"
    break;

  case 1157: // ramsey_constraints: RAMSEY_CONSTRAINTS ';' ramsey_constraints_list END ';'
#line 2439 "DynareBison.yy"
                     { driver.add_ramsey_constraints_statement(); }
#line 5112 "DynareBison.cc"
    break;

  case 1160: // ramsey_constraint: NAME LESS expression ';'
#line 2447 "DynareBison.yy"
                    { driver.ramsey_constraint_add_less(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 5118 "DynareBison.cc"
    break;

  case 1161: // ramsey_constraint: NAME GREATER expression ';'
#line 2449 "DynareBison.yy"
                    { driver.ramsey_constraint_add_greater(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 5124 "DynareBison.cc"
    break;

  case 1162: // ramsey_constraint: NAME LESS_EQUAL expression ';'
#line 2451 "DynareBison.yy"
                    { driver.ramsey_constraint_add_less_equal(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 5130 "DynareBison.cc"
    break;

  case 1163: // ramsey_constraint: NAME GREATER_EQUAL expression ';'
#line 2453 "DynareBison.yy"
                    { driver.ramsey_constraint_add_greater_equal(yystack_[3].value.as < string > (),yystack_[1].value.as < expr_t > ()); }
#line 5136 "DynareBison.cc"
    break;

  case 1164: // evaluate_planner_objective: EVALUATE_PLANNER_OBJECTIVE ';'
#line 2457 "DynareBison.yy"
                             { driver.evaluate_planner_objective(); }
#line 5142 "DynareBison.cc"
    break;

  case 1165: // occbin_setup: OCCBIN_SETUP ';'
#line 2461 "DynareBison.yy"
               { driver.occbin_setup(); }
#line 5148 "DynareBison.cc"
    break;

  case 1166: // occbin_setup: OCCBIN_SETUP '(' occbin_setup_options_list ')' ';'
#line 2463 "DynareBison.yy"
               { driver.occbin_setup(); }
#line 5154 "DynareBison.cc"
    break;

  case 1192: // occbin_solver: OCCBIN_SOLVER ';'
#line 2495 "DynareBison.yy"
                { driver.occbin_solver(); }
#line 5160 "DynareBison.cc"
    break;

  case 1193: // occbin_solver: OCCBIN_SOLVER '(' occbin_solver_options_list ')' ';'
#line 2497 "DynareBison.yy"
                { driver.occbin_solver(); }
#line 5166 "DynareBison.cc"
    break;

  case 1194: // occbin_solver: OCCBIN_SOLVER '(' occbin_solver_options_list ')' symbol_list ';'
#line 2499 "DynareBison.yy"
                { driver.occbin_solver(); }
#line 5172 "DynareBison.cc"
    break;

  case 1203: // occbin_write_regimes: OCCBIN_WRITE_REGIMES ';'
#line 2514 "DynareBison.yy"
                       { driver.occbin_write_regimes(); }
#line 5178 "DynareBison.cc"
    break;

  case 1204: // occbin_write_regimes: OCCBIN_WRITE_REGIMES '(' occbin_write_regimes_options_list ')' ';'
#line 2516 "DynareBison.yy"
                       { driver.occbin_write_regimes(); }
#line 5184 "DynareBison.cc"
    break;

  case 1211: // occbin_graph: OCCBIN_GRAPH ';'
#line 2529 "DynareBison.yy"
               { driver.occbin_graph(); }
#line 5190 "DynareBison.cc"
    break;

  case 1212: // occbin_graph: OCCBIN_GRAPH '(' occbin_graph_options_list ')' ';'
#line 2531 "DynareBison.yy"
               { driver.occbin_graph(); }
#line 5196 "DynareBison.cc"
    break;

  case 1213: // occbin_graph: OCCBIN_GRAPH symbol_list ';'
#line 2533 "DynareBison.yy"
               { driver.occbin_graph(); }
#line 5202 "DynareBison.cc"
    break;

  case 1214: // occbin_graph: OCCBIN_GRAPH '(' occbin_graph_options_list ')' symbol_list ';'
#line 2535 "DynareBison.yy"
               { driver.occbin_graph(); }
#line 5208 "DynareBison.cc"
    break;

  case 1218: // discretionary_policy: DISCRETIONARY_POLICY ';'
#line 2545 "DynareBison.yy"
                       { driver.discretionary_policy(); }
#line 5214 "DynareBison.cc"
    break;

  case 1219: // discretionary_policy: DISCRETIONARY_POLICY '(' discretionary_policy_options_list ')' ';'
#line 2547 "DynareBison.yy"
                       { driver.discretionary_policy(); }
#line 5220 "DynareBison.cc"
    break;

  case 1220: // discretionary_policy: DISCRETIONARY_POLICY symbol_list ';'
#line 2549 "DynareBison.yy"
                       { driver.discretionary_policy(); }
#line 5226 "DynareBison.cc"
    break;

  case 1221: // discretionary_policy: DISCRETIONARY_POLICY '(' discretionary_policy_options_list ')' symbol_list ';'
#line 2551 "DynareBison.yy"
                       { driver.discretionary_policy(); }
#line 5232 "DynareBison.cc"
    break;

  case 1237: // write_latex_dynamic_model: WRITE_LATEX_DYNAMIC_MODEL ';'
#line 2582 "DynareBison.yy"
                            { driver.write_latex_dynamic_model(false); }
#line 5238 "DynareBison.cc"
    break;

  case 1238: // write_latex_dynamic_model: WRITE_LATEX_DYNAMIC_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2584 "DynareBison.yy"
                            { driver.write_latex_dynamic_model(true); }
#line 5244 "DynareBison.cc"
    break;

  case 1239: // write_latex_static_model: WRITE_LATEX_STATIC_MODEL ';'
#line 2588 "DynareBison.yy"
                           { driver.write_latex_static_model(false); }
#line 5250 "DynareBison.cc"
    break;

  case 1240: // write_latex_static_model: WRITE_LATEX_STATIC_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2590 "DynareBison.yy"
                            { driver.write_latex_static_model(true); }
#line 5256 "DynareBison.cc"
    break;

  case 1241: // write_latex_original_model: WRITE_LATEX_ORIGINAL_MODEL ';'
#line 2594 "DynareBison.yy"
                           { driver.write_latex_original_model(false); }
#line 5262 "DynareBison.cc"
    break;

  case 1242: // write_latex_original_model: WRITE_LATEX_ORIGINAL_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2596 "DynareBison.yy"
                            { driver.write_latex_original_model(true); }
#line 5268 "DynareBison.cc"
    break;

  case 1243: // write_latex_steady_state_model: WRITE_LATEX_STEADY_STATE_MODEL ';'
#line 2600 "DynareBison.yy"
                                 { driver.write_latex_steady_state_model(); }
#line 5274 "DynareBison.cc"
    break;

  case 1244: // shock_decomposition: SHOCK_DECOMPOSITION ';'
#line 2604 "DynareBison.yy"
                      {driver.shock_decomposition(); }
#line 5280 "DynareBison.cc"
    break;

  case 1245: // shock_decomposition: SHOCK_DECOMPOSITION '(' shock_decomposition_options_list ')' ';'
#line 2606 "DynareBison.yy"
                      { driver.shock_decomposition(); }
#line 5286 "DynareBison.cc"
    break;

  case 1246: // shock_decomposition: SHOCK_DECOMPOSITION symbol_list ';'
#line 2608 "DynareBison.yy"
                      { driver.shock_decomposition(); }
#line 5292 "DynareBison.cc"
    break;

  case 1247: // shock_decomposition: SHOCK_DECOMPOSITION '(' shock_decomposition_options_list ')' symbol_list ';'
#line 2610 "DynareBison.yy"
                      { driver.shock_decomposition(); }
#line 5298 "DynareBison.cc"
    break;

  case 1248: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION ';'
#line 2614 "DynareBison.yy"
                               {driver.realtime_shock_decomposition(); }
#line 5304 "DynareBison.cc"
    break;

  case 1249: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION '(' realtime_shock_decomposition_options_list ')' ';'
#line 2616 "DynareBison.yy"
                               { driver.realtime_shock_decomposition(); }
#line 5310 "DynareBison.cc"
    break;

  case 1250: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION symbol_list ';'
#line 2618 "DynareBison.yy"
                               { driver.realtime_shock_decomposition(); }
#line 5316 "DynareBison.cc"
    break;

  case 1251: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION '(' realtime_shock_decomposition_options_list ')' symbol_list ';'
#line 2620 "DynareBison.yy"
                               { driver.realtime_shock_decomposition(); }
#line 5322 "DynareBison.cc"
    break;

  case 1252: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION ';'
#line 2624 "DynareBison.yy"
                           {driver.plot_shock_decomposition(); }
#line 5328 "DynareBison.cc"
    break;

  case 1253: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION '(' plot_shock_decomposition_options_list ')' ';'
#line 2626 "DynareBison.yy"
                           { driver.plot_shock_decomposition(); }
#line 5334 "DynareBison.cc"
    break;

  case 1254: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION symbol_list ';'
#line 2628 "DynareBison.yy"
                           { driver.plot_shock_decomposition(); }
#line 5340 "DynareBison.cc"
    break;

  case 1255: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION '(' plot_shock_decomposition_options_list ')' symbol_list ';'
#line 2630 "DynareBison.yy"
                           { driver.plot_shock_decomposition(); }
#line 5346 "DynareBison.cc"
    break;

  case 1256: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION ';'
#line 2634 "DynareBison.yy"
                                  {driver.initial_condition_decomposition(); }
#line 5352 "DynareBison.cc"
    break;

  case 1257: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION '(' initial_condition_decomposition_options_list ')' ';'
#line 2636 "DynareBison.yy"
                                  { driver.initial_condition_decomposition(); }
#line 5358 "DynareBison.cc"
    break;

  case 1258: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION symbol_list ';'
#line 2638 "DynareBison.yy"
                                  { driver.initial_condition_decomposition(); }
#line 5364 "DynareBison.cc"
    break;

  case 1259: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION '(' initial_condition_decomposition_options_list ')' symbol_list ';'
#line 2640 "DynareBison.yy"
                                  { driver.initial_condition_decomposition(); }
#line 5370 "DynareBison.cc"
    break;

  case 1260: // squeeze_shock_decomposition: SQUEEZE_SHOCK_DECOMPOSITION ';'
#line 2644 "DynareBison.yy"
                              { driver.squeeze_shock_decomposition(); }
#line 5376 "DynareBison.cc"
    break;

  case 1261: // squeeze_shock_decomposition: SQUEEZE_SHOCK_DECOMPOSITION symbol_list ';'
#line 2646 "DynareBison.yy"
                              { driver.squeeze_shock_decomposition(); }
#line 5382 "DynareBison.cc"
    break;

  case 1281: // bvar_density: BVAR_DENSITY INT_NUMBER ';'
#line 2675 "DynareBison.yy"
               { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5388 "DynareBison.cc"
    break;

  case 1282: // bvar_density: BVAR_DENSITY '(' bvar_density_options_list ')' INT_NUMBER ';'
#line 2677 "DynareBison.yy"
               { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5394 "DynareBison.cc"
    break;

  case 1289: // bvar_forecast: BVAR_FORECAST INT_NUMBER ';'
#line 2691 "DynareBison.yy"
                { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 5400 "DynareBison.cc"
    break;

  case 1290: // bvar_forecast: BVAR_FORECAST '(' bvar_forecast_options_list ')' INT_NUMBER ';'
#line 2693 "DynareBison.yy"
                { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 5406 "DynareBison.cc"
    break;

  case 1341: // sbvar: SBVAR ';'
#line 2751 "DynareBison.yy"
        { driver.sbvar(); }
#line 5412 "DynareBison.cc"
    break;

  case 1342: // sbvar: SBVAR '(' sbvar_options_list ')' ';'
#line 2753 "DynareBison.yy"
        { driver.sbvar(); }
#line 5418 "DynareBison.cc"
    break;

  case 1359: // ms_variance_decomposition: MS_VARIANCE_DECOMPOSITION ';'
#line 2777 "DynareBison.yy"
                            { driver.ms_variance_decomposition(); }
#line 5424 "DynareBison.cc"
    break;

  case 1360: // ms_variance_decomposition: MS_VARIANCE_DECOMPOSITION '(' ms_variance_decomposition_options_list ')' ';'
#line 2779 "DynareBison.yy"
                            { driver.ms_variance_decomposition(); }
#line 5430 "DynareBison.cc"
    break;

  case 1377: // ms_forecast: MS_FORECAST ';'
#line 2803 "DynareBison.yy"
              { driver.ms_forecast(); }
#line 5436 "DynareBison.cc"
    break;

  case 1378: // ms_forecast: MS_FORECAST '(' ms_forecast_options_list ')' ';'
#line 2805 "DynareBison.yy"
              { driver.ms_forecast(); }
#line 5442 "DynareBison.cc"
    break;

  case 1395: // ms_irf: MS_IRF ';'
#line 2829 "DynareBison.yy"
         { driver.ms_irf(); }
#line 5448 "DynareBison.cc"
    break;

  case 1396: // ms_irf: MS_IRF '(' ms_irf_options_list ')' ';'
#line 2831 "DynareBison.yy"
         { driver.ms_irf(); }
#line 5454 "DynareBison.cc"
    break;

  case 1397: // ms_irf: MS_IRF symbol_list ';'
#line 2833 "DynareBison.yy"
         { driver.ms_irf(); }
#line 5460 "DynareBison.cc"
    break;

  case 1398: // ms_irf: MS_IRF '(' ms_irf_options_list ')' symbol_list ';'
#line 2835 "DynareBison.yy"
         { driver.ms_irf(); }
#line 5466 "DynareBison.cc"
    break;

  case 1405: // ms_compute_probabilities: MS_COMPUTE_PROBABILITIES ';'
#line 2849 "DynareBison.yy"
                           { driver.ms_compute_probabilities(); }
#line 5472 "DynareBison.cc"
    break;

  case 1406: // ms_compute_probabilities: MS_COMPUTE_PROBABILITIES '(' ms_compute_probabilities_options_list ')' ';'
#line 2851 "DynareBison.yy"
                           { driver.ms_compute_probabilities(); }
#line 5478 "DynareBison.cc"
    break;

  case 1417: // ms_compute_mdd: MS_COMPUTE_MDD ';'
#line 2869 "DynareBison.yy"
                 { driver.ms_compute_mdd(); }
#line 5484 "DynareBison.cc"
    break;

  case 1418: // ms_compute_mdd: MS_COMPUTE_MDD '(' ms_compute_mdd_options_list ')' ';'
#line 2871 "DynareBison.yy"
                 { driver.ms_compute_mdd(); }
#line 5490 "DynareBison.cc"
    break;

  case 1428: // ms_simulation: MS_SIMULATION ';'
#line 2888 "DynareBison.yy"
                { driver.ms_simulation(); }
#line 5496 "DynareBison.cc"
    break;

  case 1429: // ms_simulation: MS_SIMULATION '(' ms_simulation_options_list ')' ';'
#line 2890 "DynareBison.yy"
                { driver.ms_simulation(); }
#line 5502 "DynareBison.cc"
    break;

  case 1467: // ms_estimation: MS_ESTIMATION ';'
#line 2935 "DynareBison.yy"
                { driver.ms_estimation(); }
#line 5508 "DynareBison.cc"
    break;

  case 1468: // ms_estimation: MS_ESTIMATION '(' ms_estimation_options_list ')' ';'
#line 2937 "DynareBison.yy"
                { driver.ms_estimation(); }
#line 5514 "DynareBison.cc"
    break;

  case 1469: // dynare_sensitivity: DYNARE_SENSITIVITY ';'
#line 2941 "DynareBison.yy"
                     { driver.dynare_sensitivity(); }
#line 5520 "DynareBison.cc"
    break;

  case 1470: // dynare_sensitivity: DYNARE_SENSITIVITY '(' dynare_sensitivity_options_list ')' ';'
#line 2943 "DynareBison.yy"
                     { driver.dynare_sensitivity(); }
#line 5526 "DynareBison.cc"
    break;

  case 1595: // homotopy_setup: HOMOTOPY_SETUP ';' homotopy_list END ';'
#line 3091 "DynareBison.yy"
               { driver.end_homotopy();}
#line 5532 "DynareBison.cc"
    break;

  case 1598: // homotopy_item: symbol COMMA expression COMMA expression ';'
#line 3098 "DynareBison.yy"
                { driver.homotopy_val(yystack_[5].value.as < string > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ());}
#line 5538 "DynareBison.cc"
    break;

  case 1599: // homotopy_item: symbol COMMA expression ';'
#line 3100 "DynareBison.yy"
                { driver.homotopy_val(yystack_[3].value.as < string > (), nullptr, yystack_[1].value.as < expr_t > ());}
#line 5544 "DynareBison.cc"
    break;

  case 1600: // forecast: FORECAST ';'
#line 3103 "DynareBison.yy"
                       {driver.forecast();}
#line 5550 "DynareBison.cc"
    break;

  case 1601: // forecast: FORECAST '(' forecast_options ')' ';'
#line 3104 "DynareBison.yy"
                                                  {driver.forecast();}
#line 5556 "DynareBison.cc"
    break;

  case 1602: // forecast: FORECAST symbol_list ';'
#line 3105 "DynareBison.yy"
                                     {driver.forecast();}
#line 5562 "DynareBison.cc"
    break;

  case 1603: // forecast: FORECAST '(' forecast_options ')' symbol_list ';'
#line 3106 "DynareBison.yy"
                                                              {driver.forecast();}
#line 5568 "DynareBison.cc"
    break;

  case 1611: // conditional_forecast: CONDITIONAL_FORECAST '(' conditional_forecast_options ')' ';'
#line 3121 "DynareBison.yy"
                       { driver.conditional_forecast(); }
#line 5574 "DynareBison.cc"
    break;

  case 1619: // plot_conditional_forecast: PLOT_CONDITIONAL_FORECAST symbol_list ';'
#line 3136 "DynareBison.yy"
                            { driver.plot_conditional_forecast(); }
#line 5580 "DynareBison.cc"
    break;

  case 1620: // plot_conditional_forecast: PLOT_CONDITIONAL_FORECAST '(' PERIODS EQUAL INT_NUMBER ')' symbol_list ';'
#line 3138 "DynareBison.yy"
                            { driver.plot_conditional_forecast(yystack_[3].value.as < string > ()); }
#line 5586 "DynareBison.cc"
    break;

  case 1621: // conditional_forecast_paths: CONDITIONAL_FORECAST_PATHS ';' conditional_forecast_paths_shock_list END ';'
#line 3142 "DynareBison.yy"
                             { driver.conditional_forecast_paths(); }
#line 5592 "DynareBison.cc"
    break;

  case 1624: // conditional_forecast_paths_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 3150 "DynareBison.yy"
                                        { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<pair<int, int>> > (), yystack_[1].value.as < vector<expr_t> > (), true); }
#line 5598 "DynareBison.cc"
    break;

  case 1625: // $@29: %empty
#line 3153 "DynareBison.yy"
                                            { driver.begin_steady_state_model(); }
#line 5604 "DynareBison.cc"
    break;

  case 1626: // steady_state_model: STEADY_STATE_MODEL ';' $@29 steady_state_equation_list END ';'
#line 3154 "DynareBison.yy"
                                                        { driver.reset_data_tree(); }
#line 5610 "DynareBison.cc"
    break;

  case 1629: // steady_state_equation: symbol EQUAL expression ';'
#line 3162 "DynareBison.yy"
                        { driver.add_steady_state_model_equal(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5616 "DynareBison.cc"
    break;

  case 1630: // steady_state_equation: '[' symbol_list ']' EQUAL expression ';'
#line 3164 "DynareBison.yy"
                        { driver.add_steady_state_model_equal_multiple(yystack_[1].value.as < expr_t > ()); }
#line 5622 "DynareBison.cc"
    break;

  case 1631: // calib_smoother: CALIB_SMOOTHER ';'
#line 3168 "DynareBison.yy"
                 { driver.calib_smoother(); }
#line 5628 "DynareBison.cc"
    break;

  case 1632: // calib_smoother: CALIB_SMOOTHER '(' calib_smoother_options_list ')' ';'
#line 3170 "DynareBison.yy"
                 { driver.calib_smoother(); }
#line 5634 "DynareBison.cc"
    break;

  case 1633: // calib_smoother: CALIB_SMOOTHER symbol_list ';'
#line 3172 "DynareBison.yy"
                 { driver.calib_smoother(); }
#line 5640 "DynareBison.cc"
    break;

  case 1634: // calib_smoother: CALIB_SMOOTHER '(' calib_smoother_options_list ')' symbol_list ';'
#line 3174 "DynareBison.yy"
                 { driver.calib_smoother(); }
#line 5646 "DynareBison.cc"
    break;

  case 1653: // generate_irfs: GENERATE_IRFS ';' END ';'
#line 3200 "DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 5652 "DynareBison.cc"
    break;

  case 1654: // generate_irfs: GENERATE_IRFS ';' generate_irfs_element_list END ';'
#line 3202 "DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 5658 "DynareBison.cc"
    break;

  case 1655: // generate_irfs: GENERATE_IRFS '(' generate_irfs_options_list ')' ';' END ';'
#line 3204 "DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 5664 "DynareBison.cc"
    break;

  case 1656: // generate_irfs: GENERATE_IRFS '(' generate_irfs_options_list ')' ';' generate_irfs_element_list END ';'
#line 3206 "DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 5670 "DynareBison.cc"
    break;

  case 1663: // generate_irfs_element: NAME COMMA generate_irfs_exog_element_list ';'
#line 3222 "DynareBison.yy"
                        { driver.add_generate_irfs_element(yystack_[3].value.as < string > ()); }
#line 5676 "DynareBison.cc"
    break;

  case 1664: // generate_irfs_exog_element_list: generate_irfs_exog_element_list COMMA symbol EQUAL signed_number
#line 3226 "DynareBison.yy"
                                  { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 5682 "DynareBison.cc"
    break;

  case 1665: // generate_irfs_exog_element_list: symbol EQUAL signed_number
#line 3228 "DynareBison.yy"
                                  { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 5688 "DynareBison.cc"
    break;

  case 1666: // extended_path: EXTENDED_PATH ';'
#line 3232 "DynareBison.yy"
                { driver.extended_path(); }
#line 5694 "DynareBison.cc"
    break;

  case 1667: // extended_path: EXTENDED_PATH '(' extended_path_options_list ')' ';'
#line 3234 "DynareBison.yy"
                { driver.extended_path(); }
#line 5700 "DynareBison.cc"
    break;

  case 1675: // model_diagnostics: MODEL_DIAGNOSTICS ';'
#line 3249 "DynareBison.yy"
                    { driver.model_diagnostics(); }
#line 5706 "DynareBison.cc"
    break;

  case 1676: // calibration_range: '[' expression COMMA expression ']'
#line 3253 "DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = { yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > () }; }
#line 5712 "DynareBison.cc"
    break;

  case 1677: // calibration_range: PLUS
#line 3255 "DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = { driver.add_non_negative_constant("0"), driver.add_inf_constant() }; }
#line 5718 "DynareBison.cc"
    break;

  case 1678: // calibration_range: MINUS
#line 3257 "DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = { driver.add_uminus(driver.add_inf_constant()), driver.add_non_negative_constant("0") }; }
#line 5724 "DynareBison.cc"
    break;

  case 1679: // moment_calibration: MOMENT_CALIBRATION ';' moment_calibration_list END ';'
#line 3261 "DynareBison.yy"
                     { driver.end_moment_calibration(); }
#line 5730 "DynareBison.cc"
    break;

  case 1682: // moment_calibration_item: symbol COMMA symbol COMMA calibration_range ';'
#line 3269 "DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "0", yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5736 "DynareBison.cc"
    break;

  case 1683: // moment_calibration_item: symbol COMMA symbol '(' signed_integer ')' COMMA calibration_range ';'
#line 3271 "DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5742 "DynareBison.cc"
    break;

  case 1684: // moment_calibration_item: symbol COMMA symbol '(' signed_integer_range ')' COMMA calibration_range ';'
#line 3273 "DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5748 "DynareBison.cc"
    break;

  case 1685: // irf_calibration: IRF_CALIBRATION ';' irf_calibration_list END ';'
#line 3277 "DynareBison.yy"
                  { driver.end_irf_calibration(); }
#line 5754 "DynareBison.cc"
    break;

  case 1686: // irf_calibration: IRF_CALIBRATION '(' o_relative_irf ')' ';' irf_calibration_list END ';'
#line 3279 "DynareBison.yy"
                  { driver.end_irf_calibration(); }
#line 5760 "DynareBison.cc"
    break;

  case 1689: // irf_calibration_item: symbol COMMA symbol COMMA calibration_range ';'
#line 3287 "DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[5].value.as < string > (), "1", yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5766 "DynareBison.cc"
    break;

  case 1690: // irf_calibration_item: symbol '(' INT_NUMBER ')' COMMA symbol COMMA calibration_range ';'
#line 3289 "DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5772 "DynareBison.cc"
    break;

  case 1691: // irf_calibration_item: symbol '(' integer_range ')' COMMA symbol COMMA calibration_range ';'
#line 3291 "DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 5778 "DynareBison.cc"
    break;

  case 1692: // smoother2histval: SMOOTHER2HISTVAL ';'
#line 3295 "DynareBison.yy"
                   { driver.smoother2histval(); }
#line 5784 "DynareBison.cc"
    break;

  case 1693: // smoother2histval: SMOOTHER2HISTVAL '(' smoother2histval_options_list ')' ';'
#line 3297 "DynareBison.yy"
                   { driver.smoother2histval(); }
#line 5790 "DynareBison.cc"
    break;

  case 1701: // shock_groups: SHOCK_GROUPS ';' shock_group_list END ';'
#line 3312 "DynareBison.yy"
               { driver.end_shock_groups("default"); }
#line 5796 "DynareBison.cc"
    break;

  case 1702: // shock_groups: SHOCK_GROUPS '(' NAME EQUAL symbol ')' ';' shock_group_list END ';'
#line 3314 "DynareBison.yy"
               {driver.end_shock_groups(yystack_[5].value.as < string > ());}
#line 5802 "DynareBison.cc"
    break;

  case 1705: // shock_group_element: symbol EQUAL shock_name_list ';'
#line 3321 "DynareBison.yy"
                                                       { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 5808 "DynareBison.cc"
    break;

  case 1706: // shock_group_element: QUOTED_STRING EQUAL shock_name_list ';'
#line 3322 "DynareBison.yy"
                                                              { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 5814 "DynareBison.cc"
    break;

  case 1707: // shock_name_list: shock_name_list COMMA symbol
#line 3325 "DynareBison.yy"
                                               {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5820 "DynareBison.cc"
    break;

  case 1708: // shock_name_list: shock_name_list symbol
#line 3326 "DynareBison.yy"
                                         {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5826 "DynareBison.cc"
    break;

  case 1709: // shock_name_list: symbol
#line 3327 "DynareBison.yy"
                         {driver.add_shock_group_element(yystack_[0].value.as < string > ());}
#line 5832 "DynareBison.cc"
    break;

  case 1710: // init2shocks: INIT2SHOCKS ';' init2shocks_list END ';'
#line 3331 "DynareBison.yy"
              { driver.end_init2shocks("default"); }
#line 5838 "DynareBison.cc"
    break;

  case 1711: // init2shocks: INIT2SHOCKS '(' NAME EQUAL symbol ')' ';' init2shocks_list END ';'
#line 3333 "DynareBison.yy"
              {driver.end_init2shocks(yystack_[5].value.as < string > ());}
#line 5844 "DynareBison.cc"
    break;

  case 1714: // init2shocks_element: symbol symbol ';'
#line 3340 "DynareBison.yy"
                                        { driver.add_init2shocks(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5850 "DynareBison.cc"
    break;

  case 1715: // init2shocks_element: symbol COMMA symbol ';'
#line 3341 "DynareBison.yy"
                                              { driver.add_init2shocks(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5856 "DynareBison.cc"
    break;

  case 1716: // o_dr_algo: DR_ALGO EQUAL INT_NUMBER
#line 3344 "DynareBison.yy"
                                     {
                                       if (yystack_[0].value.as < string > () == "0")
                                         driver.warning("dr_algo option is now deprecated, and may be removed in a future version of Dynare");
                                       else
                                         driver.error("dr_algo=1 option is no longer supported");
                                     }
#line 5867 "DynareBison.cc"
    break;

  case 1717: // o_solve_algo: SOLVE_ALGO EQUAL INT_NUMBER
#line 3350 "DynareBison.yy"
                                           { driver.option_num("solve_algo", yystack_[0].value.as < string > ()); }
#line 5873 "DynareBison.cc"
    break;

  case 1718: // o_simul_algo: SIMUL_ALGO EQUAL INT_NUMBER
#line 3351 "DynareBison.yy"
                                           {
                                             if (yystack_[0].value.as < string > () == "0")
                                               driver.warning("simul_algo option is now deprecated, and may be removed in a future version of Dynare");
                                             else
                                               driver.error("simul_algo=1 option is no longer supported");
                                           }
#line 5884 "DynareBison.cc"
    break;

  case 1719: // o_stack_solve_algo: STACK_SOLVE_ALGO EQUAL INT_NUMBER
#line 3357 "DynareBison.yy"
                                                       { driver.option_num("stack_solve_algo", yystack_[0].value.as < string > ()); }
#line 5890 "DynareBison.cc"
    break;

  case 1720: // o_robust_lin_solve: ROBUST_LIN_SOLVE
#line 3358 "DynareBison.yy"
                                      { driver.option_num("simul.robust_lin_solve", "true"); }
#line 5896 "DynareBison.cc"
    break;

  case 1721: // o_endogenous_terminal_period: ENDOGENOUS_TERMINAL_PERIOD
#line 3359 "DynareBison.yy"
                                                          { driver.option_num("endogenous_terminal_period", "true"); }
#line 5902 "DynareBison.cc"
    break;

  case 1722: // o_linear: LINEAR
#line 3360 "DynareBison.yy"
                  { driver.linear(); }
#line 5908 "DynareBison.cc"
    break;

  case 1723: // o_order: ORDER EQUAL INT_NUMBER
#line 3361 "DynareBison.yy"
                                 { driver.option_num("order", yystack_[0].value.as < string > ()); }
#line 5914 "DynareBison.cc"
    break;

  case 1724: // o_replic: REPLIC EQUAL INT_NUMBER
#line 3362 "DynareBison.yy"
                                   { driver.option_num("replic", yystack_[0].value.as < string > ()); }
#line 5920 "DynareBison.cc"
    break;

  case 1725: // o_drop: DROP EQUAL INT_NUMBER
#line 3363 "DynareBison.yy"
                               { driver.option_num("drop", yystack_[0].value.as < string > ()); }
#line 5926 "DynareBison.cc"
    break;

  case 1726: // o_ar: AR EQUAL INT_NUMBER
#line 3364 "DynareBison.yy"
                           { driver.option_num("ar", yystack_[0].value.as < string > ()); }
#line 5932 "DynareBison.cc"
    break;

  case 1727: // o_nocorr: NOCORR
#line 3365 "DynareBison.yy"
                  { driver.option_num("nocorr", "true"); }
#line 5938 "DynareBison.cc"
    break;

  case 1728: // o_nofunctions: NOFUNCTIONS
#line 3366 "DynareBison.yy"
                            { driver.option_num("nofunctions", "true"); }
#line 5944 "DynareBison.cc"
    break;

  case 1729: // o_nomoments: NOMOMENTS
#line 3367 "DynareBison.yy"
                        { driver.option_num("nomoments", "true"); }
#line 5950 "DynareBison.cc"
    break;

  case 1730: // o_irf: IRF EQUAL INT_NUMBER
#line 3368 "DynareBison.yy"
                             { driver.option_num("irf", yystack_[0].value.as < string > ()); }
#line 5956 "DynareBison.cc"
    break;

  case 1731: // o_irf_shocks: IRF_SHOCKS EQUAL '(' symbol_list ')'
#line 3369 "DynareBison.yy"
                                                    { driver.option_symbol_list("irf_shocks"); }
#line 5962 "DynareBison.cc"
    break;

  case 1732: // o_hp_filter: HP_FILTER EQUAL non_negative_number
#line 3370 "DynareBison.yy"
                                                  { driver.option_num("hp_filter", yystack_[0].value.as < string > ()); }
#line 5968 "DynareBison.cc"
    break;

  case 1733: // o_hp_ngrid: HP_NGRID EQUAL INT_NUMBER
#line 3371 "DynareBison.yy"
                                       {
                                         driver.warning("The 'hp_ngrid' option is deprecated. It has been superseded by the 'filtered_theoretical_moments_grid' option.");
                                         driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ());
                                       }
#line 5977 "DynareBison.cc"
    break;

  case 1734: // o_filtered_theoretical_moments_grid: FILTERED_THEORETICAL_MOMENTS_GRID EQUAL INT_NUMBER
#line 3375 "DynareBison.yy"
                                                                                         { driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ()); }
#line 5983 "DynareBison.cc"
    break;

  case 1735: // o_one_sided_hp_filter: ONE_SIDED_HP_FILTER EQUAL non_negative_number
#line 3376 "DynareBison.yy"
                                                                      { driver.option_num("one_sided_hp_filter", yystack_[0].value.as < string > ()); }
#line 5989 "DynareBison.cc"
    break;

  case 1736: // o_periods: PERIODS EQUAL INT_NUMBER
#line 3377 "DynareBison.yy"
                                     { driver.option_num("periods", yystack_[0].value.as < string > ()); }
#line 5995 "DynareBison.cc"
    break;

  case 1737: // o_solver_periods: SOLVER_PERIODS EQUAL INT_NUMBER
#line 3378 "DynareBison.yy"
                                                   { driver.option_num("ep.periods", yystack_[0].value.as < string > ()); }
#line 6001 "DynareBison.cc"
    break;

  case 1738: // o_extended_path_order: ORDER EQUAL INT_NUMBER
#line 3379 "DynareBison.yy"
                                               { driver.option_num("ep.stochastic.order", yystack_[0].value.as < string > ()); }
#line 6007 "DynareBison.cc"
    break;

  case 1739: // o_hybrid: HYBRID
#line 3380 "DynareBison.yy"
                  { driver.option_num("ep.stochastic.hybrid_order", "2"); }
#line 6013 "DynareBison.cc"
    break;

  case 1740: // o_steady_maxit: MAXIT EQUAL INT_NUMBER
#line 3381 "DynareBison.yy"
                                        { driver.option_num("steady.maxit", yystack_[0].value.as < string > ()); }
#line 6019 "DynareBison.cc"
    break;

  case 1741: // o_simul_maxit: MAXIT EQUAL INT_NUMBER
#line 3382 "DynareBison.yy"
                                       { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 6025 "DynareBison.cc"
    break;

  case 1742: // o_bandpass_filter: BANDPASS_FILTER
#line 3383 "DynareBison.yy"
                                    { driver.option_num("bandpass.indicator", "true"); }
#line 6031 "DynareBison.cc"
    break;

  case 1743: // o_bandpass_filter: BANDPASS_FILTER EQUAL vec_int
#line 3385 "DynareBison.yy"
                    {
                      driver.option_num("bandpass.indicator", "true");
                      driver.option_vec_int("bandpass.passband", yystack_[0].value.as < vector<int> > ());
                    }
#line 6040 "DynareBison.cc"
    break;

  case 1744: // o_dp_maxit: MAXIT EQUAL INT_NUMBER
#line 3390 "DynareBison.yy"
                                    { driver.option_num("dp.maxit", yystack_[0].value.as < string > ()); }
#line 6046 "DynareBison.cc"
    break;

  case 1745: // o_osr_maxit: MAXIT EQUAL INT_NUMBER
#line 3391 "DynareBison.yy"
                                     { driver.option_num("osr.maxit", yystack_[0].value.as < string > ()); }
#line 6052 "DynareBison.cc"
    break;

  case 1746: // o_osr_tolf: TOLF EQUAL non_negative_number
#line 3392 "DynareBison.yy"
                                            { driver.option_num("osr.tolf", yystack_[0].value.as < string > ()); }
#line 6058 "DynareBison.cc"
    break;

  case 1747: // o_pf_tolf: TOLF EQUAL non_negative_number
#line 3393 "DynareBison.yy"
                                           { driver.option_num("dynatol.f", yystack_[0].value.as < string > ()); }
#line 6064 "DynareBison.cc"
    break;

  case 1748: // o_pf_tolx: TOLX EQUAL non_negative_number
#line 3394 "DynareBison.yy"
                                           { driver.option_num("dynatol.x", yystack_[0].value.as < string > ()); }
#line 6070 "DynareBison.cc"
    break;

  case 1749: // o_steady_tolf: TOLF EQUAL non_negative_number
#line 3395 "DynareBison.yy"
                                               { driver.option_num("solve_tolf", yystack_[0].value.as < string > ()); }
#line 6076 "DynareBison.cc"
    break;

  case 1750: // o_opt_algo: OPT_ALGO EQUAL INT_NUMBER
#line 3396 "DynareBison.yy"
                                       { driver.option_num("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 6082 "DynareBison.cc"
    break;

  case 1751: // o_opt_algo: OPT_ALGO EQUAL filename
#line 3397 "DynareBison.yy"
                                     { driver.option_str("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 6088 "DynareBison.cc"
    break;

  case 1752: // o_cutoff: CUTOFF EQUAL non_negative_number
#line 3399 "DynareBison.yy"
                                            { driver.cutoff(yystack_[0].value.as < string > ()); }
#line 6094 "DynareBison.cc"
    break;

  case 1753: // o_markowitz: MARKOWITZ EQUAL non_negative_number
#line 3400 "DynareBison.yy"
                                                  { driver.option_num("markowitz", yystack_[0].value.as < string > ()); }
#line 6100 "DynareBison.cc"
    break;

  case 1754: // o_minimal_solving_periods: MINIMAL_SOLVING_PERIODS EQUAL non_negative_number
#line 3401 "DynareBison.yy"
                                                                              { driver.option_num("minimal_solving_periods", yystack_[0].value.as < string > ()); }
#line 6106 "DynareBison.cc"
    break;

  case 1755: // o_mfs: MFS EQUAL INT_NUMBER
#line 3402 "DynareBison.yy"
                             { driver.mfs(yystack_[0].value.as < string > ()); }
#line 6112 "DynareBison.cc"
    break;

  case 1757: // o_simul_replic: SIMUL_REPLIC EQUAL INT_NUMBER
#line 3404 "DynareBison.yy"
                                               { driver.option_num("simul_replic", yystack_[0].value.as < string > ()); }
#line 6118 "DynareBison.cc"
    break;

  case 1758: // o_simul_seed: SIMUL_SEED EQUAL INT_NUMBER
#line 3405 "DynareBison.yy"
                                           { driver.error("'simul_seed' option is no longer supported; use 'set_dynare_seed' command instead"); }
#line 6124 "DynareBison.cc"
    break;

  case 1759: // o_qz_criterium: QZ_CRITERIUM EQUAL non_negative_number
#line 3406 "DynareBison.yy"
                                                        { driver.option_num("qz_criterium", yystack_[0].value.as < string > ()); }
#line 6130 "DynareBison.cc"
    break;

  case 1760: // o_qz_zero_threshold: QZ_ZERO_THRESHOLD EQUAL non_negative_number
#line 3407 "DynareBison.yy"
                                                                  { driver.option_num("qz_zero_threshold", yystack_[0].value.as < string > ()); }
#line 6136 "DynareBison.cc"
    break;

  case 1761: // o_file: FILE EQUAL filename
#line 3408 "DynareBison.yy"
                             { driver.option_str("file", yystack_[0].value.as < string > ()); }
#line 6142 "DynareBison.cc"
    break;

  case 1762: // o_pac_name: MODEL_NAME EQUAL symbol
#line 3409 "DynareBison.yy"
                                     { driver.option_str("pac.model_name", yystack_[0].value.as < string > ()); }
#line 6148 "DynareBison.cc"
    break;

  case 1763: // o_pac_aux_model_name: AUXILIARY_MODEL_NAME EQUAL symbol
#line 3410 "DynareBison.yy"
                                                         { driver.option_str("pac.aux_model_name", yystack_[0].value.as < string > ()); }
#line 6154 "DynareBison.cc"
    break;

  case 1764: // o_pac_discount: DISCOUNT EQUAL symbol
#line 3411 "DynareBison.yy"
                                       { driver.option_str("pac.discount", yystack_[0].value.as < string > ()); }
#line 6160 "DynareBison.cc"
    break;

  case 1765: // $@30: %empty
#line 3412 "DynareBison.yy"
                      { driver.begin_pac_growth(); }
#line 6166 "DynareBison.cc"
    break;

  case 1766: // o_pac_growth: GROWTH $@30 EQUAL hand_side
#line 3412 "DynareBison.yy"
                                                                     { driver.set_pac_growth(yystack_[0].value.as < expr_t > ()); }
#line 6172 "DynareBison.cc"
    break;

  case 1767: // o_var_name: MODEL_NAME EQUAL symbol
#line 3413 "DynareBison.yy"
                                     { driver.option_str("var.model_name", yystack_[0].value.as < string > ()); }
#line 6178 "DynareBison.cc"
    break;

  case 1768: // o_series: SERIES EQUAL symbol
#line 3414 "DynareBison.yy"
                               { driver.option_str("series", yystack_[0].value.as < string > ()); }
#line 6184 "DynareBison.cc"
    break;

  case 1769: // o_datafile: DATAFILE EQUAL filename
#line 3415 "DynareBison.yy"
                                     { driver.option_str("datafile", yystack_[0].value.as < string > ()); }
#line 6190 "DynareBison.cc"
    break;

  case 1770: // o_filename: FILENAME EQUAL filename
#line 3416 "DynareBison.yy"
                                     { driver.option_str("filename", yystack_[0].value.as < string > ()); }
#line 6196 "DynareBison.cc"
    break;

  case 1771: // o_var_eq_tags: EQTAGS EQUAL vec_str
#line 3417 "DynareBison.yy"
                                     { driver.option_vec_str("var.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 6202 "DynareBison.cc"
    break;

  case 1772: // o_var_structural: STRUCTURAL
#line 3418 "DynareBison.yy"
                              { driver.option_num("var.structural", "true"); }
#line 6208 "DynareBison.cc"
    break;

  case 1773: // o_dirname: DIRNAME EQUAL filename
#line 3419 "DynareBison.yy"
                                   { driver.option_str("dirname", yystack_[0].value.as < string > ()); }
#line 6214 "DynareBison.cc"
    break;

  case 1774: // o_huge_number: HUGE_NUMBER EQUAL non_negative_number
#line 3420 "DynareBison.yy"
                                                      { driver.option_num("huge_number", yystack_[0].value.as < string > ()); }
#line 6220 "DynareBison.cc"
    break;

  case 1775: // o_nobs: NOBS EQUAL vec_int
#line 3422 "DynareBison.yy"
         { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 6226 "DynareBison.cc"
    break;

  case 1776: // o_nobs: NOBS EQUAL vec_int_number
#line 3424 "DynareBison.yy"
         { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 6232 "DynareBison.cc"
    break;

  case 1777: // o_trend_component_model_name: MODEL_NAME EQUAL symbol
#line 3426 "DynareBison.yy"
                                                       { driver.option_str("trend_component.name", yystack_[0].value.as < string > ()); }
#line 6238 "DynareBison.cc"
    break;

  case 1778: // o_trend_component_model_targets: TARGETS EQUAL vec_str
#line 3427 "DynareBison.yy"
                                                        { driver.option_vec_str("trend_component.targets", yystack_[0].value.as < vector<string> > ()); }
#line 6244 "DynareBison.cc"
    break;

  case 1779: // o_trend_component_model_eq_tags: EQTAGS EQUAL vec_str
#line 3428 "DynareBison.yy"
                                                       { driver.option_vec_str("trend_component.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 6250 "DynareBison.cc"
    break;

  case 1780: // o_conditional_variance_decomposition: CONDITIONAL_VARIANCE_DECOMPOSITION EQUAL vec_int
#line 3430 "DynareBison.yy"
                                       { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 6256 "DynareBison.cc"
    break;

  case 1781: // o_conditional_variance_decomposition: CONDITIONAL_VARIANCE_DECOMPOSITION EQUAL vec_int_number
#line 3432 "DynareBison.yy"
                                       { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 6262 "DynareBison.cc"
    break;

  case 1782: // o_est_first_obs: FIRST_OBS EQUAL vec_int
#line 3435 "DynareBison.yy"
                  { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 6268 "DynareBison.cc"
    break;

  case 1783: // o_est_first_obs: FIRST_OBS EQUAL vec_int_number
#line 3437 "DynareBison.yy"
                  { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 6274 "DynareBison.cc"
    break;

  case 1784: // o_posterior_sampling_method: POSTERIOR_SAMPLING_METHOD EQUAL QUOTED_STRING
#line 3440 "DynareBison.yy"
                              { driver.option_str("posterior_sampler_options.posterior_sampling_method", yystack_[0].value.as < string > ()); }
#line 6280 "DynareBison.cc"
    break;

  case 1785: // o_first_obs: FIRST_OBS EQUAL INT_NUMBER
#line 3441 "DynareBison.yy"
                                         { driver.option_num("first_obs", yystack_[0].value.as < string > ()); }
#line 6286 "DynareBison.cc"
    break;

  case 1786: // o_data_first_obs: FIRST_OBS EQUAL date_expr
#line 3442 "DynareBison.yy"
                                             { driver.option_date("firstobs", yystack_[0].value.as < string > ()); }
#line 6292 "DynareBison.cc"
    break;

  case 1787: // o_first_simulation_period: FIRST_SIMULATION_PERIOD EQUAL INT_NUMBER
#line 3443 "DynareBison.yy"
                                                                     { driver.option_num("first_simulation_period", yystack_[0].value.as < string > ()); }
#line 6298 "DynareBison.cc"
    break;

  case 1788: // o_date_first_simulation_period: FIRST_SIMULATION_PERIOD EQUAL date_expr
#line 3444 "DynareBison.yy"
                                                                         { driver.option_date("firstsimulationperiod", yystack_[0].value.as < string > ()); }
#line 6304 "DynareBison.cc"
    break;

  case 1789: // o_last_obs: LAST_OBS EQUAL INT_NUMBER
#line 3445 "DynareBison.yy"
                                       { driver.option_num("last_obs", yystack_[0].value.as < string > ()); }
#line 6310 "DynareBison.cc"
    break;

  case 1790: // o_data_last_obs: LAST_OBS EQUAL date_expr
#line 3446 "DynareBison.yy"
                                           { driver.option_date("lastobs", yystack_[0].value.as < string > ()); }
#line 6316 "DynareBison.cc"
    break;

  case 1791: // o_keep_kalman_algo_if_singularity_is_detected: KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED
#line 3447 "DynareBison.yy"
                                                                                            { driver.option_num("kalman.keep_kalman_algo_if_singularity_is_detected", "true"); }
#line 6322 "DynareBison.cc"
    break;

  case 1792: // o_data_nobs: NOBS EQUAL INT_NUMBER
#line 3448 "DynareBison.yy"
                                    { driver.option_num("nobs", yystack_[0].value.as < string > ()); }
#line 6328 "DynareBison.cc"
    break;

  case 1793: // o_shift: SHIFT EQUAL signed_number
#line 3449 "DynareBison.yy"
                                    { driver.option_num("shift", yystack_[0].value.as < string > ()); }
#line 6334 "DynareBison.cc"
    break;

  case 1794: // o_shape: SHAPE EQUAL prior_distribution
#line 3450 "DynareBison.yy"
                                         { driver.prior_shape = yystack_[0].value.as < PriorDistributions > (); }
#line 6340 "DynareBison.cc"
    break;

  case 1795: // o_mode: MODE EQUAL signed_number
#line 3451 "DynareBison.yy"
                                  { driver.option_num("mode", yystack_[0].value.as < string > ()); }
#line 6346 "DynareBison.cc"
    break;

  case 1796: // o_mean: MEAN EQUAL signed_number
#line 3452 "DynareBison.yy"
                                  { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 6352 "DynareBison.cc"
    break;

  case 1797: // o_mean_vec: MEAN EQUAL vec_value
#line 3453 "DynareBison.yy"
                                  { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 6358 "DynareBison.cc"
    break;

  case 1798: // o_truncate: TRUNCATE EQUAL vec_value
#line 3454 "DynareBison.yy"
                                      { driver.option_num("truncate", yystack_[0].value.as < string > ()); }
#line 6364 "DynareBison.cc"
    break;

  case 1799: // o_stdev: STDEV EQUAL non_negative_number
#line 3455 "DynareBison.yy"
                                          { driver.option_num("stdev", yystack_[0].value.as < string > ()); }
#line 6370 "DynareBison.cc"
    break;

  case 1800: // o_jscale: JSCALE EQUAL non_negative_number
#line 3456 "DynareBison.yy"
                                            { driver.option_num("jscale", yystack_[0].value.as < string > ()); }
#line 6376 "DynareBison.cc"
    break;

  case 1801: // o_init: INIT EQUAL signed_number
#line 3457 "DynareBison.yy"
                                  { driver.option_num("init", yystack_[0].value.as < string > ()); }
#line 6382 "DynareBison.cc"
    break;

  case 1802: // o_bounds: BOUNDS EQUAL vec_value_w_inf
#line 3458 "DynareBison.yy"
                                        { driver.option_num("bounds", yystack_[0].value.as < string > ()); }
#line 6388 "DynareBison.cc"
    break;

  case 1803: // o_domain: DOMAINN EQUAL vec_value
#line 3459 "DynareBison.yy"
                                   { driver.option_num("domain", yystack_[0].value.as < string > ()); }
#line 6394 "DynareBison.cc"
    break;

  case 1804: // o_interval: INTERVAL EQUAL vec_value
#line 3460 "DynareBison.yy"
                                      { driver.option_num("interval", yystack_[0].value.as < string > ()); }
#line 6400 "DynareBison.cc"
    break;

  case 1805: // o_variance: VARIANCE EQUAL expression
#line 3461 "DynareBison.yy"
                                       { driver.set_prior_variance(yystack_[0].value.as < expr_t > ()); }
#line 6406 "DynareBison.cc"
    break;

  case 1806: // o_variance_mat: VARIANCE EQUAL vec_of_vec_value
#line 3462 "DynareBison.yy"
                                                 { driver.option_num("variance",yystack_[0].value.as < string > ()); }
#line 6412 "DynareBison.cc"
    break;

  case 1807: // o_prefilter: PREFILTER EQUAL INT_NUMBER
#line 3463 "DynareBison.yy"
                                         { driver.option_num("prefilter", yystack_[0].value.as < string > ()); }
#line 6418 "DynareBison.cc"
    break;

  case 1808: // o_presample: PRESAMPLE EQUAL INT_NUMBER
#line 3464 "DynareBison.yy"
                                         { driver.option_num("presample", yystack_[0].value.as < string > ()); }
#line 6424 "DynareBison.cc"
    break;

  case 1809: // o_lik_algo: LIK_ALGO EQUAL INT_NUMBER
#line 3465 "DynareBison.yy"
                                       { driver.option_num("lik_algo", yystack_[0].value.as < string > ()); }
#line 6430 "DynareBison.cc"
    break;

  case 1810: // o_lik_init: LIK_INIT EQUAL INT_NUMBER
#line 3466 "DynareBison.yy"
                                       { driver.option_num("lik_init", yystack_[0].value.as < string > ()); }
#line 6436 "DynareBison.cc"
    break;

  case 1811: // o_nograph: NOGRAPH
#line 3468 "DynareBison.yy"
            { driver.option_num("nograph", "true"); }
#line 6442 "DynareBison.cc"
    break;

  case 1812: // o_nograph: GRAPH
#line 3470 "DynareBison.yy"
            { driver.option_num("nograph", "false"); }
#line 6448 "DynareBison.cc"
    break;

  case 1813: // o_posterior_nograph: POSTERIOR_NOGRAPH
#line 3473 "DynareBison.yy"
            { driver.option_num("no_graph.posterior", "true"); }
#line 6454 "DynareBison.cc"
    break;

  case 1814: // o_posterior_nograph: POSTERIOR_GRAPH
#line 3475 "DynareBison.yy"
            { driver.option_num("no_graph.posterior", "false"); }
#line 6460 "DynareBison.cc"
    break;

  case 1815: // o_psd_nograph: NOGRAPH
#line 3477 "DynareBison.yy"
                        { driver.option_num("no_graph.plot_shock_decomposition", "true"); }
#line 6466 "DynareBison.cc"
    break;

  case 1816: // o_shock_decomposition_nograph: NOGRAPH
#line 3478 "DynareBison.yy"
                                        { driver.option_num("no_graph.shock_decomposition", "true"); }
#line 6472 "DynareBison.cc"
    break;

  case 1817: // o_init_state: INIT_STATE EQUAL INT_NUMBER
#line 3479 "DynareBison.yy"
                                           { driver.option_num("shock_decomp.init_state", yystack_[0].value.as < string > ()); }
#line 6478 "DynareBison.cc"
    break;

  case 1818: // o_forecast_type: FORECAST EQUAL UNCONDITIONAL
#line 3481 "DynareBison.yy"
                  { driver.option_str("shock_decomp.forecast_type", "unconditional"); }
#line 6484 "DynareBison.cc"
    break;

  case 1819: // o_forecast_type: FORECAST EQUAL CONDITIONAL
#line 3483 "DynareBison.yy"
                  { driver.option_str("shock_decomp.forecast_type", "conditional"); }
#line 6490 "DynareBison.cc"
    break;

  case 1820: // o_shock_decomposition_presample: PRESAMPLE EQUAL INT_NUMBER
#line 3484 "DynareBison.yy"
                                                             { driver.option_num("shock_decomp.presample", yystack_[0].value.as < string > ()); }
#line 6496 "DynareBison.cc"
    break;

  case 1821: // o_shock_decomposition_forecast: FORECAST EQUAL INT_NUMBER
#line 3485 "DynareBison.yy"
                                                           { driver.option_num("shock_decomp.forecast", yystack_[0].value.as < string > ()); }
#line 6502 "DynareBison.cc"
    break;

  case 1822: // o_save_realtime: SAVE_REALTIME EQUAL vec_int
#line 3486 "DynareBison.yy"
                                              { driver.option_vec_int("shock_decomp.save_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 6508 "DynareBison.cc"
    break;

  case 1823: // o_fast_realtime: FAST_REALTIME EQUAL vec_int
#line 3488 "DynareBison.yy"
                  { driver.option_vec_int("shock_decomp.fast_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 6514 "DynareBison.cc"
    break;

  case 1824: // o_fast_realtime: FAST_REALTIME EQUAL vec_int_number
#line 3490 "DynareBison.yy"
                  { driver.option_vec_int("shock_decomp.fast_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 6520 "DynareBison.cc"
    break;

  case 1825: // o_nodisplay: NODISPLAY
#line 3492 "DynareBison.yy"
                        { driver.option_num("nodisplay", "true"); }
#line 6526 "DynareBison.cc"
    break;

  case 1826: // o_icd_nodisplay: NODISPLAY
#line 3493 "DynareBison.yy"
                            { driver.option_num("initial_condition_decomp.nodisplay", "true"); }
#line 6532 "DynareBison.cc"
    break;

  case 1827: // o_psd_nodisplay: NODISPLAY
#line 3494 "DynareBison.yy"
                            { driver.option_num("plot_shock_decomp.nodisplay", "true"); }
#line 6538 "DynareBison.cc"
    break;

  case 1828: // o_psd_init2shocks: INIT2SHOCKS
#line 3495 "DynareBison.yy"
                                { driver.option_str("plot_shock_decomp.init2shocks", "default"); }
#line 6544 "DynareBison.cc"
    break;

  case 1829: // o_psd_init2shocks: INIT2SHOCKS EQUAL symbol
#line 3496 "DynareBison.yy"
                                             { driver.option_str("plot_shock_decomp.init2shocks", yystack_[0].value.as < string > ()); }
#line 6550 "DynareBison.cc"
    break;

  case 1830: // o_icd_max_nrows: MAX_NROWS EQUAL INT_NUMBER
#line 3498 "DynareBison.yy"
                                             { driver.option_num("initial_condition_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 6556 "DynareBison.cc"
    break;

  case 1831: // o_psd_max_nrows: MAX_NROWS EQUAL INT_NUMBER
#line 3499 "DynareBison.yy"
                                             { driver.option_num("plot_shock_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 6562 "DynareBison.cc"
    break;

  case 1832: // o_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3501 "DynareBison.yy"
                 { driver.process_graph_format_option(); }
#line 6568 "DynareBison.cc"
    break;

  case 1833: // o_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3503 "DynareBison.yy"
                 { driver.process_graph_format_option(); }
#line 6574 "DynareBison.cc"
    break;

  case 1834: // o_icd_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3506 "DynareBison.yy"
                     { driver.initial_condition_decomp_process_graph_format_option(); }
#line 6580 "DynareBison.cc"
    break;

  case 1835: // o_icd_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3508 "DynareBison.yy"
                     { driver.initial_condition_decomp_process_graph_format_option(); }
#line 6586 "DynareBison.cc"
    break;

  case 1836: // o_psd_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3511 "DynareBison.yy"
                     { driver.plot_shock_decomp_process_graph_format_option(); }
#line 6592 "DynareBison.cc"
    break;

  case 1837: // o_psd_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3513 "DynareBison.yy"
                     { driver.plot_shock_decomp_process_graph_format_option(); }
#line 6598 "DynareBison.cc"
    break;

  case 1838: // o_shock_decomposition_with_epilogue: WITH_EPILOGUE
#line 3515 "DynareBison.yy"
                                                    { driver.option_num("shock_decomp.with_epilogue", "true"); }
#line 6604 "DynareBison.cc"
    break;

  case 1839: // o_icd_with_epilogue: WITH_EPILOGUE
#line 3516 "DynareBison.yy"
                                    { driver.option_num("initial_condition_decomp.with_epilogue", "true"); }
#line 6610 "DynareBison.cc"
    break;

  case 1840: // allowed_graph_formats: EPS
#line 3518 "DynareBison.yy"
                        { driver.add_graph_format("eps"); }
#line 6616 "DynareBison.cc"
    break;

  case 1841: // allowed_graph_formats: FIG
#line 3520 "DynareBison.yy"
                        { driver.add_graph_format("fig"); }
#line 6622 "DynareBison.cc"
    break;

  case 1842: // allowed_graph_formats: PDF
#line 3522 "DynareBison.yy"
                        { driver.add_graph_format("pdf"); }
#line 6628 "DynareBison.cc"
    break;

  case 1843: // allowed_graph_formats: NONE
#line 3524 "DynareBison.yy"
                        { driver.add_graph_format("none"); }
#line 6634 "DynareBison.cc"
    break;

  case 1846: // o_subsample_name: symbol EQUAL date_expr ':' date_expr
#line 3531 "DynareBison.yy"
                   { driver.set_subsample_name_equal_to_date_range(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 6640 "DynareBison.cc"
    break;

  case 1847: // o_bvar_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3533 "DynareBison.yy"
                                                     { driver.option_num("bvar.conf_sig", yystack_[0].value.as < string > ()); }
#line 6646 "DynareBison.cc"
    break;

  case 1848: // o_forecasts_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3534 "DynareBison.yy"
                                                          { driver.option_num("forecasts.conf_sig", yystack_[0].value.as < string > ()); }
#line 6652 "DynareBison.cc"
    break;

  case 1849: // o_conditional_forecast_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3535 "DynareBison.yy"
                                                                     { driver.option_num("conditional_forecast.conf_sig", yystack_[0].value.as < string > ()); }
#line 6658 "DynareBison.cc"
    break;

  case 1850: // o_mh_conf_sig: MH_CONF_SIG EQUAL non_negative_number
#line 3536 "DynareBison.yy"
                                                      { driver.option_num("mh_conf_sig", yystack_[0].value.as < string > ()); }
#line 6664 "DynareBison.cc"
    break;

  case 1851: // o_mh_replic: MH_REPLIC EQUAL INT_NUMBER
#line 3537 "DynareBison.yy"
                                         { driver.option_num("mh_replic", yystack_[0].value.as < string > ()); }
#line 6670 "DynareBison.cc"
    break;

  case 1852: // o_posterior_max_subsample_draws: POSTERIOR_MAX_SUBSAMPLE_DRAWS EQUAL INT_NUMBER
#line 3538 "DynareBison.yy"
                                                                                 { driver.option_num("posterior_max_subsample_draws", yystack_[0].value.as < string > ()); }
#line 6676 "DynareBison.cc"
    break;

  case 1853: // o_mh_drop: MH_DROP EQUAL non_negative_number
#line 3539 "DynareBison.yy"
                                              { driver.option_num("mh_drop", yystack_[0].value.as < string > ()); }
#line 6682 "DynareBison.cc"
    break;

  case 1854: // o_mh_jscale: MH_JSCALE EQUAL non_negative_number
#line 3540 "DynareBison.yy"
                                                  { driver.option_num("mh_jscale", yystack_[0].value.as < string > ()); }
#line 6688 "DynareBison.cc"
    break;

  case 1855: // o_mh_tune_jscale: MH_TUNE_JSCALE EQUAL non_negative_number
#line 3542 "DynareBison.yy"
                 { driver.option_num("mh_tune_jscale.target", yystack_[0].value.as < string > ()); driver.option_num("mh_tune_jscale.status", "true");}
#line 6694 "DynareBison.cc"
    break;

  case 1856: // o_mh_tune_jscale: MH_TUNE_JSCALE
#line 3543 "DynareBison.yy"
                                  {driver.option_num("mh_tune_jscale.status", "true");}
#line 6700 "DynareBison.cc"
    break;

  case 1857: // o_mh_tune_guess: MH_TUNE_GUESS EQUAL non_negative_number
#line 3544 "DynareBison.yy"
                                                          { driver.option_num("mh_tune_jscale.guess", yystack_[0].value.as < string > ()); }
#line 6706 "DynareBison.cc"
    break;

  case 1858: // o_optim: OPTIM EQUAL '(' name_value_pair_with_boolean_list ')'
#line 3545 "DynareBison.yy"
                                                                 { driver.option_str("optim_opt", yystack_[1].value.as < string > ()); }
#line 6712 "DynareBison.cc"
    break;

  case 1859: // o_posterior_sampler_options: POSTERIOR_SAMPLER_OPTIONS EQUAL '(' name_value_pair_with_suboptions_list ')'
#line 3546 "DynareBison.yy"
                                                                                                           { driver.option_str("posterior_sampler_options.sampling_opt", yystack_[1].value.as < string > ()); }
#line 6718 "DynareBison.cc"
    break;

  case 1860: // o_proposal_distribution: PROPOSAL_DISTRIBUTION EQUAL symbol
#line 3547 "DynareBison.yy"
                                                             { driver.option_str("posterior_sampler_options.posterior_sampling_method.proposal_distribution", yystack_[0].value.as < string > ()); }
#line 6724 "DynareBison.cc"
    break;

  case 1861: // o_no_posterior_kernel_density: NO_POSTERIOR_KERNEL_DENSITY
#line 3549 "DynareBison.yy"
                             { driver.option_num("estimation.moments_posterior_density.indicator", "false"); }
#line 6730 "DynareBison.cc"
    break;

  case 1862: // o_mh_init_scale: MH_INIT_SCALE EQUAL non_negative_number
#line 3551 "DynareBison.yy"
                                                          { driver.option_num("mh_init_scale", yystack_[0].value.as < string > ()); }
#line 6736 "DynareBison.cc"
    break;

  case 1863: // o_mode_file: MODE_FILE EQUAL filename
#line 3552 "DynareBison.yy"
                                       { driver.option_str("mode_file", yystack_[0].value.as < string > ()); }
#line 6742 "DynareBison.cc"
    break;

  case 1864: // o_mode_compute: MODE_COMPUTE EQUAL INT_NUMBER
#line 3553 "DynareBison.yy"
                                               { driver.option_num("mode_compute", yystack_[0].value.as < string > ()); }
#line 6748 "DynareBison.cc"
    break;

  case 1865: // o_mode_compute: MODE_COMPUTE EQUAL symbol
#line 3554 "DynareBison.yy"
                                           { driver.option_str("mode_compute", yystack_[0].value.as < string > ()); }
#line 6754 "DynareBison.cc"
    break;

  case 1866: // o_mode_check: MODE_CHECK
#line 3555 "DynareBison.yy"
                          { driver.option_num("mode_check.status", "true"); }
#line 6760 "DynareBison.cc"
    break;

  case 1867: // o_mode_check_neighbourhood_size: MODE_CHECK_NEIGHBOURHOOD_SIZE EQUAL signed_number_w_inf
#line 3556 "DynareBison.yy"
                                                                                          { driver.option_num("mode_check.neighbourhood_size", yystack_[0].value.as < string > ()); }
#line 6766 "DynareBison.cc"
    break;

  case 1868: // o_mode_check_number_of_points: MODE_CHECK_NUMBER_OF_POINTS EQUAL INT_NUMBER
#line 3557 "DynareBison.yy"
                                                                             { driver.option_num("mode_check.number_of_points", yystack_[0].value.as < string > ()); }
#line 6772 "DynareBison.cc"
    break;

  case 1869: // o_mode_check_symmetric_plots: MODE_CHECK_SYMMETRIC_PLOTS EQUAL INT_NUMBER
#line 3558 "DynareBison.yy"
                                                                           { driver.option_num("mode_check.symmetric_plots", yystack_[0].value.as < string > ()); }
#line 6778 "DynareBison.cc"
    break;

  case 1870: // o_prior_trunc: PRIOR_TRUNC EQUAL non_negative_number
#line 3559 "DynareBison.yy"
                                                      { driver.option_num("prior_trunc", yystack_[0].value.as < string > ()); }
#line 6784 "DynareBison.cc"
    break;

  case 1871: // o_mh_posterior_mode_estimation: MH_POSTERIOR_MODE_ESTIMATION
#line 3560 "DynareBison.yy"
                                                              { driver.option_num("mh_posterior_mode_estimation", "true"); }
#line 6790 "DynareBison.cc"
    break;

  case 1872: // o_mh_nblocks: MH_NBLOCKS EQUAL INT_NUMBER
#line 3561 "DynareBison.yy"
                                           { driver.option_num("mh_nblck", yystack_[0].value.as < string > ()); }
#line 6796 "DynareBison.cc"
    break;

  case 1873: // o_load_mh_file: LOAD_MH_FILE
#line 3562 "DynareBison.yy"
                              { driver.option_num("load_mh_file", "true"); }
#line 6802 "DynareBison.cc"
    break;

  case 1874: // o_load_results_after_load_mh: LOAD_RESULTS_AFTER_LOAD_MH
#line 3563 "DynareBison.yy"
                                                          { driver.option_num("load_results_after_load_mh", "true"); }
#line 6808 "DynareBison.cc"
    break;

  case 1875: // o_loglinear: LOGLINEAR
#line 3564 "DynareBison.yy"
                        { driver.option_num("loglinear", "true"); }
#line 6814 "DynareBison.cc"
    break;

  case 1876: // o_linear_approximation: LINEAR_APPROXIMATION
#line 3565 "DynareBison.yy"
                                              { driver.option_num("linear_approximation", "true"); }
#line 6820 "DynareBison.cc"
    break;

  case 1877: // o_logdata: LOGDATA
#line 3566 "DynareBison.yy"
                    { driver.option_num("logdata", "true"); }
#line 6826 "DynareBison.cc"
    break;

  case 1878: // o_nodiagnostic: NODIAGNOSTIC
#line 3567 "DynareBison.yy"
                              { driver.option_num("nodiagnostic", "true"); }
#line 6832 "DynareBison.cc"
    break;

  case 1879: // o_bayesian_irf: BAYESIAN_IRF
#line 3568 "DynareBison.yy"
                              { driver.option_num("bayesian_irf", "true"); }
#line 6838 "DynareBison.cc"
    break;

  case 1880: // o_dsge_var: DSGE_VAR EQUAL non_negative_number
#line 3570 "DynareBison.yy"
             { driver.option_num("dsge_var", yystack_[0].value.as < string > ()); }
#line 6844 "DynareBison.cc"
    break;

  case 1881: // o_dsge_var: DSGE_VAR EQUAL INF_CONSTANT
#line 3572 "DynareBison.yy"
             { driver.option_num("dsge_var", "Inf"); }
#line 6850 "DynareBison.cc"
    break;

  case 1882: // o_dsge_var: DSGE_VAR
#line 3574 "DynareBison.yy"
             { driver.option_str("dsge_var", "NaN"); }
#line 6856 "DynareBison.cc"
    break;

  case 1883: // o_dsge_varlag: DSGE_VARLAG EQUAL INT_NUMBER
#line 3576 "DynareBison.yy"
                                             { driver.option_num("dsge_varlag", yystack_[0].value.as < string > ()); }
#line 6862 "DynareBison.cc"
    break;

  case 1884: // o_tex: TEX
#line 3577 "DynareBison.yy"
            { driver.option_num("TeX", "true"); }
#line 6868 "DynareBison.cc"
    break;

  case 1885: // o_forecast: FORECAST EQUAL INT_NUMBER
#line 3578 "DynareBison.yy"
                                       { driver.option_num("forecast", yystack_[0].value.as < string > ()); }
#line 6874 "DynareBison.cc"
    break;

  case 1886: // o_smoother: SMOOTHER
#line 3579 "DynareBison.yy"
                      { driver.option_num("smoother", "true"); }
#line 6880 "DynareBison.cc"
    break;

  case 1887: // o_moments_varendo: MOMENTS_VARENDO
#line 3580 "DynareBison.yy"
                                    { driver.option_num("moments_varendo", "true"); }
#line 6886 "DynareBison.cc"
    break;

  case 1888: // o_contemporaneous_correlation: CONTEMPORANEOUS_CORRELATION
#line 3581 "DynareBison.yy"
                                                            { driver.option_num("contemporaneous_correlation", "true"); }
#line 6892 "DynareBison.cc"
    break;

  case 1889: // o_filtered_vars: FILTERED_VARS
#line 3582 "DynareBison.yy"
                                { driver.option_num("filtered_vars", "true"); }
#line 6898 "DynareBison.cc"
    break;

  case 1890: // o_relative_irf: RELATIVE_IRF
#line 3583 "DynareBison.yy"
                              { driver.option_num("relative_irf", "true"); }
#line 6904 "DynareBison.cc"
    break;

  case 1891: // o_fast_kalman_filter: FAST_KALMAN_FILTER
#line 3584 "DynareBison.yy"
                                           { driver.option_num("fast_kalman_filter", "true"); }
#line 6910 "DynareBison.cc"
    break;

  case 1892: // o_kalman_algo: KALMAN_ALGO EQUAL INT_NUMBER
#line 3585 "DynareBison.yy"
                                             { driver.option_num("kalman_algo", yystack_[0].value.as < string > ()); }
#line 6916 "DynareBison.cc"
    break;

  case 1893: // o_kalman_tol: KALMAN_TOL EQUAL non_negative_number
#line 3586 "DynareBison.yy"
                                                    { driver.option_num("kalman_tol", yystack_[0].value.as < string > ()); }
#line 6922 "DynareBison.cc"
    break;

  case 1894: // o_diffuse_kalman_tol: DIFFUSE_KALMAN_TOL EQUAL non_negative_number
#line 3587 "DynareBison.yy"
                                                                    { driver.option_num("diffuse_kalman_tol", yystack_[0].value.as < string > ()); }
#line 6928 "DynareBison.cc"
    break;

  case 1895: // o_schur_vec_tol: SCHUR_VEC_TOL EQUAL non_negative_number
#line 3588 "DynareBison.yy"
                                                          { driver.option_num("schur_vec_tol", yystack_[0].value.as < string > ()); }
#line 6934 "DynareBison.cc"
    break;

  case 1896: // o_marginal_density: MARGINAL_DENSITY EQUAL LAPLACE
#line 3590 "DynareBison.yy"
                     { driver.option_str("mc_marginal_density", "laplace"); }
#line 6940 "DynareBison.cc"
    break;

  case 1897: // o_marginal_density: MARGINAL_DENSITY EQUAL MODIFIEDHARMONICMEAN
#line 3592 "DynareBison.yy"
                     { driver.option_str("mc_marginal_density", "modifiedharmonicmean"); }
#line 6946 "DynareBison.cc"
    break;

  case 1898: // o_print: PRINT
#line 3594 "DynareBison.yy"
                { driver.option_num("noprint", "false"); }
#line 6952 "DynareBison.cc"
    break;

  case 1899: // o_noprint: NOPRINT
#line 3595 "DynareBison.yy"
                    { driver.option_num("noprint", "true"); }
#line 6958 "DynareBison.cc"
    break;

  case 1900: // o_xls_sheet: XLS_SHEET EQUAL symbol
#line 3596 "DynareBison.yy"
                                     { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 6964 "DynareBison.cc"
    break;

  case 1901: // o_xls_sheet: XLS_SHEET EQUAL QUOTED_STRING
#line 3597 "DynareBison.yy"
                                            { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 6970 "DynareBison.cc"
    break;

  case 1902: // o_xls_range: XLS_RANGE EQUAL range
#line 3599 "DynareBison.yy"
                                    { driver.option_str("xls_range", yystack_[0].value.as < string > ()); }
#line 6976 "DynareBison.cc"
    break;

  case 1903: // o_filter_step_ahead: FILTER_STEP_AHEAD EQUAL vec_int
#line 3600 "DynareBison.yy"
                                                      { driver.option_vec_int("filter_step_ahead", yystack_[0].value.as < vector<int> > ()); }
#line 6982 "DynareBison.cc"
    break;

  case 1904: // o_taper_steps: TAPER_STEPS EQUAL vec_int
#line 3601 "DynareBison.yy"
                                          { driver.option_vec_int("convergence.geweke.taper_steps", yystack_[0].value.as < vector<int> > ()); }
#line 6988 "DynareBison.cc"
    break;

  case 1905: // o_geweke_interval: GEWEKE_INTERVAL EQUAL vec_value
#line 3602 "DynareBison.yy"
                                                    { driver.option_num("convergence.geweke.geweke_interval",yystack_[0].value.as < string > ()); }
#line 6994 "DynareBison.cc"
    break;

  case 1906: // o_raftery_lewis_diagnostics: RAFTERY_LEWIS_DIAGNOSTICS
#line 3603 "DynareBison.yy"
                                                        { driver.option_num("convergence.rafterylewis.indicator", "true"); }
#line 7000 "DynareBison.cc"
    break;

  case 1907: // o_raftery_lewis_qrs: RAFTERY_LEWIS_QRS EQUAL vec_value
#line 3604 "DynareBison.yy"
                                                        { driver.option_num("convergence.rafterylewis.qrs",yystack_[0].value.as < string > ()); }
#line 7006 "DynareBison.cc"
    break;

  case 1908: // o_constant: CONSTANT
#line 3605 "DynareBison.yy"
                      { driver.option_num("noconstant", "false"); }
#line 7012 "DynareBison.cc"
    break;

  case 1909: // o_noconstant: NOCONSTANT
#line 3606 "DynareBison.yy"
                          { driver.option_num("noconstant", "true"); }
#line 7018 "DynareBison.cc"
    break;

  case 1910: // o_mh_recover: MH_RECOVER
#line 3607 "DynareBison.yy"
                          { driver.option_num("mh_recover", "true"); }
#line 7024 "DynareBison.cc"
    break;

  case 1911: // o_mh_initialize_from_previous_mcmc: MH_INITIALIZE_FROM_PREVIOUS_MCMC
#line 3608 "DynareBison.yy"
                                                                      { driver.option_num("mh_initialize_from_previous_mcmc.status", "true"); }
#line 7030 "DynareBison.cc"
    break;

  case 1912: // o_mh_initialize_from_previous_mcmc_directory: MH_INITIALIZE_FROM_PREVIOUS_MCMC_DIRECTORY EQUAL filename
#line 3609 "DynareBison.yy"
                                                                                                         { driver.option_str("mh_initialize_from_previous_mcmc.directory", yystack_[0].value.as < string > ()); }
#line 7036 "DynareBison.cc"
    break;

  case 1913: // o_mh_initialize_from_previous_mcmc_record: MH_INITIALIZE_FROM_PREVIOUS_MCMC_RECORD EQUAL filename
#line 3610 "DynareBison.yy"
                                                                                                   { driver.option_str("mh_initialize_from_previous_mcmc.record", yystack_[0].value.as < string > ()); }
#line 7042 "DynareBison.cc"
    break;

  case 1914: // o_mh_initialize_from_previous_mcmc_prior: MH_INITIALIZE_FROM_PREVIOUS_MCMC_PRIOR EQUAL filename
#line 3611 "DynareBison.yy"
                                                                                                 { driver.option_str("mh_initialize_from_previous_mcmc.prior", yystack_[0].value.as < string > ()); }
#line 7048 "DynareBison.cc"
    break;

  case 1915: // o_diffuse_filter: DIFFUSE_FILTER
#line 3612 "DynareBison.yy"
                                 {driver.option_num("diffuse_filter", "true"); }
#line 7054 "DynareBison.cc"
    break;

  case 1916: // o_plot_priors: PLOT_PRIORS EQUAL INT_NUMBER
#line 3613 "DynareBison.yy"
                                            {driver.option_num("plot_priors", yystack_[0].value.as < string > ()); }
#line 7060 "DynareBison.cc"
    break;

  case 1917: // o_aim_solver: AIM_SOLVER
#line 3614 "DynareBison.yy"
                         {driver.option_num("aim_solver", "true"); }
#line 7066 "DynareBison.cc"
    break;

  case 1918: // o_partial_information: PARTIAL_INFORMATION
#line 3615 "DynareBison.yy"
                                            {driver.option_num("partial_information", "true"); }
#line 7072 "DynareBison.cc"
    break;

  case 1919: // o_sub_draws: SUB_DRAWS EQUAL INT_NUMBER
#line 3616 "DynareBison.yy"
                                        {driver.option_num("sub_draws",yystack_[0].value.as < string > ());}
#line 7078 "DynareBison.cc"
    break;

  case 1920: // o_planner_discount: PLANNER_DISCOUNT EQUAL expression
#line 3617 "DynareBison.yy"
                                                       { driver.set_planner_discount(yystack_[0].value.as < expr_t > ()); }
#line 7084 "DynareBison.cc"
    break;

  case 1921: // o_planner_discount_latex_name: PLANNER_DISCOUNT_LATEX_NAME EQUAL TEX_NAME
#line 3618 "DynareBison.yy"
                                                                           { driver.set_planner_discount_latex_name(yystack_[0].value.as < string > ()); }
#line 7090 "DynareBison.cc"
    break;

  case 1922: // o_sylvester: SYLVESTER EQUAL FIXED_POINT
#line 3619 "DynareBison.yy"
                                          {driver.option_num("sylvester_fp", "true"); }
#line 7096 "DynareBison.cc"
    break;

  case 1923: // o_sylvester: SYLVESTER EQUAL DEFAULT
#line 3620 "DynareBison.yy"
                                         {driver.option_num("sylvester_fp", "false"); }
#line 7102 "DynareBison.cc"
    break;

  case 1924: // o_sylvester_fixed_point_tol: SYLVESTER_FIXED_POINT_TOL EQUAL non_negative_number
#line 3621 "DynareBison.yy"
                                                                                  {driver.option_num("sylvester_fixed_point_tol",yystack_[0].value.as < string > ());}
#line 7108 "DynareBison.cc"
    break;

  case 1925: // o_lyapunov: LYAPUNOV EQUAL FIXED_POINT
#line 3622 "DynareBison.yy"
                                        {driver.option_num("lyapunov_fp", "true"); }
#line 7114 "DynareBison.cc"
    break;

  case 1926: // o_lyapunov: LYAPUNOV EQUAL DOUBLING
#line 3623 "DynareBison.yy"
                                        {driver.option_num("lyapunov_db", "true"); }
#line 7120 "DynareBison.cc"
    break;

  case 1927: // o_lyapunov: LYAPUNOV EQUAL SQUARE_ROOT_SOLVER
#line 3624 "DynareBison.yy"
                                                  {driver.option_num("lyapunov_srs", "true"); }
#line 7126 "DynareBison.cc"
    break;

  case 1928: // o_lyapunov: LYAPUNOV EQUAL DEFAULT
#line 3625 "DynareBison.yy"
                                       {driver.option_num("lyapunov_fp", "false"); driver.option_num("lyapunov_db", "false"); driver.option_num("lyapunov_srs", "false");}
#line 7132 "DynareBison.cc"
    break;

  case 1929: // o_lyapunov_complex_threshold: LYAPUNOV_COMPLEX_THRESHOLD EQUAL non_negative_number
#line 3626 "DynareBison.yy"
                                                                                    {driver.option_num("lyapunov_complex_threshold",yystack_[0].value.as < string > ());}
#line 7138 "DynareBison.cc"
    break;

  case 1930: // o_lyapunov_fixed_point_tol: LYAPUNOV_FIXED_POINT_TOL EQUAL non_negative_number
#line 3627 "DynareBison.yy"
                                                                                {driver.option_num("lyapunov_fixed_point_tol",yystack_[0].value.as < string > ());}
#line 7144 "DynareBison.cc"
    break;

  case 1931: // o_lyapunov_doubling_tol: LYAPUNOV_DOUBLING_TOL EQUAL non_negative_number
#line 3628 "DynareBison.yy"
                                                                          {driver.option_num("lyapunov_doubling_tol",yystack_[0].value.as < string > ());}
#line 7150 "DynareBison.cc"
    break;

  case 1932: // o_dr: DR EQUAL CYCLE_REDUCTION
#line 3629 "DynareBison.yy"
                                {driver.option_num("dr_cycle_reduction", "true"); }
#line 7156 "DynareBison.cc"
    break;

  case 1933: // o_dr: DR EQUAL LOGARITHMIC_REDUCTION
#line 3630 "DynareBison.yy"
                                        {driver.option_num("dr_logarithmic_reduction", "true"); }
#line 7162 "DynareBison.cc"
    break;

  case 1934: // o_dr: DR EQUAL DEFAULT
#line 3631 "DynareBison.yy"
                          {driver.option_num("dr_cycle_reduction", "false"); driver.option_num("dr_logarithmic_reduction", "false");}
#line 7168 "DynareBison.cc"
    break;

  case 1935: // o_dr_cycle_reduction_tol: DR_CYCLE_REDUCTION_TOL EQUAL non_negative_number
#line 3632 "DynareBison.yy"
                                                                            {driver.option_num("dr_cycle_reduction_tol",yystack_[0].value.as < string > ());}
#line 7174 "DynareBison.cc"
    break;

  case 1936: // o_dr_logarithmic_reduction_tol: DR_LOGARITHMIC_REDUCTION_TOL EQUAL non_negative_number
#line 3633 "DynareBison.yy"
                                                                                        {driver.option_num("dr_logarithmic_reduction_tol",yystack_[0].value.as < string > ());}
#line 7180 "DynareBison.cc"
    break;

  case 1937: // o_dr_logarithmic_reduction_maxiter: DR_LOGARITHMIC_REDUCTION_MAXITER EQUAL INT_NUMBER
#line 3634 "DynareBison.yy"
                                                                                       {driver.option_num("dr_logarithmic_reduction_maxiter",yystack_[0].value.as < string > ());}
#line 7186 "DynareBison.cc"
    break;

  case 1938: // o_psd_detail_plot: DETAIL_PLOT
#line 3635 "DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.detail_plot", "true"); }
#line 7192 "DynareBison.cc"
    break;

  case 1939: // o_icd_detail_plot: DETAIL_PLOT
#line 3636 "DynareBison.yy"
                                { driver.option_num("initial_condition_decomp.detail_plot", "true"); }
#line 7198 "DynareBison.cc"
    break;

  case 1940: // o_psd_interactive: INTERACTIVE
#line 3637 "DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.interactive", "true"); }
#line 7204 "DynareBison.cc"
    break;

  case 1941: // o_psd_screen_shocks: SCREEN_SHOCKS
#line 3638 "DynareBison.yy"
                                    { driver.option_num("plot_shock_decomp.screen_shocks", "true"); }
#line 7210 "DynareBison.cc"
    break;

  case 1942: // o_psd_steadystate: STEADYSTATE
#line 3639 "DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.steadystate", "true"); }
#line 7216 "DynareBison.cc"
    break;

  case 1943: // o_icd_steadystate: STEADYSTATE
#line 3640 "DynareBison.yy"
                                { driver.option_num("initial_condition_decomp.steadystate", "true"); }
#line 7222 "DynareBison.cc"
    break;

  case 1944: // o_icd_fig_name: FIG_NAME EQUAL filename
#line 3641 "DynareBison.yy"
                                         { driver.option_str("initial_condition_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 7228 "DynareBison.cc"
    break;

  case 1945: // o_psd_fig_name: FIG_NAME EQUAL filename
#line 3642 "DynareBison.yy"
                                         { driver.option_str("plot_shock_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 7234 "DynareBison.cc"
    break;

  case 1946: // o_psd_type: TYPE EQUAL QOQ
#line 3644 "DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "qoq"); }
#line 7240 "DynareBison.cc"
    break;

  case 1947: // o_psd_type: TYPE EQUAL YOY
#line 3646 "DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "yoy"); }
#line 7246 "DynareBison.cc"
    break;

  case 1948: // o_psd_type: TYPE EQUAL AOA
#line 3648 "DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "aoa"); }
#line 7252 "DynareBison.cc"
    break;

  case 1949: // o_icd_type: TYPE EQUAL QOQ
#line 3651 "DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "qoq"); }
#line 7258 "DynareBison.cc"
    break;

  case 1950: // o_icd_type: TYPE EQUAL YOY
#line 3653 "DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "yoy"); }
#line 7264 "DynareBison.cc"
    break;

  case 1951: // o_icd_type: TYPE EQUAL AOA
#line 3655 "DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "aoa"); }
#line 7270 "DynareBison.cc"
    break;

  case 1952: // o_icd_plot_init_date: PLOT_INIT_DATE EQUAL date_expr
#line 3657 "DynareBison.yy"
                                                      { driver.option_date("initial_condition_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 7276 "DynareBison.cc"
    break;

  case 1953: // o_icd_plot_end_date: PLOT_END_DATE EQUAL date_expr
#line 3658 "DynareBison.yy"
                                                    { driver.option_date("initial_condition_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 7282 "DynareBison.cc"
    break;

  case 1954: // o_psd_plot_init_date: PLOT_INIT_DATE EQUAL date_expr
#line 3659 "DynareBison.yy"
                                                      { driver.option_date("plot_shock_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 7288 "DynareBison.cc"
    break;

  case 1955: // o_psd_plot_end_date: PLOT_END_DATE EQUAL date_expr
#line 3660 "DynareBison.yy"
                                                    { driver.option_date("plot_shock_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 7294 "DynareBison.cc"
    break;

  case 1956: // o_icd_write_xls: WRITE_XLS
#line 3661 "DynareBison.yy"
                            { driver.option_num("initial_condition_decomp.write_xls", "true"); }
#line 7300 "DynareBison.cc"
    break;

  case 1957: // o_psd_write_xls: WRITE_XLS
#line 3662 "DynareBison.yy"
                            { driver.option_num("plot_shock_decomp.write_xls", "true"); }
#line 7306 "DynareBison.cc"
    break;

  case 1958: // o_psd_realtime: REALTIME EQUAL INT_NUMBER
#line 3663 "DynareBison.yy"
                                           { driver.option_num("plot_shock_decomp.realtime", yystack_[0].value.as < string > ()); }
#line 7312 "DynareBison.cc"
    break;

  case 1959: // o_psd_vintage: VINTAGE EQUAL INT_NUMBER
#line 3664 "DynareBison.yy"
                                         { driver.option_num("plot_shock_decomp.vintage", yystack_[0].value.as < string > ()); }
#line 7318 "DynareBison.cc"
    break;

  case 1960: // o_psd_diff: DIFF
#line 3665 "DynareBison.yy"
                  { driver.option_num("plot_shock_decomp.diff", "true"); }
#line 7324 "DynareBison.cc"
    break;

  case 1961: // o_icd_diff: DIFF
#line 3666 "DynareBison.yy"
                  { driver.option_num("initial_condition_decomp.diff", "true"); }
#line 7330 "DynareBison.cc"
    break;

  case 1962: // o_psd_flip: FLIP
#line 3667 "DynareBison.yy"
                  { driver.option_num("plot_shock_decomp.flip", "true"); }
#line 7336 "DynareBison.cc"
    break;

  case 1963: // o_icd_flip: FLIP
#line 3668 "DynareBison.yy"
                  { driver.option_num("initial_condition_decomp.flip", "true"); }
#line 7342 "DynareBison.cc"
    break;

  case 1964: // o_bvar_prior_tau: BVAR_PRIOR_TAU EQUAL signed_number
#line 3669 "DynareBison.yy"
                                                      { driver.option_num("bvar_prior_tau", yystack_[0].value.as < string > ()); }
#line 7348 "DynareBison.cc"
    break;

  case 1965: // o_bvar_prior_decay: BVAR_PRIOR_DECAY EQUAL non_negative_number
#line 3670 "DynareBison.yy"
                                                                { driver.option_num("bvar_prior_decay", yystack_[0].value.as < string > ()); }
#line 7354 "DynareBison.cc"
    break;

  case 1966: // o_bvar_prior_lambda: BVAR_PRIOR_LAMBDA EQUAL signed_number
#line 3671 "DynareBison.yy"
                                                            { driver.option_num("bvar_prior_lambda", yystack_[0].value.as < string > ()); }
#line 7360 "DynareBison.cc"
    break;

  case 1967: // o_bvar_prior_mu: BVAR_PRIOR_MU EQUAL non_negative_number
#line 3672 "DynareBison.yy"
                                                          { driver.option_num("bvar_prior_mu", yystack_[0].value.as < string > ()); }
#line 7366 "DynareBison.cc"
    break;

  case 1968: // o_bvar_prior_omega: BVAR_PRIOR_OMEGA EQUAL INT_NUMBER
#line 3673 "DynareBison.yy"
                                                       { driver.option_num("bvar_prior_omega", yystack_[0].value.as < string > ()); }
#line 7372 "DynareBison.cc"
    break;

  case 1969: // o_bvar_prior_flat: BVAR_PRIOR_FLAT
#line 3674 "DynareBison.yy"
                                    { driver.option_num("bvar_prior_flat", "true"); }
#line 7378 "DynareBison.cc"
    break;

  case 1970: // o_bvar_prior_train: BVAR_PRIOR_TRAIN EQUAL INT_NUMBER
#line 3675 "DynareBison.yy"
                                                       { driver.option_num("bvar_prior_train", yystack_[0].value.as < string > ()); }
#line 7384 "DynareBison.cc"
    break;

  case 1971: // o_bvar_replic: BVAR_REPLIC EQUAL INT_NUMBER
#line 3676 "DynareBison.yy"
                                             { driver.option_num("bvar_replic", yystack_[0].value.as < string > ()); }
#line 7390 "DynareBison.cc"
    break;

  case 1972: // o_stderr_multiples: STDERR_MULTIPLES
#line 3677 "DynareBison.yy"
                                      { driver.option_num("irf_opt.stderr_multiples", "true"); }
#line 7396 "DynareBison.cc"
    break;

  case 1973: // o_diagonal_only: DIAGONAL_ONLY
#line 3678 "DynareBison.yy"
                                { driver.option_num("irf_opt.diagonal_only", "true"); }
#line 7402 "DynareBison.cc"
    break;

  case 1974: // o_number_of_particles: NUMBER_OF_PARTICLES EQUAL INT_NUMBER
#line 3679 "DynareBison.yy"
                                                             { driver.option_num("particle.number_of_particles", yystack_[0].value.as < string > ()); }
#line 7408 "DynareBison.cc"
    break;

  case 1975: // o_particle_filter_options: PARTICLE_FILTER_OPTIONS EQUAL '(' name_value_pair_with_boolean_list ')'
#line 3680 "DynareBison.yy"
                                                                                                    { driver.option_str("particle.particle_filter_options", yystack_[1].value.as < string > ()); }
#line 7414 "DynareBison.cc"
    break;

  case 1977: // o_resampling: RESAMPLING EQUAL NONE
#line 3682 "DynareBison.yy"
                                      {driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.none", "true"); }
#line 7420 "DynareBison.cc"
    break;

  case 1978: // o_resampling: RESAMPLING EQUAL GENERIC
#line 3683 "DynareBison.yy"
                                         {driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.generic", "true"); }
#line 7426 "DynareBison.cc"
    break;

  case 1979: // o_resampling_threshold: RESAMPLING_THRESHOLD EQUAL non_negative_number
#line 3684 "DynareBison.yy"
                                                                        { driver.option_num("particle.resampling.threshold", yystack_[0].value.as < string > ()); }
#line 7432 "DynareBison.cc"
    break;

  case 1980: // o_resampling_method: RESAMPLING_METHOD EQUAL KITAGAWA
#line 3685 "DynareBison.yy"
                                                       {driver.option_num("particle.resampling.method.kitagawa", "true"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 7438 "DynareBison.cc"
    break;

  case 1981: // o_resampling_method: RESAMPLING_METHOD EQUAL SMOOTH
#line 3686 "DynareBison.yy"
                                               {driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "true"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 7444 "DynareBison.cc"
    break;

  case 1982: // o_resampling_method: RESAMPLING_METHOD EQUAL STRATIFIED
#line 3687 "DynareBison.yy"
                                                   {driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.method.stratified", "true"); }
#line 7450 "DynareBison.cc"
    break;

  case 1983: // o_cpf_weights: CPF_WEIGHTS EQUAL AMISANOTRISTANI
#line 3688 "DynareBison.yy"
                                                  {driver.option_num("particle.cpf_weights_method.amisanotristani", "true"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "false"); }
#line 7456 "DynareBison.cc"
    break;

  case 1984: // o_cpf_weights: CPF_WEIGHTS EQUAL MURRAYJONESPARSLOW
#line 3689 "DynareBison.yy"
                                                     {driver.option_num("particle.cpf_weights_method.amisanotristani", "false"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "true"); }
#line 7462 "DynareBison.cc"
    break;

  case 1985: // o_filter_algorithm: FILTER_ALGORITHM EQUAL symbol
#line 3690 "DynareBison.yy"
                                                   { driver.option_str("particle.filter_algorithm", yystack_[0].value.as < string > ()); }
#line 7468 "DynareBison.cc"
    break;

  case 1986: // o_nonlinear_filter_initialization: NONLINEAR_FILTER_INITIALIZATION EQUAL INT_NUMBER
#line 3691 "DynareBison.yy"
                                                                                     { driver.option_num("particle.initialization", yystack_[0].value.as < string > ()); }
#line 7474 "DynareBison.cc"
    break;

  case 1987: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL CUBATURE
#line 3692 "DynareBison.yy"
                                                                 {driver.option_num("particle.proposal_approximation.cubature", "true"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "false");}
#line 7480 "DynareBison.cc"
    break;

  case 1988: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL UNSCENTED
#line 3693 "DynareBison.yy"
                                                         {driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "true"); driver.option_num("particle.proposal_approximation.montecarlo", "false");}
#line 7486 "DynareBison.cc"
    break;

  case 1989: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL MONTECARLO
#line 3694 "DynareBison.yy"
                                                          {driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "true");}
#line 7492 "DynareBison.cc"
    break;

  case 1990: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL CUBATURE
#line 3695 "DynareBison.yy"
                                                                         {driver.option_num("particle.distribution_approximation.cubature", "true"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "false");}
#line 7498 "DynareBison.cc"
    break;

  case 1991: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL UNSCENTED
#line 3696 "DynareBison.yy"
                                                             {driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "true"); driver.option_num("particle.distribution_approximation.montecarlo", "false");}
#line 7504 "DynareBison.cc"
    break;

  case 1992: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL MONTECARLO
#line 3697 "DynareBison.yy"
                                                              {driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "true");}
#line 7510 "DynareBison.cc"
    break;

  case 1993: // o_gsa_identification: IDENTIFICATION EQUAL INT_NUMBER
#line 3698 "DynareBison.yy"
                                                       { driver.option_num("identification", yystack_[0].value.as < string > ()); }
#line 7516 "DynareBison.cc"
    break;

  case 1994: // o_gsa_morris: MORRIS EQUAL INT_NUMBER
#line 3699 "DynareBison.yy"
                                       { driver.option_num("morris", yystack_[0].value.as < string > ()); }
#line 7522 "DynareBison.cc"
    break;

  case 1995: // o_gsa_stab: STAB EQUAL INT_NUMBER
#line 3700 "DynareBison.yy"
                                    { driver.option_num("stab", yystack_[0].value.as < string > ()); }
#line 7528 "DynareBison.cc"
    break;

  case 1996: // o_gsa_redform: REDFORM EQUAL INT_NUMBER
#line 3701 "DynareBison.yy"
                                          { driver.option_num("redform", yystack_[0].value.as < string > ()); }
#line 7534 "DynareBison.cc"
    break;

  case 1997: // o_gsa_pprior: PPRIOR EQUAL INT_NUMBER
#line 3702 "DynareBison.yy"
                                        { driver.option_num("pprior", yystack_[0].value.as < string > ()); }
#line 7540 "DynareBison.cc"
    break;

  case 1998: // o_gsa_prior_range: PRIOR_RANGE EQUAL INT_NUMBER
#line 3703 "DynareBison.yy"
                                                  { driver.option_num("prior_range", yystack_[0].value.as < string > ()); }
#line 7546 "DynareBison.cc"
    break;

  case 1999: // o_gsa_ppost: PPOST EQUAL INT_NUMBER
#line 3704 "DynareBison.yy"
                                      { driver.option_num("ppost", yystack_[0].value.as < string > ()); }
#line 7552 "DynareBison.cc"
    break;

  case 2000: // o_gsa_ilptau: ILPTAU EQUAL INT_NUMBER
#line 3705 "DynareBison.yy"
                                       { driver.option_num("ilptau", yystack_[0].value.as < string > ()); }
#line 7558 "DynareBison.cc"
    break;

  case 2001: // o_gsa_morris_nliv: MORRIS_NLIV EQUAL INT_NUMBER
#line 3706 "DynareBison.yy"
                                                 { driver.option_num("morris_nliv", yystack_[0].value.as < string > ()); }
#line 7564 "DynareBison.cc"
    break;

  case 2002: // o_gsa_morris_ntra: MORRIS_NTRA EQUAL INT_NUMBER
#line 3707 "DynareBison.yy"
                                                 { driver.option_num("morris_ntra", yystack_[0].value.as < string > ()); }
#line 7570 "DynareBison.cc"
    break;

  case 2003: // o_gsa_nsam: NSAM EQUAL INT_NUMBER
#line 3708 "DynareBison.yy"
                                   { driver.option_num("Nsam", yystack_[0].value.as < string > ()); }
#line 7576 "DynareBison.cc"
    break;

  case 2004: // o_gsa_load_redform: LOAD_REDFORM EQUAL INT_NUMBER
#line 3709 "DynareBison.yy"
                                                   { driver.option_num("load_redform", yystack_[0].value.as < string > ()); }
#line 7582 "DynareBison.cc"
    break;

  case 2005: // o_gsa_load_rmse: LOAD_RMSE EQUAL INT_NUMBER
#line 3710 "DynareBison.yy"
                                             { driver.option_num("load_rmse", yystack_[0].value.as < string > ()); }
#line 7588 "DynareBison.cc"
    break;

  case 2006: // o_gsa_load_stab: LOAD_STAB EQUAL INT_NUMBER
#line 3711 "DynareBison.yy"
                                             { driver.option_num("load_stab", yystack_[0].value.as < string > ()); }
#line 7594 "DynareBison.cc"
    break;

  case 2007: // o_gsa_alpha2_stab: ALPHA2_STAB EQUAL non_negative_number
#line 3712 "DynareBison.yy"
                                                          { driver.option_num("alpha2_stab", yystack_[0].value.as < string > ()); }
#line 7600 "DynareBison.cc"
    break;

  case 2008: // o_gsa_logtrans_redform: LOGTRANS_REDFORM EQUAL INT_NUMBER
#line 3713 "DynareBison.yy"
                                                           { driver.option_num("logtrans_redform", yystack_[0].value.as < string > ()); }
#line 7606 "DynareBison.cc"
    break;

  case 2009: // o_gsa_threshold_redform: THRESHOLD_REDFORM EQUAL vec_value_w_inf
#line 3714 "DynareBison.yy"
                                                                  { driver.option_num("threshold_redform",yystack_[0].value.as < string > ()); }
#line 7612 "DynareBison.cc"
    break;

  case 2010: // o_gsa_ksstat_redform: KSSTAT_REDFORM EQUAL non_negative_number
#line 3715 "DynareBison.yy"
                                                                { driver.option_num("ksstat_redform", yystack_[0].value.as < string > ()); }
#line 7618 "DynareBison.cc"
    break;

  case 2011: // o_gsa_alpha2_redform: ALPHA2_REDFORM EQUAL non_negative_number
#line 3716 "DynareBison.yy"
                                                                { driver.option_num("alpha2_redform", yystack_[0].value.as < string > ()); }
#line 7624 "DynareBison.cc"
    break;

  case 2012: // o_gsa_namendo: NAMENDO EQUAL '(' symbol_list_ext ')'
#line 3717 "DynareBison.yy"
                                                      { driver.option_symbol_list("namendo"); }
#line 7630 "DynareBison.cc"
    break;

  case 2013: // o_gsa_namlagendo: NAMLAGENDO EQUAL '(' symbol_list_ext ')'
#line 3718 "DynareBison.yy"
                                                            { driver.option_symbol_list("namlagendo"); }
#line 7636 "DynareBison.cc"
    break;

  case 2014: // o_gsa_namexo: NAMEXO EQUAL '(' symbol_list_ext ')'
#line 3719 "DynareBison.yy"
                                                    { driver.option_symbol_list("namexo"); }
#line 7642 "DynareBison.cc"
    break;

  case 2015: // o_gsa_rmse: RMSE EQUAL INT_NUMBER
#line 3720 "DynareBison.yy"
                                   { driver.option_num("rmse", yystack_[0].value.as < string > ()); }
#line 7648 "DynareBison.cc"
    break;

  case 2016: // o_gsa_lik_only: LIK_ONLY EQUAL INT_NUMBER
#line 3721 "DynareBison.yy"
                                           { driver.option_num("lik_only", yystack_[0].value.as < string > ()); }
#line 7654 "DynareBison.cc"
    break;

  case 2017: // o_gsa_var_rmse: VAR_RMSE EQUAL '(' symbol_list_ext ')'
#line 3722 "DynareBison.yy"
                                                        { driver.option_symbol_list("var_rmse"); }
#line 7660 "DynareBison.cc"
    break;

  case 2018: // o_gsa_pfilt_rmse: PFILT_RMSE EQUAL non_negative_number
#line 3723 "DynareBison.yy"
                                                        { driver.option_num("pfilt_rmse", yystack_[0].value.as < string > ()); }
#line 7666 "DynareBison.cc"
    break;

  case 2019: // o_gsa_istart_rmse: ISTART_RMSE EQUAL INT_NUMBER
#line 3724 "DynareBison.yy"
                                                 { driver.option_num("istart_rmse", yystack_[0].value.as < string > ()); }
#line 7672 "DynareBison.cc"
    break;

  case 2020: // o_gsa_alpha_rmse: ALPHA_RMSE EQUAL non_negative_number
#line 3725 "DynareBison.yy"
                                                        { driver.option_num("alpha_rmse", yystack_[0].value.as < string > ()); }
#line 7678 "DynareBison.cc"
    break;

  case 2021: // o_gsa_alpha2_rmse: ALPHA2_RMSE EQUAL non_negative_number
#line 3726 "DynareBison.yy"
                                                          { driver.option_num("alpha2_rmse", yystack_[0].value.as < string > ()); }
#line 7684 "DynareBison.cc"
    break;

  case 2022: // o_gsa_sample_file: GSA_SAMPLE_FILE EQUAL INT_NUMBER
#line 3728 "DynareBison.yy"
                    { driver.option_num("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 7690 "DynareBison.cc"
    break;

  case 2023: // o_gsa_sample_file: GSA_SAMPLE_FILE EQUAL filename
#line 3730 "DynareBison.yy"
                    { driver.option_str("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 7696 "DynareBison.cc"
    break;

  case 2024: // o_gsa_neighborhood_width: NEIGHBORHOOD_WIDTH EQUAL non_negative_number
#line 3732 "DynareBison.yy"
                                                                        { driver.option_num("neighborhood_width", yystack_[0].value.as < string > ()); }
#line 7702 "DynareBison.cc"
    break;

  case 2025: // o_gsa_pvalue_ks: PVALUE_KS EQUAL non_negative_number
#line 3733 "DynareBison.yy"
                                                       { driver.option_num("pvalue_ks", yystack_[0].value.as < string > ()); }
#line 7708 "DynareBison.cc"
    break;

  case 2026: // o_gsa_pvalue_corr: PVALUE_CORR EQUAL non_negative_number
#line 3734 "DynareBison.yy"
                                                           { driver.option_num("pvalue_corr", yystack_[0].value.as < string > ()); }
#line 7714 "DynareBison.cc"
    break;

  case 2027: // o_load_ident_files: LOAD_IDENT_FILES EQUAL INT_NUMBER
#line 3735 "DynareBison.yy"
                                                       { driver.option_num("load_ident_files", yystack_[0].value.as < string > ()); }
#line 7720 "DynareBison.cc"
    break;

  case 2028: // o_useautocorr: USEAUTOCORR EQUAL INT_NUMBER
#line 3736 "DynareBison.yy"
                                             { driver.option_num("useautocorr", yystack_[0].value.as < string > ()); }
#line 7726 "DynareBison.cc"
    break;

  case 2029: // o_prior_mc: PRIOR_MC EQUAL INT_NUMBER
#line 3737 "DynareBison.yy"
                                       { driver.option_num("prior_mc", yystack_[0].value.as < string > ()); }
#line 7732 "DynareBison.cc"
    break;

  case 2030: // o_advanced: ADVANCED EQUAL signed_integer
#line 3738 "DynareBison.yy"
                                           { driver.option_num("advanced", yystack_[0].value.as < string > ()); }
#line 7738 "DynareBison.cc"
    break;

  case 2031: // o_max_dim_cova_group: MAX_DIM_COVA_GROUP EQUAL INT_NUMBER
#line 3739 "DynareBison.yy"
                                                           { driver.option_num("max_dim_cova_group", yystack_[0].value.as < string > ()); }
#line 7744 "DynareBison.cc"
    break;

  case 2032: // o_homotopy_mode: HOMOTOPY_MODE EQUAL INT_NUMBER
#line 3741 "DynareBison.yy"
                                                 {driver.option_num("homotopy_mode",yystack_[0].value.as < string > ()); }
#line 7750 "DynareBison.cc"
    break;

  case 2033: // o_homotopy_steps: HOMOTOPY_STEPS EQUAL INT_NUMBER
#line 3742 "DynareBison.yy"
                                                   {driver.option_num("homotopy_steps",yystack_[0].value.as < string > ()); }
#line 7756 "DynareBison.cc"
    break;

  case 2034: // o_homotopy_force_continue: HOMOTOPY_FORCE_CONTINUE EQUAL INT_NUMBER
#line 3743 "DynareBison.yy"
                                                                    { driver.option_num("homotopy_force_continue",yystack_[0].value.as < string > ()); }
#line 7762 "DynareBison.cc"
    break;

  case 2035: // o_nocheck: NOCHECK
#line 3744 "DynareBison.yy"
                    {driver.option_num("steadystate.nocheck","true"); }
#line 7768 "DynareBison.cc"
    break;

  case 2036: // o_controlled_varexo: CONTROLLED_VAREXO EQUAL '(' symbol_list ')'
#line 3746 "DynareBison.yy"
                                                                  { driver.option_symbol_list("controlled_varexo"); }
#line 7774 "DynareBison.cc"
    break;

  case 2037: // o_parameter_set: PARAMETER_SET EQUAL PRIOR_MODE
#line 3748 "DynareBison.yy"
                  { driver.option_str("parameter_set", "prior_mode"); }
#line 7780 "DynareBison.cc"
    break;

  case 2038: // o_parameter_set: PARAMETER_SET EQUAL PRIOR_MEAN
#line 3750 "DynareBison.yy"
                  { driver.option_str("parameter_set", "prior_mean"); }
#line 7786 "DynareBison.cc"
    break;

  case 2039: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MEAN
#line 3752 "DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_mean"); }
#line 7792 "DynareBison.cc"
    break;

  case 2040: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MODE
#line 3754 "DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_mode"); }
#line 7798 "DynareBison.cc"
    break;

  case 2041: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MEDIAN
#line 3756 "DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_median"); }
#line 7804 "DynareBison.cc"
    break;

  case 2042: // o_parameter_set: PARAMETER_SET EQUAL MLE_MODE
#line 3758 "DynareBison.yy"
                  { driver.option_str("parameter_set", "mle_mode"); }
#line 7810 "DynareBison.cc"
    break;

  case 2043: // o_parameter_set: PARAMETER_SET EQUAL CALIBRATION
#line 3760 "DynareBison.yy"
                  { driver.option_str("parameter_set", "calibration"); }
#line 7816 "DynareBison.cc"
    break;

  case 2044: // o_nodecomposition: NODECOMPOSITION
#line 3762 "DynareBison.yy"
                                    { driver.option_num("nodecomposition", "true"); }
#line 7822 "DynareBison.cc"
    break;

  case 2045: // o_spectral_density: SPECTRAL_DENSITY
#line 3763 "DynareBison.yy"
                                      { driver.option_num("SpectralDensity.trigger", "true"); }
#line 7828 "DynareBison.cc"
    break;

  case 2046: // o_ms_drop: DROP EQUAL INT_NUMBER
#line 3764 "DynareBison.yy"
                                  { driver.option_num("ms.drop", yystack_[0].value.as < string > ()); }
#line 7834 "DynareBison.cc"
    break;

  case 2047: // o_ms_mh_replic: MH_REPLIC EQUAL INT_NUMBER
#line 3765 "DynareBison.yy"
                                            { driver.option_num("ms.mh_replic", yystack_[0].value.as < string > ()); }
#line 7840 "DynareBison.cc"
    break;

  case 2048: // o_freq: FREQ EQUAL INT_NUMBER
#line 3767 "DynareBison.yy"
         { driver.option_num("ms.freq",yystack_[0].value.as < string > ()); }
#line 7846 "DynareBison.cc"
    break;

  case 2049: // o_freq: FREQ EQUAL MONTHLY
#line 3769 "DynareBison.yy"
         { driver.option_num("ms.freq","12"); }
#line 7852 "DynareBison.cc"
    break;

  case 2050: // o_freq: FREQ EQUAL QUARTERLY
#line 3771 "DynareBison.yy"
         { driver.option_num("ms.freq","4"); }
#line 7858 "DynareBison.cc"
    break;

  case 2051: // o_initial_year: INITIAL_YEAR EQUAL INT_NUMBER
#line 3773 "DynareBison.yy"
                                               {driver.option_num("ms.initial_year",yystack_[0].value.as < string > ()); }
#line 7864 "DynareBison.cc"
    break;

  case 2052: // o_initial_subperiod: INITIAL_SUBPERIOD EQUAL INT_NUMBER
#line 3774 "DynareBison.yy"
                                                         {driver.option_num("ms.initial_subperiod",yystack_[0].value.as < string > ()); }
#line 7870 "DynareBison.cc"
    break;

  case 2053: // o_final_year: FINAL_YEAR EQUAL INT_NUMBER
#line 3775 "DynareBison.yy"
                                           {driver.option_num("ms.final_year",yystack_[0].value.as < string > ()); }
#line 7876 "DynareBison.cc"
    break;

  case 2054: // o_final_subperiod: FINAL_SUBPERIOD EQUAL INT_NUMBER
#line 3776 "DynareBison.yy"
                                                     {driver.option_num("ms.final_subperiod",yystack_[0].value.as < string > ()); }
#line 7882 "DynareBison.cc"
    break;

  case 2055: // o_data: DATA EQUAL filename
#line 3777 "DynareBison.yy"
                             { driver.option_str("ms.data", yystack_[0].value.as < string > ()); }
#line 7888 "DynareBison.cc"
    break;

  case 2056: // o_vlist: VLIST EQUAL INT_NUMBER
#line 3778 "DynareBison.yy"
                                 {driver.option_num("ms.vlist",yystack_[0].value.as < string > ()); }
#line 7894 "DynareBison.cc"
    break;

  case 2057: // o_vlistlog: VLISTLOG EQUAL '(' symbol_list ')'
#line 3779 "DynareBison.yy"
                                                {driver.option_symbol_list("ms.vlistlog"); }
#line 7900 "DynareBison.cc"
    break;

  case 2058: // o_vlistper: VLISTPER EQUAL INT_NUMBER
#line 3780 "DynareBison.yy"
                                       {driver.option_num("ms.vlistper",yystack_[0].value.as < string > ()); }
#line 7906 "DynareBison.cc"
    break;

  case 2059: // o_restriction_fname: RESTRICTION_FNAME EQUAL NAME
#line 3782 "DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname",yystack_[0].value.as < string > ());
                      }
#line 7915 "DynareBison.cc"
    break;

  case 2060: // o_restriction_fname: RESTRICTION_FNAME EQUAL UPPER_CHOLESKY
#line 3787 "DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","upper_cholesky");
                      }
#line 7924 "DynareBison.cc"
    break;

  case 2061: // o_restriction_fname: RESTRICTION_FNAME EQUAL LOWER_CHOLESKY
#line 3792 "DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","lower_cholesky");
                      }
#line 7933 "DynareBison.cc"
    break;

  case 2062: // o_nlags: NLAGS EQUAL INT_NUMBER
#line 3797 "DynareBison.yy"
                                 {driver.option_num("ms.nlags",yystack_[0].value.as < string > ()); }
#line 7939 "DynareBison.cc"
    break;

  case 2063: // o_cross_restrictions: CROSS_RESTRICTIONS
#line 3798 "DynareBison.yy"
                                          {driver.option_num("ms.cross_restrictions","true"); }
#line 7945 "DynareBison.cc"
    break;

  case 2064: // o_contemp_reduced_form: CONTEMP_REDUCED_FORM
#line 3799 "DynareBison.yy"
                                              {driver.option_num("ms.contemp_reduced_form","true"); }
#line 7951 "DynareBison.cc"
    break;

  case 2065: // o_real_pseudo_forecast: REAL_PSEUDO_FORECAST EQUAL INT_NUMBER
#line 3800 "DynareBison.yy"
                                                               {driver.option_num("ms.real_pseudo_forecast",yystack_[0].value.as < string > ()); }
#line 7957 "DynareBison.cc"
    break;

  case 2066: // o_no_bayesian_prior: NO_BAYESIAN_PRIOR
#line 3801 "DynareBison.yy"
                                        {driver.option_num("ms.bayesian_prior","false"); }
#line 7963 "DynareBison.cc"
    break;

  case 2067: // o_dummy_obs: DUMMY_OBS EQUAL INT_NUMBER
#line 3802 "DynareBison.yy"
                                         {driver.option_num("ms.dummy_obs",yystack_[0].value.as < string > ()); }
#line 7969 "DynareBison.cc"
    break;

  case 2068: // o_nstates: NSTATES EQUAL INT_NUMBER
#line 3803 "DynareBison.yy"
                                     {driver.option_num("ms.nstates",yystack_[0].value.as < string > ()); }
#line 7975 "DynareBison.cc"
    break;

  case 2069: // o_indxscalesstates: INDXSCALESSTATES EQUAL INT_NUMBER
#line 3804 "DynareBison.yy"
                                                       {driver.option_num("ms.indxscalesstates",yystack_[0].value.as < string > ()); }
#line 7981 "DynareBison.cc"
    break;

  case 2070: // o_alpha: ALPHA EQUAL non_negative_number
#line 3805 "DynareBison.yy"
                                          {driver.option_num("ms.alpha",yystack_[0].value.as < string > ()); }
#line 7987 "DynareBison.cc"
    break;

  case 2071: // o_beta: BETA EQUAL non_negative_number
#line 3806 "DynareBison.yy"
                                        {driver.option_num("ms.beta",yystack_[0].value.as < string > ()); }
#line 7993 "DynareBison.cc"
    break;

  case 2072: // o_gsig2_lmdm: GSIG2_LMDM EQUAL INT_NUMBER
#line 3807 "DynareBison.yy"
                                           {driver.option_num("ms.gsig2_lmdm",yystack_[0].value.as < string > ()); }
#line 7999 "DynareBison.cc"
    break;

  case 2073: // o_specification: SPECIFICATION EQUAL SIMS_ZHA
#line 3809 "DynareBison.yy"
                  {driver.option_num("ms.specification","1"); }
#line 8005 "DynareBison.cc"
    break;

  case 2074: // o_specification: SPECIFICATION EQUAL NONE
#line 3811 "DynareBison.yy"
                  {driver.option_num("ms.specification","0"); }
#line 8011 "DynareBison.cc"
    break;

  case 2075: // o_q_diag: Q_DIAG EQUAL non_negative_number
#line 3813 "DynareBison.yy"
                                            {driver.option_num("ms.q_diag",yystack_[0].value.as < string > ()); }
#line 8017 "DynareBison.cc"
    break;

  case 2076: // o_flat_prior: FLAT_PRIOR EQUAL INT_NUMBER
#line 3814 "DynareBison.yy"
                                           {driver.option_num("ms.flat_prior",yystack_[0].value.as < string > ()); }
#line 8023 "DynareBison.cc"
    break;

  case 2077: // o_ncsk: NCSK EQUAL INT_NUMBER
#line 3815 "DynareBison.yy"
                               {driver.option_num("ms.ncsk",yystack_[0].value.as < string > ()); }
#line 8029 "DynareBison.cc"
    break;

  case 2078: // o_nstd: NSTD EQUAL INT_NUMBER
#line 3816 "DynareBison.yy"
                               {driver.option_num("ms.nstd",yystack_[0].value.as < string > ()); }
#line 8035 "DynareBison.cc"
    break;

  case 2079: // o_ninv: NINV EQUAL INT_NUMBER
#line 3817 "DynareBison.yy"
                               {driver.option_num("ms.ninv",yystack_[0].value.as < string > ()); }
#line 8041 "DynareBison.cc"
    break;

  case 2080: // o_indxparr: INDXPARR EQUAL INT_NUMBER
#line 3818 "DynareBison.yy"
                                       {driver.option_num("ms.indxparr",yystack_[0].value.as < string > ()); }
#line 8047 "DynareBison.cc"
    break;

  case 2081: // o_indxovr: INDXOVR EQUAL INT_NUMBER
#line 3819 "DynareBison.yy"
                                     {driver.option_num("ms.indxovr",yystack_[0].value.as < string > ()); }
#line 8053 "DynareBison.cc"
    break;

  case 2082: // o_aband: ABAND EQUAL INT_NUMBER
#line 3820 "DynareBison.yy"
                                 {driver.option_num("ms.aband",yystack_[0].value.as < string > ()); }
#line 8059 "DynareBison.cc"
    break;

  case 2083: // o_indxap: INDXAP EQUAL INT_NUMBER
#line 3821 "DynareBison.yy"
                                   {driver.option_num("ms.indxap",yystack_[0].value.as < string > ()); }
#line 8065 "DynareBison.cc"
    break;

  case 2084: // o_apband: APBAND EQUAL INT_NUMBER
#line 3822 "DynareBison.yy"
                                   {driver.option_num("ms.apband",yystack_[0].value.as < string > ()); }
#line 8071 "DynareBison.cc"
    break;

  case 2085: // o_indximf: INDXIMF EQUAL INT_NUMBER
#line 3823 "DynareBison.yy"
                                     {driver.option_num("ms.indximf",yystack_[0].value.as < string > ()); }
#line 8077 "DynareBison.cc"
    break;

  case 2086: // o_indxfore: INDXFORE EQUAL INT_NUMBER
#line 3824 "DynareBison.yy"
                                       {driver.option_num("ms.indxfore",yystack_[0].value.as < string > ()); }
#line 8083 "DynareBison.cc"
    break;

  case 2087: // o_foreband: FOREBAND EQUAL INT_NUMBER
#line 3825 "DynareBison.yy"
                                       {driver.option_num("ms.foreband",yystack_[0].value.as < string > ()); }
#line 8089 "DynareBison.cc"
    break;

  case 2088: // o_indxgforhat: INDXGFOREHAT EQUAL INT_NUMBER
#line 3826 "DynareBison.yy"
                                              {driver.option_num("ms.indxgforehat",yystack_[0].value.as < string > ()); }
#line 8095 "DynareBison.cc"
    break;

  case 2089: // o_indxgimfhat: INDXGIMFHAT EQUAL INT_NUMBER
#line 3827 "DynareBison.yy"
                                             {driver.option_num("ms.indxgimfhat",yystack_[0].value.as < string > ()); }
#line 8101 "DynareBison.cc"
    break;

  case 2090: // o_indxestima: INDXESTIMA EQUAL INT_NUMBER
#line 3828 "DynareBison.yy"
                                           {driver.option_num("ms.indxestima",yystack_[0].value.as < string > ()); }
#line 8107 "DynareBison.cc"
    break;

  case 2091: // o_indxgdls: INDXGDLS EQUAL INT_NUMBER
#line 3829 "DynareBison.yy"
                                       {driver.option_num("ms.indxgdls",yystack_[0].value.as < string > ()); }
#line 8113 "DynareBison.cc"
    break;

  case 2092: // o_eq_ms: EQ_MS EQUAL INT_NUMBER
#line 3830 "DynareBison.yy"
                                 {driver.option_num("ms.eq_ms",yystack_[0].value.as < string > ()); }
#line 8119 "DynareBison.cc"
    break;

  case 2093: // o_cms: CMS EQUAL INT_NUMBER
#line 3831 "DynareBison.yy"
                             {driver.option_num("ms.cms",yystack_[0].value.as < string > ()); }
#line 8125 "DynareBison.cc"
    break;

  case 2094: // o_ncms: NCMS EQUAL INT_NUMBER
#line 3832 "DynareBison.yy"
                               {driver.option_num("ms.ncms",yystack_[0].value.as < string > ()); }
#line 8131 "DynareBison.cc"
    break;

  case 2095: // o_eq_cms: EQ_CMS EQUAL INT_NUMBER
#line 3833 "DynareBison.yy"
                                   {driver.option_num("ms.eq_cms",yystack_[0].value.as < string > ()); }
#line 8137 "DynareBison.cc"
    break;

  case 2096: // o_tlindx: TLINDX EQUAL INT_NUMBER
#line 3834 "DynareBison.yy"
                                   {driver.option_num("ms.tlindx",yystack_[0].value.as < string > ()); }
#line 8143 "DynareBison.cc"
    break;

  case 2097: // o_tlnumber: TLNUMBER EQUAL INT_NUMBER
#line 3835 "DynareBison.yy"
                                       {driver.option_num("ms.tlnumber",yystack_[0].value.as < string > ()); }
#line 8149 "DynareBison.cc"
    break;

  case 2098: // o_cnum: CNUM EQUAL INT_NUMBER
#line 3836 "DynareBison.yy"
                               {driver.option_num("ms.cnum",yystack_[0].value.as < string > ()); }
#line 8155 "DynareBison.cc"
    break;

  case 2099: // o_k_order_solver: K_ORDER_SOLVER
#line 3837 "DynareBison.yy"
                                  {driver.option_num("k_order_solver","true"); }
#line 8161 "DynareBison.cc"
    break;

  case 2100: // o_pruning: PRUNING
#line 3838 "DynareBison.yy"
                    { driver.option_num("pruning", "true"); }
#line 8167 "DynareBison.cc"
    break;

  case 2101: // o_chain: CHAIN EQUAL INT_NUMBER
#line 3839 "DynareBison.yy"
                                 { driver.option_num("ms.chain",yystack_[0].value.as < string > ()); }
#line 8173 "DynareBison.cc"
    break;

  case 2102: // o_restrictions: RESTRICTIONS EQUAL vec_of_vec_value
#line 3841 "DynareBison.yy"
                 { driver.option_num("ms.restrictions",yystack_[0].value.as < string > ()); }
#line 8179 "DynareBison.cc"
    break;

  case 2103: // o_duration: DURATION EQUAL non_negative_number
#line 3844 "DynareBison.yy"
             { driver.option_num("ms.duration",yystack_[0].value.as < string > ()); }
#line 8185 "DynareBison.cc"
    break;

  case 2104: // o_duration: DURATION EQUAL vec_value_w_inf
#line 3846 "DynareBison.yy"
             { driver.option_num("ms.duration",yystack_[0].value.as < string > ()); }
#line 8191 "DynareBison.cc"
    break;

  case 2105: // o_number_of_regimes: NUMBER_OF_REGIMES EQUAL INT_NUMBER
#line 3848 "DynareBison.yy"
                                                         { driver.option_num("ms.number_of_regimes",yystack_[0].value.as < string > ()); }
#line 8197 "DynareBison.cc"
    break;

  case 2106: // o_number_of_lags: NUMBER_OF_LAGS EQUAL INT_NUMBER
#line 3849 "DynareBison.yy"
                                                   { driver.option_num("ms.number_of_lags",yystack_[0].value.as < string > ()); }
#line 8203 "DynareBison.cc"
    break;

  case 2107: // o_parameters: PARAMETERS EQUAL '[' symbol_list ']'
#line 3850 "DynareBison.yy"
                                                    { driver.option_symbol_list("ms.parameters"); }
#line 8209 "DynareBison.cc"
    break;

  case 2108: // o_coefficients: COEFFICIENTS
#line 3851 "DynareBison.yy"
                              { driver.option_str("ms.coefficients","svar_coefficients"); }
#line 8215 "DynareBison.cc"
    break;

  case 2109: // o_variances: VARIANCES
#line 3852 "DynareBison.yy"
                        { driver.option_str("ms.variances","svar_variances"); }
#line 8221 "DynareBison.cc"
    break;

  case 2110: // o_equations: EQUATIONS EQUAL vec_int
#line 3854 "DynareBison.yy"
              { driver.option_vec_int("ms.equations",yystack_[0].value.as < vector<int> > ()); }
#line 8227 "DynareBison.cc"
    break;

  case 2111: // o_equations: EQUATIONS EQUAL vec_int_number
#line 3856 "DynareBison.yy"
              { driver.option_vec_int("ms.equations",yystack_[0].value.as < vector<int> > ()); }
#line 8233 "DynareBison.cc"
    break;

  case 2112: // o_silent_optimizer: SILENT_OPTIMIZER
#line 3858 "DynareBison.yy"
                                      { driver.option_num("silent_optimizer", "true"); }
#line 8239 "DynareBison.cc"
    break;

  case 2113: // o_instruments: INSTRUMENTS EQUAL '(' symbol_list ')'
#line 3859 "DynareBison.yy"
                                                      {driver.option_symbol_list("instruments"); }
#line 8245 "DynareBison.cc"
    break;

  case 2114: // o_ext_func_name: EXT_FUNC_NAME EQUAL namespace_qualified_filename
#line 3861 "DynareBison.yy"
                                                                   { driver.external_function_option("name", yystack_[0].value.as < string > ()); }
#line 8251 "DynareBison.cc"
    break;

  case 2115: // o_ext_func_nargs: EXT_FUNC_NARGS EQUAL INT_NUMBER
#line 3862 "DynareBison.yy"
                                                   { driver.external_function_option("nargs",yystack_[0].value.as < string > ()); }
#line 8257 "DynareBison.cc"
    break;

  case 2116: // o_first_deriv_provided: FIRST_DERIV_PROVIDED EQUAL namespace_qualified_filename
#line 3864 "DynareBison.yy"
                         { driver.external_function_option("first_deriv_provided", yystack_[0].value.as < string > ()); }
#line 8263 "DynareBison.cc"
    break;

  case 2117: // o_first_deriv_provided: FIRST_DERIV_PROVIDED
#line 3866 "DynareBison.yy"
                         { driver.external_function_option("first_deriv_provided", ""); }
#line 8269 "DynareBison.cc"
    break;

  case 2118: // o_second_deriv_provided: SECOND_DERIV_PROVIDED EQUAL namespace_qualified_filename
#line 3869 "DynareBison.yy"
                          { driver.external_function_option("second_deriv_provided", yystack_[0].value.as < string > ()); }
#line 8275 "DynareBison.cc"
    break;

  case 2119: // o_second_deriv_provided: SECOND_DERIV_PROVIDED
#line 3871 "DynareBison.yy"
                          { driver.external_function_option("second_deriv_provided", ""); }
#line 8281 "DynareBison.cc"
    break;

  case 2120: // o_filter_covariance: FILTER_COVARIANCE
#line 3874 "DynareBison.yy"
                        { driver.option_num("filter_covariance","true");}
#line 8287 "DynareBison.cc"
    break;

  case 2121: // o_filter_decomposition: FILTER_DECOMPOSITION
#line 3877 "DynareBison.yy"
                           { driver.option_num("filter_decomposition","true");}
#line 8293 "DynareBison.cc"
    break;

  case 2122: // o_smoothed_state_uncertainty: SMOOTHED_STATE_UNCERTAINTY
#line 3880 "DynareBison.yy"
                           { driver.option_num("smoothed_state_uncertainty","true");}
#line 8299 "DynareBison.cc"
    break;

  case 2123: // o_smoother_redux: SMOOTHER_REDUX
#line 3883 "DynareBison.yy"
                           { driver.option_num("smoother_redux","true");}
#line 8305 "DynareBison.cc"
    break;

  case 2124: // o_selected_variables_only: SELECTED_VARIABLES_ONLY
#line 3886 "DynareBison.yy"
                           { driver.option_num("selected_variables_only","true");}
#line 8311 "DynareBison.cc"
    break;

  case 2125: // o_cova_compute: COVA_COMPUTE EQUAL INT_NUMBER
#line 3889 "DynareBison.yy"
                 { driver.option_num("cova_compute",yystack_[0].value.as < string > ());}
#line 8317 "DynareBison.cc"
    break;

  case 2126: // o_output_file_tag: OUTPUT_FILE_TAG EQUAL filename
#line 3891 "DynareBison.yy"
                                                   {driver.option_str("ms.output_file_tag", yystack_[0].value.as < string > ()); }
#line 8323 "DynareBison.cc"
    break;

  case 2127: // o_file_tag: FILE_TAG EQUAL filename
#line 3892 "DynareBison.yy"
                                     { driver.option_str("ms.file_tag", yystack_[0].value.as < string > ()); }
#line 8329 "DynareBison.cc"
    break;

  case 2128: // o_no_create_init: NO_CREATE_INIT
#line 3893 "DynareBison.yy"
                                  { driver.option_num("ms.create_init", "false"); }
#line 8335 "DynareBison.cc"
    break;

  case 2129: // o_simulation_file_tag: SIMULATION_FILE_TAG EQUAL filename
#line 3894 "DynareBison.yy"
                                                           { driver.option_str("ms.simulation_file_tag", yystack_[0].value.as < string > ()); }
#line 8341 "DynareBison.cc"
    break;

  case 2130: // o_coefficients_prior_hyperparameters: COEFFICIENTS_PRIOR_HYPERPARAMETERS EQUAL vec_value
#line 3896 "DynareBison.yy"
                                       { driver.option_num("ms.coefficients_prior_hyperparameters",yystack_[0].value.as < string > ()); }
#line 8347 "DynareBison.cc"
    break;

  case 2131: // o_convergence_starting_value: CONVERGENCE_STARTING_VALUE EQUAL non_negative_number
#line 3898 "DynareBison.yy"
                               { driver.option_num("ms.convergence_starting_value",yystack_[0].value.as < string > ()); }
#line 8353 "DynareBison.cc"
    break;

  case 2132: // o_convergence_ending_value: CONVERGENCE_ENDING_VALUE EQUAL non_negative_number
#line 3900 "DynareBison.yy"
                             { driver.option_num("ms.convergence_ending_value",yystack_[0].value.as < string > ()); }
#line 8359 "DynareBison.cc"
    break;

  case 2133: // o_convergence_increment_value: CONVERGENCE_INCREMENT_VALUE EQUAL non_negative_number
#line 3902 "DynareBison.yy"
                                { driver.option_num("ms.convergence_increment_value",yystack_[0].value.as < string > ()); }
#line 8365 "DynareBison.cc"
    break;

  case 2134: // o_max_iterations_starting_value: MAX_ITERATIONS_STARTING_VALUE EQUAL INT_NUMBER
#line 3904 "DynareBison.yy"
                                  { driver.option_num("ms.max_iterations_starting_value",yystack_[0].value.as < string > ()); }
#line 8371 "DynareBison.cc"
    break;

  case 2135: // o_max_iterations_increment_value: MAX_ITERATIONS_INCREMENT_VALUE EQUAL non_negative_number
#line 3906 "DynareBison.yy"
                                   { driver.option_num("ms.max_iterations_increment_value",yystack_[0].value.as < string > ()); }
#line 8377 "DynareBison.cc"
    break;

  case 2136: // o_max_block_iterations: MAX_BLOCK_ITERATIONS EQUAL INT_NUMBER
#line 3908 "DynareBison.yy"
                         { driver.option_num("ms.max_block_iterations",yystack_[0].value.as < string > ()); }
#line 8383 "DynareBison.cc"
    break;

  case 2137: // o_max_repeated_optimization_runs: MAX_REPEATED_OPTIMIZATION_RUNS EQUAL INT_NUMBER
#line 3910 "DynareBison.yy"
                                   { driver.option_num("ms.max_repeated_optimization_runs",yystack_[0].value.as < string > ()); }
#line 8389 "DynareBison.cc"
    break;

  case 2138: // o_function_convergence_criterion: FUNCTION_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 3912 "DynareBison.yy"
                                   { driver.option_num("ms.function_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 8395 "DynareBison.cc"
    break;

  case 2139: // o_parameter_convergence_criterion: PARAMETER_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 3914 "DynareBison.yy"
                                    { driver.option_num("ms.parameter_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 8401 "DynareBison.cc"
    break;

  case 2140: // o_number_of_large_perturbations: NUMBER_OF_LARGE_PERTURBATIONS EQUAL INT_NUMBER
#line 3916 "DynareBison.yy"
                                  { driver.option_num("ms.number_of_large_perturbations",yystack_[0].value.as < string > ()); }
#line 8407 "DynareBison.cc"
    break;

  case 2141: // o_number_of_small_perturbations: NUMBER_OF_SMALL_PERTURBATIONS EQUAL INT_NUMBER
#line 3918 "DynareBison.yy"
                                  { driver.option_num("ms.number_of_small_perturbations",yystack_[0].value.as < string > ()); }
#line 8413 "DynareBison.cc"
    break;

  case 2142: // o_number_of_posterior_draws_after_perturbation: NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION EQUAL INT_NUMBER
#line 3920 "DynareBison.yy"
                                                 { driver.option_num("ms.number_of_posterior_draws_after_perturbation",yystack_[0].value.as < string > ()); }
#line 8419 "DynareBison.cc"
    break;

  case 2143: // o_max_number_of_stages: MAX_NUMBER_OF_STAGES EQUAL INT_NUMBER
#line 3922 "DynareBison.yy"
                         { driver.option_num("ms.max_number_of_stages",yystack_[0].value.as < string > ()); }
#line 8425 "DynareBison.cc"
    break;

  case 2144: // o_random_function_convergence_criterion: RANDOM_FUNCTION_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 3924 "DynareBison.yy"
                                          { driver.option_num("ms.random_function_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 8431 "DynareBison.cc"
    break;

  case 2145: // o_random_parameter_convergence_criterion: RANDOM_PARAMETER_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 3926 "DynareBison.yy"
                                           { driver.option_num("ms.random_parameter_convergence_criterion",yystack_[0].value.as < string > ()); }
#line 8437 "DynareBison.cc"
    break;

  case 2146: // o_thinning_factor: THINNING_FACTOR EQUAL INT_NUMBER
#line 3927 "DynareBison.yy"
                                                     { driver.option_num("ms.thinning_factor",yystack_[0].value.as < string > ()); }
#line 8443 "DynareBison.cc"
    break;

  case 2147: // o_adaptive_mh_draws: ADAPTIVE_MH_DRAWS EQUAL INT_NUMBER
#line 3928 "DynareBison.yy"
                                                         { driver.option_num("ms.adaptive_mh_draws",yystack_[0].value.as < string > ()); }
#line 8449 "DynareBison.cc"
    break;

  case 2148: // o_save_draws: SAVE_DRAWS
#line 3929 "DynareBison.yy"
                          { driver.option_num("ms.save_draws","true"); }
#line 8455 "DynareBison.cc"
    break;

  case 2149: // o_proposal_draws: PROPOSAL_DRAWS EQUAL INT_NUMBER
#line 3930 "DynareBison.yy"
                                                   { driver.option_num("ms.proposal_draws",yystack_[0].value.as < string > ()); }
#line 8461 "DynareBison.cc"
    break;

  case 2150: // o_use_mean_center: USE_MEAN_CENTER
#line 3931 "DynareBison.yy"
                                    { driver.option_num("ms.use_mean_center","true"); }
#line 8467 "DynareBison.cc"
    break;

  case 2151: // o_proposal_type: PROPOSAL_TYPE EQUAL INT_NUMBER
#line 3932 "DynareBison.yy"
                                                 { driver.option_num("ms.proposal_type",yystack_[0].value.as < string > ()); }
#line 8473 "DynareBison.cc"
    break;

  case 2152: // o_proposal_lower_bound: PROPOSAL_LOWER_BOUND EQUAL signed_number
#line 3933 "DynareBison.yy"
                                                                  { driver.option_num("ms.proposal_lower_bound",yystack_[0].value.as < string > ()); }
#line 8479 "DynareBison.cc"
    break;

  case 2153: // o_proposal_upper_bound: PROPOSAL_UPPER_BOUND EQUAL signed_number
#line 3934 "DynareBison.yy"
                                                                  { driver.option_num("ms.proposal_upper_bound",yystack_[0].value.as < string > ()); }
#line 8485 "DynareBison.cc"
    break;

  case 2154: // o_parameter_uncertainty: PARAMETER_UNCERTAINTY
#line 3935 "DynareBison.yy"
                                                { driver.option_num("ms.parameter_uncertainty","true"); }
#line 8491 "DynareBison.cc"
    break;

  case 2155: // o_horizon: HORIZON EQUAL INT_NUMBER
#line 3936 "DynareBison.yy"
                                     { driver.option_num("ms.horizon",yystack_[0].value.as < string > ()); }
#line 8497 "DynareBison.cc"
    break;

  case 2156: // o_filtered_probabilities: FILTERED_PROBABILITIES
#line 3937 "DynareBison.yy"
                                                  { driver.option_num("ms.filtered_probabilities","true"); }
#line 8503 "DynareBison.cc"
    break;

  case 2157: // o_real_time_smoothed: REAL_TIME_SMOOTHED
#line 3938 "DynareBison.yy"
                                          { driver.option_num("ms.real_time_smoothed_probabilities","true"); }
#line 8509 "DynareBison.cc"
    break;

  case 2158: // o_no_error_bands: NO_ERROR_BANDS
#line 3939 "DynareBison.yy"
                                  { driver.option_num("ms.error_bands","false"); }
#line 8515 "DynareBison.cc"
    break;

  case 2159: // o_error_band_percentiles: ERROR_BAND_PERCENTILES EQUAL vec_value
#line 3940 "DynareBison.yy"
                                                                  { driver.option_num("ms.percentiles",yystack_[0].value.as < string > ()); }
#line 8521 "DynareBison.cc"
    break;

  case 2160: // o_shock_draws: SHOCK_DRAWS EQUAL INT_NUMBER
#line 3941 "DynareBison.yy"
                                             { driver.option_num("ms.shock_draws",yystack_[0].value.as < string > ()); }
#line 8527 "DynareBison.cc"
    break;

  case 2161: // o_shocks_per_parameter: SHOCKS_PER_PARAMETER EQUAL INT_NUMBER
#line 3942 "DynareBison.yy"
                                                               { driver.option_num("ms.shocks_per_parameter",yystack_[0].value.as < string > ()); }
#line 8533 "DynareBison.cc"
    break;

  case 2162: // o_free_parameters: FREE_PARAMETERS EQUAL vec_value
#line 3943 "DynareBison.yy"
                                                    { driver.option_num("ms.free_parameters",yystack_[0].value.as < string > ()); }
#line 8539 "DynareBison.cc"
    break;

  case 2163: // o_median: MEDIAN
#line 3944 "DynareBison.yy"
                  { driver.option_num("ms.median","1"); }
#line 8545 "DynareBison.cc"
    break;

  case 2164: // o_median: MEDIAN EQUAL signed_number
#line 3945 "DynareBison.yy"
                                      { driver.option_num("median", yystack_[0].value.as < string > ()); }
#line 8551 "DynareBison.cc"
    break;

  case 2165: // o_regimes: REGIMES
#line 3946 "DynareBison.yy"
                    { driver.option_num("ms.regimes","true"); }
#line 8557 "DynareBison.cc"
    break;

  case 2166: // o_regime: REGIME EQUAL INT_NUMBER
#line 3947 "DynareBison.yy"
                                   { driver.option_num("ms.regime",yystack_[0].value.as < string > ()); }
#line 8563 "DynareBison.cc"
    break;

  case 2167: // o_data_obs_nbr: DATA_OBS_NBR EQUAL INT_NUMBER
#line 3948 "DynareBison.yy"
                                               { driver.option_num("ms.forecast_data_obs",yystack_[0].value.as < string > ()); }
#line 8569 "DynareBison.cc"
    break;

  case 2168: // o_discretionary_tol: DISCRETIONARY_TOL EQUAL non_negative_number
#line 3949 "DynareBison.yy"
                                                                 { driver.option_num("discretionary_tol",yystack_[0].value.as < string > ()); }
#line 8575 "DynareBison.cc"
    break;

  case 2169: // o_analytic_derivation: ANALYTIC_DERIVATION
#line 3950 "DynareBison.yy"
                                            { driver.option_num("analytic_derivation", "1"); }
#line 8581 "DynareBison.cc"
    break;

  case 2170: // o_analytic_derivation_mode: ANALYTIC_DERIVATION_MODE EQUAL signed_number
#line 3951 "DynareBison.yy"
                                                                          { driver.option_num("analytic_derivation_mode", yystack_[0].value.as < string > ()); }
#line 8587 "DynareBison.cc"
    break;

  case 2171: // o_endogenous_prior: ENDOGENOUS_PRIOR
#line 3952 "DynareBison.yy"
                                      { driver.option_num("endogenous_prior", "true"); }
#line 8593 "DynareBison.cc"
    break;

  case 2172: // o_use_univariate_filters_if_singularity_is_detected: USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED EQUAL INT_NUMBER
#line 3953 "DynareBison.yy"
                                                                                                                         { driver.option_num("use_univariate_filters_if_singularity_is_detected", yystack_[0].value.as < string > ()); }
#line 8599 "DynareBison.cc"
    break;

  case 2173: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL HESSIAN
#line 3955 "DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8605 "DynareBison.cc"
    break;

  case 2174: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL PRIOR_VARIANCE
#line 3956 "DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8611 "DynareBison.cc"
    break;

  case 2175: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL IDENTITY_MATRIX
#line 3958 "DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8617 "DynareBison.cc"
    break;

  case 2176: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL filename
#line 3960 "DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 8623 "DynareBison.cc"
    break;

  case 2177: // o_rescale_prediction_error_covariance: RESCALE_PREDICTION_ERROR_COVARIANCE
#line 3962 "DynareBison.yy"
                                                                            { driver.option_num("rescale_prediction_error_covariance", "true"); }
#line 8629 "DynareBison.cc"
    break;

  case 2178: // o_use_penalized_objective_for_hessian: USE_PENALIZED_OBJECTIVE_FOR_HESSIAN
#line 3963 "DynareBison.yy"
                                                                            { driver.option_num("hessian.use_penalized_objective","true"); }
#line 8635 "DynareBison.cc"
    break;

  case 2179: // o_irf_plot_threshold: IRF_PLOT_THRESHOLD EQUAL non_negative_number
#line 3964 "DynareBison.yy"
                                                                    { driver.option_num("impulse_responses.plot_threshold", yystack_[0].value.as < string > ()); }
#line 8641 "DynareBison.cc"
    break;

  case 2180: // o_dr_display_tol: DR_DISPLAY_TOL EQUAL non_negative_number
#line 3965 "DynareBison.yy"
                                                            { driver.option_num("dr_display_tol", yystack_[0].value.as < string > ()); }
#line 8647 "DynareBison.cc"
    break;

  case 2181: // o_consider_all_endogenous: CONSIDER_ALL_ENDOGENOUS
#line 3966 "DynareBison.yy"
                                                    { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_variables"); }
#line 8653 "DynareBison.cc"
    break;

  case 2182: // o_consider_all_endogenous_and_auxiliary: CONSIDER_ALL_ENDOGENOUS_AND_AUXILIARY
#line 3967 "DynareBison.yy"
                                                                                { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_and_auxiliary_variables"); }
#line 8659 "DynareBison.cc"
    break;

  case 2183: // o_consider_only_observed: CONSIDER_ONLY_OBSERVED
#line 3968 "DynareBison.yy"
                                                  { driver.option_str("endo_vars_for_moment_computations_in_estimation", "only_observed_variables"); }
#line 8665 "DynareBison.cc"
    break;

  case 2184: // o_no_homotopy: NO_HOMOTOPY
#line 3969 "DynareBison.yy"
                            { driver.option_num("no_homotopy", "true"); }
#line 8671 "DynareBison.cc"
    break;

  case 2185: // o_infile: INFILE EQUAL filename
#line 3971 "DynareBison.yy"
                                 { driver.option_str("infile", yystack_[0].value.as < string > ()); }
#line 8677 "DynareBison.cc"
    break;

  case 2186: // o_invars: INVARS EQUAL '(' symbol_list ')'
#line 3972 "DynareBison.yy"
                                            { driver.option_symbol_list("invars"); }
#line 8683 "DynareBison.cc"
    break;

  case 2187: // o_period: PERIOD EQUAL INT_NUMBER
#line 3973 "DynareBison.yy"
                                   { driver.option_num("period", yystack_[0].value.as < string > ()); }
#line 8689 "DynareBison.cc"
    break;

  case 2188: // o_outfile: OUTFILE EQUAL filename
#line 3974 "DynareBison.yy"
                                   { driver.option_str("outfile", yystack_[0].value.as < string > ()); }
#line 8695 "DynareBison.cc"
    break;

  case 2189: // o_outvars: OUTVARS EQUAL '(' symbol_list ')'
#line 3975 "DynareBison.yy"
                                              { driver.option_symbol_list("outvars"); }
#line 8701 "DynareBison.cc"
    break;

  case 2190: // o_lmmcp: LMMCP
#line 3976 "DynareBison.yy"
                {driver.option_num("lmmcp.status", "true"); }
#line 8707 "DynareBison.cc"
    break;

  case 2191: // o_function: FUNCTION EQUAL filename
#line 3977 "DynareBison.yy"
                                     { driver.option_str("function", yystack_[0].value.as < string > ()); }
#line 8713 "DynareBison.cc"
    break;

  case 2192: // o_sampling_draws: SAMPLING_DRAWS EQUAL INT_NUMBER
#line 3978 "DynareBison.yy"
                                                   { driver.option_num("sampling_draws",yystack_[0].value.as < string > ()); }
#line 8719 "DynareBison.cc"
    break;

  case 2193: // o_use_shock_groups: USE_SHOCK_GROUPS
#line 3979 "DynareBison.yy"
                                      { driver.option_str("plot_shock_decomp.use_shock_groups","default"); }
#line 8725 "DynareBison.cc"
    break;

  case 2194: // o_use_shock_groups: USE_SHOCK_GROUPS EQUAL symbol
#line 3980 "DynareBison.yy"
                                                   { driver.option_str("plot_shock_decomp.use_shock_groups", yystack_[0].value.as < string > ()); }
#line 8731 "DynareBison.cc"
    break;

  case 2195: // o_colormap: COLORMAP EQUAL symbol
#line 3982 "DynareBison.yy"
                                   { driver.option_num("plot_shock_decomp.colormap",yystack_[0].value.as < string > ()); }
#line 8737 "DynareBison.cc"
    break;

  case 2196: // o_icd_colormap: COLORMAP EQUAL symbol
#line 3983 "DynareBison.yy"
                                       { driver.option_num("initial_condition_decomp.colormap",yystack_[0].value.as < string > ()); }
#line 8743 "DynareBison.cc"
    break;

  case 2197: // o_no_init_estimation_check_first_obs: NO_INIT_ESTIMATION_CHECK_FIRST_OBS
#line 3984 "DynareBison.yy"
                                                                          { driver.option_num("no_init_estimation_check_first_obs", "true"); }
#line 8749 "DynareBison.cc"
    break;

  case 2198: // o_heteroskedastic_filter: HETEROSKEDASTIC_FILTER
#line 3985 "DynareBison.yy"
                                                  { driver.option_num("heteroskedastic_filter", "true"); }
#line 8755 "DynareBison.cc"
    break;

  case 2199: // o_pfwee_terminal_steady_state_as_guess_value: TERMINAL_STEADY_STATE_AS_GUESS_VALUE
#line 3986 "DynareBison.yy"
                                                                                    { driver.option_num("pfwee.terminal_steady_state_as_guess_value", "true"); }
#line 8761 "DynareBison.cc"
    break;

  case 2200: // o_bartlett_kernel_lag: BARTLETT_KERNEL_LAG EQUAL INT_NUMBER
#line 3989 "DynareBison.yy"
                                                             { driver.option_num("mom.bartlett_kernel_lag", yystack_[0].value.as < string > ()); }
#line 8767 "DynareBison.cc"
    break;

  case 2201: // o_weighting_matrix: WEIGHTING_MATRIX EQUAL vec_str
#line 3991 "DynareBison.yy"
                                                    { driver.option_vec_cellstr("mom.weighting_matrix", yystack_[0].value.as < vector<string> > ()); }
#line 8773 "DynareBison.cc"
    break;

  case 2202: // o_weighting_matrix_scaling_factor: WEIGHTING_MATRIX_SCALING_FACTOR EQUAL non_negative_number
#line 3993 "DynareBison.yy"
                                                                                              { driver.option_num("mom.weighting_matrix_scaling_factor", yystack_[0].value.as < string > ()); }
#line 8779 "DynareBison.cc"
    break;

  case 2203: // o_analytic_standard_errors: ANALYTIC_STANDARD_ERRORS
#line 3995 "DynareBison.yy"
                                                      { driver.option_num("mom.analytic_standard_errors", "true"); }
#line 8785 "DynareBison.cc"
    break;

  case 2204: // o_analytic_jacobian: ANALYTIC_JACOBIAN
#line 3997 "DynareBison.yy"
                                        { driver.option_num("mom.analytic_jacobian", "true"); }
#line 8791 "DynareBison.cc"
    break;

  case 2205: // o_mom_method: MOM_METHOD EQUAL GMM
#line 4000 "DynareBison.yy"
               { driver.option_str("mom.mom_method", "GMM"); }
#line 8797 "DynareBison.cc"
    break;

  case 2206: // o_mom_method: MOM_METHOD EQUAL SMM
#line 4002 "DynareBison.yy"
               { driver.option_str("mom.mom_method", "SMM"); }
#line 8803 "DynareBison.cc"
    break;

  case 2207: // o_penalized_estimator: PENALIZED_ESTIMATOR
#line 4004 "DynareBison.yy"
                                            { driver.option_num("mom.penalized_estimator", "true"); }
#line 8809 "DynareBison.cc"
    break;

  case 2208: // o_verbose: VERBOSE
#line 4005 "DynareBison.yy"
                    { driver.option_num("mom.verbose", "true"); }
#line 8815 "DynareBison.cc"
    break;

  case 2209: // o_simulation_multiple: SIMULATION_MULTIPLE EQUAL INT_NUMBER
#line 4007 "DynareBison.yy"
                                                             { driver.option_num("mom.simulation_multiple", yystack_[0].value.as < string > ()); }
#line 8821 "DynareBison.cc"
    break;

  case 2210: // o_mom_burnin: BURNIN EQUAL INT_NUMBER
#line 4008 "DynareBison.yy"
                                       { driver.option_num("mom.burnin", yystack_[0].value.as < string > ()); }
#line 8827 "DynareBison.cc"
    break;

  case 2211: // o_bounded_shock_support: BOUNDED_SHOCK_SUPPORT
#line 4009 "DynareBison.yy"
                                                { driver.option_num("mom.bounded_shock_support", "true"); }
#line 8833 "DynareBison.cc"
    break;

  case 2212: // o_mom_seed: SEED EQUAL INT_NUMBER
#line 4010 "DynareBison.yy"
                                   { driver.option_num("mom.seed", yystack_[0].value.as < string > ()); }
#line 8839 "DynareBison.cc"
    break;

  case 2213: // o_additional_optimizer_steps: ADDITIONAL_OPTIMIZER_STEPS EQUAL vec_int
#line 4011 "DynareBison.yy"
                                                                        { driver.option_vec_int("additional_optimizer_steps", yystack_[0].value.as < vector<int> > ()); }
#line 8845 "DynareBison.cc"
    break;

  case 2214: // o_mom_se_tolx: SE_TOLX EQUAL non_negative_number
#line 4013 "DynareBison.yy"
                                                  { driver.option_num("mom.se_tolx", yystack_[0].value.as < string > ()); }
#line 8851 "DynareBison.cc"
    break;

  case 2215: // o_analytical_girf: ANALYTICAL_GIRF
#line 4015 "DynareBison.yy"
                                    { driver.option_num("irf_opt.analytical_GIRF", "true"); }
#line 8857 "DynareBison.cc"
    break;

  case 2216: // o_irf_in_percent: IRF_IN_PERCENT
#line 4016 "DynareBison.yy"
                                  { driver.option_num("irf_opt.percent", "true"); }
#line 8863 "DynareBison.cc"
    break;

  case 2217: // o_emas_girf: EMAS_GIRF
#line 4017 "DynareBison.yy"
                        { driver.option_num("irf_opt.ergodic_mean_irf", "true"); }
#line 8869 "DynareBison.cc"
    break;

  case 2218: // o_emas_drop: EMAS_DROP EQUAL INT_NUMBER
#line 4018 "DynareBison.yy"
                                         { driver.option_num("irf_opt.EM.drop", yystack_[0].value.as < string > ()); }
#line 8875 "DynareBison.cc"
    break;

  case 2219: // o_emas_tolf: EMAS_TOLF EQUAL non_negative_number
#line 4019 "DynareBison.yy"
                                                  { driver.option_num("irf_opt.EM.tolf", yystack_[0].value.as < string > ()); }
#line 8881 "DynareBison.cc"
    break;

  case 2220: // o_emas_max_iter: EMAS_MAX_ITER EQUAL INT_NUMBER
#line 4020 "DynareBison.yy"
                                                 { driver.option_num("irf_opt.EM.iter", yystack_[0].value.as < string > ()); }
#line 8887 "DynareBison.cc"
    break;

  case 2221: // o_no_identification_strength: NO_IDENTIFICATION_STRENGTH
#line 4023 "DynareBison.yy"
                                                          { driver.option_num("no_identification_strength", "true"); }
#line 8893 "DynareBison.cc"
    break;

  case 2222: // o_no_identification_reducedform: NO_IDENTIFICATION_REDUCEDFORM
#line 4024 "DynareBison.yy"
                                                                { driver.option_num("no_identification_reducedform", "true"); }
#line 8899 "DynareBison.cc"
    break;

  case 2223: // o_no_identification_moments: NO_IDENTIFICATION_MOMENTS
#line 4025 "DynareBison.yy"
                                                        { driver.option_num("no_identification_moments", "true"); }
#line 8905 "DynareBison.cc"
    break;

  case 2224: // o_no_identification_minimal: NO_IDENTIFICATION_MINIMAL
#line 4026 "DynareBison.yy"
                                                        { driver.option_num("no_identification_minimal", "true"); }
#line 8911 "DynareBison.cc"
    break;

  case 2225: // o_no_identification_spectrum: NO_IDENTIFICATION_SPECTRUM
#line 4027 "DynareBison.yy"
                                                          { driver.option_num("no_identification_spectrum", "true"); }
#line 8917 "DynareBison.cc"
    break;

  case 2226: // o_normalize_jacobians: NORMALIZE_JACOBIANS EQUAL INT_NUMBER
#line 4028 "DynareBison.yy"
                                                             { driver.option_num("normalize_jacobians", yystack_[0].value.as < string > ()); }
#line 8923 "DynareBison.cc"
    break;

  case 2227: // o_grid_nbr: GRID_NBR EQUAL INT_NUMBER
#line 4029 "DynareBison.yy"
                                       { driver.option_num("grid_nbr", yystack_[0].value.as < string > ()); }
#line 8929 "DynareBison.cc"
    break;

  case 2228: // o_tol_rank: TOL_RANK EQUAL non_negative_number
#line 4030 "DynareBison.yy"
                                                { driver.option_num("tol_rank", yystack_[0].value.as < string > ()); }
#line 8935 "DynareBison.cc"
    break;

  case 2229: // o_tol_deriv: TOL_DERIV EQUAL non_negative_number
#line 4031 "DynareBison.yy"
                                                  { driver.option_num("tol_deriv", yystack_[0].value.as < string > ()); }
#line 8941 "DynareBison.cc"
    break;

  case 2230: // o_tol_sv: TOL_SV EQUAL non_negative_number
#line 4032 "DynareBison.yy"
                                            { driver.option_num("tol_sv", yystack_[0].value.as < string > ()); }
#line 8947 "DynareBison.cc"
    break;

  case 2231: // o_checks_via_subsets: CHECKS_VIA_SUBSETS EQUAL INT_NUMBER
#line 4033 "DynareBison.yy"
                                                           { driver.option_num("checks_via_subsets", yystack_[0].value.as < string > ()); }
#line 8953 "DynareBison.cc"
    break;

  case 2232: // o_max_dim_subsets_groups: MAX_DIM_SUBSETS_GROUPS EQUAL INT_NUMBER
#line 4034 "DynareBison.yy"
                                                                   { driver.option_num("max_dim_subsets_groups", yystack_[0].value.as < string > ()); }
#line 8959 "DynareBison.cc"
    break;

  case 2233: // o_zero_moments_tolerance: ZERO_MOMENTS_TOLERANCE EQUAL non_negative_number
#line 4035 "DynareBison.yy"
                                                                            { driver.option_num("zero_moments_tolerance", yystack_[0].value.as < string > ()); }
#line 8965 "DynareBison.cc"
    break;

  case 2234: // o_occbin_simul_maxit: SIMUL_MAXIT EQUAL INT_NUMBER
#line 4039 "DynareBison.yy"
                                                    { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 8971 "DynareBison.cc"
    break;

  case 2235: // o_occbin_simul_periods: SIMUL_PERIODS EQUAL INT_NUMBER
#line 4040 "DynareBison.yy"
                                                        { driver.option_num("simul.periods", yystack_[0].value.as < string > ()); }
#line 8977 "DynareBison.cc"
    break;

  case 2236: // o_occbin_simul_curb_retrench: SIMUL_CURB_RETRENCH
#line 4041 "DynareBison.yy"
                                                   { driver.option_num("simul.curb_retrench", "true"); }
#line 8983 "DynareBison.cc"
    break;

  case 2237: // o_occbin_simul_check_ahead_periods: SIMUL_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4042 "DynareBison.yy"
                                                                                { driver.option_num("simul.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 8989 "DynareBison.cc"
    break;

  case 2238: // o_occbin_simul_debug: SIMUL_DEBUG
#line 4043 "DynareBison.yy"
                                   { driver.option_num("simul.debug", "true"); }
#line 8995 "DynareBison.cc"
    break;

  case 2239: // o_occbin_simul_periodic_solution: SIMUL_PERIODIC_SOLUTION
#line 4044 "DynareBison.yy"
                                                           { driver.option_num("simul.periodic_solution", "true"); }
#line 9001 "DynareBison.cc"
    break;

  case 2240: // o_occbin_likelihood_inversion_filter: LIKELIHOOD_INVERSION_FILTER
#line 4047 "DynareBison.yy"
                                                                   { driver.option_num("likelihood.inversion_filter", "true"); }
#line 9007 "DynareBison.cc"
    break;

  case 2241: // o_occbin_likelihood_piecewise_kalman_filter: LIKELIHOOD_PIECEWISE_KALMAN_FILTER
#line 4048 "DynareBison.yy"
                                                                                 { driver.option_num("likelihood.inversion_filter", "false"); }
#line 9013 "DynareBison.cc"
    break;

  case 2242: // o_occbin_likelihood_maxit: LIKELIHOOD_MAXIT EQUAL INT_NUMBER
#line 4049 "DynareBison.yy"
                                                              { driver.option_num("likelihood.maxit", yystack_[0].value.as < string > ()); }
#line 9019 "DynareBison.cc"
    break;

  case 2243: // o_occbin_likelihood_periods: LIKELIHOOD_PERIODS EQUAL INT_NUMBER
#line 4050 "DynareBison.yy"
                                                                  { driver.option_num("likelihood.periods", yystack_[0].value.as < string > ()); }
#line 9025 "DynareBison.cc"
    break;

  case 2244: // o_occbin_likelihood_curb_retrench: LIKELIHOOD_CURB_RETRENCH
#line 4051 "DynareBison.yy"
                                                             { driver.option_num("likelihood.curb_retrench", "true"); }
#line 9031 "DynareBison.cc"
    break;

  case 2245: // o_occbin_likelihood_check_ahead_periods: LIKELIHOOD_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4052 "DynareBison.yy"
                                                                                          { driver.option_num("likelihood.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9037 "DynareBison.cc"
    break;

  case 2246: // o_occbin_likelihood_periodic_solution: LIKELIHOOD_PERIODIC_SOLUTION
#line 4053 "DynareBison.yy"
                                                                     { driver.option_num("likelihood.periodic_solution", "true"); }
#line 9043 "DynareBison.cc"
    break;

  case 2247: // o_occbin_likelihood_max_kalman_iterations: LIKELIHOOD_MAX_KALMAN_ITERATIONS EQUAL INT_NUMBER
#line 4054 "DynareBison.yy"
                                                                                              { driver.option_num("likelihood.max_number_of_iterations", yystack_[0].value.as < string > ()); }
#line 9049 "DynareBison.cc"
    break;

  case 2248: // o_occbin_smoother_inversion_filter: SMOOTHER_INVERSION_FILTER
#line 4055 "DynareBison.yy"
                                                               { driver.option_num("smoother.inversion_filter", "true"); }
#line 9055 "DynareBison.cc"
    break;

  case 2249: // o_occbin_smoother_piecewise_kalman_filter: SMOOTHER_PIECEWISE_KALMAN_FILTER
#line 4056 "DynareBison.yy"
                                                                             { driver.option_num("smoother.inversion_filter", "false"); }
#line 9061 "DynareBison.cc"
    break;

  case 2250: // o_occbin_smoother_maxit: SMOOTHER_MAXIT EQUAL INT_NUMBER
#line 4057 "DynareBison.yy"
                                                          { driver.option_num("smoother.maxit", yystack_[0].value.as < string > ()); }
#line 9067 "DynareBison.cc"
    break;

  case 2251: // o_occbin_smoother_periods: SMOOTHER_PERIODS EQUAL INT_NUMBER
#line 4058 "DynareBison.yy"
                                                              { driver.option_num("smoother.periods", yystack_[0].value.as < string > ()); }
#line 9073 "DynareBison.cc"
    break;

  case 2252: // o_occbin_smoother_curb_retrench: SMOOTHER_CURB_RETRENCH
#line 4059 "DynareBison.yy"
                                                         { driver.option_num("smoother.curb_retrench", "true"); }
#line 9079 "DynareBison.cc"
    break;

  case 2253: // o_occbin_smoother_check_ahead_periods: SMOOTHER_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4060 "DynareBison.yy"
                                                                                      { driver.option_num("smoother.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9085 "DynareBison.cc"
    break;

  case 2254: // o_occbin_smoother_debug: SMOOTHER_DEBUG
#line 4061 "DynareBison.yy"
                                         { driver.option_num("smoother.debug", "true"); }
#line 9091 "DynareBison.cc"
    break;

  case 2255: // o_occbin_smoother_periodic_solution: SMOOTHER_PERIODIC_SOLUTION
#line 4062 "DynareBison.yy"
                                                                 { driver.option_num("smoother.periodic_solution", "true"); }
#line 9097 "DynareBison.cc"
    break;

  case 2256: // o_occbin_filter_use_relaxation: FILTER_USE_RELEXATION
#line 4063 "DynareBison.yy"
                                                       { driver.option_num("filter.use_relaxation", "true"); }
#line 9103 "DynareBison.cc"
    break;

  case 2257: // o_occbin_write_regimes_periods: PERIODS EQUAL vec_int
#line 4067 "DynareBison.yy"
                                 { driver.option_vec_int("write_regimes.periods", yystack_[0].value.as < vector<int> > ()); }
#line 9109 "DynareBison.cc"
    break;

  case 2258: // o_occbin_write_regimes_periods: PERIODS EQUAL vec_int_number
#line 4069 "DynareBison.yy"
                                 { driver.option_vec_int("write_regimes.periods", yystack_[0].value.as < vector<int> > ()); }
#line 9115 "DynareBison.cc"
    break;

  case 2259: // o_occbin_write_regimes_filename: FILENAME EQUAL filename
#line 4070 "DynareBison.yy"
                                                          { driver.option_str("write_regimes.filename", yystack_[0].value.as < string > ()); }
#line 9121 "DynareBison.cc"
    break;

  case 2260: // o_occbin_write_regimes_smoother: SMOOTHER
#line 4071 "DynareBison.yy"
                                           { driver.option_str("write_regimes.type", "smoother"); }
#line 9127 "DynareBison.cc"
    break;

  case 2261: // o_occbin_write_regimes_simul: SIMUL
#line 4072 "DynareBison.yy"
                                     { driver.option_str("write_regimes.type", "simul"); }
#line 9133 "DynareBison.cc"
    break;

  case 2262: // o_occbin_graph_noconstant: NOCONSTANT
#line 4075 "DynareBison.yy"
                                       { driver.option_num("graph.steady_state", "false"); }
#line 9139 "DynareBison.cc"
    break;

  case 2263: // range: symbol ':' symbol
#line 4078 "DynareBison.yy"
        { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 9145 "DynareBison.cc"
    break;

  case 2264: // integer_range: INT_NUMBER ':' INT_NUMBER
#line 4081 "DynareBison.yy"
                { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 9151 "DynareBison.cc"
    break;

  case 2265: // integer_range_w_inf: INT_NUMBER ':' INT_NUMBER
#line 4084 "DynareBison.yy"
                      { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), yystack_[0].value.as < string > () }; }
#line 9157 "DynareBison.cc"
    break;

  case 2266: // integer_range_w_inf: INT_NUMBER ':' INF_CONSTANT
#line 4086 "DynareBison.yy"
                      { yylhs.value.as < pair<string,string> > () = { yystack_[2].value.as < string > (), "Inf" }; }
#line 9163 "DynareBison.cc"
    break;

  case 2267: // signed_integer_range: signed_integer ':' signed_integer
#line 4090 "DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 9169 "DynareBison.cc"
    break;

  case 2268: // signed_integer_range: MINUS '(' signed_integer ':' signed_integer ')'
#line 4092 "DynareBison.yy"
                       { yylhs.value.as < string > () = "-(" + yystack_[3].value.as < string > () + ':' + yystack_[1].value.as < string > () + ")"; }
#line 9175 "DynareBison.cc"
    break;

  case 2269: // vec_int_number: INT_NUMBER
#line 4095 "DynareBison.yy"
                 { yylhs.value.as < vector<int> > () = { stoi(yystack_[0].value.as < string > ()) }; }
#line 9181 "DynareBison.cc"
    break;

  case 2270: // vec_int_elem: vec_int_number
#line 4098 "DynareBison.yy"
               { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 9187 "DynareBison.cc"
    break;

  case 2271: // vec_int_elem: INT_NUMBER ':' INT_NUMBER
#line 4100 "DynareBison.yy"
               {
                 yylhs.value.as < vector<int> > () = {};
                 for (int i = stoi(yystack_[2].value.as < string > ()); i <= stoi(yystack_[0].value.as < string > ()); i++)
                   yylhs.value.as < vector<int> > ().push_back(i);
               }
#line 9197 "DynareBison.cc"
    break;

  case 2272: // vec_int_1: '[' vec_int_elem
#line 4108 "DynareBison.yy"
            { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > ();}
#line 9203 "DynareBison.cc"
    break;

  case 2273: // vec_int_1: '[' COMMA vec_int_elem
#line 4110 "DynareBison.yy"
            { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > ();}
#line 9209 "DynareBison.cc"
    break;

  case 2274: // vec_int_1: vec_int_1 vec_int_elem
#line 4112 "DynareBison.yy"
            {
              yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 9218 "DynareBison.cc"
    break;

  case 2275: // vec_int_1: vec_int_1 COMMA vec_int_elem
#line 4117 "DynareBison.yy"
            {
              yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 9227 "DynareBison.cc"
    break;

  case 2276: // vec_int: vec_int_1 ']'
#line 4123 "DynareBison.yy"
          { yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > (); }
#line 9233 "DynareBison.cc"
    break;

  case 2277: // vec_int: vec_int_1 COMMA ']'
#line 4124 "DynareBison.yy"
          { yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > (); }
#line 9239 "DynareBison.cc"
    break;

  case 2278: // vec_str_1: '[' QUOTED_STRING
#line 4128 "DynareBison.yy"
            { yylhs.value.as < vector<string> > () = { yystack_[0].value.as < string > () }; }
#line 9245 "DynareBison.cc"
    break;

  case 2279: // vec_str_1: '[' COMMA QUOTED_STRING
#line 4130 "DynareBison.yy"
            { yylhs.value.as < vector<string> > () = { yystack_[0].value.as < string > () }; }
#line 9251 "DynareBison.cc"
    break;

  case 2280: // vec_str_1: vec_str_1 QUOTED_STRING
#line 4132 "DynareBison.yy"
            {
              yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 9260 "DynareBison.cc"
    break;

  case 2281: // vec_str_1: vec_str_1 COMMA QUOTED_STRING
#line 4137 "DynareBison.yy"
            {
              yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 9269 "DynareBison.cc"
    break;

  case 2282: // vec_str: vec_str_1 ']'
#line 4143 "DynareBison.yy"
          { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 9275 "DynareBison.cc"
    break;

  case 2283: // vec_str: vec_str_1 COMMA ']'
#line 4144 "DynareBison.yy"
          { yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > (); }
#line 9281 "DynareBison.cc"
    break;

  case 2284: // vec_value_1: '[' signed_number
#line 4148 "DynareBison.yy"
              { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 9287 "DynareBison.cc"
    break;

  case 2285: // vec_value_1: '[' COMMA signed_number
#line 4150 "DynareBison.yy"
              { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 9293 "DynareBison.cc"
    break;

  case 2286: // vec_value_1: vec_value_1 signed_number
#line 4152 "DynareBison.yy"
              { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 9299 "DynareBison.cc"
    break;

  case 2287: // vec_value_1: vec_value_1 COMMA signed_number
#line 4154 "DynareBison.yy"
              { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 9305 "DynareBison.cc"
    break;

  case 2288: // vec_value: vec_value_1 ']'
#line 4158 "DynareBison.yy"
             { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ']'; }
#line 9311 "DynareBison.cc"
    break;

  case 2289: // vec_value: vec_value_1 COMMA ']'
#line 4160 "DynareBison.yy"
             { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ']'; }
#line 9317 "DynareBison.cc"
    break;

  case 2290: // vec_value_list: vec_value_list COMMA vec_value
#line 4164 "DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 9323 "DynareBison.cc"
    break;

  case 2291: // vec_value_list: vec_value
#line 4165 "DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9329 "DynareBison.cc"
    break;

  case 2292: // vec_of_vec_value: '[' vec_value_list ']'
#line 4169 "DynareBison.yy"
                   { yylhs.value.as < string > () = yystack_[1].value.as < string > (); }
#line 9335 "DynareBison.cc"
    break;

  case 2293: // vec_of_vec_value: vec_value
#line 4170 "DynareBison.yy"
                   { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9341 "DynareBison.cc"
    break;

  case 2294: // vec_value_1_w_inf: '[' signed_number_w_inf
#line 4174 "DynareBison.yy"
                    { yylhs.value.as < string > () = '[' + yystack_[0].value.as < string > (); }
#line 9347 "DynareBison.cc"
    break;

  case 2295: // vec_value_1_w_inf: vec_value_1_w_inf signed_number_w_inf
#line 4176 "DynareBison.yy"
                    { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ' ' + yystack_[0].value.as < string > (); }
#line 9353 "DynareBison.cc"
    break;

  case 2296: // vec_value_w_inf: vec_value_1_w_inf ']'
#line 4180 "DynareBison.yy"
                  { yylhs.value.as < string > () = yystack_[1].value.as < string > () + ']'; }
#line 9359 "DynareBison.cc"
    break;

  case 2297: // symbol: NAME
#line 4182 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9365 "DynareBison.cc"
    break;

  case 2298: // symbol: ALPHA
#line 4183 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9371 "DynareBison.cc"
    break;

  case 2299: // symbol: BETA
#line 4184 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9377 "DynareBison.cc"
    break;

  case 2300: // symbol: NINV
#line 4185 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9383 "DynareBison.cc"
    break;

  case 2301: // symbol: ABAND
#line 4186 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9389 "DynareBison.cc"
    break;

  case 2302: // symbol: CMS
#line 4187 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9395 "DynareBison.cc"
    break;

  case 2303: // symbol: NCMS
#line 4188 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9401 "DynareBison.cc"
    break;

  case 2304: // symbol: CNUM
#line 4189 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9407 "DynareBison.cc"
    break;

  case 2305: // symbol: GAMMA
#line 4190 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9413 "DynareBison.cc"
    break;

  case 2306: // symbol: INV_GAMMA
#line 4191 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9419 "DynareBison.cc"
    break;

  case 2307: // symbol: INV_GAMMA1
#line 4192 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9425 "DynareBison.cc"
    break;

  case 2308: // symbol: INV_GAMMA2
#line 4193 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9431 "DynareBison.cc"
    break;

  case 2309: // symbol: NORMAL
#line 4194 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9437 "DynareBison.cc"
    break;

  case 2310: // symbol: UNIFORM
#line 4195 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9443 "DynareBison.cc"
    break;

  case 2311: // symbol: EPS
#line 4196 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9449 "DynareBison.cc"
    break;

  case 2312: // symbol: PDF
#line 4197 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9455 "DynareBison.cc"
    break;

  case 2313: // symbol: FIG
#line 4198 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9461 "DynareBison.cc"
    break;

  case 2314: // symbol: NONE
#line 4199 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9467 "DynareBison.cc"
    break;

  case 2315: // symbol: DR
#line 4200 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9473 "DynareBison.cc"
    break;

  case 2316: // symbol: PRIOR
#line 4201 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9479 "DynareBison.cc"
    break;

  case 2317: // symbol: TRUE
#line 4202 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9485 "DynareBison.cc"
    break;

  case 2318: // symbol: FALSE
#line 4203 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9491 "DynareBison.cc"
    break;

  case 2319: // symbol: BIND
#line 4204 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9497 "DynareBison.cc"
    break;

  case 2320: // symbol: RELAX
#line 4205 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9503 "DynareBison.cc"
    break;

  case 2321: // symbol: ERROR_BIND
#line 4206 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9509 "DynareBison.cc"
    break;

  case 2322: // symbol: ERROR_RELAX
#line 4207 "DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 9515 "DynareBison.cc"
    break;


#line 9519 "DynareBison.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -3603;

  const short parser::yytable_ninf_ = -2317;

  const short
  parser::yypact_[] =
  {
    6688,   338,   353, 10063,  -152,   -14,   -66,   -39,   -27, 10676,
     499,    10,    17,   685, 11228,    24,    28,   716,   785,    33,
      38, -3603,    45, 11849,    47,   802,    52,    55,   821,   829,
      56,   835,    79,   140,   251,   866, 12163,   915,   922,   255,
     261,   301, -3603,   927,   376,   380,   469, 12202, 16384, 16384,
     502, -3603, 12706,  1020,  1056,  1059,  1090, 16384,   177,  1094,
    1098, 12249,  1110,   697,  1144,  1146,   472,  1148, 12316, 12355,
    1153, 12392,   493, 12411,   523,  1156,  1158,  1164, 12459, -3603,
   -3603, -3603, -3603, -3603, 16384, 12725, 16384, 16384, -3603, -3603,
   16384,   526, 12612, 16384,  1168,  1171,  1173,   525,   534,   579,
     587,  1176,   594,  1178, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603,  1182,   611, 12649,  1184,  1186,  1192,  1194,
    1197,  1211, -3603,   613,   592,   615,   618,   624,   632,   635,
     638,  1222, 12802,   218,  6139, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603,   354, -3603, -3603,  1100, -3603, -3603,  1152, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
     258,   641,  3088,   648,  2903, -3603,  2628,  4535, -3603,   320,
   -3603,  1512,  1304,   968, 16384, -3603,   369,  5524,   331, 15967,
   15967, 16384,  1342, -3603,  7294,  5576, 14102, 14184, 14393,  1375,
   -3603,  1145,  1340, 16384,  1711, -3603,  1872,  5926, 16384, 16384,
    1361,   687, 16384, -3603,   514, 16384,  1401,   687, 16384,  1125,
   15967,  1291, -3603, -3603,  2685, -3603,  1290,   768,  5328, -3603,
   -3603, -3603,  1078,  1205, -3603, 16384, 16384,   475,   978, 16384,
   16384, 16384, -3603,  5012,  6474,  7495,  7641,    96,  1349,   805,
   11422,  1229,  7703, -3603,   503, -3603, 11268, -3603,   503, -3603,
    2675,  7787, 15967,   413,   179,  1114,  1251, -3603,  2539,  7858,
   16169,  1301,   858, -3603,  4598, -3603,  1250, -3603, -3603,  1420,
   -3603,  5280,  7899, -3603,  1246,  8052, -3603,  1112, -3603,  7562,
    8088,  1324, -3603,  3452,  8248, -3603, -3603,  8125, -3603,  1198,
   -3603,   591, -3603,  1326,  8277,  8305,   284,  8346,    99,  8391,
     102,  8499,   103, 16384, 16384,  8544, -3603,  1210, -3603,   420,
    8596,  8642,  1196, -3603,  1356, -3603,  1366, -3603,  1379, -3603,
     223, -3603,   239, -3603, 11302,  1280, 16384,  1373, -3603, 13823,
    1046, -3603,  1167,  8661, -3603,  3570, -3603, 13660, -3603,   760,
   -3603,  1187, -3603,   104, -3603,  2589,   920,   844, -3603,   194,
   -3603,   870,   181,   181, -3603, -3603,  1080, -3603,  8857,  1095,
   -3603, -3603, 14327, 16384, 14347, 14435, 12091, 15713, -3603,  1573,
   -3603,  1596,  1601,  1608,  1621,  1627, -3603,  1629,  1670,  1672,
   -3603,  1682,  1686,  1707,  1715, -3603,  1756,  1106, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603,  1747,  1753,  1775, -3603,  1815,
    1165, -3603, -3603, -3603,  1796, -3603,  1814,  1824, -3603, -3603,
    1833, -3603, -3603, -3603, -3603,  1199,  1862, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, 16384, -3603, -3603, -3603, -3603, -3603, -3603,
    1215, -3603,  1854,  1863,  1865,  1877,  1882,  1884,  1888,  1890,
   -3603,   207, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603,  1891,  1892,  1893,  1894,   212, -3603, -3603, -3603,
   -3603, -3603, -3603, 16384,   505, -3603,  1916,  1898, -3603, -3603,
   -3603,  1900, -3603,  1906,  1908,  1910, -3603,  1911, -3603,  1912,
   -3603,  1284,  1944, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  1299, -3603,
    1298,  1317, 14745, -3603,  1954,  1334, -3603, -3603,  1971,  1972,
   -3603, -3603, -3603,  1974,  1977,  1978, -3603, -3603, -3603,  1980,
    1983,  1984, -3603,  1986,  1988, -3603, -3603,  1989,  1990,  1991,
    1992,  1993, -3603,  1995,  1996,  1998, -3603, -3603, -3603,  1999,
    2000,  2002,  2005,  2006,  2009,  2013,  2014,  2015, -3603,  2016,
    2021, -3603, -3603,  2022,  2026,  2027,  2030, -3603,  2033,  2036,
    2044,  2046,  2047, -3603, -3603,  2048,  2050,  2051,  2052, -3603,
    2054,  2057,  2059,  2068,  2072,  2073,  2074,  2077,  2079,  2085,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  2089,
    2091, -3603,  2092, -3603,  2094,  2095,  2097,  2098, -3603, -3603,
    2101,  2102, -3603,  2106,  2108,  2112, -3603,  2115, -3603, -3603,
   -3603, -3603, -3603,  2116,  2118,  2121,   224, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, 16384, -3603,
   16384, 14081, -3603,   170, -3603, 16384, 16384, 10703, -3603,  2143,
   16384, 16384, 14125, -3603,  2144,  1339, -3603,  2125,  2128, -3603,
    1497,  2156, -3603, -3603, -3603, -3603, -3603, -3603, -3603,    54,
   14774, -3603,  2161,  2151,  2153,  2154,  2162,  2167,   225, -3603,
     227, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  1533, 14917,
   -3603,  1535,  1537,  2171,  2176,  2177,  2180,  2181,   231, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   14954, -3603,  2205,  2188,  2191,  2192,  2193,  2195,  2196,  2198,
    2200,  2201, -3603, -3603, -3603, -3603, -3603,  2204,  2206,  2207,
    2218,  2230,  2238,  2239,  2242,  1569,  2268, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, 14994,  1660,   234, 15036, -3603,   217,  1691,
    1692,  2335, 11422, 11279,  2339, -3603, -3603,  2342,  2343, -3603,
    2344, -3603,  2348, -3603, -3603,   250, -3603, -3603, -3603,  2351,
    1716,   528, 15967, -3603,  1718,   260, -3603, 16384, -3603,   520,
    1720, 15246, -3603,  2378, 15265, -3603,  1724,  1726,  2382,   509,
   -3603,  1728,  2383, -3603, -3603, 15286, -3603,  1730, 15305, 15327,
    7544,  2366,  2372,  2374,  2375, -3603,  2385,  2392,  2395,  2400,
    2406, -3603, -3603, -3603, -3603, -3603, -3603,  2408,  2409, -3603,
    2411,  2414, -3603,   265, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, 16384, -3603,   107,  1736, 14372,   737, -3603,
    1744, -3603, -3603, -3603,  1781,  1783,  1784,  1788,  1790,  1792,
   11422, 11422,  1793,  1795,  1798,  1800,  1803,  1805,  1806,  1810,
    1816,  1819,  1820,  1823,  1825,  1827,  1830,  1831,  1834,  1835,
    1844, 11422,  3995, -3603,   -28,  1037,  2459, -3603,   273, -3603,
   -3603, -3603,  2480,  2482, -3603,  2483,  2485, -3603, -3603,  2487,
   -3603,   278, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603,   300, -3603, -3603,
   -3603, -3603, -3603,   304, -3603, -3603, -3603,  1746, 16384, 16384,
     542, -3603, -3603,   321,   336, 16384,   533, -3603,  1853,  2490,
    2492, -3603,  2493,  2495, -3603,  1860,  2518, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603,  2498, 14663, -3603,  2499,  2500,   656,
   -3603, -3603,   341, -3603,  2502,  2503,  2508,  2514,  2516,  1889,
    2541, -3603, -3603, -3603, -3603, -3603,  2371,   345, -3603,  2526,
    2528, -3603,   348, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603,  2529,  2531,  2533,  2534,  1901,  2557, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
    2542,  2543,  2544,   351, -3603, -3603, -3603, -3603, -3603,   355,
   -3603, -3603, -3603, -3603,  1060,   522, -3603,  2546,  2547,   359,
   -3603, -3603, -3603, -3603, -3603,  2548,  2549,  2553,  2554,  2558,
    2561, -3603, -3603, -3603,  2562,  2567,  2568, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603,  2569,  1905,  2578,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603,  1939,  2597, -3603, -3603, -3603, -3603, -3603,
   -3603,  2577,  2579, -3603, -3603,  1945,  2606, -3603, -3603, -3603,
   -3603, -3603,  1951,  2611, -3603, -3603, -3603,  2592,  2594, 16384,
   -3603,   108,  1736, -3603, 16384, -3603,   111,  1736, -3603, 16384,
   -3603,   168,  1736, -3603,  8892, -3603,  8911, -3603, 16384, -3603,
   -3603,  2598,  2599,  2600,  2602,  2603,  2604,  2605,   366, -3603,
    2609, -3603, -3603, -3603, -3603, -3603,  2610,  2613,  2614, -3603,
    2616,  2617,  2619, -3603, -3603, -3603,  2620,  2622,  1961,  2632,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, 16384, -3603,  2302, -3603,  1997,  2008,  2010,  2625, -3603,
    2626,   367, -3603, -3603, -3603, -3603,  1010,  2627,  2631,  2634,
     368, -3603, -3603, -3603, -3603,  2636,  2641,  2645,  2648,  2649,
    2651,  2652,  2654,  2655,  2657,  2660,  2663,  2664,  2671,  2673,
    2677,  2681,  2692,  2698,  2699,  2702,  2703,  2706,  2708,  2710,
    2711,  2712,  2713,  2714,  2716,  2717,  2017,  2696, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
    2718,  2719,  2720,  2722,   377, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, 15504, -3603, 14684,  2723,  2725,  2726,  2727,
    2742,  2743,  2744,  2745,  2746,  2747,  2749, -3603,  2751, -3603,
    2752,  2754,  2755,  2756, -3603,  2757,  2761,  2762,  2764,  2765,
    2766,  2768,  2769,  2771,  2772,  2776,  2777,  2778,  2779,  2780,
    2781,  2783,  2784,  2787,  2790,  2792,  2797,  2798,  2799,  2801,
    2802,  2804,  2805,  2827,  2049, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603,  2810, -3603, -3603,  2813,  2814,  2816,  2836,
    2837,  2838,  2839,  2840,  2841,  2843, -3603,  2846,  2869,  2214,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  2872,  2219, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603,  2856, -3603,  2857,  2862,  2865,  2871,  2873,  2874,
    2877,  2878,  2879,  2880,  2881,  2882,  2884,  2888,  2891,  2893,
    2256, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  2894,  2899, -3603,  2900,
    2922,  2266, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  2905,
    2906,  2909,  2911, -3603,  2924,  2276, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603,  2934,  2280, -3603, -3603, -3603,
   -3603,  2917,  2940,  2284, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,   150,  2921,
    2923,  2925,  2927,  2930,  2931,   379, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603,  2454, -3603, -3603,  2932,   383, -3603, -3603,
   -3603, -3603, -3603,  2933,  2935,  2938,  2939,   386, -3603, -3603,
   -3603, -3603, -3603,  2942,  2944,   387, -3603, -3603, -3603,   391,
    2748,  2948,  2952,  2953,  2954,  2955, -3603, -3603, -3603, -3603,
    2956,  2957, -3603,  2958,  2960,  2961,  2288,  2971, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603,  2305,  2327,  2330,  2324,   416,
   -3603,  2966,  2333,  2334,  2336,  2340,  2345,  2350,  2337,  2346,
   -3603,  2354,  2355,  2356,  2357, -3603, 12091, 12091,  2358,  2359,
    2361,  2362,  2363,  2365,  2368,  2369,  2370,  2396,  2397,  2399,
    2405,  2407,  2412, 12091,  6760, -3603,   -16, -3603, -3603,  2415,
     259,  2389,   528,   574,   528,  2907,   574,  2915, 15967,  2918,
     315,  2945,  2973, 16212, 16384,  3088,  2981,  2983,   528,  2985,
    2903,  2986,  2373,  2989,   528,  1370, 12868,  2628, -3603, 16384,
    2990,  2991,  2992,   528,   528,  3006,   528,  3007,  1512,  2401,
     528,  2417,  3009,  3010,  1304,  2445,  2446,  2447, -3603, 16384,
   15967,  1075,    50,  1340,  1340, 16384,  3016, 12915,   369, -3603,
   12945, 12964,  2453, -3603, 12091,  2455,  3020,  2734,   528, 16384,
     528,   528,   528,  3024, 15967,   315,   155,   315,  3025,  2461,
     528,   528,  3026,  3029,   463,   528,   528,   528,   528,   528,
     528,   528,   528,  3030,  3031, 15967, 15967, 15967,  3041,  1230,
    3045,  3046, 16120, 15967,  3048,  2373,  2478,  2478, 15821,  3049,
     595,   528,  1364,  1599,  3050, 16384,  1400,  1462,  2484,  3058,
    3060,   528,  2507,   508,  3062,  1846,   528,  3069,  1302,  2510,
    3075,  3078,   528,  3082,  7294, 13021,  2998, -3603,  2517, -3603,
    4392, -3603,  3023,  3173,  2520, -3603, 12091,  3176,  3178,  2524,
   -3603, 12091,  2525,  3092,  3093,  2532,  1145,  3094,  2535,  2540,
   -3603, 12091,  2928,  2936,  2937,  2951,  2959,  1711,  2559,  1872,
   13059,  2537,  2560, -3603,   399,  2563, 16384, 15967,   517,   521,
     559,   687,  2564,  2566, -3603, 12091,   574,   528,  3097,  3099,
     399,  3105,  3124, 15909,  3128,  3133,  3134,   528,   528,   528,
    3136,  3137,   528,  2572,   514,  2573,  2574,  2575,  2576, -3603,
   16384,  3144,  2581,  2607, -3603, 10880,  7218, 16384, 16384, 10584,
   -3603,  1170, -3603,   528,   528,  2608,  3172,  2612,  2685,  2618,
     436, 15967,  2615,  2621,   528, -3603,  2623,  2624,  2633, -3603,
    2635,  2638, -3603, 16384,  2639, -3603,   399, -3603, 16384,  2640,
   -3603,  2643,   978,  2646, -3603, 12091,  2647,  2656,  7756, 16384,
    7326,   528,  3174,  3177, 16016,   528,  3180,  3182,   528,  3187,
     528,  3191,  3192,  3197,  5012, 13212,   238,  1736, -3603, -3603,
   16384, -3603,  3244,  4993, -3603, -3603, -3603, 11422, 11422, 11422,
   11422, 16384, 16384,  2895,  2895, 11422, 11422, 11422, 11422, 11422,
   11422, 11422, 11422, 11422, 11422, 11422, 11422, 11422, 11422, 11422,
   11422, 11422, 11422,   399,  1403, 11422, 11422, 11422, 11422, 11422,
   11422, 11422, 11422, 11422, 11422, 11422,  2661, 16384,  2644, -3603,
   -3603, -3603,  3198,   503,  2662,   528,   528,  3207,   528,  3214,
   11268,  2665,   503,  2666, 11268,  2667,  2668,  3267,   462,  2669,
   -3603,  2693,  2670,  3077,  2674,  2688,  2691, -3603,  2705,  1587,
    3217, 16384, 16384, 13258,  2539, 16384,  2724, -3603, 16384, 16384,
     528,   528, 12091,  -110,   432, -3603, -3603,  4598,  2729, 15967,
    2672, 15967,  2676,  3220,  2731,  1250, 16384,  4473, -3603,  3289,
    1420,  2732,   528,  2373,  5280, 13277,  3223,   315,  3230,  2373,
   13315,  1246,  2707, 12091,  3035,  1112,  2733,  7562, 13372, 12091,
   12091, 12091, 12091,  2735, -3603,  3259,   528,  3452, 13420,  3276,
    3291,  3292,  3293,  3302,  3303,  3304,  3305,  3307,  3308,  2750,
    8125, 13468,  1198, 15967,   315,  2753,   591, 13515,  1326, -3603,
   -3603,   311,  1736, -3603, -3603,   326,  1736, -3603, -3603,   363,
    1736, -3603, -3603, 16384, -3603, -3603, 16384, -3603, -3603, -3603,
   -3603, 16384, 12091, 16384, 16384,  3309,   399,  1210,  2758, 15967,
    1399,  3311,  3312,   881,  1340,  1340, 16384,  3313, 13573,   420,
    3061, -3603,  2760,  2767,  2770, 16384,  2759,   223,  2773,  3385,
    3388,  3389, -3603,   418, -3603, -3603, -3603, -3603, -3603, 16384,
    2759,  2759,   239,  2785,  3322,  3323,  3327,  3330,  3331,  3332,
    3335,  3337,  3338,  3353,  3354,  3357,  3358,   528,  3359,  2791,
     528,   528,  2794,  2795,  2796,  3364,  3365,  2811,   528,  3368,
     528,   528,   528,   528,   528,  2803, 11302, 15967,  1340,  1340,
    3377,  1280,  2815,  2819, -3603, 16384,  2820, 16384,   314,  3380,
    3382,  3387,  3390, 15967,  3391,  2821,  3392,   322,  3393,  3394,
    3407,  3410,  3411,   528,   528,  3412,  3413,  3414,  3415,  3418,
    3419,   528,  3420,  3421,  3423,  3424,  3425,  3426,  3430,  3431,
    3432,  3433,  3434,  3435,  3436,  3437,  3441,  3454,  3455,  3459,
    2478, 13823,  2823, -3603,  3460, 15967,  3461, 15967, 15967,  2478,
    3462,  3463,  2478,   574,  3465,  1167, 13611,  3570,  2829,    81,
     528,   528,   528,  3467,   528,  3468,  3469,   528,   528,  3472,
    3474,  3475,  3476,   528,   528, 13660,  2912,  3477,  3479,  3480,
     760,  2919,  3481,   574,   574,  3483,  1187,  2920,   104,  2926,
    3487,  2589,  2941,  3040,    92,  2943,  2946,   789, -3603,  2902,
    2947,  3490,   357,  3491,  3493,   844,  2963, -3603,   548, -3603,
     315,   194,  2964, 16312,  3505, 16312, 16312,   870,  2968, 15967,
    3508,   181,  2974,  2976,  3211,   575, -3603,   528,  1395,  3514,
    2759,   528,  3517,  3519,  2373,   528,  3520,  2977,  1080,  2965,
   16384, 16384, -3603,  3509, 16384,  2979,  1340, 16384, 16384, -3603,
   16527, 16384, 16384, -3603, 16365, 12091, 12091, 12091, 12091,  3216,
    3216, 12091, 12091, 12091, 12091, 12091, 12091, 12091, 12091, 12091,
   12091, 12091, 12091, 12091, 12091, 12091,  2854, 12091, 12091, 12091,
   12091, 12091, 12091, 12091, 12091, 12091, 12091, 12091, -3603,  2970,
    1696,  2972,   302, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603,   518, -3603,   309, -3603, -3603, -3603, -3603, -3603,
   -3603,  2975, -3603,  2980, -3603, -3603, -3603, -3603,  2982, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
    8955, -3603,  9000, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, 16384, -3603, -3603, -3603, -3603,
    3376, -3603,  2987, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603,   836, -3603,  3225,  3225, -3603, -3603, -3603,  9054, -3603,
   -3603,  9108, -3603,  9153, -3603,  7346, 16384, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,   836, -3603,
   -3603, -3603, -3603, 16384, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603,   530,   583, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,   497,
     243, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603,  3355, -3603, -3603, -3603,  3355,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
    3361, -3603, -3603, -3603, -3603, -3603, -3603,  9207, 16384, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  7647,  3638,
    2988,  3639, 16384, 12091, -3603,   966, 16384, 12091, -3603,  7690,
   14144, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  1335, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  9252, 15856,
   -3603, -3603,  3552,  3556,  2994, 16384, -3603, -3603,  3225, -3603,
    3225, -3603,  3225, -3603, -3603, -3603,   872, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, 16384, -3603,
   -3603,  3646,    -7,  2995, 16384, -3603, 11422,  3001,  7823, -3603,
     183, -3603,  3632,  3640,  3004, -3603, -3603, 11422, -3603, -3603,
   -3603, 16384, -3603, 15967, -3603, -3603, -3603, -3603,  5360, -3603,
     528,  3011, -3603, -3603,  3427, -3603,  1078, -3603,   221, -3603,
    3012,   372,  3642, -3603,   676, -3603, -3603,  3047, -3603, -3603,
   16384,  7923, 12091, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
    9271,  1736, -3603, -3603, -3603,  3406, -3603, -3603,  2367,  2653,
    3471,  3497,  3015,  3017,  3524,  3664,  3800,  3908,  4110,  4226,
    4249,  4323,  4370,  4385,  4511,  4536,  2700,  4707,  4738,   342,
     415,  4869,  3021, -3603,  2737,  2737,  1073,  1073,  1073,  1073,
     647,   647,  2895,  2895,  3279, -3603, -3603, 11422,  3022, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, 16384, 16384, 12091,   313, -3603,  3027,   544,
    3028,  1078,  3443, -3603,   537, -3603, -3603, -3603, -3603, -3603,
   -3603,  9313, -3603,  9502, -3603, -3603,  9565,  3033, -3603, -3603,
    4994,   656,  3032,   779, 12091, -3603, -3603, -3603, -3603, 16384,
   -3603, 16384, -3603, -3603, -3603,   470,  3036, -3603, 12091, -3603,
   -3603, -3603, -3603, -3603, -3603,  9605, -3603, -3603, -3603, -3603,
   -3603, -3603,  9661, -3603, 16384,  4811, -3603, -3603, -3603, -3603,
   -3603,  9718,  8017,  8030,  8222,  8242, -3603, -3603, -3603, -3603,
   -3603,  9762, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603,  9804, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603,  9824, -3603, 11422, 11422,  1736, -3603, -3603,
    1736, -3603, -3603,  1736, -3603, -3603, -3603, -3603, 11422, -3603,
    4811, -3603, -3603,  3034, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603,   836, -3603,  3225,  3225, -3603, -3603,
   -3603,  9861, -3603, -3603, -3603, -3603, -3603, -3603,   513,   178,
   -3603, -3603, -3603, 16384, 16384, 16384,  3660,  1010,  3037, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  1230,
     506, -3603, -3603, -3603,  4956,  4956,  4956, -3603, -3603,  4956,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603,  3038, -3603,  3039, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, 16384, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, 11422, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
    9919, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  3593,  3597,
    3042, -3603, -3603,  3044, -3603, 16384,   371, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  3679,  3051, -3603, -3603,
   -3603, -3603, -3603, -3603,  3043, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  3052,  3053, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603,   600,  3701,  3055, -3603, -3603,   162,  3703,  3056,
    3057,  3059,  3717,  3063, -3603,  3064,  2866,  2950,  5020,  5063,
    5299,  5359,  5489,  5509,  5560,  5587,  5637,  5679,  5706,  5862,
    5896,  6075,  6140,   461,   709, -3603,  2817,  2817,  1255,  1255,
    1255,  1255,   976,   976,  3216,  3216,  3279, 12091,  3697,  3706,
    3707,   429, -3603, -3603, -3603, -3603,   723,  3066,  3708,  3641,
    3070, -3603, -3603,   310, -3603, -3603, 16384, -3603, -3603, -3603,
   16384, -3603, -3603,   931,  3643,  3071, -3603,   430, -3603, -3603,
   -3603, -3603, 15556,   447,  1030, -3603, -3603,   574, -3603,   524,
   -3603, -3603,  3739, -3603, -3603,   448,   451,  3740, -3603, -3603,
     452, -3603, -3603,  4392, -3603, 12091,  3741,  2967, 12091,  3743,
    8279, -3603,  3089, 14165, 12091, -3603, -3603,  3090,   296,  3085,
   -3603, -3603,  3727, 15596, 12091, -3603, 15618,   110,  3750,  3668,
    3753, 15647,  6152, -3603, -3603, 16384, 11422,  3499, 11422, -3603,
    8529,  1128, -3603,   454, 11279, -3603,  3107, -3603,  3643,   541,
     110,   944,  3755, 16384, -3603,   574,  3135,   688,  3138, 12091,
   -3603,  8786, -3603, -3603, -3603, 11422, 11422, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603,  3527, -3603, -3603, 11422, -3603, 11422, -3603,
   -3603,  3139,  3995,   455, 16384,  3771,  3775,  8831, 12091,  3143,
    3146,   547,  3147, -3603,   577,  3643,  3149,   603, -3603, 16384,
   -3603, -3603, -3603,  3150, -3603,   432, -3603, 12091, -3603,  6172,
    1189,  3932,  3782, -3603,  8889, -3603, -3603,  3967, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  6184,  6211, -3603, -3603,
   -3603,  3995,   494,   457, -3603,  3545, -3603,   172, -3603, -3603,
   -3603, -3603, -3603, 11422, -3603, -3603, -3603, -3603, -3603, -3603,
   14703,  3154,  3155,  3156,  3157, -3603,  3179,  4182,  6242, -3603,
    3833,  3193, -3603, -3603,   582, -3603,   199, 12091, -3603,  1396,
   -3603,  3826,  3828,  3829,  3830,  3831,  3843,  3845,  3846,  3849,
     458, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, 16384,  3212,  1340, 16384,  3213,  3405, 16384,  3215,
    3770, 12091, 12091, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, 12091, -3603,
   12091, -3603,  4811,   465,  2791,   528,   574,  1696,  3221,  3857,
    3871,   466, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603,  1696,  3238, -3603,  3807, -3603, -3603, -3603,
   -3603, -3603,  3237,   346, 16069,   836, -3603,  3245, -3603, -3603,
   -3603, -3603, -3603,  1200,  3355, -3603, -3603,  1225,  3361, -3603,
    4811,  3899,  3901,  3902, -3603, 12091, 12091,  9279, 12091, -3603,
   -3603,  3248,  9442,  1696,  3249,   333, 12091,  3262,  9497,  3264,
   -3603, -3603, 12091,  3266, 16384, -3603, 16384,  3268, 16384, -3603,
    1247, -3603,  9606, -3603, -3603, 15967, -3603, 10727, -3603,   495,
    3269,  3270,   370,    14,  3265, 12091,  3905, -3603, -3603,  3274,
   -3603, 10041, -3603,  6255,  6448,   473,  2984,  3103, 11422, 11422,
   -3603, 10014, 12091, 12091, -3603, 10053,  1078, -3603,  3278,  1078,
    3281, -3603,   496, -3603,  3282, -3603, 16169,  6468, -3603, -3603,
   -3603, 12091, -3603, -3603, 16384, 16384, -3603, -3603, -3603, -3603,
   -3603, -3603,  3995, -3603, -3603, -3603, -3603, 16384, -3603, 16384,
   -3603,  3397, -3603,  2478, -3603, 10082, 11422, 11422, 11422, 11422,
    1396, -3603,   574,  2478,   528,  2947,   574,  2478,  2233,  2478,
    2478,   600,  3283,  3285,  3837,  3225,  3286, 16567, -3603,  3287,
   16414, -3603,  6624,  6636,  3148,  3201, 12091, -3603, -3603, -3603,
   -3603, -3603, -3603,   574, 12091,   723,  3296,   474,   723, -3603,
    3842,  3858,  3294,  3592, -3603,  3300,   375,  3297, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  3699, -3603, -3603, 12091,
   12091, 12091,  3383, 10119, -3603, 10175, -3603, -3603,   477,   723,
    3306,  3937, 10221, -3603, -3603, -3603,  3395, -3603,  3961,  3963,
   -3603, 10117,  3623, 11422, -3603, -3603, -3603,  3314,  3618, -3603,
   -3603,   399,  3973,   399,  3974, 10242,   574, -3603, -3603, -3603,
   -3603,   325, -3603, 11422, 11422,  6690,  3995, -3603, 10369, 10421,
   -3603,   633, -3603,   655, -3603,  1542, -3603, 14726, -3603, 10434,
   10174,   412, 10210, 15666, 10317,  3645, 11448,  3892,  3446, -3603,
   -3603, 10448, 10460, 10565, 10617, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  3326,  3328,  3057,  3329,
    3333, -3603,  3336, -3603, -3603, 12091, 12091,  4811, -3603,  4811,
   -3603, -3603,  3334,   479, -3603,  3324,  3895,   803,  1696,  3341,
     400,  3992, -3603,   480,  3993, -3603,  3994, 12091, -3603, -3603,
    3345,   481,  1696,  3346, -3603, 12091,   110,   110, 16384, -3603,
    3659, -3603, 10845, -3603,   803,  3342,   110, -3603,   110, -3603,
   -3603,  3347,  3348,  6704,  6723, -3603, -3603, -3603,  3352,  3356,
     803,   803,  3360, -3603, 16384, -3603,   414,  1736, -3603, -3603,
    3366, 16384, -3603,  3666, -3603, 11869, 11901,  3363,  5338,  3988,
   11448, -3603,  4010,  3923, -3603, -3603, -3603, -3603,  3911, 16622,
    3535, 16465,  3919,  6793,  6810, -3603,  3369,  3934, -3603, 12091,
     515, -3603,   482,   723,  3373,  4004,  1160,  3699, -3603,  1218,
   12091, 10914, -3603,  3375,   484,   723,  1294,  3384,  3386,  3698,
   -3603, -3603,   519,   399,  3404,  3408, -3603, -3603, -3603, -3603,
   -3603, -3603,   529,   598, -3603,   573,  1736, -3603, -3603, -3603,
    3700, -3603,  3409,  3417, 16384, 12059, -3603,  5338, -3603, 16384,
    4043,  3057,  3399, -3603, -3603,  3402, -3603, -3603, -3603, -3603,
   -3603,  6886,  1036, -3603, 12091, -3603,  3416,   486,  1696,  3438,
   -3603,  4044,  4046, -3603, -3603,  3422,   489, -3603, -3603, -3603,
   -3603, -3603,  3440, -3603, -3603, -3603, -3603,  1736, -3603, -3603,
   -3603, 16384, 16384,  4066,  3439, 11448,   373, -3603, 16384,  3583,
    3971, -3603, 12091, -3603,  6923, -3603,  3445,   490,   723, 12091,
   12091, -3603,  3450, -3603, -3603,  4070,  4075,  3987, 16384,  3451,
   16384, -3603,   487, -3603, -3603,  6979, -3603, -3603,  3453,   492,
   -3603,  4079, -3603,  3991,  4001,  3456,  4081, -3603, -3603, -3603,
   -3603, -3603,  3457, 12091,  3464,  3466, -3603,  4002, -3603,  4811,
   -3603, -3603,  3473, -3603
  };

  const short
  parser::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2318,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2297,     0,     0,     0,     0,     0,     0,     0,
       0,  1148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2317,
    2319,  2320,  2321,  2322,     0,     0,     0,     0,  1047,  1052,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2298,  2299,  2301,  2300,  2302,  2303,
    2304,  2305,  2306,  2307,  2308,  2309,  2310,  2311,  2312,  2313,
    2315,  2314,  2316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   478,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,    48,    49,    95,    97,
       5,    33,    35,    34,   121,     6,     7,     8,     4,     9,
      10,    11,    17,    13,   111,    14,    15,    16,    32,   122,
     123,   124,    12,    18,    20,    89,    90,    91,    92,    19,
      21,    22,    23,    57,   112,   113,   114,   115,   118,   116,
     117,    24,    93,    25,    27,    29,    28,    52,    30,    31,
      38,    39,     0,    36,    37,     0,    40,    41,     0,    26,
      42,    46,    43,    44,    45,    47,    50,    51,    53,    54,
      55,    74,    75,    76,    56,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    68,    69,    70,   104,   102,   103,
     101,   100,    99,    98,    71,    72,    73,    86,    88,    87,
      94,   105,    96,   106,   107,   108,   109,   110,   119,   120,
       0,     0,     0,     0,     0,  1631,     0,     0,   744,     0,
     555,     0,     0,     0,     0,  1256,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,     0,
    1666,     0,     0,     0,     0,  1600,     0,     0,     0,     0,
       0,     0,     0,  1092,     0,     0,     0,     0,     0,     0,
       0,     0,   358,   386,     0,  1135,     0,  1142,     0,  1134,
     561,   565,     0,     0,  1675,     0,     0,     0,     0,     0,
       0,     0,  1082,     0,     0,     0,     0,   243,     0,     0,
       0,     0,     0,   566,     0,   572,     0,   590,     0,   596,
       0,     0,     0,     0,     0,     0,     0,  1244,     0,     0,
       0,     0,     0,   667,     0,  1692,     0,  1625,   543,     0,
     680,     0,     0,  1248,     0,     0,  1151,     0,  1153,     0,
       0,     0,  1218,     0,     0,  1164,  1165,     0,  1192,     0,
    1203,     0,  1211,     0,     0,     0,     0,     0,   207,     0,
     219,     0,   231,     0,     0,     0,   255,     0,  1252,     0,
       0,     0,   258,  1237,     0,  1239,     0,  1241,     0,  1243,
       0,   161,     0,  1469,     0,     0,     0,     0,  1341,     0,
       0,  1395,     0,     0,  1359,     0,  1467,     0,  1428,     0,
    1417,     0,  1405,     0,  1377,     0,     0,     0,   344,     0,
     501,     0,     0,     0,   362,   602,     0,  1260,     0,     0,
       1,     3,     0,     0,     0,     0,     0,     0,  1281,     0,
    1969,     0,     0,     0,     0,     0,  1908,     0,     0,     0,
    1909,     0,     0,     0,     0,  1269,  1280,     0,  1270,  1275,
    1273,  1276,  1274,  1271,  1272,  1277,  1278,  1262,  1263,  1264,
    1265,  1266,  1267,  1268,  1289,     0,     0,     0,  1283,  1288,
       0,  1285,  1284,  1286,     0,  1889,     0,     0,  1875,  1915,
       0,  2120,  2121,  2122,  2123,     0,  1636,  1639,  1643,  1640,
    1642,  1637,  1641,  1646,  1651,  1652,  1638,  1647,  1650,  1644,
    1645,  1648,  1649,     0,  1633,   742,   263,   264,   265,   266,
       0,  2035,     0,     0,     0,     0,     0,     0,     0,     0,
     559,     0,   558,   547,   552,   554,   551,   560,   548,   549,
     550,   553,     0,     0,     0,     0,     0,  1612,  1615,  1614,
    1616,  1617,  1618,     0,     0,  1622,     0,     0,  1956,  1943,
    1939,     0,  1963,     0,     0,     0,  1826,     0,  1961,     0,
    1839,     0,  1580,  1587,  1593,  1588,  1594,  1582,  1583,  1589,
    1581,  1585,  1586,  1584,  1590,  1591,  1592,  1258,     0,   125,
       0,     0,     0,   337,     0,     0,  1917,  2169,     0,     0,
    1879,  2112,  2044,     0,     0,     0,  2181,  2182,  2183,     0,
       0,     0,  2171,     0,     0,  1791,  1812,     0,     0,     0,
       0,     0,  1891,     0,     0,     0,  1873,  1874,  1877,     0,
       0,     0,     0,     0,     0,     0,  1856,     0,  1871,     0,
       0,  1910,  1911,     0,     0,     0,     0,  1866,     0,     0,
       0,     0,     0,  1887,  1888,     0,     0,     0,     0,  1906,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2178,  2177,  1825,  1878,  1811,  1813,  1814,  1972,  1973,     0,
       0,  1918,     0,  1861,     0,     0,  1882,     0,  1890,  1886,
       0,     0,  1884,     0,     0,     0,  2124,     0,  2197,  2198,
    2215,  2216,  2217,     0,     0,     0,     0,   904,   958,   968,
     990,   944,   978,   993,   905,  1014,  1015,   906,   976,   907,
    1019,  1021,   908,   909,   910,   911,   912,   913,   914,   915,
     916,   917,   918,  1000,   919,   920,   921,   922,   923,  1020,
    1017,  1018,   924,   925,   926,   927,   928,   930,   929,   931,
     932,   933,   934,   935,   936,   937,   939,   940,   942,   943,
     945,   946,   947,   948,   949,   950,   941,   951,   952,   953,
     954,   955,   956,   957,   994,   995,   997,   996,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   969,   970,   979,
     980,   981,   982,   983,   984,   985,   986,   987,   988,  1030,
    1031,  1004,  1005,  1006,  1007,  1008,  1011,  1009,  1010,  1012,
    1013,   938,  1016,   971,   972,   973,   974,   975,   977,   989,
     991,   992,   998,  1023,  1022,   999,  1001,  1002,  1003,  1032,
    1033,  1024,  1025,  1026,  1027,  1028,  1029,   901,     0,   770,
       0,     0,   764,     0,   768,     0,     0,     0,   790,     0,
       0,     0,     0,   784,     0,     0,  1739,     0,     0,  2190,
       0,  1669,  1670,  1671,  1672,  1673,  1674,   815,   816,     0,
       0,   796,     0,     0,     0,     0,     0,     0,     0,   352,
       0,  1604,  1606,  1608,  1609,  1610,  1607,  1602,     0,     0,
     342,     0,     0,     0,     0,     0,     0,     0,     0,   323,
     333,   325,   324,   332,   326,   327,   328,   329,   330,   331,
       0,  1596,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2221,  2222,  2223,  2224,  2225,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1095,  1129,  1104,  1096,
    1103,  1107,  1109,  1110,  1111,  1113,  1116,  1108,  1130,  1112,
    1102,  1105,  1098,  1097,  1099,  1100,  1101,  1106,  1114,  1115,
    1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124,  1125,  1126,
    1127,  1128,  1131,     0,     0,     0,     0,  1687,     0,     0,
       0,     0,     0,     0,     0,   373,   376,     0,   379,  1722,
       0,   378,     0,   377,   385,     0,   381,   374,   375,     0,
       0,     0,     0,  1132,  1144,     0,   564,     0,   521,     0,
       0,     0,  1680,     0,     0,  1064,     0,     0,     0,     0,
    1662,     0,  1658,  1659,  1660,     0,  1060,     0,     0,     0,
       0,     0,     0,     0,     0,  2099,     0,     0,     0,     0,
       0,  1727,  1728,  1729,  1899,  1898,  2100,     0,     0,  1756,
       0,     0,  1075,     0,  1074,   686,   687,   688,   689,   690,
     691,   692,   693,   695,   696,   700,   701,   711,   712,   713,
     714,  1076,  1077,  1078,   715,   717,   716,   718,   719,  1080,
     724,   697,   698,   699,  1079,   735,   694,   702,   720,   721,
     722,   723,   727,   728,   729,   730,   731,   732,   709,   710,
     725,   726,  1081,   733,   734,   703,   704,   705,   706,   707,
     708,  1084,  1072,     0,   196,   241,   249,     0,     0,   246,
       0,   270,   751,   750,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1149,   407,   403,  1136,     0,  1619,     0,   569,
     570,   571,     0,     0,  1876,     0,     0,  2184,  1721,     0,
    1720,     0,   575,   583,   576,   584,   580,   579,   586,   587,
     577,   578,   581,   589,   588,   582,   585,     0,   593,   594,
     595,  2199,   601,     0,   599,   600,   127,     0,     0,     0,
       0,   462,   463,     0,     0,     0,     0,   475,     0,     0,
       0,  1816,  2193,     0,  1838,     0,  1526,  1528,  1533,  1532,
    1537,  1531,  1534,  1535,  1536,  1538,  1539,  1541,  1542,  1540,
    1527,  1529,  1530,  1246,     0,     0,  1704,     0,     0,     0,
     671,   672,     0,   670,     0,     0,     0,     0,     0,     0,
    1695,  1696,  1697,  1698,  1699,  1700,     0,     0,   546,     0,
    1742,  2045,     0,   736,   685,   741,   740,   737,   738,   739,
     682,     0,     0,     0,     0,     0,  1544,  1546,  1548,  1547,
    1551,  1552,  1553,  1554,  1555,  1556,  1545,  1549,  1550,  1250,
       0,     0,     0,     0,  1228,  1229,  1230,  1231,  1234,     0,
    1233,  1235,  1236,  1155,     0,     0,  1159,     0,     0,     0,
    1223,  1224,  1226,  1225,  1220,     0,     0,     0,     0,     0,
       0,  2236,  2244,  2252,     0,     0,     0,  2238,  2254,  2239,
    2246,  2255,  2240,  2248,  2256,  2241,  2249,     0,     0,  1168,
    1170,  1169,  1171,  1172,  1174,  1173,  1181,  1182,  1176,  1175,
    1177,  1178,  1179,  1180,  1188,  1189,  1184,  1183,  1185,  1186,
    1190,  1187,  1191,     0,  1196,  1198,  1197,  1199,  1200,  1201,
    1202,     0,     0,  2261,  2260,     0,  1206,  1207,  1208,  1209,
    1210,  2262,     0,  1216,  1217,  1213,  1066,     0,     0,     0,
     144,   205,   213,   210,     0,   193,   217,   225,   222,     0,
     194,   229,   237,   234,     0,  1051,     0,  1056,     0,   195,
     253,     0,     0,     0,     0,     0,     0,     0,     0,   170,
       0,  1957,  1940,  1941,  1942,  1938,     0,     0,     0,  1962,
       0,     0,     0,  1827,  1815,  1960,  1828,     0,     0,  1558,
    1576,  1561,  1577,  1578,  1562,  1563,  1564,  1565,  1566,  1568,
    1567,  1572,  1573,  1569,  1570,  1571,  1574,  1575,  1559,  1560,
    1254,     0,   197,   256,   261,     0,     0,     0,     0,  1772,
       0,     0,   151,   152,   153,   154,     0,     0,     0,     0,
       0,   157,   158,   159,   160,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1472,  1519,  1505,
    1506,  1507,  1508,  1509,  1521,  1510,  1511,  1512,  1513,  1514,
    1516,  1515,  1520,  1522,  1473,  1474,  1475,  1476,  1477,  1478,
    1479,  1480,  1481,  1482,  1483,  1484,  1485,  1486,  1487,  1488,
    1497,  1489,  1490,  1498,  1500,  1499,  1491,  1492,  1501,  1493,
    1494,  1495,  1496,  1502,  1503,  1504,  1517,  1518,  1523,  1524,
       0,     0,     0,     0,     0,   821,   822,   823,   824,   825,
     826,   827,   828,     0,  1713,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2063,     0,  2064,
       0,     0,     0,     0,  2066,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1340,     0,  1291,  1337,  1292,  1293,  1294,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,  1323,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1338,     0,  2154,  2165,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2163,  2156,     0,  1394,     0,
    1379,  1380,  1381,  1388,  1382,  1383,  1384,  1385,  1386,  1387,
    1389,  1390,  1392,  1391,  1397,  2158,  1358,     0,  1343,  1344,
    1345,  1351,  1355,  1356,  1346,  1347,  1348,  1349,  1350,  1352,
    1354,  1353,     0,  2128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1466,
       0,  1436,  1437,  1438,  1431,  1432,  1433,  1434,  1435,  1439,
    1440,  1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,
    1430,  1450,  1451,  1452,  1453,  1454,  1455,  1456,  1457,  1458,
    1459,  1460,  1461,  1462,  1463,  1464,     0,     0,  2148,     0,
    1427,     0,  1422,  1421,  1419,  1420,  1423,  1424,  1425,     0,
       0,     0,     0,  2150,  1416,     0,  1407,  1408,  1409,  1413,
    1414,  1410,  1411,  1412,  2157,  1404,     0,  1399,  1400,  1401,
    1402,     0,  1376,     0,  1361,  1362,  1363,  1368,  1373,  1374,
    1365,  1366,  1367,  1369,  1370,  1372,  1371,  1364,     0,     0,
       0,     0,     0,     0,     0,     0,   504,   505,   507,   506,
     508,   509,   510,     0,  2108,  2109,     0,     0,   513,   517,
     514,   515,   516,     0,     0,  2117,  2119,     0,   675,   676,
     677,   678,   679,     0,     0,     0,   664,   665,   666,     0,
       0,     0,     0,     0,     0,     0,  2203,  2204,  2207,  2208,
       0,     0,  2211,     0,     0,     0,     0,   605,   609,   653,
     654,   607,   621,   639,   631,   629,   632,   624,   623,   622,
     637,   635,   657,   658,   660,   659,   627,   630,   628,   655,
     625,   633,   634,   626,   641,   651,   652,   647,   648,   649,
     650,   642,   643,   644,   645,   646,   611,   638,   608,   613,
     614,   620,   640,   606,   610,   612,   619,   616,   617,   618,
     636,   615,   656,  1261,   840,     0,     0,     0,     0,     0,
     835,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     313,     0,     0,     0,     0,   312,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   275,   274,  1136,   831,   893,
     836,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   743,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1623,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   126,
       0,     0,     0,   336,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   767,     0,   763,
     316,   766,     0,     0,     0,   789,     0,     0,     0,     0,
     783,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     795,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   341,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1597,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1688,
       0,     0,     0,     0,   136,     0,     0,     0,     0,     0,
     392,     0,   393,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1146,     0,   565,     0,     0,     0,   520,
       0,     0,  1681,     0,     0,  1063,     0,  1653,     0,     0,
    1661,     0,     0,     0,  1059,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   242,   247,   244,   252,
       0,   199,     0,     0,   203,   201,   271,     0,     0,     0,
       0,     0,     0,   423,   422,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   404,
     405,   406,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     461,     0,     0,     0,     0,     0,     0,   474,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1703,     0,     0,
       0,     0,     0,     0,   536,   754,   542,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1628,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1158,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
     145,   206,   211,   208,   216,   218,   223,   220,   228,   230,
     235,   232,   240,     0,  1048,  1049,     0,  1053,  1054,   254,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     257,   259,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1765,     0,   164,   165,   166,   167,   168,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1712,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   481,     0,
       0,     0,     0,     0,     0,     0,     0,   348,     0,   347,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   364,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   830,     0,     0,     0,     0,     0,     0,   874,
       0,     0,     0,   892,     0,     0,     0,     0,     0,   288,
     287,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   272,     0,
       0,     0,     0,  1965,  1966,  1967,  1968,  1964,  1970,  1769,
    1785,  2269,     0,  1776,     0,  1775,  1807,  1808,  1901,  1900,
    1902,     0,  1279,     0,  1971,  1847,  1885,  1287,     0,  1903,
    1892,  1894,  2043,  2037,  2038,  2040,  2039,  2041,  2042,  1632,
       0,  1635,     0,   267,  2032,  2033,  2034,  1749,  1753,  1740,
    1760,  1717,   557,   556,  1849,     0,  1736,  1724,  1613,  1611,
       0,  1621,     0,  1944,  1949,  1950,  1951,  1840,  1842,  1841,
    1843,     0,  1834,  1952,  1953,  2196,  1830,  1257,     0,  1579,
    1088,     0,  1086,     0,   334,     0,     0,  1726,  1784,  1774,
    1860,  1848,  1935,  1936,  1937,  1773,  1783,  1782,     0,  1832,
    1781,  1780,  1730,     0,  2179,  1893,  1809,  1810,  1926,  1928,
    1925,  1927,  1930,  1931,  1850,  1853,  1862,  1854,  1855,  1857,
    1872,  1851,  1912,  1913,  1914,  1852,   757,     0,     0,   759,
     758,  1867,  1869,  1868,  1864,  1865,  1863,  1919,  1904,     0,
       0,  1905,  1907,  2174,  2173,  2175,  2176,  1974,  1976,  1978,
    1977,  1979,  1980,  1982,  1981,  1983,  1984,  1986,  1985,  1987,
    1988,  1989,  1990,  1991,  1992,     0,  1723,  1916,  1870,     0,
    1881,  1880,  1883,  1923,  1922,  1924,  2172,  1932,  1933,  1934,
       0,  2125,  2218,  2219,  2220,   903,   900,     0,     0,   762,
     807,   808,   810,   811,   813,   809,   812,   814,   317,     0,
       0,     0,     0,     0,   788,     0,     0,     0,   780,     0,
       0,  1738,  1737,  1667,  1668,   817,   818,   794,     0,   357,
     354,   353,   356,   355,   351,   350,  1605,  1601,     0,     0,
     339,   749,     0,     0,     0,     0,  1768,  1770,  1786,  1787,
    1788,  1789,  1790,   322,   320,  1595,     0,  2170,  1895,  2027,
    2031,  2030,  2029,  2028,  2022,  2023,  1998,  2226,  2227,  2228,
    2229,  2230,  2231,  2232,  2233,  1093,  1094,   318,     0,   321,
    1685,     0,     0,     0,     0,  1090,     0,     0,     0,   360,
       0,   399,   401,     0,     0,   390,   391,     0,   395,   383,
    1752,     0,  1755,     0,   384,   388,  1896,  1897,     0,  1143,
       0,     0,   563,   562,     0,   518,     0,  1679,     0,  1062,
       0,     0,     0,  1654,     0,  1657,  1057,     0,  1058,  1067,
       0,     0,     0,  1070,  2180,  1716,  1725,  1750,  1751,  1732,
    1733,  1734,  1746,  1745,  1759,  1757,  1718,  1758,  1073,  1083,
       0,   248,   245,   250,   200,     0,   204,   202,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   402,   416,   417,   412,   413,   414,   415,
     408,   409,   411,   410,   418,  1150,  1137,     0,     0,   568,
     567,  1747,  1748,  1741,  1754,  1719,   574,   573,   592,   591,
     598,   597,  1091,     0,     0,     0,     0,   455,     0,     0,
       0,     0,     0,   471,     0,  1819,  1818,  1817,  2194,  2195,
    1245,     0,  1525,     0,  1709,  1701,     0,     0,   752,   753,
       0,     0,     0,     0,     0,   540,   669,   668,  2185,     0,
    2188,     0,  2187,  1693,  1694,     0,     0,  1627,     0,   545,
     544,  1735,  1743,   684,   681,     0,  1821,  1824,  1823,  1820,
    1822,  1249,     0,  1543,     0,  1920,  1921,  1227,  1152,  1232,
    1154,     0,     0,     0,     0,     0,  1157,  1744,  2168,  1222,
    1219,     0,  2234,  2242,  2250,  2235,  2243,  2251,  2237,  2245,
    2253,  2247,  1166,  1167,  1193,     0,  1195,  2259,  2258,  2257,
    1204,  1205,  1212,     0,  1215,     0,     0,   212,   209,   214,
     224,   221,   226,   236,   233,   238,  1050,  1055,     0,   178,
     179,   172,   175,   176,   177,   180,   171,   169,  1945,  1946,
    1947,  1948,  1958,  1959,     0,  1836,  1954,  1955,  1829,  1831,
    1253,     0,  1557,   260,  1238,  1240,  1242,  1767,     0,     0,
    1771,   150,   149,     0,     0,     0,     0,     0,     0,  1777,
    1778,  1779,   156,   155,  1993,  1994,  1995,  1996,  1997,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,     0,
       0,  2009,  2010,  2011,     0,     0,     0,  2015,  2016,     0,
    2018,  2019,  2020,  2021,  2024,  2025,  2026,  1470,  1471,  1761,
    1792,   820,   819,  1710,     0,  1714,     0,  2048,  2049,  2050,
    2051,  2052,  2053,  2054,  2055,  2056,     0,  2058,  2059,  2060,
    2061,  2062,  2065,  2067,  2068,  2069,  2070,  2071,  2082,  2079,
    2093,  2094,  2098,  2072,  2075,  2076,  2077,  2078,  2080,  2081,
    2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,
    2095,  2096,  2097,  2130,  1339,  1342,     0,  2166,  2126,  2155,
    2129,  2127,  2159,  2161,  2160,  2162,  2164,  2146,  1393,  1396,
       0,  1357,  1360,  2073,  2074,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    1465,  1468,  2046,  2047,  2147,  1426,  1429,  2151,  2153,  2152,
    2149,  1415,  1418,  1403,  1406,  2167,  1375,  1378,     0,     0,
       0,   487,   488,     0,   480,     0,     0,  2293,  2102,  2101,
    2103,  2104,  2105,  2106,   503,   502,     0,     0,   346,  2111,
    2110,   512,   511,  1139,  1138,  2114,  2115,  2116,  2118,   674,
     673,  2191,  2192,   663,   661,   662,     0,     0,   365,  1929,
    2205,  2206,  2200,  2201,  2202,  2209,  2212,  2213,  2214,  2210,
     603,   604,     0,     0,     0,   834,   829,     0,     0,     0,
     875,     0,     0,     0,   893,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   273,   285,   286,   281,   282,
     283,   284,   276,   277,   279,   278,   280,     0,     0,     0,
       0,     0,   888,   889,   890,   891,     0,   894,   838,     0,
    2269,  2270,  2272,     0,  2276,  2274,     0,  1282,  1290,  1634,
       0,   262,   268,     0,     0,     0,  1844,     0,  1259,  1089,
    1087,   338,     0,     0,     0,   755,   756,     0,  2284,     0,
    2288,  2286,     0,  1038,  1040,     0,     0,     0,  1042,  1045,
       0,   902,   769,   316,   765,   316,     0,     0,     0,     0,
       0,   787,     0,     0,     0,  1603,   832,   895,   842,     0,
     747,   748,     0,     0,     0,  1599,     0,     0,     0,     0,
       0,     0,     0,   359,   361,     0,     0,     0,     0,   387,
       0,     0,  1140,     0,     0,  1133,     0,  1145,     0,     0,
       0,     0,     0,     0,  1663,     0,     0,     0,     0,     0,
    1068,     0,  1085,   251,   198,     0,     0,   440,   441,   420,
     421,   424,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   450,   425,     0,   438,   439,     0,   447,     0,   449,
     451,     0,   452,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   470,     0,     0,     0,     0,  1247,     0,
    1706,  1708,  1705,     0,   541,   535,   528,     0,   538,     0,
       0,     0,     0,  1626,     0,   683,  1251,     0,  1156,  1160,
    1161,  1162,  1163,  1221,  1194,  1214,     0,     0,   215,   227,
     239,   174,     0,     0,  1255,     0,  2278,     0,  2280,  2282,
    1762,  1764,  1763,     0,   163,   162,  2294,  2296,  2295,   746,
     745,     0,     0,     0,     0,  1715,     0,     0,     0,  1398,
       0,     0,   483,   479,     0,  2291,     0,     0,   345,     0,
     363,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   863,   864,   872,   870,   865,   868,   867,   873,   871,
     869,   866,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   311,   299,   300,     0,   308,
       0,   310,   314,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   851,   852,   860,   858,   853,   856,   855,   861,
     859,   857,   854,     0,     0,  2273,     0,  2277,  2275,  2263,
     269,  2036,   527,     0,     0,     0,  1835,     0,  1833,  1731,
    2285,  2289,  2287,     0,     0,  1858,  1975,     0,     0,  1859,
     317,     0,     0,     0,   771,     0,     0,     0,     0,   785,
     781,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1677,  1678,     0,     0,     0,  2264,     0,     0,     0,   398,
       0,   400,     0,   394,   380,     0,   382,     0,  1147,     0,
       0,     0,     0,     0,     0,     0,     0,  1665,  1655,     0,
    1061,     0,  1071,     0,     0,     0,     0,     0,     0,     0,
     445,     0,     0,     0,   465,     0,     0,   457,     0,     0,
       0,   469,     0,   473,     0,  1707,     0,     0,   539,  2186,
    2189,     0,  1629,  2113,     0,     0,  2266,  2265,  1837,  2279,
    2281,  2283,  1766,  2012,  2013,  2014,  2017,     0,  2057,     0,
     484,     0,  2107,     0,  2292,     0,     0,     0,     0,     0,
     366,   367,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1846,     0,     0,   876,     0,
       0,   894,     0,     0,     0,     0,     0,   306,  1802,  1800,
    1801,   887,   881,     0,     0,     0,     0,     0,     0,  2271,
       0,     0,   523,     0,   833,   897,   846,     0,  1845,   335,
     761,  1034,   760,  1035,  1039,  1041,     0,  1043,  1046,   316,
     316,   316,     0,     0,   793,     0,   782,   797,     0,     0,
     896,   844,     0,   340,  1598,   319,     0,  1689,     0,     0,
    1686,     0,   140,     0,   397,   454,  1141,     0,     0,   519,
    1682,     0,     0,     0,     0,     0,     0,  1656,  1069,   442,
     443,     0,   426,     0,     0,     0,   453,  1620,     0,     0,
     464,     0,   456,     0,   458,     0,   472,     0,   537,     0,
       0,   183,     0,     0,     0,   132,     0,     0,   482,  2290,
     349,     0,     0,     0,     0,   368,  1793,  1797,  1799,  1806,
    1795,  1804,   798,   799,   801,   802,   804,   800,   803,   805,
     806,  1794,  1803,  1798,   862,   841,     0,     0,   877,     0,
       0,   895,     0,   303,   304,     0,     0,   315,  1796,  1805,
     850,   837,     0,     0,   526,   522,     0,     0,     0,     0,
       0,     0,  1036,     0,   775,   772,   776,     0,   791,   786,
       0,     0,     0,     0,   343,     0,     0,     0,     0,   137,
     138,   143,     0,   389,     0,     0,     0,  2267,     0,  1065,
    1664,     0,     0,     0,     0,   419,   467,   466,     0,     0,
       0,     0,     0,  1630,     0,   148,   181,   189,   186,   146,
       0,     0,   129,   130,   135,     0,     0,     0,   493,     0,
     494,   495,     0,     0,   369,   370,   371,   372,     0,     0,
       0,     0,     0,     0,     0,   882,     0,     0,   525,     0,
       0,   534,     0,     0,   898,   848,     0,     0,  1044,     0,
     316,     0,   883,     0,     0,     0,     0,     0,     0,   139,
     141,   396,     0,     0,     0,     0,   427,   428,   446,   448,
     460,   459,     0,     0,  1702,   182,   187,   184,   192,  1711,
     131,   133,     0,     0,     0,     0,   485,     0,   496,     0,
       0,   879,     0,   878,   897,     0,   896,   307,   309,   839,
     524,     0,     0,  1624,     0,   533,     0,     0,     0,     0,
    1037,     0,   777,   792,   843,     0,     0,  1676,  1690,  1691,
     142,   468,     0,  1683,  1684,   476,   477,   188,   185,   190,
     134,     0,     0,     0,     0,     0,     0,   492,     0,     0,
       0,   531,     0,   532,     0,   885,     0,     0,     0,   316,
     316,   884,     0,  2268,   191,     0,     0,     0,     0,     0,
       0,   490,     0,   880,   898,     0,   530,   847,     0,     0,
     773,   778,   845,     0,     0,     0,     0,   486,   491,   489,
     529,   886,     0,     0,     0,     0,   497,     0,   849,   779,
     498,   499,     0,   500
  };

  const short
  parser::yypgoto_[] =
  {
   -3603, -3603,  4005, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  1631, -3603, -3603,  1618,
   -3603, -3603, -3603,   825, -3603, -3603,  1658, -3603,   163, -3603,
   -3603, -3603, -3603, -3603,  -941, -3603,  -406, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  1975, -3603,
   -3603, -2114, -3603, -3603, -3603,  3850,  1948, -3603,  -300,  -622,
   -3603,  1155,  -917, -3603, -3603, -3603,  1473, -3603, -3603, -3603,
    1966, -3603, -3603, -3603, -3603, -3603, -3603,  1460, -3603,   147,
    1914, -3603, -3603, -3603, -3603,   527, -2108, -3603,   531,  1531,
   -3603, -3603, -2063, -3603,   991, -1221,  -331, -2861, -3603,   996,
   -1226, -3603, -3603, -3603,  1506, -3603, -3603, -3603,  -191,  -184,
   -3603,   -63, -3603, -3603, -3603,  1507, -3603, -3603,  1502, -3603,
    1118, -3102, -3603, -3486, -3603,   997, -3603, -3603,  -215, -3603,
   -3603,  2132, -3603, -3603,  1940, -3603, -3603,  -196, -3603, -3603,
    -222, -3603, -3603,  1832, -3603, -3603, -3603, -3603,  1489, -3603,
   -3603, -3603,  3756,  1511, -3603, -3603,  1801, -3603, -3603,  1516,
   -3603, -3603,  -202,  1791,   196, -2521, -1883,  1957,  -816, -3603,
   -1408, -3603, -3603, -3603,  3343, -3603, -3603, -3602, -3603,  1236,
    -881, -3603, -3603,  3340, -3603, -3603,  3319, -3603, -3337, -3603,
    -295, -3603, -3603, -3603,  1649, -3603, -3603,  3772, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -2822,   182, -3603,
     205, -3603,  3774, -3603, -2590,   374, -3603,  3777, -3603, -3603,
    2075, -2751, -3603,   339,  1306,   332, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603,  3916,   118, -3603, -3603,  3203,
   -3603, -3603, -3603, -3603, -3603,  1946, -3603, -3603, -3603, -3603,
   -3603, -3603,  2019, -3603, -3603,   446,  -328,  -747, -3603,  2003,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603,  2914, -3603, -3603,
    1794, -3603, -3603,  1797, -3603, -3603,  1799, -3603, -3603,  1802,
   -3603, -3603, -3603,  1809, -3603,  1826, -3603,  -256, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  -103,  2213,
   -3603, -3603,  2216, -3603, -3603,  1646, -3603, -3603,  1635, -3603,
   -3603,  1597, -3603, -3603,  1638, -3603, -3603,  1610, -3603, -3603,
    1613, -3603, -3603,  1620, -3603, -3603,  1626, -3603, -3603,  1734,
   -3603,  1907, -3603,  1883, -3603,  1804, -3603,  2227, -3603, -3603,
   -3603,  3381, -3603, -3603,  2127, -3603, -3603,  2253, -3603, -3603,
   -3603,  3744, -3603, -3603, -3603,  1913, -3603,  2274, -3603, -3603,
    2060, -3603,  1260, -1042, -3603, -3603,  2159, -3603, -3603, -2939,
   -3603, -3603,  3315, -3603,  1303, -1003, -3603,  1931, -3603, -3603,
     362, -1267,  1952, -3603,   352, -1607, -3603,   248, -3603, -3603,
   -3603, -3603, -3603,  -259,   -90, -3603,  -185, -3603, -3603, -3603,
    -181,  -135, -3603, -3603, -3603, -3603,   270, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603,  -176, -3603, -3603, -3603, -3603, -3603,  -436,  -260, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  -398,  -252, -3603, -3603,
   -3603,  -422,  -318,    48, -3603, -3603, -3603,   -92, -3603, -3603,
    -180,  -360, -3603, -3603, -3603,  -335, -3603, -3603, -3130, -3066,
   -2998, -3603, -3603, -2993, -2984, -3603, -3603, -3603, -2977, -2969,
   -3603, -3603,  -206,  -183, -3603,  -271,  -268, -3603, -3603,  -239,
   -3603, -3603, -3603, -3603, -3603, -3603,  -117, -3603, -3603, -3603,
   -3603, -3603,   -68, -3603, -3603,  -235, -3603, -1860, -2425,  1625,
   -3603,  -273, -3603,  -310, -3603, -3603, -3603, -3603, -3603, -3603,
    -316, -3603, -3603, -3603, -3603,  -294,  -415,  -412,  -403,  -394,
    -362,  -283, -3603, -3603, -3603, -3603,  -203, -3603,  -359, -3603,
   -3603, -3603, -3603,  -254,  -255, -3603, -3603,   -83,   -78,  -101,
   -3603,  -134, -3603,  -177,  -354, -3603,  -166,  -246,  -200,  -195,
     -67, -3603, -3603, -3603, -3603,   -61,   -49, -3603, -3603, -3603,
   -3603, -3603,  -193,  -348,  -266,   -35, -3603,  -289, -3603,  -265,
    -253,  -346, -3603,  -343,  -340,  -244,  -241,  -236,  -230, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,   -57,
      25, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  -287, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603,  -282,  -267, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603,  -129,  -302, -3603, -3603, -3603,  -385,
    -380,  -370,  -367,  -365, -3603, -3603, -3603, -3603, -3603,  -364,
    -344,  -332, -3603,  -312, -3603, -3603, -3603,  -293,  -278,  -275,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603,  -339,  -336,  -414, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  -311,  -217, -3603, -3603,
   -3603, -3603,   -24,   -21,   -15,    -2, -3603, -3603,   -74,   -20,
   -3603,  -141,  -261, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  -123, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603,  -162,  -132,  -356, -3603,
   -3603,  -118,  -102,   -97,   -91,  -437,   -71,   -69, -3603, -3603,
    -258,  -192, -3603, -3603, -3603, -3603, -3603,     5, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  -158, -3603,
   -3603,  -245,  -238, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603,     8,    11,    39,    62,    63,    73, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,  -330,
    -325,  -304,  -291,  -280,  -243,  -242, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603, -3603,
   -3603, -3603, -1463, -2571, -3603, -1737, -3603, -2279, -3603, -1584,
   -3603,   335, -3603, -2477,     0
  };

  const short
  parser::yydefgoto_[] =
  {
       0,   144,   145,   146,   147,   148,  3436,  4154,   149,  3056,
    4111,   150,  3286,  3285,   151,  1511,  1512,   152,  1520,  1521,
     153,  1516,  2533,  2534,   154,  1458,  1459,  3298,  4150,   155,
     156,   157,   158,   159,  2321,  1158,  1159,   407,   409,   411,
     346,   415,   421,   160,   560,  2822,   161,   162,  3920,  2779,
    3873,  3923,   163,   164,   165,   938,   939,   166,   632,   633,
     167,   929,   930,   168,  1893,  2698,  2699,  3506,   169,   918,
     919,   170,  1022,  2255,   171,  1920,  2715,  2716,  4030,  4031,
    1034,  1035,   172,  1023,  3684,  2259,  2260,  3060,  3061,  2261,
    2368,  3733,  2262,   173,  1240,  1241,  1242,  3744,   174,  1246,
    1247,   175,   456,  2687,  2688,  4156,  4385,  4158,  4386,  4269,
    4270,  4271,   176,   177,  1885,  1886,   178,  1897,  1898,   179,
    1049,  3903,   180,  4290,  2413,  2414,   181,  1297,   570,   182,
     571,   572,   183,  1045,  1046,   184,  1198,  1280,   185,  1211,
    1281,   186,  1227,  1228,   187,  1233,  1234,   188,  1936,  1937,
     189,   190,  1915,  1916,   191,  1282,  1283,   192,  1907,  1908,
     193,  1302,  1338,  1304,  3800,  3801,  3014,  2035,  4291,  2910,
    2911,  4084,   194,   881,   882,   883,  2980,  3924,   195,   892,
     893,   196,   887,   888,   197,   910,   911,  4181,  2981,   908,
    3018,   198,   199,  1614,  1615,   200,   201,   202,  1999,   203,
    2781,  3894,  2729,  3934,  4223,  4209,  4359,  3881,  3882,  3830,
    3831,   204,   205,   206,  3591,  3592,   207,   208,   209,   746,
     747,  3633,  4213,  3634,  3635,  3639,  3640,   210,   413,  1444,
     211,   414,  1446,   212,   213,  1065,  1066,   214,  1054,  1055,
     215,   216,  1069,   217,  1093,  1094,   218,   219,   220,   221,
     222,   223,   975,   976,   224,   327,  2036,  3515,  3683,   328,
     225,   350,  2366,   226,   227,   228,  1345,  1346,   229,   230,
    1378,  1379,   231,  1403,  1404,   232,  1415,  1416,   233,  1422,
    1423,   234,  1349,  1350,  1333,  1334,  1339,  1351,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   495,   496,   497,
     244,   519,   520,   245,  1673,  1674,   246,  1756,  1757,   247,
    1862,  1863,   248,  1738,  1739,   249,  1855,  1856,   250,  1844,
    1845,   251,  1830,  1831,   252,  1789,  1790,   253,   254,  1556,
    1557,  1255,  1256,  1315,  1316,  1478,  1479,   611,   612,   255,
     950,   951,   256,   920,   921,   257,   586,   587,   258,   259,
     594,   595,   260,  1296,  2427,  2428,   261,   535,   536,   262,
    1061,  1062,  1059,  1060,  3091,   263,   900,   901,   264,  3943,
     265,  1051,  1052,   266,  1016,  1017,   267,  1289,  1290,   268,
    1275,  1276,  3203,   269,  1623,  1624,  1095,  1096,  1097,  1214,
    1215,  1216,  1036,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1305,  1110,   903,   904,   905,
     574,  1217,  1306,  1352,  1111,  1112,  1218,  1219,   575,  1113,
    1037,  1220,  1221,  1038,  1114,  1115,  1116,  1117,  1118,  1616,
    2535,  2536,  2537,  2538,  3336,  1513,   940,   498,   942,  1514,
    1515,   755,   756,   499,  1522,  1523,  1524,  1120,   759,   760,
     500,   945,   946,   947,   948,   949,   761,  1620,  3883,  3884,
    3885,  3886,  3835,  3887,  3888,  3593,  3594,  3595,  3889,  3890,
    3891,  3840,   501,   502,   764,   765,  1121,   767,  1480,  1261,
    1262,  1263,  1321,  1322,  1323,  1324,  1122,   613,  1481,  1482,
     614,  1483,  1123,   615,  1484,  1264,   616,  3616,  3617,  2000,
     521,   770,   590,   771,   772,   773,   774,   775,   776,   777,
     778,   779,   780,   781,   782,   783,   784,   785,   786,   787,
     788,   789,   790,   791,   792,   793,   540,  1222,   795,   796,
     797,   798,   799,  1125,   522,   802,   803,  1126,   541,  1127,
     807,   542,   809,   543,   988,  1040,  1128,  1129,   503,   504,
     546,   814,   815,   816,   817,   505,   506,   820,   821,   822,
     823,   824,   547,   826,  1130,  1131,   829,  1341,  1336,  1132,
    1133,   832,  1968,   833,   834,  1134,  1135,  1136,  1137,  1485,
     617,  1486,  1487,  1488,   618,   619,  1489,  1490,   620,   621,
     622,  1491,  1492,   623,  1493,  1494,  1495,  1496,   624,  1497,
     625,   507,   508,   509,   510,   511,   512,   513,   523,  1138,
    1139,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,  1574,  1575,  1576,  1577,  1578,   990,  1580,  1581,  1582,
    1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,
    1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,
     991,  1603,  1604,  1605,   992,   993,   994,   995,   996,   578,
     579,   580,   581,   591,   548,   851,  1309,  1832,  1833,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1806,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,
    1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,
    1717,  1718,  1719,  1720,  1721,  1140,  1141,  1887,  1888,  1889,
    1890,  1891,  1892,  1900,  1901,  1902,   852,  1342,  1909,  1910,
    1911,  1912,   549,   550,   551,   552,   857,   858,  1740,  1741,
    1809,  1742,  1722,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1743,  1837,
    1838,  1849,  1850,  1851,  1852,  1853,  1744,  1745,  1746,  1860,
    1765,  1747,  1748,  1749,  1750,  3892,  1752,  1753,  1877,  1353,
     859,   999,   860,   861,   862,   863,   864,  1143,  1144,   866,
     867,   868,  1225,  1291,  1292,  1293,  1294,  1295,  1226,  1917,
    1918,  1271,  1272,   626,   869,   870,  1235,  1978,  1979,  1980,
    1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,
    1991,  1145,  1146,  1147,  1148,  1149,  1150,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1380,  1381,  1382,  1383,  1384,  1385,  1386,  1387,  1388,  1389,
    1390,  1391,  1392,  1393,  1394,  1395,  1396,  1397,  1398,  1399,
    1400,  1401,  1402,  1417,  1418,  1419,  1420,  1424,  2800,  3053,
    3304,  3964,  3601,  3602,  2794,  2795,  3329,  3330,  2920,  3497,
    3816,  3498,  3360,  3361,  2037
  };

  const short
  parser::yytable_[] =
  {
     270,  1048,  1433,   278,  1438,  1751,  1443,   909,  2407,   278,
    2103,  2190,  2213,  2249,   278,  1013,  2584,  2290,  1874,  2390,
    2397,   577,  1194,   278,   537,  1119,   766,  1124,   827,   830,
    1939,   985,  1142,   926,   753,   749,   329,  1617,   923,   801,
     800,   831,   754,   981,  1942,  1899,   982,   278,   278,   347,
     835,  1951,   278,   836,  1952,   977,   998,   278,   837,   941,
     986,   278,  1794,  1953,   838,   941,  2979,  1795,   278,   278,
     539,   278,  1954,   278,  1405,  1618,   544,  1796,   278,  1308,
    1797,   545,  1798,  1799,   278,   408,   410,   412,   762,  1764,
     416,   794,   278,   422,   811,  1406,   538,  1859,  1335,   812,
    1619,   825,  1201,  1800,  1955,   576,  1230,  1957,  1407,   750,
    1224,   763,  1959,   751,  1224,  1801,  1257,   810,  1963,  1408,
    1967,   989,  1201,  1969,  1569,   278,  1970,  1975,  1224,   979,
    1976,   944,  1317,  1340,  1212,  1802,  1992,   944,  1232,  1327,
    1570,  1092,   278,   906,   270,  1320,  1328,  1579,  1943,  1325,
    1950,  3065,  1606,   592,  1803,  1977,  1409,  1410,  1199,   752,
     808,  1568,  1260,  1564,  1298,  1265,  1565,  1607,  1267,  1804,
    1337,   518,  1805,  1268,  1498,  1269,  1608,   768,  1307,  1303,
     987,  1499,  1559,  1956,  1676,   997,  1810,  1675,  1259,   924,
    1223,  1266,   588,   806,  1223,  1791,  3066,   983,  1947,   277,
    1964,  1965,   758,   576,  1319,   287,  1940,  1938,  1223,  3638,
     295,   804,  1958,  1966,  1941,  3501,   805,  2325,  1019,   307,
    1960,  2180,  1971,  3605,   978,  1972,   769,   813,  1562,  3787,
    1973,  1571,  2852,   818,  3675,  1621,  1974,   839,   925,  1270,
    1622,  1573,  1609,   344,   345,   819,   984,  1792,   352,  1558,
    4023,  1563,  1793,   361,  1561,  1326,  2879,   369,  2078,   828,
    1946,  3340,  3341,  2084,   382,   385,  1961,   390,  2250,   394,
     853,  1962,  3690,   854,   404,  2174,  2207,   555,  2209,   855,
     405,  1063,  2221,  1762,   596,  2221,  1945,   555,   420,   329,
     329,   634,   856,  1868,  3629,   555,   884,   889,   894,   865,
    1572,  2268,   871,   912,  1760,   872,  3922,   555,   928,   931,
    1848,  2275,   952,  1763,  1866,   634,  2314,  1566,  1018,   840,
     329,   443,  1761,  1869,  2373,  2809,  1836,  1766,   329,  2380,
     476,  -875,  1867,   873,  1162,  1053,  1056,  1870,   468,  1067,
    1067,  1070,   757,  1767,   555,   555,  1155,  3031,  1768,  1948,
    1195,  2382,   555,  1871,  1769,  2384,   874,   875,  1872,   943,
    3603,   555,   329,  1064,  1873,   943,  1567,   876,  -877,   555,
    1277,  1758,  2391,  1807,  1770,  1834,  1771,  1846,  2877,  1857,
    2881,  1864,   555,  1163,  1875,   555,  1876,  2393,   597,   598,
     555,  2103,  2417,  3726,   555,   599,  2430,  4071,  1949,  2434,
     600,   601,  2445,  3090,   555,   555,  2447,  1431,  2918,  1436,
    2457,  1441,  3832,  1445,  1447,  1450,  1258,  2507,  2527,  2542,
     555,  1503,  3627,  3693,  4410,  1759,   472,  1808,  2581,  1835,
    2695,  1847,  1318,  1858,  2701,  1865,  1625,  2707,  2711,  1460,
    1461,  3533,  2711,   555,  1462,  1463,  1464,  -879,  1162,  3600,
    3600,  1465,  1466,  3623,  3387,  2791,  3597,  1467,  1468,  1427,
    1238,  1243,  1162,  2416,   602,  4241,  3728,  2734,   555,  3337,
    3152,   628,  1998,  2001,  2005,  2009,  3833,  2041,   271,  1913,
    3877,  3905,  1560,  3213,  4010,   603,  4072,  4100,  4215,  1156,
    3788,  1508,  1432,   273,  2197,  1437,  1442,  1163,  3905,  3914,
    2317,  2482,  3914,  3918,  2486,  3955,  3979,  1517,  3905,  4041,
    3661,  1163,  3868,  3184,  1944,  1469,  4056,  4065,   637,   953,
     638,   553,  2888,  1162,  4131,  3877,   604,   605,  3877,   573,
    4065,  4297,  4065,  3877,  3185,  3877,  1470,  4065,  4410,  3011,
    4065,  3877,   748,  4065,  3834,  1057,  4071,  4071,  3627,  3836,
    3940,  3941,   589,  2068,  4294,   279,  2889,  2890,  3837,   487,
      21,  2490,  2921,  2922,  3785,  3838,  4352,  1518,  3398,  3599,
    4352,   902,  1163,  3839,   348,  2087,   922,  1471,  1472,  2289,
    4352,  2847,  2848,  2849,   980,  2850,  3959,  2793,  1162,  1238,
    2278,  1238,  2453,  2086,  1238,  3076,  3211,  1162,  3453,  1162,
    3212,  3688,  2197,  2396,  1213,   556,  1162,  3746,  1213,   907,
    1162,  3960,  2389,   907,  3740,  1162,  3454,  3988,  3507,  1162,
    1162,  1162,  1213,  3305,  1200,   606,  4006,   573,  1229,   656,
     657,  3121,   634,   553,  4007,  4072,  4072,  1163,  2906,   288,
    2950,   282,   349,  3992,  1200,  3527,  1163,  3990,  1163,  4352,
    3077,   907,  2876,  3315,  2880,  1163,  2683,  2790,  3600,  1163,
    3738,  3019,  3625,   526,  1163,  1162,   954,   283,  1163,  1163,
    1163,  1411,    21,  3994,  1162,   665,  1473,  1727,   955,  -444,
     284,  1474,  3489,  2410,  2411,  2367,  2847,  2848,  2849,  1162,
    2850,  -305,   280,   281,  1194,  1194,  3232,  2367,  3490,  3021,
    3238,  3668,  3240,  4248,  3287,  3669,  3821,  3822,  3823,  3824,
    3825,  3826,  3827,  3828,  1163,  3626,    42,   289,  2279,  3290,
    1730,  1058,  4122,  1163,   290,  4249,  4123,   557,   558,   559,
     296,   529,  1736,  1854,   297,   630,   631,  3279,  1163,  2684,
     302,  2685,  2686,   487,   303,   933,  3696,  1162,  4312,  2318,
    2319,  3961,   304,  1252,   308,  1058,  3293,  2851,  3969,   311,
    3870,   312,  2198,   317,  4322,  4323,  1020,   934,  1344,   372,
     712,   935,   936,   937,  1044,   714,  2355,  2356,  2357,  2358,
    2359,  2360,  2361,  2362,  2363,  2364,   320,  2365,  2323,   720,
    1881,   584,   956,   957,  2697,   607,  1163,  4420,  1894,  1895,
     530,  1896,   584,  1157,  2891,  4257,  1157,  4326,  1237,  1157,
    1157,  2410,  2411,  1914,  1157,  1157,   958,   724,  1157,  3942,
    1239,  2714,  2928,  2929,  1826,  3786,   608,    21,    42,  3821,
    3879,  3823,  3880,  3825,  3826,  3827,  3828,   585,  3598,  3012,
    3013,  1244,  1194,  1194,  3802,  3803,  1253,   321,  3804,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  3493,
    2365,  1428,  2878,  1194,    79,    80,    81,    82,    83,  4101,
    1162,   732,  2410,  2411,  3844,  1157,  2181,  1475,  2176,  1412,
    2177,   884,  4011,  1509,   362,  2182,  2183,   889,  3789,  3783,
    2187,  2188,   894,  3676,  1162,  2767,  2768,  2769,  2770,  2771,
    2772,  2773,  2774,  2775,  2776,  1510,  2777,  3388,  3389,  4024,
     912,  3832,   593,  3399,  3400,  2079,   959,   960,  3829,  1163,
    2085,  1519,  1058,  3664,  2251,  1476,  1413,  1047,  3691,   931,
    1414,   469,  2175,  2208,  1058,  2210,  4295,  2410,  2411,  2222,
    1245,   489,  2247,  1163,  1245,  1157,  2907,  2908,  1047,  1239,
     952,  1239,  1827,  3630,  1239,  2410,  2411,   322,  2269,  2410,
    2411,   334,  4361,  3510,  2410,  2411,  4377,   335,  2276,  2410,
    2411,   477, -2316,  2315,  3237,  3833,    79,    80,    81,    82,
      83,  2374,   553,    42,  1047,   961,  2381,  3537,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   336,  2383, -2316,
    1245,  3278,  2385,   634,  2410,  2411,  1018,  3648,  1157,  3604,
    3897,    21,  1195,  1195,  2792,  2483,  2484,  1828,  3895,  2392,
    2487,  2488,  3898,  1157,  2792,  2491,  2492,   629,  2410,  2411,
    1047,  3829,   329,  3834,  2394,   272,  3433,  2277,  3836,  2418,
    3727,  1053,  4073,  2431,  1056,  3442,  2435,  3837,  3445,  2446,
     274,   473,  1047,  2448,  3838,  1067,  3359,  2458,  1067,  2298,
    1157,   609,  3839,   610,  2508,  2528,  2543,  4121,  3694,  4411,
    2919,   553,   339,   636,  3011,  2582,   340,  2696, -2316,  2363,
    2364,  2702,  2365,   641,  2708,  2712,  2410,  2411,   643,  2713,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  1157,
      21,  1157,  1477,  3729,  2735,  4141,  3338,  1162,  4143,  1879,
    2930,    79,    80,    81,    82,    83,   487,  3878,  3906,  3214,
     649,   650,   651,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,  2316,  2777,  3908,  3915,  2322,  2322,  3916,
    3919,   653,  3956,  3980,   488,  4008,  4042,  3638,  3186,  3869,
    1195,  1195,   474,  4057,  4066,   341,  1163,    42,   377,   553,
    3762,  4132,  4202,  2294,  1075,  4220,  2294,  4286,  4298,  4303,
    4356,  1195,  4365,  4429,  4396,   656,   657,  4402,  4418,   391,
    4432,  4118,  4145,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,  3797,  1330,    21,  2410,
    2411,  4353,  4354,  1735,   475,  4371,  4354,  2784,  2970,   395,
    2787,   429,   954,   417,  3911,  4375,  4354,  3509,  2387,  2388,
     553,   430,  3067,  2410,  2411,  2395,  4203,   717,   718,   668,
     669,  1162,  1921,   670,   671,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   896,  1277,    42,  4221,  2529,    21,
    1157,   687,   688,   689,   690,   691,   431,  4307,  4308,  1451,
    4080,  1162,  4022,  2530,   432,  2683,  2429,  4314,   458,  4315,
    1163,   435,   487,  4067,  4376,  4354,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,  1162,  2777,   440,  4113,
     457,  1162,   459,  2909,   460,    79,    80,    81,    82,    83,
     488,   461,  2971,  1727,   489,  4212,   712,  1610,   933,   462,
    1163,   714,   463,  4098,   464,  1084,  1735,   478,   582,  1311,
     583,  2957,  2958,   719,   514,   720,  2369,  2370,  2371,  2972,
    2973,  2974,  2906,  2412,  1611,  1163,  1612,  2847,  2848,  2849,
    1163,  2850,   722,   491,    42,   593,  1730,   635,  2684,  3124,
    2685,  2686,  3127,   724,  3012,  3962,  3654,   895,  1284,  1285,
    1086,   291,   292,  1087,   568,  2959,   932,  4058,  1829,  1737,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
    3027,  2777,  2847,  2848,  2849,  1880,  2850,  3871,  2775,  2776,
     897,  2777,   298,   299,    79,    80,    81,    82,    83,  2481,
     730,   731,   907,   584,  2485,    42,  1014,   732,  2812,  2489,
    1881,  1882,  1883,  1884,  2495,  2324,  2498,   728,  2499,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,  1021,  2531,
    1039,  4357,  4081,  1331,  1332,  1041,  2410,  2411,  1452,  1903,
    1904,  1905,  1906,  4366,  2975,  1047,  3757,  1050,  2273,  1160,
     898,   300,   301,  1453,  1724,  1312,  2449,  2450,  2451,  2452,
     489,  2520,   493,   494,  2844,  2845,  2846,  1251,   309,   310,
    4289,  1161,  4081,  2361,  2362,  2363,  2364,  1196,  2365,  1725,
    1726,  1245,    79,    80,    81,    82,    83,   313,   314,  3921,
    1286,  1287,   530,  1248,  1613,   315,   316,  4081,   561,  1288,
    1313,   318,   319,   562,   563,   564,  4360,  1278,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  1279,  1355,   899,
    1344,  1358,   323,   324,  1361,   565,  4419,  1364,  3665,  1252,
    1367,  1421,  1369,    79,    80,    81,    82,    83,  3314,  1504,
     530,  2532,   584,  1505,  4082,  2932,  2933,  2934,  3215,   566,
    2410,  2411,   567,  1506,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,   734,  2365,  1507,  2976,  4292,  1626,
    1454,   330,   331,  1625,  1723,  2586,  1878,   585,   332,   333,
     561,  1994,  4304,   337,   338,   562,   563,   564,  4087,  3901,
    2410,  2411,  2939,  2940,  2941,  2042,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,  2410,  2411,   565,  2043,  1455,
    2907,  2908,  1253,  2044,  2813,  2814,  2815,  2816,  2817,  2818,
    2045,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,   566,  2365,  2046,   567,  2773,  2774,  2775,  2776,  2047,
    2777,  2048,   493,   494,  2942,  2943,  2944,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   353,   354,  2767,  2768,
    2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,  3909,  2777,
    1727,  1728,  2049,  4392,  2050,  1922,  1923,  1924,  1925,  1926,
    1927,  1928,  1929,  1930,  2051,  1931,  1932,  1933,  2052,  1934,
    1727,  1935,   355,   356,   569,   357,   358,  2977,  4397,  2767,
    2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,  2053,
    2777,   974,  1729,  1730,  1456,  1731,  1732,  2054,  1733,  1734,
    1735,  4026,  4027,  4028,  4029,  1736,   359,   360,  2853,  2854,
     363,   364,  1729,  1730,   365,   366,  1737,  2055,  3963,   913,
     914,   915,   916,   917,  2056,   537,   370,   371,   577,  2057,
    1839,  1840,  1841,  1842,  1843,  2058,   568,  3446,  3309,  3310,
    3311,  3588,  3589,  3590,  2935,  2936,  3954,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,  2059,  2365,  3065,
     373,   374,   375,   376,   378,   379,   569,  3478,  3479,   386,
     387,   539,   396,   397,   398,   399,  2060,   544,  2062,  1457,
     400,   401,   545,  2061,   423,   424,  3068,   425,   426,   427,
     428,  1192,   433,   434,   436,   437,  2063,   538,   438,   439,
     444,   445,   446,   447,  3066,  1314,  2064,  3999,   448,   449,
     450,   451,   576,   452,   453,  2065,   766,  2066,   827,   830,
    3122,  3123,  3815,  2067,   753,   749,   645,   454,   455,   801,
     800,   831,   754,  2069,  3020,  3022,  2070,  1194,   465,   466,
     835,  1194,  4086,   836,  3328,  2071,   926,  2072,   837,  2953,
    2954,   923,  3195,  3196,   838,  3530,  3531,  4250,  4251,  2073,
    1254,  3796,  3798,  4114,  2074,   592,  2075,   518,  3517,  3518,
    2076,   985,  2077,  2080,  2081,  2082,  2083,  2089,   762,   941,
    2090,   794,  2091,   981,   811,  4214,   982,  4216,  2092,   812,
    2093,   825,  2094,  2095,  2096,   977,   998,   656,   657,   750,
     986,   763,  2097,   751,   588,  2098,  1119,   810,  1124,  1194,
    1194,  1194,  1194,  1142,  4367,  2099,  2100,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  2101,  2104,  1194,  1194,  1194,
    1194,  1194,  1194,  1194,  1194,  1194,  1194,  1194,   906,   752,
     808,   944,  2105,  2106,  2107,  4078,  2108,  2192,   329,  2109,
    2110,   989,  2111,  2799,  2801,  2112,  2113,   768,  2114,   979,
    2115,  2116,  2117,  2118,  2119,  2120,   278,  2121,  2122,  2823,
    2123,  2124,  2125,   806,  2126,  3288,  3289,  2127,  2128,  3291,
    3292,  2129,   758,  3294,  3295,  2130,  2131,  2132,  2133,  2842,
     329,   804,   924,  2134,  2135,  2855,   805,   278,  2136,  2137,
     278,   278,  2138,  3628,  3631,  2139,   769,   813,  2140,  2870,
     987,  3153,  1092,   818,   329,   997,  2141,   839,  2142,  2143,
    2144,  1201,  2145,  2146,  2147,   819,  2148,   983,   712,  2149,
    1230,  2150,  1308,   714,  1224,   329,   329,   329,  1224,   828,
    2151,   925,  2915,   329,  2152,  2153,  2154,  1405,   329,  2155,
     853,  2156,  1257,   854,   978,  2938,  1335,  2157,  3176,   855,
     584,  2158,  3180,  2159,  2160,  1201,  2161,  2162,  1406,  2163,
    2164,  1224,   856,  2165,  2166,   278,   984,  3169,  2167,   865,
    2168,  1407,   871,  1617,  2169,   872,  4362,  2170,  2171,  1317,
    2172,  3249,  1408,  2173,  2186,  2191,  1327,  2193,  1260,   840,
    2194,  1265,  1320,  1328,  1267,  2195,  1325,  2196,  1751,  1268,
     278,  1269,  2201,   873,  1223,  3229,  3016,   329,  1223,  3316,
    3317,  1618,   757,  2202,  1259,  2203,  2204,  1266,  1337,  1409,
    1410,  1307,  1303,   329,  2205,  1063,   874,   875,  4235,  2206,
    4237,  2211,  2214,  2216,  1874,  2215,  1619,   876,  2217,  2218,
    3051,  1223,  2219,  2220,   576,  1195,  2225,  3062,  3063,  1195,
    2226,  1319,  2820,  2227,  2228,  2229,  1569,  2230,  2231,   943,
    2232,   329,  2233,  2234,  1498,  1270,  2235,  2243,  2236,  2237,
    1794,  1499,  1570,  3088,  3022,  1795,  4421,  1899,  3092,  1579,
    2238,  1764,  1939,  2858,  1606,  1796,  2861,  2863,  1797,  3102,
    1798,  1799,  2239,  1568,   329,  1564,  1942,  1193,  1565,  1607,
    2240,  2241,  1326,  1951,  2242,   278,  1952,  1064,  1608,  2244,
    2322,  1800,  1859,  2322,  1559,  1953,   573,  1195,  1195,  1195,
    1195,  3132,  3133,  1801,  1954,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1802,   589,  1195,  1195,  1195,  1195,  1195,
    1195,  1195,  1195,  1195,  1195,  1195,  1955,  3166,  2246,  1957,
    1562,  2967,  1803,  1571,  1959,  3514,  1676,  3514,  3514,  1675,
    1963,  1621,  1967,  1573,  1609,  1969,  1622,  1804,  1970,  1975,
    1805,  1558,  1976,  1563,  4242,  2416,  1561,  3758,  1992,  2252,
    2253,  3198,  3199,   278,  1810,  3204,  3008,  2254,  3204,  3207,
    1943,  2263,  1950,  1791,  2264,  2265,  2266,  1977,  3705,   329,
    2267,   329,   748,  2270,  2271,  2274,   278,  2429,  2280,  2283,
    4372,  2286,  2287,  2288,  2292,   278,  2291,  2295,  2301,  4159,
     278,  3547,  1572,  1157,  2302,  1956,  2303,  2304,   278,  4167,
    2326,  2034,  1258,  4171,  2386,  4182,  4183,  2305,   278,  1566,
    1947,    21,  1964,  1965,  2306,  1792,   902,  2307,  1940,  1938,
    1793,   278,  2308,   329,  1958,  1966,  1941,   278,  2309,   922,
    2310,  2311,  1960,  2312,  1971,  1762,  2313,  1972,  2327,  1318,
    2328,  2329,  1973,  3296,  2789,  2330,  3297,  2331,  1974,  2332,
    2335,  3299,  2336,  3301,  3302,  2337,  1760,  2338,  1567,   329,
    2339,  3120,  2340,  2341,   980,  1763,  3318,  2342,   278,  1868,
    2390,  2397,  1946,  2343,  1761,  3327,  2344,  2345,  1961,  1766,
    2346,  2372,  2347,  1962,  2348,  1848,  2843,  2349,  2350,  3339,
    1866,  2351,  2352,  2909,  2909,  1767,  2584,  1836,  1945,  1869,
    1768,  2353,  2375,  2256,  2376,  2377,  1769,  2378,  1867,  2379,
    2875,  2398,  2399,  1870,  2400,  2401,  3622,  2402,  2403,  2404,
    2405,  2408,  2409,  1758,  2419,  2420,  1770,   329,  1771,  1871,
    2421,  2902,  2903,  2904,  1872,  3384,  2422,  3386,  2423,  2916,
    1873,  1807,  2425,   329,  2926,   487,  1834,  2424,  2432,  3201,
    2433,  2436,  1846,  2437,  1857,  2438,  2439,  1864,  2441,  2440,
    1875,  1948,  1876,  2469,  2442,  2443,  2444,    42,  2455,  2456,
    2459,  2460,  3225,   488,  1560,  2461,  2462,  1759,  1213,  2470,
    2463,  3235,  1213,  2464,  2465,   329,  3242,   329,   329,  2466,
    2467,  2468,  1249,  1200,  3251,  1808,   278,  2471,  2472,  2473,
    1835,  2474,  1229,  2475,  3261,  2290,  1847,  2476,  1858,  2477,
    1949,  1865,  2478,  3017,  2479,  1213,  2480,  3275,  2249,  2518,
    2500,  2501,  2502,  3283,  2503,  2504,  2505,  2506,   573,  3035,
    3628,  2509,  2510,  2519,   487,  2511,  2512,  1200,  2513,  2514,
     527,  2515,  2516,  1024,  2517,  2521,  1025,  2525,  2526,  2539,
    2697,  2333,  2334,  2540,  3706,  2522,  2541,   528,  2544,   329,
     524,   525,   488,  2545,  3321,  3703,  2523,  2546,  2524,  1026,
    2547,  2548,  2354,  2549,  2550,  2575,  2551,  2552,  1194,  2553,
    3543,  3544,  2554,  1027,  2001,  2555,  2556,  3548,  3549,  1194,
    3551,  3552,  3553,  2557,  3555,  2558,  2213,  2576,  3666,  2559,
    3108,  3723,  4172,  2560,  1028,  1048,   529,  2632,  4173,  4174,
    4175,  4176,  4177,  4178,  2561,    79,    80,    81,    82,    83,
    2562,  2563,  2190,  4179,  2564,  2565,  1944,   526,  2566,   527,
    2567,  4180,  2568,  2569,  2570,  2571,  2572,  1250,  2573,  2574,
    2577,  2578,  2579,   489,  2580,  2587,   528,  2588,  2589,  2590,
    1251,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,  3910,  2365,  3912,  2591,  2592,  2593,  2594,  2595,  2596,
     555,  2597,  3612,  2598,  2599,   530,  2600,  2601,  2602,  2603,
    1202,  1203,   491,  2604,  2605,   278,  2606,  2607,  2608,  1194,
    2609,  2610,  3450,  2611,  2612,   529,  1204,  1029,  2613,  2614,
    2615,  2616,  2617,  2618,   566,  2619,  2620,  1205,   555,  2621,
    3743,   555,  2622,   555,  2623,  3218,   634,  3220,  1030,  2624,
    2625,  2626,  1252,  2627,  2628,  1206,  2629,  2630,  2631,  3967,
    2407,  3778,  2633,   278,  3779,  2634,  2635,  3780,  2636,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,  2637,  2638,
    2639,  2640,  2641,  2642,   530,  2643,  1724,  3851,  2644,  3277,
    2645,   491,  2646,  2647,   479,   480,   481,  2648,  2649,  2650,
     482,   483,   484,   485,  2651,  1207,   515,  2652,  1031,  3215,
    1084,  1725,  1726,  2653,  2665,  2654,  2655,   516,   486,  2656,
    2657,  2658,  2659,  2660,  2661,  3308,  2662,  1194,  1194,   487,
    2663,   493,   494,  2664,  2666,  1253,  2667,   555,  3642,  1032,
    1194,  2668,  2669,  2670,  2671,  2676,  1085,  2672,  2673,  1193,
    1193,  2674,  3646,  2675,  2677,  2678,  3649,   488,  2679,  2680,
     894,  2681,  2682,  2689,  2714,  2690,  2727,  2691,  2272,  2692,
    2103,  3852,  2693,  2694,  2700,  2703,   517,  2704,   555,  3659,
    2705,  2706,  2730,  1208,  2709,   931,  2710,  1209,  3926,   569,
    2717,  1210,  2728,  3379,  2718,  2719,  2720,  2721,  2722,  2723,
    2724,  3613,  2725,  2726,  2731,  4133,  2732,  2733,  2736,  3394,
    2737,  2738,  2739,  2743,  2103,  2300,  2868,  2786,   634,  2968,
     493,   494,  2741,  2740,  1018,  2788,  1195,  2742,  2790,  2744,
    4060,  2745,  2746,  2747,  2748,  2751,  2752,  1195,  2753,  2754,
    2755,   278,  2756,   329,  2982,  2757,  2758,  2759,   329,  3624,
    2426,  3438,  2792,  3440,  3441,  2796,  1033,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,  4083,  2365,   899,
    3699,  4083,  2782,  2760,  2761,  3841,  2762,  2833,  1194,   479,
     480,   481,  2763,  2797,  2764,   482,   483,   484,   485,  2765,
     555,  2803,  2780,  2804,  2835,  2806,  2808,  1193,  1193,  2810,
    2824,  2825,  2826,   486,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,   487,  2365,  2829,  2831,  1193,  2836,
    2837,  2839,  2840,  2841,  4134,  3521,  2856,   489,   490,  2864,
    2867,  2866,  1727,  1728,  2874,  2882,  2886,  1195,  2883,  2887,
    2900,  2901,   488,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,  2905,  2365,  3735,  3736,  2912,  2913,  2919,  2917,  2927,
    2937,  2945,   531,   532,   533,   534,   491,   492,  2946,  4195,
    2947,   555,  2952,  3751,  1729,  1730,  3751,  1731,  1732,  2956,
    1733,  1734,  1735,  1861,  2949,  2961,  4166,  2960,  2962,   278,
    4170,   278,  2964,  2969,  2983,   555,  2984,  2986,  1737,  2987,
    2988,  2990,  2991,  2992,  2995,   555,  2415,  3029,  2993,  3030,
    2999,  2996,   555,  1254,   278,  3032,  2997,  4198,  3000,  3001,
    3009,   555,  4196,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,   555,  2777,  3002,  3033,  3005,  3010,  3681,  3036,  3015,
    3024,  3003,  3025,  3037,  3038,   555,  3042,  3043,  3045,  3047,
    3048,  3049,  3050,   555,  3052,  1195,  1195,  3054,  2767,  2768,
    2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,  1195,  2777,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
    4240,  2777,  3072,  3055,  3105,  3071,  3125,  3106,  3183,  3073,
    3110,   555,  3111,  3079,  3075,   493,   494,  3113,  3080,  3083,
    3084,  3115,  3116,  3790,  3791,  3792,  1231,  3117,  3168,  3085,
    2365,  3086,   489,   490,  3087,  3089,  3093,  3173,  1194,  3094,
    1194,  3167,  3096,  3098,  3175,  3188,  1194,  3197,  2279,  3190,
    3222,  3228,  3099,  3236,   278,   278,   278,  3165,  3170,   278,
    3239,  3177,  3179,  3181,  3182,  3187,  3189,  1194,  1194,  3219,
    3191,   491,   492,  3221,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,  3192,  2777,   278,  3193,  1194,  3257,
    1194,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,  3194,  2777,  3991,  3244,  3760,  3262,  3761,  2355,  2356,
    2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  3246,  2365,
    3205,  3263,  3264,  3265,  4217,  3217,  1195,  3223,  3230,  3248,
    3767,  3256,  3266,  3267,  3268,  3269,  4225,  3270,  3271,  3303,
     555,  3312,  3313,  3319,  3323,   636,  3272,  3333,   638,  3280,
    3334,  3335,  3344,  3345,  3307,  1194,  3324,  3346,  3328,  1071,
    3347,  3348,  3349,  3325,  4355,  3350,  3326,  3351,  3352,  3332,
    4083,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,  3343,  2777,  3353,  3354,   278,  4355,  3355,  3356,  3358,
    3359,  3364,  3365,  3366,  3367,  3368,  4355,  4355,  3371,  3377,
     493,   494,   649,   650,   651,  1072,  1073,  3380,  3369,  3682,
    3390,  3382,  3391,  3526,  1044,  3383,  3385,  3392,  3396,  3435,
    3393,  3395,  3397,  3401,  3402,  3452,  4393,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,  3403,  2365,  4045,
    3404,  3405,  3408,  3409,  3410,  3411,  1075,  1330,  3412,  3413,
    3415,  3416,  3575,  3417,  3418,  3419,  3420,   656,   657,   658,
    3421,  3422,  3423,  3424,  3425,  3426,  3427,  3428,  1076,  1077,
    1078,  3429,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,
    2775,  2776,  3807,  2777,  3430,  3431,   659,   660,   661,  3432,
    3437,  3439,  3443,  3444,  3841,  3447,  3899,  3458,  3460,  3461,
    3900,  3495,  3464,   555,  3465,  3466,  3467,  3472,  3471,  3473,
    3474,  3477,   634,  3480,   555,  3476,  3482,  3485,  3488,  1194,
    3499,  3502,  3484,  3503,  1347,  2767,  2768,  2769,  2770,  2771,
    2772,  2773,  2774,  2775,  2776,  3516,  2777,  3487,  3522,  3491,
    1194,  1194,  3492,   894,  3532,  3743,  3496,  3535,  3743,  3536,
    3539,  2777,  2038,   931,  3614,  2197,   634,  3632,   694,  3505,
    3512,  1018,  3542,  3637,  3520,  3062,  1195,  3587,  1195,  3596,
    3524,   555,  3525,  3540,  1195,  3546,  3607,  3606,  3608,  3643,
    3645,  3814,  3660,  3966,  3644,  3615,  3661,  3667,  1194,  1194,
    1194,  1194,  3662,  3670,  3677,  1195,  1195,  3673,   712,  1081,
    3679,  1082,  3678,   714,  3695,  3688,  1083,  1084,  3704,  3687,
    3692,   717,   718,  3709, -2317,  3710,  1195,   720,  1195,  3731,
    3734,  3745,  3793,  3810,   278,  3739,  3742,  3811,  3756,   721,
     584,  3753,  3763,  3795,  3805,  4258,  3782,  3806,  3812,  3995,
    3813,  3817,  3842,  1085,  3845,  3698,  2367,  3818,  3819,  3820,
     555,   555,  1086,  3843,  3846,  1087,   568,   555,  3848,  3874,
   -2316,  3849,  3847,  3893,   728,   585,  1088,  3850,  3875,  3876,
    -876,  3600,  3896,  3902,  3904,  1194,  3058,  1089,  1090,  1091,
    3913,  3917,  3925,  1195,  3928,  3930,   569,  3933,  3935,  3936,
     555,  3944,   730,   731,  3946,  1194,  1194,   555,  3945,   732,
    3991,  3951,  3991,  1331,   555,  3958,  1348,  2767,  2768,  2769,
    2770,  2771,  2772,  2773,  2774,  2775,  2776,  3965,  2777,  2767,
    2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,  3975,
    2777,  3968,  4043,  3982,  3970,  4046,  3978,  3983,  4049,  3986,
    4327,  4328,  3987,  3989,  4001,  3993,  3996,  4009,  3128,  3129,
    3130,  3131,  4013,  4014,  4015,  4016,  3134,  3135,  3136,  3137,
    3138,  3139,  3140,  3141,  3142,  3143,  3144,  3145,  3146,  3147,
    3148,  3149,  3150,  3151,  4020,  4017,  3154,  3155,  3156,  3157,
    3158,  3159,  3160,  3161,  3162,  3163,  3164,  1724,  4032,  4021,
    4033,  4034,  4035,  4036,  4077,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2363,  2364,  4037,  2365,  4038,  4039,  4378,
    4379,  4040,  1725,  1726,  4051,  4044,  4047,  4062,  4050,  4063,
    3981,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,  4048,  2365,  4064,  4108,  4068,  4109,  4069,  4112,  4070,
    4089,  4079,  4090,  4091,  4096,   329,  4099,  1195,  2355,  2356,
    2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  4103,  2365,
    4105,  4404,  4107,  4124,  4110,  4119,  4120,  4126,  1195,  1195,
    4127,   555,  4204,   553,  4142,  4157,   734,  4144,  4146,  4185,
    3656,  2749,  2750,  4186,  4187,  4190,  1277,  4207,  4205,  2783,
    2415,  2785,  4201,  2415,  4151,  4151,  4206,  4208,  2766,  -878,
    4210,  4211,  4226,  4222,  4227,  2805,  4231,  1625,   553,  4155,
    4233,  2811,    21,  4234,  4236,  4238,  1195,  1195,  1195,  1195,
    2827,  2828,  4272,  2830,  4273,  4288,  4287,  2834,  4264,  4278,
    4285,  4279,  4280,  4296,  4299,  4300,  4281,  4189,  4293,  4282,
    4192,  4302,  4310,  4305,  4313,  4316,  4317,    21,  4320,  4331,
    4336,  4339,  4321,  4340,  4074,  2869,  4324,  2871,  2872,  2873,
    4334,  4343,  4329,  4346,  4350,  4349,  -880,  2884,  2885,  2865,
    4358,  4364,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,
    4368,  4370,  4369,  4380,  4388,  4399,  2415,  4400,  2355,  2356,
    2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2931,  2365,
    4373,  4230,  4389,  1195,  4374,  4390,  4381,  4407,  2948,  4413,
    2951,  4423,  4395,  2955,  4382,  4414,  4424,  4425,  4401,  2963,
    4433,  4434,  4437,  1195,  1195,   740,   741,   742,   743,   744,
     745,  4435,  4442,  1727,  1728,  4398,  4408,  1277,  4403,   471,
    4256,  4417,  4256,  1625,  4263,  2978,  4422,  4427,  3331,  4431,
    3342,  2985,  3794,  4438,  4436,  3306,  2989,  1015,  4152,  3023,
    3663,  3508,  4440,  3004,  4441,  3528,  2998,  4165,    42,  3707,
    3741,  4443,  3074,  2415,  3028,  1729,  1730,  1755,  1731,  1732,
    3747,  1733,  1734,  3494,  3039,  3040,  3041,  4412,  1736,  3044,
    3026,  4409,  3504,  3511,  3689,  3708,  3949,  4338,  3755,  1737,
    2832,  3957,  1193,    42,  3178,  3082,  1193,  3541,  3216,  1919,
    3069,  3070,  3523,  3519,  2179,  3233,  3653,  2185,  4309,  2200,
    3381,  3081,  3711,   553,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,  1997,  2365,  4184,  4200,  2004,  2965,
    4088,  4061,  2008,  4085,  4325,  3636,  1068,  2285,  3104,  2454,
    3118,  4330,  3109,  3046,  3273,  3112,  3259,  3114,  2802,  3276,
    3097,  3247,    21,  3101,  3078,  3281,  2807,  3434,  3486,  4342,
    3284,  4345,  3451,  3448,  1193,  1193,  1193,  1193,  3483,  3481,
    3475,  3470,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    3378,  3202,  1193,  1193,  1193,  1193,  1193,  1193,  1193,  1193,
    1193,  1193,  1193,  3322,  3243,  2859,    79,    80,    81,    82,
      83,  2224,  3171,  3172,  4383,  3174,  3006,  2838,  2088,  4387,
    3227,  2821,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,
    2363,  2364,  3095,  2365,  3697,  2994,  3224,  3671,  4147,  3545,
    3206,    79,    80,    81,    82,    83,  2282,  3208,  3209,  4153,
    4169,  2415,  3712,     0,     0,     0,     0,     0,     0,     0,
       0,  4405,  4406,     0,     0,     0,     0,  3210,  4387,  3231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4116,  2970,     0,     0,     0,     0,     0,  4426,     0,
    4428,     0,     0,  3258,     0,     0,     0,     0,  3245,     0,
       0,     0,     0,     0,  3252,  3253,  3254,  3255,    42,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,
    2365,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,     0,     0,  3300,     0,     0,
       0,     0,    21,  1162,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,  2971,     0,  3713,     0,
       0,     0,     0,     0,  3357,     0,     0,  3362,  3363,     0,
       0,     0,     0,     0,  2010,  3370,     0,  3372,  3373,  3374,
    3375,  3376,  1163,  2972,  2973,  2974,     0,     0,     0,     0,
       0,     0,     0,  3226,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,     0,  2365,     0,     0,     0,     0,
    3406,  3407,     0,    21,     0,     0,     0,     0,  3414,     0,
       0,     0,     0,  2011,     0,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,   553,  3672,     0,     0,
       0,  2012,     0,     0,     0,     0,     0,     0,  3680,     0,
    2415,     0,     0,  2013,  2014,     0,     0,  3455,  3456,  3457,
       0,  3459,     0,     0,  3462,  3463,  3714,     0,     0,     0,
    3468,  3469,     0,     0,     0,    21,     0,     0,     0,     0,
    2415,  2415,     0,     0,     0,     0,     0,     0,    42,     0,
    4000,     0,     0,     0,  2015,     0,     0,     0,     0,  3500,
       0,     0,     0,     0,   487,     0,     0,     0,  2975,     0,
    2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,
       0,  2365,     0,     0,  3529,  4003,     0,     0,  3534,     0,
       0,     0,  3538,  2355,  2356,  2357,  2358,  2359,  2360,  2361,
    2362,  2363,  2364,     0,  2365,     0,     0,     0,  3732,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    42,
    3556,  3557,  3558,  3559,     0,     0,  3560,  3561,  3562,  3563,
    3564,  3565,  3566,  3567,  3568,  3569,  3570,  3571,  3572,  3573,
    3574,     0,  3576,  3577,  3578,  3579,  3580,  3581,  3582,  3583,
    3584,  3585,  3586,  1202,  1203,     0,     0,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,  2365,  1204,
       0,     0,     0,     0,     0,     0,     0,   566,     0,     0,
    1205,    42,     0,     0,     0,     0,    79,    80,    81,    82,
      83,  2976,     0,     0,     0,     0,     0,     0,  1206,     0,
       0,     0,     0,     0,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,     0,  2365,  3776,  3777,  3715,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  3781,
    2365,     0,  2016,  2017,     0,     0,     0,     0,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,     0,
       0,     0,  2029,  2030,  2031,  2032,     0,     0,  1207,     0,
       0,     0,     0,  1084,  3208,  3209,     0,    79,    80,    81,
      82,    83,     0,     0,     0,     0,  2415,  2415,     0,     0,
       0,     0,     0,     0,     0,     0,   584,     0,     0,     0,
    4018,     0,     0,     0,     0,     0,     0,     0,     0,  1085,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    79,
      80,    81,    82,    83,  3716,     0,  1208,     0,     0,     0,
    1209,  2977,   569,     0,  1210,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2363,  2364,     0,  2365,  3717,  3647,     0,
       0,     0,  3650,     0,     0,     0,     0,  3808,     0,     0,
    2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,
       0,  2365,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,  1193,     0,   636,     0,     0,   638,     0,
       0,     0,   899,     0,  1193,   641,     0,     0,     0,  1071,
     643,  3718,     0,     0,     0,     0,     0,  3686,     0,     0,
       0,     0,     0,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   649,   650,   651,  1072,  1073,  3701,  3719,     0,
       0,     0,     0,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3720,     0,     0,     0,     0,     0,  2033,
       0,     0,     0,     0,     0,     0,     0,     0,  1074,     0,
       0,     0,     0,     0,     0,     0,  1075,     0,     0,     0,
       0,     0,     0,     0,  1193,     0,     0,   656,   657,   658,
       0,     0,     0,     0,     0,     0,     0,     0,  1076,  1077,
    1078,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,     0,  2365,     0,     0,     0,   659,   660,   661,     0,
    3737,     0,     0,     0,     0,     0,     0,  1079,  2415,     0,
    2415,     0,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,
    2363,  2364,  2426,  2365,     0,     0,     0,     0,     0,  3759,
       0,     0,     0,     0,  1080,     0,     0,     0,     0,     0,
       0,     0,    42,  3764,     0,     0,     0,  3950,     0,  3952,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3721,
       0,     0,     0,     0,     0,     0,     0,     0,   694,     0,
       0,     0,     0,     0,     0,     0,  3973,  3974,     0,    42,
       0,   554,  1193,  1193,  3722,  2767,  2768,  2769,  2770,  2771,
    2772,  2773,  2774,  2775,  2776,  1193,  2777,  3976,     0,  3977,
       0,     0,     0,     0,     0,     0,     0,     0,   712,  1081,
       0,  1082,     0,   714,     0,     0,  1083,  1084,     0,     0,
       0,   717,   718,   636,     0,   719,   638,   720,     0,     0,
       0,     0,     0,     0,     0,     0,   642,  1071,     0,   721,
     584,     0,     0,  2355,  2356,  2357,  2358,  2359,  2360,  2361,
    2362,  2363,  2364,  1085,  2365,     0,  2415,  2415,     0,     0,
       0,     0,  1086,     0,  4012,  1087,   568,     0,     0,     0,
       0,     0,     0,     0,   728,   585,  1088,     0,     0,     0,
     649,   650,   651,  1072,  1073,     0,     0,  1089,  1090,  1091,
      79,    80,    81,    82,    83,     0,   569,     0,     0,     0,
       0,     0,   730,   731,     0,     0,     0,     0,     0,   732,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,  1075,     0,     0,    79,    80,    81,
      82,    83,     0,  1193,     0,   656,   657,   658,     0,     0,
       0,     0,     0,     0,     0,     0,  1076,  1077,  1078,     0,
    1299,  1042,     0,     0,     0,  3724,     0,     0,    21,     0,
       0,     0,     0,     0,   659,   660,   661,     0,  2767,  2768,
    2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,
       0,     0,     0,     0,     0,     0,  3725,     0,   528,     0,
      21,     0,     0,  2415,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,   694,  2767,  2768,  2769,
    2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,  4135,
    4136,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   712,  1081,     0,  1082,
       0,   714,     0,     0,  1083,  1084,   734,     0,     0,   717,
     718,     0,     0,     0,     0,   720,     0,  4161,  4162,  4163,
    4164,     0,  3872,     0,     0,     0,     0,   721,   584,     0,
       0,     0,     0,     0,    42,   553,     0,  3730,     0,     0,
       0,  1085,     0,     0,  2415,     0,  2415,     0,     0,     0,
    1086,     0,     0,  1087,   568,     0,     0,     0,     0,     0,
       0,     0,   728,   585,  1088,     0,    42,     0,     0,     0,
       0,     0,     0,     0,    21,  1089,  1090,  1091,     0,     0,
       0,     0,     0,  3927,   569,     0,     0,   553,     0,  3932,
     730,   731,     0,  1193,     0,  1193,     0,   732,     0,  3938,
     325,  1193,     0,     0,  4232,     0,     0,     0,     0,     0,
       0,     0,  2415,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1193,  1193,  4243,  4244,    21,     0,  3799,     0,
       0,     0,   325,     0,  3971,     0,     0,     0,     0,     0,
       0,     0,     0,  1193,     0,  1193,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   740,   741,   742,   743,   744,
     745,  3126,  3754,     0,     0,  1300,     0,     0,     0,     0,
       0,     0,  2415,  3985,     0,     0,     0,     0,     0,     0,
       0,     0,    79,    80,    81,    82,    83,     0,  3853,     0,
       0,     0,  3997,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,     0,
    1193,     0,     0,     0,    79,    80,    81,    82,    83,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,  3854,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,
    4335,  2776,     0,  2777,  1301,     0,     0,     0,     0,     0,
       0,     0,  4025,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   734,     0,     0,     0,     0,     0,
       0,     0,    42,     0,     0,     0,  4052,  4053,     0,     0,
       0,     0,  4059,  2415,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4054,     0,  4055,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
    2415,     0,     0,     0,  2415,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
    4092,  4093,     0,  4095,     0,     0,     0,     0,     0,     0,
       0,  4102,     0,     0,  1193,     0,     0,  4106,    79,    80,
      81,    82,    83,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,  1193,  1193,     0,     0,     0,
    4125,     0,     0,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,     0,     0,  4138,  4139,     0,
       0,     0,     0,   740,   741,   742,   743,   744,   745,     0,
      79,    80,    81,    82,    83,     0,  4149,   553,     0,     0,
       0,     0,     0,  1193,  1193,  1193,  1193,     0,     0,  2415,
       0,  4168,     0,  2415,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,     0,  2777,     0,  3855,     0,     0,
       0,     0,     0,     0,     0,     0,    21,     0,     0,     0,
    2415,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,  4197,  2777,     0,  1043,     0,     0,     0,     0,  4199,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,  3685,  3856,     0,     0,
    1193,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,     0,  2777,  2415,     0,     0,     0,     0,     0,     0,
    1193,  1193,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,     0,
       0,  4268,     0,     0,     0,     0,     0,     0,     0,   470,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
       0,  2777,     0,     1,     2,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2415,     0,     0,     0,     0,     0,
    4283,  4284,    42,     0,     0,     0,     0,     0,     3,     4,
       5,     6,     7,     0,     0,     0,     8,     0,     0,     0,
       0,  2415,  4301,     0,     9,     0,     0,  3857,     0,     0,
    4306,     0,     0,     0,    10,    11,    12,  2415,  2415,     0,
      13,     0,    14,    15,    16,    17,    18,  3858,     0,     0,
       0,     0,     0,     0,     0,     0,    19,    20,     0,    21,
     627,     0,     0,     0,     0,     0,    22,     0,     0,     0,
    2749,  2750,    23,     0,     0,  4337,     0,  2415,     0,     0,
       0,     0,     0,  2415,     0,     0,     0,     0,    24,    25,
      26,    27,     0,     0,  4351,     0,     0,     0,  3859,  2415,
      28,     0,    29,    30,     0,     0,     0,     0,     0,  2415,
    2415,     0,   877,     0,     0,     0,    31,     0,     0,     0,
       0,     0,     0,     0,     0,  3860,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,    32,  2777,     0,  2415,
    3584,     0,     0,     0,     0,    33,     0,    34,     0,     0,
      79,    80,    81,    82,    83,     0,     0,     0,     0,  4394,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
       0,  2777,     0,     0,     0,  3861,    35,    36,    37,    38,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
    4268,     0,     0,    40,     0,     0,     0,  4415,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,     0,     0,     0,     0,    42,     0,  3862,     0,     0,
      43,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4439,     0,
      44,    45,     0,    46,  3863,    47,    48,     0,     0,     0,
       0,     0,     0,     0,    49,     0,     0,    50,     0,    51,
      52,     0,     0,     0,    53,    54,     0,     0,    55,    56,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,    57,    58,     0,     0,    59,    60,
      61,    62,     0,    63,    64,     0,     0,     0,     0,    65,
       0,     0,    66,     0,     0,     0,     0,    67,    68,     0,
       0,     0,     0,    69,     0,     0,     0,    70,    71,    72,
       0,     0,    73,     0,    74,    75,    76,    77,    78,  2767,
    2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,
    2777,     0,     0,     0,     0,   553,     0,     0,     0,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,    84,
       0,     0,     0,     0,     0,     0,    85,    86,    87,     0,
      88,    89,    90,     0,    91,    92,    93,    94,    95,    96,
      97,     0,     0,     0,    21,     0,    98,    99,     0,     0,
    3864,     0,   100,     0,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,     0,  2777,  2355,  2356,  2357,  2358,
    2359,  2360,  2361,  2362,  2363,  2364,     0,  2365,     0,     0,
       0,     0,     0,     0,  3865,   101,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,  2355,  2356,
    2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,  2365,
       0,     0,   927,     0,     0,     0,     0,     0,     0,   102,
       0,     0,     0,     0,   103,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2363,  2364,     0,  2365,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,  2355,  2356,  2357,  2358,
    2359,  2360,  2361,  2362,  2363,  2364,     0,  2365,     0,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,
    2365,     0,     1,     2,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   123,   124,     0,     0,   125,   126,
      42,   127,   128,   129,   130,   131,   132,     3,     4,     5,
       6,     7,     0,     0,   133,     8,     0,     0,     0,   134,
     135,   136,     0,     9,     0,     0,     0,   137,     0,     0,
       0,     0,     0,    10,    11,    12,     0,     0,     0,    13,
       0,    14,    15,    16,    17,    18,     0,     0,     0,   138,
     139,     0,     0,     0,     0,    19,    20,     0,    21,     0,
       0,     0,     0,  3866,     0,    22,     0,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   140,   141,     0,     0,     0,    24,    25,    26,
      27,     0,     0,     0,     0,     0,     0,     0,     0,    28,
       0,    29,    30,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,   142,     0,   143,     0,     0,     0,  3867,     0,
       0,     0,     0,     0,     0,    32,     0,     0,     0,     0,
    3948,     0,     0,     0,    33,     0,    34,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
    3998,     0,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,
    2363,  2364,  4004,  2365,     0,    35,    36,    37,    38,     0,
       0,    39,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,
    2775,  2776,    40,  2777,     0,     0,     0,     0,     0,  4005,
       0,     0,     0,     0,     0,     0,    41,     0,     0,     0,
       0,     0,     0,     0,    42,     0,     0,     0,     0,    43,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4019,     0,     0,     0,     0,     0,     0,     0,     0,    44,
      45,     0,    46,  4129,    47,    48,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,    50,     0,    51,    52,
       0,     0,     0,    53,    54,     0,     0,    55,    56,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,    57,    58,     0,     0,    59,    60,    61,
      62,     0,    63,    64,     0,     0,     0,     0,    65,     0,
       0,    66,     0,     0,     0,     0,    67,    68,     0,     0,
       0,     0,    69,     0,     0,     0,    70,    71,    72,     0,
       0,    73,     0,    74,    75,    76,    77,    78,  2767,  2768,
    2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
       0,  2777,    79,    80,    81,    82,    83,     0,    84,     0,
       0,     0,     0,     0,     0,    85,    86,    87,     0,    88,
      89,    90,     0,    91,    92,    93,    94,    95,    96,    97,
       0,     0,     0,     0,     0,    98,    99,     0,     0,     0,
       0,   100,     0,     0,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,     0,  2365,     0,     0,  2355,  2356,
    2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,  2365,
       0,     0,     0,     0,   101,     0,  4130,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,  2365,     0,
       0,     0,     0,     0,     0,     0,  4148,     0,     0,     0,
    1151,     0,     0,     0,     0,     0,     0,     0,   102,     0,
       0,     0,     0,   103,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,     0,  2777,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,  2767,  2768,  2769,
    2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,     0,
       0,     0,     0,     0,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,
       0,     0,     0,   123,   124,     0,     0,   125,   126,     0,
     127,   128,   129,   130,   131,   132,     0,     0,     0,     0,
       0,     0,     0,   133,     0,     0,     0,     0,   134,   135,
     136,     0,     0,     0,     0,     0,   137,   636,   637,     0,
     638,   639,     0,   640,     0,     0,     0,   641,     0,     0,
     642,     0,   643,     0,     0,     0,     0,     0,   138,   139,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
     644,  2777,  4193,     0,     0,     0,     0,     0,   645,   486,
       0,     0,     0,     0,  4194,     0,   646,   647,   648,     0,
     487,   140,   141,     0,   649,   650,   651,  2767,  2768,  2769,
    2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,     0,
       0,     0,   652,     0,     0,   653,   524,   525,   654,     0,
       0,     0,     0,   655,     0,     0,     0,     0,     0,     0,
       0,   142,     0,   143,     0,     0,     0,   517,  4245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   656,
     657,   658,  4318,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,     0,
       0,  4319,     0,     0,     0,     0,     0,     0,   659,   660,
     661,     0,   662,   526,   663,   527,     0,     0,     0,     0,
       0,     0,     0,     0,   664,   665,     0,     0,     0,   666,
     667,     0,   528,   668,   669,     0,  2778,   670,   671,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,     0,     0,   687,   688,   689,   690,   691,
     692,  4347,     0,     0,     0,     0,     0,     0,     0,   693,
     694,   529,   695,   696,   697,   698,   699,   700,  4348,   701,
     702,     0,     0,   703,   704,     0,     0,     0,   705,     0,
       0,     0,     0,   706,   707,   708,     0,     0,     0,   709,
       0,   710,     0,     0,   711,     0,   553,     0,   489,   490,
     712,     0,   713,     0,     0,   714,   715,   716,     0,     0,
       0,     0,     0,   717,   718,   636,     0,   719,   638,   720,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1071,
       0,   721,     0,     0,     0,    21,   722,   491,   492,     0,
       0,   723,     0,     0,  4391,  2299,     0,   724,     0,     0,
       0,     0,     0,     0,     0,   725,     0,     0,   568,   726,
     727,     0,     0,     0,     0,     0,   728,     0,     0,     0,
       0,     0,   649,   650,   651,  1072,  1073,     0,     0,     0,
       0,  4416,     0,   729,    21,  1162,     0,     0,   569,     0,
       0,     0,     0,     0,   730,   731,     0,     0,     0,     0,
       0,   732,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,
    2363,  2364,     0,  2365,     0,     0,  1075,  1330,     0,     0,
       0,     0,     0,     0,     0,     0,  2010,   656,   657,   658,
       0,     0,     0,     0,  1163,     0,     0,  4430,  1076,  1077,
    1078,     0,  1153,     0,     0,     0,     0,     0,   733,     0,
       0,     0,     0,     0,     0,     0,   659,   660,   661,     0,
       0,     0,     0,     0,     0,     0,   493,   494,     0,     0,
       0,     0,     0,     0,     0,  2011,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,  2012,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   553,  2013,  2014,     0,     0,     0,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
       0,  2777,     0,     0,     0,     0,     0,     0,   694,     0,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
      42,  2777,     0,    21,     0,     0,  2015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3100,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   712,  1081,
       0,  1082,     0,   714,     0,     0,  1083,  1084,   734,     0,
       0,   717,   718,     0,     0,     0,     0,   720,   553,     0,
       0,     0,     0,     0,     0,     0,    21,  1162,     0,   721,
     584,     0,     0,     0,     0,     0,     0,     0,   531,   532,
     533,   534,     0,  1085,     0,     0,   735,     0,     0,     0,
       0,     0,  1086,     0,     0,  1087,   568,    21,     0,     0,
       0,     0,     0,     0,   728,   585,  1088,    42,  2010,    79,
      80,    81,    82,    83,     0,     0,  1163,  1089,  1090,  1091,
       0,     0,     0,     0,     0,     0,   569,   736,   737,   553,
       0,     0,   730,   731,     0,     0,     0,     0,     0,   732,
       0,     0,     0,  1331,  3059,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2011,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,    21,    42,
     553,   738,   739,     0,     0,  2012,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2013,  2014,     0,
       0,     0,     0,     0,     0,     0,     0,   740,   741,   742,
     743,   744,   745,     0,  2016,  2017,     0,     0,     0,    21,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,     0,    42,     0,  2029,  2030,  2031,  2032,  2015,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  3103,    42,     0,    79,    80,    81,    82,    83,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3621,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,     0,  2777,     0,     0,     0,   734,    79,    80,    81,
      82,    83,     0,   553,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,     0,  2777,     0,     0,     0,   553,
       0,     0,    21,     0,     0,    42,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    21,     0,
       0,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2016,  2017,     0,     0,
       0,  1152,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,     0,     0,     0,  2029,  2030,  2031,  2032,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,   740,   741,   742,   743,   744,
     745,  2033,    79,    80,    81,    82,    83,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,  2365,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    79,    80,    81,    82,    83,    42,   553,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,   553,     0,
       0,     0,     0,     0,    42,     0,     0,     0,    21,     0,
       0,     0,     0,     0,     0,     0,     0,  1154,     0,     0,
       0,     0,     0,  -774,     0,     0,   553,  2767,  2768,  2769,
    2770,  2771,  2772,  2773,  2774,  2775,  2776,    21,  2777,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    21,  3651,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1197,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    21,     0,     0,     0,
       0,     0,  1434,     0,     0,     0,    79,    80,    81,    82,
      83,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,     0,  2777,  2033,  2767,  2768,  2769,  2770,  2771,  2772,
    2773,  2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,
       0,    21,    79,    80,    81,    82,    83,     0,     0,     0,
       0,     0,     0,  1236,    42,  1355,  1356,  1357,  1358,  1359,
    1360,  1361,  1362,  1363,  1364,  1365,  1366,  1367,  1368,  1369,
    1370,  1371,  1372,  1373,  1374,  1375,  1376,  1377,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     0,     0,  3674,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1439,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1273,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    21,
       0,     0,    42,     0,     0,  1448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1310,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,  3700,
       0,     0,     0,     0,    21,     0,     0,    42,     0,     0,
       0,     0,    79,    80,    81,    82,    83,   553,     0,     0,
       0,     0,     0,     0,     0,     0,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,     0,     0,
       0,    79,    80,    81,    82,    83,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,    21,  2777,     0,     0,
       0,     0,     0,  1501,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
       0,     0,   553,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,  3769,  2777,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,     0,  3770,     0,     0,     0,
      79,    80,    81,    82,    83,    42,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,     0,     0,  1329,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    79,    80,    81,    82,    83,
      42,     0,     0,     0,  1343,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,    42,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    42,   553,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,  3771,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,  2493,     0,     0,     0,    21,  3772,     0,
       0,     0,     0,     0,  1354,     0,     0,     0,     0,     0,
       0,     0,  2496,  2355,  2356,  2357,  2358,  2359,  2360,  2361,
    2362,  2363,  2364,     0,  2365,     0,     0,     0,     0,     0,
       0,     0,    21,  1425,     0,  3929,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,   553,     0,     0,     0,
       0,  1426,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    79,    80,    81,    82,
      83,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,  3610,  1430,     0,     0,    79,    80,    81,    82,    83,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      21,     0,     0,     0,     0,     0,     0,  1435,     0,     0,
       0,     0,     0,    42,     0,   553,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,    42,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    42,     0,   553,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    21,     0,
       0,    42,     0,     0,   553,  1440,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,
       0,  2777,     0,     0,     0,  3953,     0,     0,     0,     0,
       0,     0,     0,    21,     0,     0,    42,     0,     0,     0,
    1449,    79,    80,    81,    82,    83,     0,     0,   553,     0,
       0,     0,     0,     0,     0,  2767,  2768,  2769,  2770,  2771,
    2772,  2773,  2774,  2775,  2776,     0,  2777,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,    21,     0,     0,
      42,     0,  1500,   553,     0,    79,    80,    81,    82,    83,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   553,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,     0,     0,     0,  1502,    79,
      80,    81,    82,    83,    42,     0,     0,     0,     0,     0,
       0,    21,     0,     0,   553,     0,     0,  1754,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    79,    80,    81,    82,    83,    42,
       0,     0,     0,    21,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    79,    80,
      81,    82,    83,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  3972,     0,     0,     0,     0,     0,    42,     0,
       0,     0,    79,    80,    81,    82,    83,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    42,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  3984,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    79,    80,    81,
      82,    83,     0,  3749,     0,     0,     0,     0,     0,    42,
       0,     0,     0,  1993,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,    21,     0,     0,  4002,     0,     0,  2494,     0,
       0,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3749,  2497,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,    21,   553,     0,     0,     0,
       0,  3609,     0,     0,     0,    79,    80,    81,    82,    83,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3611,    79,    80,    81,
      82,    83,   553,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,    42,     0,
       0,    21,     0,     0,     0,     0,     0,     0,     0,     0,
    3618,     0,     0,     0,     0,     0,     0,     0,     0,   553,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    21,     0,
       0,    42,     0,   553,  3619,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,    42,    21,     0,     0,   553,     0,     0,     0,  3620,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   553,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,     0,     0,
       0,     0,     0,     0,    21,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,    42,     0,     0,
       0,     0,   553,  3641,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,
    2776,     0,  2777,     0,     0,     0,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,     0,     0,  3655,    79,
      80,    81,    82,    83,    42,     0,     0,     0,     0,     0,
     553,     0,     0,     0,     0,     0,     0,  3702,     0,     0,
       0,     0,     0,     0,     0,  4094,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,    42,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3748,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
    2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,
      42,  2365,     0,     0,     0,    79,    80,    81,    82,    83,
       0,     0,     0,     0,     0,   553,     0,     0,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,    21,     0,     0,    42,     0,     0,
       0,     0,    79,    80,    81,    82,    83,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,     0,  4097,     0,
       0,     0,     0,    21,     0,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,    42,     0,     0,  4228,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    79,    80,
      81,    82,    83,  4104,     0,     0,     0,    21,  3750,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,  4254,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    79,    80,    81,    82,    83,
      42,  4254,     0,     0,    21,     0,     0,     0,     0,     0,
       0,  3752,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,    42,
       0,  3765,  4115,    79,    80,    81,    82,    83,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,    42,     0,     0,     0,  3766,  4261,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
      42,     0,     0,     0,  3768,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    42,    79,    80,    81,
      82,    83,     0,     0,     0,     0,     0,     0,  3773,     0,
       0,     0,     0,     0,     0,  2767,  2768,  2769,  2770,  2771,
    2772,  2773,  2774,  2775,  2776,     0,  2777,  2767,  2768,  2769,
    2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3774,    79,    80,    81,    82,    83,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,     0,     0,
    3775,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,    42,  2777,     0,     0,  3784,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,    79,    80,    81,    82,    83,  2767,
    2768,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,
    2777,     0,     0,     0,     0,  3809,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,  3064,  2767,  2768,  2769,  2770,  2771,
    2772,  2773,  2774,  2775,  2776,     0,  2777,     0,     0,     0,
       0,     0,     0,     0,    21,  1162,  2767,  2768,  2769,  2770,
    2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    79,    80,    81,    82,    83,     0,     0,     0,     0,
    4137,     0,     0,     0,  1163,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  4128,     0,     0,
     885,     0,     0,     0,     0,     0,     0,     0,     0,  4140,
       0,     0,     0,     0,     0,  1164,    21,     0,     0,   275,
     276,     0,     0,  2184,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1165,     0,     0,     0,     0,  4160,     0,
       0,     0,     0,    21,     0,  1166,  1167,  4117,     0,     0,
       0,     0,     0,  2767,  2768,  2769,  2770,  2771,  2772,  2773,
    2774,  2775,  2776,     0,  2777,     0,     0,    21,  1162,     0,
       0,     0,     0,  4229,     0,  4218,     0,     0,     0,     0,
      42,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,  2767,  2768,  2769,  2770,  2771,
    2772,  2773,  2774,  2775,  2776,     0,  2777,  1163,  2767,  2768,
    2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,  2777,
    4255,  4219,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,
    2363,  2364,     0,  2365,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,     0,  2365,     0,     0,  1164,     0,
       0,     0,     0,     0,     0,     0,  4259,     0,     0,     0,
       0,     0,    42,     0,     0,     0,  1165,  4224,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1166,  1167,
       0,     0,     0,     0,     0,     0,     0,     0,  4239,    42,
    3057,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      21,  1162,     0,    42,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1168,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,
    2365,     0,     0,     0,     0,     0,  1169,     0,     0,     0,
    1163,     0,     0,  4262,  1170,  1171,     0,     0,     0,     0,
    1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,
    1182,  1183,  1184,     0,  1185,  1186,  1187,  1188,  1189,  1190,
     886,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,  1164,  2365,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,  4246,     0,     0,     0,  1165,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1166,  1167,     0,     0,     0,     0,    79,    80,    81,
      82,    83,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    79,    80,    81,    82,    83,    42,  4247,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4253,  1168,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4274,     0,     0,     0,     0,  1169,
       0,     0,     0,     0,     0,     0,  4275,  1170,  1171,     0,
       0,     0,     0,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1183,  1184,     0,  1185,  1186,  1187,
    1188,  1189,  1190,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
       0,  4276,     0,     0,    79,    80,    81,    82,    83,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,     0,
    2365,  1191,     0,  2257,  1168,  2258,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   637,   953,   638,     0,
       0,     0,  1169,     0,     0,     0,     0,     0,    21,     0,
    1170,  1171,     0,  4277,     0,     0,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,     0,
    1185,  1186,  1187,  1188,  1189,  1190,   645,     0,  2767,  2768,
    2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,   487,  2777,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    21,
    1162,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   285,   286,     0,     0,   488,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   656,   657,  1163,
       0,     0,     0,  1202,  1203,     0,     0,     0,     0,     0,
       0,     0,     0,  1525,  1191,     0,  2257,     0,  2258,  1204,
       0,     0,     0,     0,     0,     0,     0,   566,     0,     0,
    1205,   526,     0,     0,     0,     0,     0,     0,     0,     0,
    1164,     0,     0,   665,     0,     0,   955,     0,  1206,     0,
     528,     0,     0,     0,    42,     0,     0,     0,  1165,     0,
       0,     0,     0,     0,     0,     0,   672,     0,     0,     0,
    1166,  1167,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   692,     0,
       0,     0,    21,  1162,     0,     0,     0,     0,     0,   529,
       0,     0,     0,     0,     0,    42,     0,     0,  1207,     0,
       0,     0,     0,  1084,     0,     0,     0,     0,    21,  1162,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4311,     0,     0,     0,     0,   489,     0,   712,     0,
       0,     0,  1163,   714,     0,     0,     0,     0,     0,  1085,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2010,     0,     0,     0,     0,     0,     0,  1191,  1163,     0,
       0,     0,     0,     0,     0,   491,   492,     0,     0,     0,
       0,     0,     0,  1164,     0,     0,  1208,     0,     0,     0,
    1209,     0,   569,     0,  1210,     0,     0,     0,     0,     0,
    4363,  1165,    79,    80,    81,    82,    83,     0,     0,  2011,
       0,     0,     0,  1166,  1167,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2013,
    2014,     0,     0,     0,     0,     0,     0,     0,    42,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   899,  1168,    42,     0,     0,     0,     0,     0,
    2015,     0,     0,     0,   959,     0,     0,     0,     0,     0,
       0,  1169,     0,     0,     0,     0,     0,     0,     0,  1170,
    1171,     0,     0,     0,     0,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,     0,  1185,
    1186,  1187,  1188,  1189,  1190,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,  1526,
    1527,  1528,  1529,   961,  1530,  1531,  1532,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1168,     0,     0,     0,
       0,     0,    79,    80,    81,    82,    83,     0,     0,     0,
       0,     0,     0,     0,  1169,     0,     0,     0,     0,     0,
       0,     0,  1170,  1171,     0,     0,     0,     0,  1172,  1173,
    1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,
    1184,     0,  1185,  1186,  1187,  1188,  1189,  1190,  4265,  4266,
       0,     0,     0,     0,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,     0,     0,     0,  2029,  2030,
    2031,  2032,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1553,  1554,  1555,
       0,     0,     0,     0,   293,   294,     0,     0,     0,    21,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    21,
    1162,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,  1191,     0,  2257,     0,
    2258,    21,  1162,     0,     0,     0,     0,     0,     0,     0,
       0,  2010,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2010,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
    2011,  4267,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2012,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2013,  2014,  2011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    42,     0,     0,     0,     0,
    2012,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2013,  2014,     0,    42,     0,     0,     0,     0,
       0,  2015,     0,     0,     0,     0,     0,     0,     0,  1191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    42,     0,    21,
    1162,     0,     0,  2015,     0,  2033,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,  1162,     0,     0,     0,     0,     0,     0,     0,
       0,  2010,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2010,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
    2011,     0,     0,    79,    80,    81,    82,    83,     0,     0,
       0,     0,     0,    21,     0,     0,     0,     0,  2012,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,     0,
    2013,  2014,  2011,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2012,     0,    21,     0,     0,    79,    80,    81,    82,    83,
       0,     0,  2013,  2014,     0,    42,     0,     0,     0,  2016,
    2017,  2015,     0,     0,     0,  2018,  2019,  2020,  2021,  2022,
    2023,  2024,  2025,  2026,  2027,  2028,     0,     0,     0,  2029,
    2030,  2031,  2032,     0,     0,     0,     0,    42,     0,    21,
       0,  2016,  2017,  2015,     0,     0,     0,  2018,  2019,  2020,
    2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,     0,     0,
       0,  2029,  2030,  2031,  2032,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    21,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,    42,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4332,     0,     0,   325,     0,     0,     0,     0,
       0,     0,    21,     0,     0,    79,    80,    81,    82,    83,
       0,     0,     0,     0,     0,    42,     0,     0,     0,  2016,
    2017,    21,     0,     0,  4333,  2018,  2019,  2020,  2021,  2022,
    2023,  2024,  2025,  2026,  2027,  2028,     0,     0,     0,  2029,
    2030,  2031,  2032,     0,     0,     0,     0,     0,     0,     0,
       0,  2016,  2017,     0,     0,     0,     0,  2018,  2019,  2020,
    2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,     0,    21,
       0,  2029,  2030,  2031,  2032,   305,   306,    79,    80,    81,
      82,    83,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2033,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    79,    80,    81,    82,
      83,    42,     0,     0,     0,     0,     0,     0,  2033,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    42,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    42,     0,     0,
       0,     0,  4384,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,    21,     0,     0,    42,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2033,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,    21,     0,  2033,     0,
       0,     0,     0,     0,     0,    79,    80,    81,    82,    83,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    79,    80,    81,    82,    83,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     326,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    21,     0,     0,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   342,   343,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,    42,     0,     0,   367,   368,     0,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   380,   381,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,     0,    79,    80,    81,    82,    83,    42,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,   383,   384,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   388,   389,
      79,    80,    81,    82,    83,     0,     0,     0,     0,     0,
       0,    21,     0,     0,    42,     0,     0,   392,   393,    79,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,   402,   403,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,    42,     0,     0,     0,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    79,    80,    81,    82,    83,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,    42,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,   418,   419,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    79,
      80,    81,    82,    83,     0,     0,     0,     0,    21,     0,
       0,     0,     0,     0,     0,   441,   442,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    21,     0,     0,     0,     0,
       0,     0,     0,   351,     0,    79,    80,    81,    82,    83,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   406,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,    79,    80,    81,    82,    83,    42,     0,
       0,     0,    21,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,    42,     0,     0,     0,   467,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    21,     0,
       0,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2819,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,     0,    42,     0,
       0,  2857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2860,    79,    80,    81,    82,    83,     0,     0,     0,
       0,     0,     0,    21,     0,     0,    42,     0,     0,     0,
    2862,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,    42,     0,   487,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2966,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,  3007,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    79,    80,    81,    82,    83,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,    42,     0,     0,
       0,     0,    79,    80,    81,    82,    83,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   487,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    79,
      80,    81,    82,    83,     0,     0,     0,     0,  3119,     0,
       0,     0,     0,     0,     0,     0,   517,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,     0,  3200,     0,     0,    79,    80,    81,
      82,    83,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3234,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    79,    80,    81,    82,    83,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3241,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3250,     0,
       0,     0,   493,   494,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3260,     0,   878,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,   878,
       0,  2178,     0,     0,     0,  1627,  1628,  1629,  1630,  1631,
       0,     0,     0,     0,     0,     0,     0,     0,  1637,  1638,
    1639,    21,   890,     0,  3274,  1644,  1772,     0,  1645,  1646,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   890,    21,     0,     0,  2189,     0,     0,     0,     0,
       0,     0,     0,  1652,     0,     0,     0,     0,     0,     0,
       0,     0,   890,     0,  3652,    21,     0,     0,     0,     0,
       0,  3282,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   885,     0,  1727,    21,  3931,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,     0,  1730,     0,     0,  3320,
    1773,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1672,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,     0,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  3449,  1627,  1628,
    1629,  1630,  1631,  1632,  1633,  1634,  1635,    42,     0,     0,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,     0,
       0,  1645,  1646,  1647,  1648,  1649,  1650,  1651,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1652,  1653,  1654,  1655,
    1656,    42,     0,     0,  1995,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,     0,     0,     0,
      42,  1669,  1670,  1671,  2002,     0,     0,     0,   879,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,     0,     0,    21,     0,   879,
       0,     0,     0,  2320,     0,     0,     0,     0,   880,     0,
      42,     0,     0,     0,     0,     0,     0,    21,     0,     0,
     890,     0,     0,     0,     0,     0,  1996,     0,     0,   880,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,  1672,     0,     0,  2003,     0,     0,     0,
       0,     0,   891,     0,     0,    79,    80,    81,    82,    83,
       0,     0,  2006,    21,     0,     0,     0,     0,     0,     0,
       0,   891,     0,     0,     0,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   891,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,    21,     0,     0,     0,     0,
       0,   886,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2007,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    42,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    42,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    42,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,     0,  2406,     0,  2585,     0,     0,     0,     0,
     891,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,     0,    21,   553,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    79,    80,    81,    82,
      83,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    79,    80,    81,
      82,    83,     0,    21,     0,     0,  4252,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2102,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,  2199,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    21,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    42,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    42,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    42,     0,     0,  1274,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2212,     0,     0,
       0,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,     0,     0,     0,  2223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1274,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    79,    80,    81,
      82,    83,     0,     0,  2245,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    79,    80,    81,
      82,    83,     0,     0,     0,     0,  2248,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      42,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      42,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    79,    80,    81,    82,    83,  2281,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2284,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,    21,  2293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2296,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,    21,     0,  2297,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    42,  2583,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3907,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,  3937,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,    21,     0,  3939,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,    21,     0,
       0,     0,     0,     0,     0,     0,     0,  3947,     0,     0,
       0,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4260,    21,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,     0,     0,     0,     0,     0,    21,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    42,    21,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    42,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    42,     0,  2038,  2039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    21,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    21,     0,     0,     0,
      79,    80,    81,    82,    83,     0,     0,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,     0,     0,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3656,
    3657,     0,    79,    80,    81,    82,    83,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    79,    80,    81,    82,    83,     0,     0,     0,  3034,
       0,     0,     0,     0,     0,     0,     0,    21,     0,     0,
      79,    80,    81,    82,    83,     0,     0,    42,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    42,     0,     0,     0,    21,    79,    80,    81,
      82,    83,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   325,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    42,  3107,     0,     0,    21,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,     0,
      21,     0,     0,    42,     0,    79,    80,    81,    82,    83,
       0,   325,  4074,  4075,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,  2040,
      79,    80,    81,    82,    83,     0,     0,     0,     0,    21,
    2914,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   325,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,    79,    80,    81,    82,    83,     0,     0,
       0,     0,     0,     0,     0,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   325,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,  2923,  2924,
    2925,    79,    80,    81,    82,    83,    42,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,  3658,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    21,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,    42,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,  1274,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    79,    80,    81,    82,    83,  3554,
       0,     0,     0,     0,  2798,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,    21,     0,     0,    42,     0,
       0,     0,     0,    79,    80,    81,    82,    83,  4191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,  4076,    79,    80,    81,    82,
      83,    42,     0,     0,     0,     0,     0,    21,     0,  4344,
       0,     0,     0,     0,  3513,     0,     0,     0,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    21,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    79,    80,    81,    82,
      83,    42,    21,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    79,
      80,    81,    82,    83,     0,     0,     0,     0,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    79,    80,    81,    82,    83,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    79,    80,    81,    82,
      83,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,  3550,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,  4188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,  4341
  };

  const short
  parser::yycheck_[] =
  {
       0,   332,   408,     3,   410,   442,   412,   302,  1275,     9,
     632,   892,   929,  1016,    14,   315,  1623,  1059,   455,  1240,
    1246,   281,   350,    23,   276,   343,   294,   343,   294,   294,
     466,   314,   343,   306,   294,   294,    36,   435,   306,   294,
     294,   294,   294,   314,   466,   459,   314,    47,    48,    49,
     294,   466,    52,   294,   466,   314,   314,    57,   294,   311,
     314,    61,   447,   466,   294,   317,  2180,   447,    68,    69,
     276,    71,   466,    73,   399,   435,   276,   447,    78,   381,
     447,   276,   447,   447,    84,    85,    86,    87,   294,   445,
      90,   294,    92,    93,   294,   399,   276,   453,   387,   294,
     435,   294,   354,   447,   466,   281,   358,   466,   399,   294,
     356,   294,   466,   294,   360,   447,   368,   294,   466,   399,
     466,   314,   374,   466,   434,   125,   466,   466,   374,   314,
     466,   311,   384,   389,   356,   447,   466,   317,   360,   384,
     434,   343,   142,   301,   144,   384,   384,   434,   466,   384,
     466,  2259,   434,   282,   447,   466,   399,   399,   354,   294,
     294,   434,   368,   434,   379,   368,   434,   434,   368,   447,
     387,   274,   447,   368,   419,   368,   434,   294,   381,   381,
     314,   419,   434,   466,   439,   314,   447,   439,   368,   306,
     356,   368,   282,   294,   360,   447,  2259,   314,   466,     3,
     466,   466,   294,   379,   384,     9,   466,   466,   374,  2960,
      14,   294,   466,   466,   466,  2692,   294,  1158,   319,    23,
     466,    51,   466,  2794,   314,   466,   294,   294,   434,    51,
     466,   434,  2092,   294,    51,   435,   466,   294,   306,   368,
     435,   434,   434,    47,    48,   294,   314,   447,    52,   434,
      51,   434,   447,    57,   434,   384,  2116,    61,    51,   294,
     466,  2540,  2541,    51,    68,    69,   466,    71,    51,    73,
     294,   466,    51,   294,    78,    51,    51,   277,    51,   294,
      84,   338,    51,   445,   284,    51,   466,   287,    92,   289,
     290,   291,   294,   455,    51,   295,   296,   297,   298,   294,
     434,    51,   294,   303,   445,   294,  3643,   307,   308,   309,
     451,    51,   312,   445,   455,   315,    51,   434,   318,   294,
     320,   125,   445,   455,    51,  2062,   449,   445,   328,    51,
      72,    72,   455,   294,    91,   335,   336,   455,   142,   339,
     340,   341,   294,   445,   344,   345,   346,  2230,   445,   466,
     350,    51,   352,   455,   445,    51,   294,   294,   455,   311,
      51,   361,   362,   338,   455,   317,   434,   294,    72,   369,
     370,   445,    51,   447,   445,   449,   445,   451,  2115,   453,
    2117,   455,   382,   140,   455,   385,   455,    51,    19,    20,
     390,  1013,    51,    51,   394,    26,    51,    51,   466,    51,
      31,    32,    51,  2286,   404,   405,    51,   407,  2145,   409,
      51,   411,  3542,   413,   414,   415,   368,    51,    51,    51,
     420,   421,    51,    51,    51,   445,    72,   447,    51,   449,
      51,   451,   384,   453,    51,   455,   436,    51,    51,    19,
      20,  2720,    51,   443,    24,    25,    26,    72,    91,   140,
     140,    31,    32,  2878,   140,   140,   154,    37,    38,   175,
      47,   282,    91,  1279,    95,   140,    51,    51,   468,    51,
    2353,   140,   472,   473,   474,   475,  3542,   477,   140,   298,
      51,    51,   434,    51,   312,   116,   140,   154,  4090,   393,
     312,   268,   393,   140,   440,   393,   393,   140,    51,    51,
     393,   393,    51,    51,   393,    51,    51,   268,    51,    51,
     140,   140,    51,    51,   466,    95,    51,    51,     4,     5,
       6,    51,    59,    91,    51,    51,   157,   158,    51,   281,
      51,    51,    51,    51,    72,    51,   116,    51,    51,   140,
      51,    51,   294,    51,  3542,    70,    51,    51,    51,  3542,
     440,   441,   282,   553,   154,   707,    93,    94,  3542,    56,
      90,   393,  2146,  2147,    51,  3542,    51,   328,   246,    51,
      51,   301,   140,  3542,    72,    70,   306,   157,   158,    70,
      51,   531,   532,   533,   314,   535,  3688,  2050,    91,    47,
      70,    47,    70,   593,    47,   159,   706,    91,   517,    91,
     710,   288,   440,    70,   356,   285,    91,    70,   360,    92,
      91,    70,    70,    92,    70,    91,   535,    70,    70,    91,
      91,    91,   374,  2506,   354,   256,   132,   379,   358,   115,
     116,   393,   632,    51,   140,   140,   140,   140,   132,   140,
     132,   707,   140,  3745,   374,    70,   140,    70,   140,    51,
     214,    92,  2115,  2513,  2117,   140,   506,   140,   140,   140,
     347,   140,   132,   149,   140,    91,   152,   706,   140,   140,
     140,    80,    90,    70,    91,   161,   256,   573,   164,   707,
     707,   261,   590,   440,   441,   713,   531,   532,   533,    91,
     535,   707,   706,   707,  1022,  1023,  2433,   713,   606,   140,
    2437,   708,  2439,    70,   393,   712,   106,   107,   108,   109,
     110,   111,   112,   113,   140,   132,   246,   707,  1049,   393,
     616,   246,   708,   140,   707,    70,   712,   407,   408,   409,
     706,   217,   628,   629,   706,   289,   290,  2474,   140,   589,
     707,   591,   592,    56,   706,    58,    70,    91,  4234,  1155,
    1156,  3690,   707,   333,   707,   246,   393,   707,    70,   707,
      51,   706,   708,   707,  4250,  4251,   320,    80,   246,    72,
     256,    84,    85,    86,   328,   261,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   707,   445,    51,   275,
     596,   288,   278,   279,   246,   426,   140,  4399,   604,   605,
     286,   607,   288,   707,   341,   393,   707,   393,   362,   707,
     707,   440,   441,   632,   707,   707,   302,   303,   707,   709,
     407,   246,   227,   228,    64,   312,   457,    90,   246,   106,
     107,   108,   109,   110,   111,   112,   113,   323,   536,   440,
     441,   662,  1170,  1171,  3365,  3366,   426,   707,  3369,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    70,
     445,   577,   707,  1191,   394,   395,   396,   397,   398,   536,
      91,   357,   440,   441,   712,   707,   706,   457,   878,   288,
     880,   881,   710,   660,   707,   885,   886,   887,   710,  3314,
     890,   891,   892,   710,    91,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   682,   445,   593,   594,   710,
     910,  4041,   407,   591,   592,   708,   402,   403,   318,   140,
     708,   682,   246,    51,   707,   505,   335,   407,   707,   929,
     339,   713,   708,   708,   246,   708,   536,   440,   441,   708,
     407,   254,   708,   140,   407,   707,   440,   441,   407,   407,
     950,   407,   192,   710,   407,   440,   441,   706,   708,   440,
     441,   706,  4299,  2700,   440,   441,   393,   706,   708,   440,
     441,   713,   713,   708,  2437,  4041,   394,   395,   396,   397,
     398,   708,    51,   246,   407,   471,   708,  2724,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   706,   708,   713,
     407,  2474,   708,  1013,   440,   441,  1016,    51,   707,   710,
     710,    90,  1022,  1023,   709,  1431,  1432,   267,  3599,   708,
    1436,  1437,  3603,   707,   709,  1441,  1442,   706,   440,   441,
     407,   318,  1042,  4041,   708,   707,  2630,  1047,  4041,   708,
     708,  1051,   706,   708,  1054,  2639,   708,  4041,  2642,   708,
     707,   707,   407,   708,  4041,  1065,   709,   708,  1068,  1069,
     707,   702,  4041,   704,   708,   708,   708,   707,   706,   706,
     709,    51,   706,     3,   140,   708,   706,   708,   713,   442,
     443,   708,   445,    13,   708,   708,   440,   441,    18,   708,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   707,
      90,   707,   702,   708,   708,  3986,   708,    91,  3989,   285,
     535,   394,   395,   396,   397,   398,    56,   708,   708,   707,
      60,    61,    62,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,  1153,   445,   708,   708,  1157,  1158,   708,
     708,    81,   708,   708,    84,   708,   708,  3918,   706,   708,
    1170,  1171,    72,   708,   708,   706,   140,   246,   706,    51,
     710,   708,   708,  1065,   104,   708,  1068,   708,   708,   708,
     708,  1191,   708,   706,   708,   115,   116,   708,   708,   706,
     708,   706,   706,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   710,   105,    90,   440,
     441,   706,   707,   623,    72,   706,   707,  2043,    10,   706,
    2046,   706,   152,   707,   710,   706,   707,  2700,  1238,  1239,
      51,   707,    72,   440,   441,  1245,  4068,   269,   270,   169,
     170,    91,   172,   173,   174,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   129,  1275,   246,  4099,   268,    90,
     707,   201,   202,   203,   204,   205,   707,  4226,  4227,    79,
      90,    91,   710,   283,   707,   506,  1296,  4236,   706,  4238,
     140,   707,    56,  3893,   706,   707,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    91,   445,   707,    72,
     707,    91,   707,  2139,   706,   394,   395,   396,   397,   398,
      84,   707,   114,   573,   254,  4086,   256,    57,    58,   707,
     140,   261,   707,  3933,   706,   265,   623,   706,    44,   103,
      46,    49,    50,   273,   706,   275,   319,   320,   321,   141,
     142,   143,   132,   707,    84,   140,    86,   531,   532,   533,
     140,   535,   292,   293,   246,   407,   616,    35,   589,  2320,
     591,   592,  2323,   303,   440,   441,    51,    12,   138,   139,
     310,   706,   707,   313,   314,    93,    35,  3874,   638,   639,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
    2226,   445,   531,   532,   533,   571,   535,   708,   442,   443,
     275,   445,   706,   707,   394,   395,   396,   397,   398,  1429,
     350,   351,    92,   288,  1434,   246,    35,   357,    68,  1439,
     596,   597,   598,   599,  1444,   708,  1446,   322,  1448,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   177,   459,
     180,  4293,   312,   361,   362,   707,   440,   441,   268,   609,
     610,   611,   612,  4305,   266,   407,   707,   282,  1042,   140,
     345,   706,   707,   283,   327,   249,   436,   437,   438,   439,
     254,  1501,   422,   423,   429,   430,   431,   261,   706,   707,
     707,   706,   312,   440,   441,   442,   443,   288,   445,   352,
     353,   407,   394,   395,   396,   397,   398,   706,   707,  3643,
     280,   281,   286,   282,   254,   706,   707,   312,   118,   289,
     294,   706,   707,   123,   124,   125,  4297,   246,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   709,   370,   424,
     246,   373,   706,   707,   376,   155,  4398,   379,   706,   333,
     382,   255,   384,   394,   395,   396,   397,   398,   707,   393,
     286,   581,   288,   237,   394,   231,   232,   233,  2414,   179,
     440,   441,   182,   237,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   534,   445,   237,   399,  4208,   246,
     410,   706,   707,  1623,   578,  1625,   706,   323,   706,   707,
     118,   536,  4222,   706,   707,   123,   124,   125,  3917,   708,
     440,   441,   242,   243,   244,    72,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   440,   441,   155,    72,   459,
     440,   441,   426,    72,   304,   305,   306,   307,   308,   309,
      72,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   179,   445,    72,   182,   440,   441,   442,   443,    72,
     445,    72,   422,   423,   242,   243,   244,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   706,   707,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   708,   445,
     573,   574,    72,   707,    72,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    72,   675,   676,   677,    72,   679,
     573,   681,   706,   707,   344,   706,   707,   549,  4358,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    72,
     445,   701,   615,   616,   574,   618,   619,    72,   621,   622,
     623,   395,   396,   397,   398,   628,   706,   707,  2093,  2094,
     706,   707,   615,   616,   706,   707,   639,    51,  3691,    98,
      99,   100,   101,   102,   708,  2067,   706,   707,  2078,    72,
     633,   634,   635,   636,   637,    72,   314,  2643,   429,   430,
     431,   135,   136,   137,   235,   236,   708,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    72,   445,  3957,
     706,   707,   706,   707,   706,   707,   344,  2673,  2674,   706,
     707,  2067,   706,   707,   706,   707,    51,  2067,    72,   659,
     706,   707,  2067,   708,   706,   707,   706,   706,   707,   706,
     707,   350,   706,   707,   706,   707,    72,  2067,   706,   707,
     706,   707,   706,   707,  3957,   649,    72,   708,   706,   707,
     706,   707,  2078,   706,   707,    72,  2174,   708,  2174,  2174,
    2316,  2317,  3496,    51,  2174,  2174,    44,   706,   707,  2174,
    2174,  2174,  2174,   708,  2219,  2220,    72,  2255,   706,   707,
    2174,  2259,   707,  2174,   709,    72,  2209,    72,  2174,    93,
      94,  2209,   355,   356,  2174,   550,   551,   405,   406,    72,
     704,  3359,  3360,   706,    72,  2084,    72,  2060,  2705,  2706,
      72,  2244,    72,    72,    72,    72,    72,    51,  2174,  2221,
      72,  2174,    72,  2244,  2174,  4089,  2244,  4091,    72,  2174,
      72,  2174,    72,    72,    72,  2244,  2244,   115,   116,  2174,
    2244,  2174,   708,  2174,  2084,    51,  2314,  2174,  2314,  2327,
    2328,  2329,  2330,  2314,   710,   706,   708,  2335,  2336,  2337,
    2338,  2339,  2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,
    2348,  2349,  2350,  2351,  2352,   708,    72,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,  2196,  2174,
    2174,  2221,   708,    72,    72,  3905,    72,   708,  2048,    72,
      72,  2244,    72,  2053,  2054,    72,    72,  2174,    72,  2244,
      72,    72,    72,    72,    72,    72,  2066,    72,    72,  2069,
      72,    72,    72,  2174,    72,  2481,  2482,    72,    72,  2485,
    2486,    72,  2174,  2489,  2490,    72,    72,    72,    72,  2089,
    2090,  2174,  2209,    72,    72,  2095,  2174,  2097,    72,    72,
    2100,  2101,    72,  2919,  2920,    72,  2174,  2174,    72,  2109,
    2244,   708,  2314,  2174,  2114,  2244,    72,  2174,    72,    72,
      72,  2373,    72,    72,    72,  2174,    72,  2244,   256,    72,
    2382,    72,  2434,   261,  2380,  2135,  2136,  2137,  2384,  2174,
      72,  2209,  2142,  2143,    72,    72,    72,  2472,  2148,    72,
    2174,    72,  2404,  2174,  2244,  2155,  2445,    72,  2380,  2174,
     288,    72,  2384,    72,    72,  2417,    72,    72,  2472,    72,
      72,  2417,  2174,    72,    72,  2175,  2244,  2373,    72,  2174,
      72,  2472,  2174,  2581,    72,  2174,  4300,    72,    72,  2441,
      72,  2447,  2472,    72,    51,    51,  2441,    72,  2404,  2174,
      72,  2404,  2441,  2441,  2404,   708,  2441,    51,  2645,  2404,
    2210,  2404,    51,  2174,  2380,  2430,  2216,  2217,  2384,  2514,
    2515,  2581,  2174,    72,  2404,    72,    72,  2404,  2445,  2472,
    2472,  2434,  2434,  2233,    72,  2292,  2174,  2174,  4121,    72,
    4123,   708,   707,    72,  2681,   708,  2581,  2174,    72,    72,
    2250,  2417,    72,    72,  2430,  2255,    51,  2257,  2258,  2259,
      72,  2441,  2066,    72,    72,    72,  2576,    72,    72,  2221,
      72,  2271,    72,    72,  2519,  2404,    72,   708,    72,    72,
    2665,  2519,  2576,  2283,  2579,  2665,  4400,  2701,  2288,  2576,
      72,  2647,  2728,  2097,  2576,  2665,  2100,  2101,  2665,  2299,
    2665,  2665,    72,  2576,  2304,  2576,  2728,   350,  2576,  2576,
      72,    72,  2441,  2728,    72,  2315,  2728,  2292,  2576,    51,
    2320,  2665,  2678,  2323,  2576,  2728,  2078,  2327,  2328,  2329,
    2330,  2331,  2332,  2665,  2728,  2335,  2336,  2337,  2338,  2339,
    2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,
    2350,  2351,  2352,  2665,  2084,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2363,  2364,  2365,  2728,  2367,   708,  2728,
    2576,  2175,  2665,  2576,  2728,  2703,  2631,  2705,  2706,  2631,
    2728,  2581,  2728,  2576,  2576,  2728,  2581,  2665,  2728,  2728,
    2665,  2576,  2728,  2576,  4131,  3211,  2576,  3213,  2728,   708,
     708,  2401,  2402,  2403,  2665,  2405,  2210,    72,  2408,  2409,
    2728,    72,  2728,  2665,    72,    72,    72,  2728,    51,  2419,
      72,  2421,  2174,    72,   708,   707,  2426,  2427,   708,    51,
    4313,   707,   706,    51,    51,  2435,   708,   707,    72,  4023,
    2440,  2736,  2576,   707,    72,  2728,    72,    72,  2448,  4033,
     706,   476,  2404,  4037,   708,  4039,  4040,    72,  2458,  2576,
    2728,    90,  2728,  2728,    72,  2665,  2196,    72,  2728,  2728,
    2665,  2471,    72,  2473,  2728,  2728,  2728,  2477,    72,  2209,
      72,    72,  2728,    72,  2728,  2647,    72,  2728,   707,  2441,
     707,   707,  2728,  2493,  2048,   707,  2496,   707,  2728,   707,
     707,  2501,   707,  2503,  2504,   707,  2647,   707,  2576,  2509,
     707,  2315,   707,   707,  2244,  2647,  2516,   707,  2518,  2681,
    3741,  3747,  2728,   707,  2647,  2525,   707,   707,  2728,  2647,
     707,    72,   707,  2728,   707,  2676,  2090,   707,   707,  2539,
    2681,   707,   707,  3359,  3360,  2647,  4153,  2670,  2728,  2681,
    2647,   707,    72,  1022,    72,    72,  2647,    72,  2681,    72,
    2114,   708,    72,  2681,    72,    72,  2866,    72,   708,    51,
      72,    72,    72,  2647,    72,    72,  2647,  2577,  2647,  2681,
      72,  2135,  2136,  2137,  2681,  2585,    72,  2587,    72,  2143,
    2681,  2665,    51,  2593,  2148,    56,  2670,   708,    72,  2403,
      72,    72,  2676,    72,  2678,    72,    72,  2681,    51,   708,
    2681,  2728,  2681,   708,    72,    72,    72,   246,    72,    72,
      72,    72,  2426,    84,  2576,    72,    72,  2647,  2380,    51,
      72,  2435,  2384,    72,    72,  2635,  2440,  2637,  2638,    72,
      72,    72,   103,  2373,  2448,  2665,  2646,   708,    51,    72,
    2670,    72,  2382,   708,  2458,  3697,  2676,    51,  2678,   708,
    2728,  2681,    51,  2217,    72,  2417,    72,  2471,  3671,   708,
      72,    72,    72,  2477,    72,    72,    72,    72,  2430,  2233,
    3496,    72,    72,    51,    56,    72,    72,  2417,    72,    72,
     151,    72,    72,     8,    72,   393,    11,    72,    72,    72,
     246,  1170,  1171,    72,    51,   708,    72,   168,    72,  2709,
      82,    83,    84,    72,  2518,  3121,   708,    72,   708,    34,
      72,    72,  1191,    72,    72,   708,    72,    72,  3056,    72,
    2730,  2731,    72,    48,  2734,    72,    72,  2737,  2738,  3067,
    2740,  2741,  2742,    72,  2744,    72,  3663,    51,  3048,    72,
    2304,    51,   519,    72,    69,  3086,   217,   708,   525,   526,
     527,   528,   529,   530,    72,   394,   395,   396,   397,   398,
      72,    72,  3653,   540,    72,    72,  2728,   149,    72,   151,
      72,   548,    72,    72,    72,    72,    72,   248,    72,    72,
      72,    72,    72,   254,    72,    72,   168,    72,    72,    72,
     261,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,  3627,   445,  3629,    72,    72,    72,    72,    72,    72,
    2820,    72,  2822,    72,    72,   286,    72,    72,    72,    72,
     155,   156,   293,    72,    72,  2835,    72,    72,    72,  3167,
      72,    72,  2646,    72,    72,   217,   171,   162,    72,    72,
      72,    72,    72,    72,   179,    72,    72,   182,  2858,    72,
    3191,  2861,    72,  2863,    72,  2419,  2866,  2421,   183,    72,
      72,    72,   333,    72,    72,   200,    72,    72,    51,  3695,
    4147,  3287,    72,  2883,  3290,    72,    72,  3293,    72,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    72,    72,
      72,    72,    72,    72,   286,    72,   327,    51,    72,  2473,
      51,   293,   708,    51,    21,    22,    23,   708,    72,    72,
      27,    28,    29,    30,    72,   260,    33,    72,   253,  3755,
     265,   352,   353,    72,    51,    72,    72,    44,    45,    72,
      72,    72,    72,    72,    72,  2509,    72,  3285,  3286,    56,
      72,   422,   423,    72,   708,   426,    72,  2967,  2968,   284,
    3298,    72,    72,    51,   708,    51,   301,    72,    72,  1022,
    1023,    72,  2982,    72,   708,    51,  2986,    84,   708,    72,
    2990,    51,   708,    72,   246,    72,   708,    72,  1041,    72,
    3622,    51,    72,    72,    72,    72,   103,    72,  3008,  3009,
      72,    72,   707,   338,    72,  3015,    72,   342,    51,   344,
      72,   346,    51,  2577,    72,    72,    72,    72,    72,    72,
      72,  2835,    72,    72,   707,    51,   706,   713,    72,  2593,
     707,   707,   706,   706,  3666,  1070,   312,   140,  3048,    51,
     422,   423,   707,   713,  3054,   140,  3056,   707,   140,   713,
    3876,   707,   707,   707,   707,   707,   707,  3067,   707,   707,
     707,  3071,   707,  3073,    51,   707,   707,   707,  3078,  2883,
     709,  2635,   709,  2637,  2638,   140,   401,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,  3913,   445,   424,
    3100,  3917,   713,   707,   707,  3542,   707,   706,  3436,    21,
      22,    23,   707,   140,   707,    27,    28,    29,    30,   707,
    3120,   140,   707,   140,   707,   140,   140,  1170,  1171,   140,
     140,   140,   140,    45,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    56,   445,   140,   140,  1191,   140,
     140,   706,   706,   706,    51,  2709,   140,   254,   255,   706,
     140,   706,   573,   574,   140,   140,   140,  3167,   707,   140,
     140,   140,    84,   436,   437,   438,   439,   440,   441,   442,
     443,   140,   445,  3183,  3184,   140,   140,   709,   140,   140,
     140,   707,   564,   565,   566,   567,   293,   294,   140,    51,
     140,  3201,   140,  3203,   615,   616,  3206,   618,   619,   140,
     621,   622,   623,   624,   707,   140,  4032,   707,   140,  3219,
    4036,  3221,   140,   706,    51,  3225,   706,    51,   639,    51,
     706,   706,   140,   140,   140,  3235,  1279,   140,   706,   140,
     312,   706,  3242,   704,  3244,   140,   706,  4063,   312,   312,
     713,  3251,    51,   436,   437,   438,   439,   440,   441,   442,
     443,  3261,   445,   312,   140,   706,   706,  3071,   140,   706,
     706,   312,   706,   140,   140,  3275,   140,   140,   706,   706,
     706,   706,   706,  3283,   140,  3285,  3286,   706,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,  3298,   445,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
    4126,   445,   140,   706,   140,   707,    72,   140,    51,   707,
     140,  3321,   140,   708,   706,   422,   423,   140,   707,   706,
     706,   140,   140,  3333,  3334,  3335,   661,   140,   140,   706,
     445,   706,   254,   255,   706,   706,   706,   140,  3676,   706,
    3678,   707,   706,   706,   140,   662,  3684,   140,  3689,   282,
     140,    72,   706,   140,  3364,  3365,  3366,   706,   706,  3369,
     140,   706,   706,   706,   706,   706,   706,  3705,  3706,   707,
     706,   293,   294,   707,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   706,   445,  3396,   706,  3726,   140,
    3728,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   706,   445,  3744,   707,  3219,   140,  3221,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   393,   445,
     706,   140,   140,   140,    51,   706,  3436,   706,   706,   706,
    3244,   706,   140,   140,   140,   140,    51,   140,   140,   140,
    3450,   140,   140,   140,   393,     3,   706,    72,     6,   706,
      72,    72,   140,   140,   706,  3793,   706,   140,   709,    17,
     140,   140,   140,   706,  4290,   140,   706,   140,   140,   706,
    4296,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   706,   445,   140,   140,  3495,  4312,   140,   140,   140,
     709,   707,   707,   707,   140,   140,  4322,  4323,   140,   706,
     422,   423,    60,    61,    62,    63,    64,   140,   707,  3073,
     140,   706,   140,   312,  3078,   706,   706,   140,   707,   706,
     140,   140,   140,   140,   140,   706,  4352,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   140,   445,  3844,
     140,   140,   140,   140,   140,   140,   104,   105,   140,   140,
     140,   140,   708,   140,   140,   140,   140,   115,   116,   117,
     140,   140,   140,   140,   140,   140,   140,   140,   126,   127,
     128,   140,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,  3396,   445,   140,   140,   144,   145,   146,   140,
     140,   140,   140,   140,  4041,   140,  3606,   140,   140,   140,
    3610,   709,   140,  3613,   140,   140,   140,   140,   706,   140,
     140,   140,  3622,   140,  3624,   706,   706,   140,   588,  3957,
     140,   140,   706,   140,   182,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   140,   445,   706,   140,   706,
    3978,  3979,   706,  3653,   140,  3986,   709,   140,  3989,   140,
     140,   445,   153,  3663,   288,   440,  3666,   312,   216,   706,
     706,  3671,   707,   312,   706,  3675,  3676,   707,  3678,   707,
     706,  3681,   706,   706,  3684,   706,   706,   712,   706,    51,
      51,  3495,   140,  3693,   706,   708,   140,    51,  4026,  4027,
    4028,  4029,   708,   708,    72,  3705,  3706,   706,   256,   257,
     706,   259,    72,   261,    72,   288,   264,   265,   312,   708,
     708,   269,   270,   708,   445,   708,  3726,   275,  3728,   708,
     708,   288,    72,   140,  3734,   708,   708,   140,   706,   287,
     288,   708,   706,   706,   706,  4151,   712,   708,   706,  3749,
     706,    72,    51,   301,    51,   708,   713,   706,   706,   706,
    3760,  3761,   310,   708,   708,   313,   314,  3767,    51,    72,
     713,   708,   713,   707,   322,   323,   324,   713,    72,    72,
      72,   140,   712,   140,   713,  4113,  2255,   335,   336,   337,
      51,    51,    51,  3793,    51,   706,   344,   707,   713,    72,
    3800,    51,   350,   351,    51,  4133,  4134,  3807,   140,   357,
    4141,   312,  4143,   361,  3814,   708,   364,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    72,   445,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   312,
     445,   706,  3842,    72,   706,  3845,   707,    72,  3848,   706,
    4256,  4257,   706,   706,    72,   706,   706,   312,  2327,  2328,
    2329,  2330,   708,   708,   708,   708,  2335,  2336,  2337,  2338,
    2339,  2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,
    2349,  2350,  2351,  2352,    51,   706,  2355,  2356,  2357,  2358,
    2359,  2360,  2361,  2362,  2363,  2364,  2365,   327,    72,   706,
      72,    72,    72,    72,  3904,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    72,   445,    72,    72,  4325,
    4326,    72,   352,   353,   154,   713,   713,   706,   713,    72,
    3734,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   536,   445,    72,  3944,   707,  3946,   140,  3948,   712,
      51,   706,    51,    51,   706,  3955,   707,  3957,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   706,   445,
     706,  4377,   706,   708,   706,   706,   706,    72,  3978,  3979,
     706,  3981,   140,    51,   706,   588,   534,   706,   706,   706,
     153,  2016,  2017,   708,   708,   708,  3996,   405,   140,  2042,
    2043,  2044,   706,  2046,  4004,  4005,   712,   707,  2033,    72,
     713,   312,    51,   707,    51,  2058,   393,  4017,    51,  4019,
     706,  2064,    90,   405,    51,    51,  4026,  4027,  4028,  4029,
    2073,  2074,   140,  2076,   588,   140,   712,  2080,   393,   713,
     706,   713,   713,    51,    51,    51,   713,  4047,   707,   713,
    4050,   706,   393,   707,   712,   708,   708,    90,   706,   393,
      72,    51,   706,   140,   153,  2108,   706,  2110,  2111,  2112,
     707,   536,   706,   154,   140,   706,    72,  2120,  2121,  2104,
     707,   706,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,
     706,   393,   706,   393,    51,    51,  2139,    51,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,  2151,   445,
     706,  4111,   713,  4113,   706,   713,   707,    51,  2161,   536,
    2163,    51,   706,  2166,   707,   154,    51,   140,   706,  2172,
      51,   140,    51,  4133,  4134,   683,   684,   685,   686,   687,
     688,   140,   140,   573,   574,   707,   707,  4147,   708,   144,
    4150,   706,  4152,  4153,  4154,  2180,   706,   706,  2527,   706,
    2542,  2186,  3337,   706,   708,  2507,  2191,   317,  4005,  2221,
    3015,  2698,   708,  2207,   708,  2715,  2201,  4030,   246,   708,
    3189,   708,  2268,  2226,  2227,   615,   616,   617,   618,   619,
    3194,   621,   622,  2687,  2237,  2238,  2239,  4388,   628,  2242,
    2225,  4385,  2695,  2701,  3086,   708,  3675,  4270,  3211,   639,
    2078,  3684,  2255,   246,  2382,  2275,  2259,  2728,  2417,   463,
    2263,  2264,  2711,  2707,   881,  2434,  2990,   887,  4228,   910,
    2581,  2274,   708,    51,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   472,   445,  4041,  4065,   474,  2174,
    3918,  3877,   475,  3914,  4254,  2949,   340,  1054,  2301,  1345,
    2314,  4261,  2305,  2244,  2470,  2308,  2457,  2310,  2055,  2472,
    2295,  2445,    90,  2298,  2271,  2476,  2060,  2631,  2681,  4279,
    2478,  4281,  2647,  2645,  2327,  2328,  2329,  2330,  2678,  2676,
    2670,  2665,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,
    2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,
    2576,  2404,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,
    2363,  2364,  2365,  2519,  2441,  2098,   394,   395,   396,   397,
     398,   950,  2375,  2376,  4334,  2378,  2209,  2084,   594,  4339,
    2427,  2067,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,  2292,   445,  3094,  2196,  2425,  3054,  3996,  2734,
    2408,   394,   395,   396,   397,   398,  1051,  2410,  2411,  4017,
    4035,  2414,   708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4381,  4382,    -1,    -1,    -1,    -1,  2412,  4388,  2432,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3955,    10,    -1,    -1,    -1,    -1,    -1,  4408,    -1,
    4410,    -1,    -1,  2456,    -1,    -1,    -1,    -1,  2443,    -1,
      -1,    -1,    -1,    -1,  2449,  2450,  2451,  2452,   246,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2502,    -1,    -1,
      -1,    -1,    90,    91,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,   114,    -1,   708,    -1,
      -1,    -1,    -1,    -1,  2557,    -1,    -1,  2560,  2561,    -1,
      -1,    -1,    -1,    -1,   132,  2568,    -1,  2570,  2571,  2572,
    2573,  2574,   140,   141,   142,   143,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,
    2603,  2604,    -1,    90,    -1,    -1,    -1,    -1,  2611,    -1,
      -1,    -1,    -1,   181,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    51,  3056,    -1,    -1,
      -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,  3067,    -1,
    2643,    -1,    -1,   211,   212,    -1,    -1,  2650,  2651,  2652,
      -1,  2654,    -1,    -1,  2657,  2658,   708,    -1,    -1,    -1,
    2663,  2664,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
    2673,  2674,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
     708,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,  2692,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,   266,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,    -1,    -1,  2717,   708,    -1,    -1,  2721,    -1,
      -1,    -1,  2725,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,  3167,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   246,
    2745,  2746,  2747,  2748,    -1,    -1,  2751,  2752,  2753,  2754,
    2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,  2763,  2764,
    2765,    -1,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,
    2775,  2776,  2777,   155,   156,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,   171,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   246,    -1,    -1,    -1,    -1,   394,   395,   396,   397,
     398,   399,    -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,
      -1,    -1,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,  3285,  3286,   708,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,  3298,
     445,    -1,   440,   441,    -1,    -1,    -1,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,    -1,
      -1,    -1,   460,   461,   462,   463,    -1,    -1,   260,    -1,
      -1,    -1,    -1,   265,  2907,  2908,    -1,   394,   395,   396,
     397,   398,    -1,    -1,    -1,    -1,  2919,  2920,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
     708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   394,
     395,   396,   397,   398,   708,    -1,   338,    -1,    -1,    -1,
     342,   549,   344,    -1,   346,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   708,  2983,    -1,
      -1,    -1,  2987,    -1,    -1,    -1,    -1,  3436,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    -1,  3056,    -1,     3,    -1,    -1,     6,    -1,
      -1,    -1,   424,    -1,  3067,    13,    -1,    -1,    -1,    17,
      18,   708,    -1,    -1,    -1,    -1,    -1,  3080,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    60,    61,    62,    63,    64,  3102,   708,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   708,    -1,    -1,    -1,    -1,    -1,   707,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3167,    -1,    -1,   115,   116,   117,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,   127,
     128,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,    -1,    -1,    -1,   144,   145,   146,    -1,
    3185,    -1,    -1,    -1,    -1,    -1,    -1,   155,  3211,    -1,
    3213,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   709,   445,    -1,    -1,    -1,    -1,    -1,  3214,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,  3228,    -1,    -1,    -1,  3676,    -1,  3678,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   708,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   216,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3705,  3706,    -1,   246,
      -1,   706,  3285,  3286,   708,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,  3298,   445,  3726,    -1,  3728,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   257,
      -1,   259,    -1,   261,    -1,    -1,   264,   265,    -1,    -1,
      -1,   269,   270,     3,    -1,   273,     6,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    -1,   287,
     288,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   301,   445,    -1,  3359,  3360,    -1,    -1,
      -1,    -1,   310,    -1,  3793,   313,   314,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   322,   323,   324,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    -1,   335,   336,   337,
     394,   395,   396,   397,   398,    -1,   344,    -1,    -1,    -1,
      -1,    -1,   350,   351,    -1,    -1,    -1,    -1,    -1,   357,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   394,   395,   396,
     397,   398,    -1,  3436,    -1,   115,   116,   117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   126,   127,   128,    -1,
     130,    51,    -1,    -1,    -1,   708,    -1,    -1,    90,    -1,
      -1,    -1,    -1,    -1,   144,   145,   146,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
      -1,    -1,    -1,    -1,    -1,    -1,   708,    -1,   168,    -1,
      90,    -1,    -1,  3496,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,   216,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,  3978,
    3979,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    -1,    -1,    -1,    -1,   256,   257,    -1,   259,
      -1,   261,    -1,    -1,   264,   265,   534,    -1,    -1,   269,
     270,    -1,    -1,    -1,    -1,   275,    -1,  4026,  4027,  4028,
    4029,    -1,  3587,    -1,    -1,    -1,    -1,   287,   288,    -1,
      -1,    -1,    -1,    -1,   246,    51,    -1,   708,    -1,    -1,
      -1,   301,    -1,    -1,  3627,    -1,  3629,    -1,    -1,    -1,
     310,    -1,    -1,   313,   314,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   322,   323,   324,    -1,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,   335,   336,   337,    -1,    -1,
      -1,    -1,    -1,  3648,   344,    -1,    -1,    51,    -1,  3654,
     350,   351,    -1,  3676,    -1,  3678,    -1,   357,    -1,  3664,
     312,  3684,    -1,    -1,  4113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3705,  3706,  4133,  4134,    90,    -1,   712,    -1,
      -1,    -1,   312,    -1,  3699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3726,    -1,  3728,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,   708,   708,    -1,    -1,   425,    -1,    -1,    -1,    -1,
      -1,    -1,  3755,  3738,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   394,   395,   396,   397,   398,    -1,   708,    -1,
      -1,    -1,  3757,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,    -1,
    3793,    -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,   708,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   504,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3817,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   534,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    -1,  3851,  3852,    -1,    -1,
      -1,    -1,  3875,  3876,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3868,    -1,  3870,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,    -1,    -1,    -1,    -1,
    3913,    -1,    -1,    -1,  3917,    -1,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,    -1,    -1,    -1,
    3925,  3926,    -1,  3928,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3936,    -1,    -1,  3957,    -1,    -1,  3942,   394,   395,
     396,   397,   398,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,  3978,  3979,    -1,    -1,    -1,
    3965,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,  3982,  3983,    -1,
      -1,    -1,    -1,   683,   684,   685,   686,   687,   688,    -1,
     394,   395,   396,   397,   398,    -1,  4001,    51,    -1,    -1,
      -1,    -1,    -1,  4026,  4027,  4028,  4029,    -1,    -1,  4032,
      -1,  4034,    -1,  4036,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,   708,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
    4063,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,  4056,   445,    -1,   706,    -1,    -1,    -1,    -1,  4064,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,    -1,    -1,    -1,   706,   708,    -1,    -1,
    4113,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,  4126,    -1,    -1,    -1,    -1,    -1,    -1,
    4133,  4134,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,  4156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,    -1,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4207,    -1,    -1,    -1,    -1,    -1,
    4195,  4196,   246,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,  4234,  4217,    -1,    55,    -1,    -1,   708,    -1,    -1,
    4225,    -1,    -1,    -1,    65,    66,    67,  4250,  4251,    -1,
      71,    -1,    73,    74,    75,    76,    77,   708,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    90,
     706,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,
    4265,  4266,   103,    -1,    -1,  4270,    -1,  4290,    -1,    -1,
      -1,    -1,    -1,  4296,    -1,    -1,    -1,    -1,   119,   120,
     121,   122,    -1,    -1,  4289,    -1,    -1,    -1,   708,  4312,
     131,    -1,   133,   134,    -1,    -1,    -1,    -1,    -1,  4322,
    4323,    -1,   706,    -1,    -1,    -1,   147,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   708,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   167,   445,    -1,  4352,
    4335,    -1,    -1,    -1,    -1,   176,    -1,   178,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,  4354,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,    -1,    -1,    -1,   708,   207,   208,   209,   210,
      -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4385,    -1,    -1,   224,    -1,    -1,    -1,  4392,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,   708,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4433,    -1,
     271,   272,    -1,   274,   708,   276,   277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,    -1,    -1,   288,    -1,   290,
     291,    -1,    -1,    -1,   295,   296,    -1,    -1,   299,   300,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,   325,   326,    -1,    -1,   329,   330,
     331,   332,    -1,   334,   335,    -1,    -1,    -1,    -1,   340,
      -1,    -1,   343,    -1,    -1,    -1,    -1,   348,   349,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,   360,
      -1,    -1,   363,    -1,   365,   366,   367,   368,   369,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,   400,
      -1,    -1,    -1,    -1,    -1,    -1,   407,   408,   409,    -1,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,    -1,    -1,    -1,    90,    -1,   427,   428,    -1,    -1,
     708,    -1,   433,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,    -1,    -1,
      -1,    -1,    -1,    -1,   708,   466,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
      -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,   500,
      -1,    -1,    -1,    -1,   505,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,    -1,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   575,   576,    -1,    -1,   579,   580,
     246,   582,   583,   584,   585,   586,   587,    39,    40,    41,
      42,    43,    -1,    -1,   595,    47,    -1,    -1,    -1,   600,
     601,   602,    -1,    55,    -1,    -1,    -1,   608,    -1,    -1,
      -1,    -1,    -1,    65,    66,    67,    -1,    -1,    -1,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,   630,
     631,    -1,    -1,    -1,    -1,    87,    88,    -1,    90,    -1,
      -1,    -1,    -1,   708,    -1,    97,    -1,    -1,    -1,    -1,
      -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   663,   664,    -1,    -1,    -1,   119,   120,   121,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,
      -1,   133,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,
      -1,    -1,   703,    -1,   705,    -1,    -1,    -1,   708,    -1,
      -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,    -1,
     708,    -1,    -1,    -1,   176,    -1,   178,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     708,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   708,   445,    -1,   207,   208,   209,   210,    -1,
      -1,   213,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   224,   445,    -1,    -1,    -1,    -1,    -1,   708,
      -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   271,
     272,    -1,   274,   708,   276,   277,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,    -1,    -1,   288,    -1,   290,   291,
      -1,    -1,    -1,   295,   296,    -1,    -1,   299,   300,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,   325,   326,    -1,    -1,   329,   330,   331,
     332,    -1,   334,   335,    -1,    -1,    -1,    -1,   340,    -1,
      -1,   343,    -1,    -1,    -1,    -1,   348,   349,    -1,    -1,
      -1,    -1,   354,    -1,    -1,    -1,   358,   359,   360,    -1,
      -1,   363,    -1,   365,   366,   367,   368,   369,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   394,   395,   396,   397,   398,    -1,   400,    -1,
      -1,    -1,    -1,    -1,    -1,   407,   408,   409,    -1,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
      -1,    -1,    -1,    -1,    -1,   427,   428,    -1,    -1,    -1,
      -1,   433,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
      -1,    -1,    -1,    -1,   466,    -1,   708,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   708,    -1,    -1,    -1,
     706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   500,    -1,
      -1,    -1,    -1,   505,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,    -1,
      -1,    -1,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   575,   576,    -1,    -1,   579,   580,    -1,
     582,   583,   584,   585,   586,   587,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   595,    -1,    -1,    -1,    -1,   600,   601,
     602,    -1,    -1,    -1,    -1,    -1,   608,     3,     4,    -1,
       6,     7,    -1,     9,    -1,    -1,    -1,    13,    -1,    -1,
      16,    -1,    18,    -1,    -1,    -1,    -1,    -1,   630,   631,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      36,   445,   708,    -1,    -1,    -1,    -1,    -1,    44,    45,
      -1,    -1,    -1,    -1,   708,    -1,    52,    53,    54,    -1,
      56,   663,   664,    -1,    60,    61,    62,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,    -1,
      -1,    -1,    78,    -1,    -1,    81,    82,    83,    84,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   703,    -1,   705,    -1,    -1,    -1,   103,   708,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
     116,   117,   708,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,   708,    -1,    -1,    -1,    -1,    -1,    -1,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   160,   161,    -1,    -1,    -1,   165,
     166,    -1,   168,   169,   170,    -1,   706,   173,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,    -1,    -1,   201,   202,   203,   204,   205,
     206,   708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   708,   225,
     226,    -1,    -1,   229,   230,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,   239,   240,   241,    -1,    -1,    -1,   245,
      -1,   247,    -1,    -1,   250,    -1,    51,    -1,   254,   255,
     256,    -1,   258,    -1,    -1,   261,   262,   263,    -1,    -1,
      -1,    -1,    -1,   269,   270,     3,    -1,   273,     6,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      -1,   287,    -1,    -1,    -1,    90,   292,   293,   294,    -1,
      -1,   297,    -1,    -1,   708,    51,    -1,   303,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,   314,   315,
     316,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    -1,    -1,
      -1,   708,    -1,   339,    90,    91,    -1,    -1,   344,    -1,
      -1,    -1,    -1,    -1,   350,   351,    -1,    -1,    -1,    -1,
      -1,   357,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,    -1,    -1,   104,   105,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,   115,   116,   117,
      -1,    -1,    -1,    -1,   140,    -1,    -1,   708,   126,   127,
     128,    -1,    51,    -1,    -1,    -1,    -1,    -1,   404,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   144,   145,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    51,   211,   212,    -1,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,   216,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     246,   445,    -1,    90,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   257,
      -1,   259,    -1,   261,    -1,    -1,   264,   265,   534,    -1,
      -1,   269,   270,    -1,    -1,    -1,    -1,   275,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    -1,   287,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   564,   565,
     566,   567,    -1,   301,    -1,    -1,   572,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,   313,   314,    90,    -1,    -1,
      -1,    -1,    -1,    -1,   322,   323,   324,   246,   132,   394,
     395,   396,   397,   398,    -1,    -1,   140,   335,   336,   337,
      -1,    -1,    -1,    -1,    -1,    -1,   344,   613,   614,    51,
      -1,    -1,   350,   351,    -1,    -1,    -1,    -1,    -1,   357,
      -1,    -1,    -1,   361,   706,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    90,   246,
      51,   657,   658,    -1,    -1,   199,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   683,   684,   685,
     686,   687,   688,    -1,   440,   441,    -1,    -1,    -1,    90,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,    -1,   246,    -1,   460,   461,   462,   463,   252,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   706,   246,    -1,   394,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,    -1,    -1,    -1,   534,   394,   395,   396,
     397,   398,    -1,    51,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,    -1,    -1,    51,
      -1,    -1,    90,    -1,    -1,   246,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    90,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   440,   441,    -1,    -1,
      -1,   706,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,    -1,    -1,    -1,   460,   461,   462,   463,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    -1,    -1,    -1,   683,   684,   685,   686,   687,
     688,   707,   394,   395,   396,   397,   398,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   394,   395,   396,   397,   398,   246,    51,
      -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,
      -1,    -1,    -1,   706,    -1,    -1,    51,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    90,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    90,   706,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    90,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,   394,   395,   396,   397,
     398,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   707,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,
      -1,    90,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,    -1,   706,   246,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,   706,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    90,
      -1,    -1,   246,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   706,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,    -1,    -1,    -1,   706,
      -1,    -1,    -1,    -1,    90,    -1,    -1,   246,    -1,    -1,
      -1,    -1,   394,   395,   396,   397,   398,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,    -1,    -1,
      -1,   394,   395,   396,   397,   398,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    90,   445,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   706,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    -1,    -1,    -1,   706,    -1,    -1,    -1,
     394,   395,   396,   397,   398,   246,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   394,   395,   396,   397,   398,
     246,    -1,    -1,    -1,   706,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    51,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   706,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    51,    -1,    -1,    -1,    90,   706,    -1,
      -1,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,   706,    -1,   706,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,   706,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    51,   706,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    51,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    90,    -1,
      -1,   246,    -1,    -1,    51,   706,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,   246,    -1,    -1,    -1,
     706,   394,   395,   396,   397,   398,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
     246,    -1,   706,    51,    -1,   394,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,   706,   394,
     395,   396,   397,   398,   246,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    51,    -1,    -1,   706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   394,   395,   396,   397,   398,   246,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   394,   395,
     396,   397,   398,   246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   706,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    51,    -1,    -1,    -1,    -1,    -1,   246,
      -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    90,    -1,    -1,   706,    -1,    -1,   706,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    51,   706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    90,    51,    -1,    -1,    -1,
      -1,   706,    -1,    -1,    -1,   394,   395,   396,   397,   398,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   706,   394,   395,   396,
     397,   398,    51,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    90,    -1,
      -1,   246,    -1,    51,   706,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,   246,    90,    -1,    -1,    51,    -1,    -1,    -1,   706,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    51,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    51,   706,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,   706,   394,
     395,   396,   397,   398,   246,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,   246,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     246,   445,    -1,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    -1,    -1,    90,    -1,    -1,   246,    -1,    -1,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,
      -1,    -1,    -1,    90,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,   246,    -1,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   394,   395,
     396,   397,   398,   706,    -1,    -1,    -1,    90,   706,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   394,   395,   396,   397,   398,
     246,    51,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
      90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,
      -1,   706,   706,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,   246,    -1,    -1,    -1,   706,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   246,   394,   395,   396,
     397,   398,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,
      -1,    -1,    -1,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,    -1,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     706,   394,   395,   396,   397,   398,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,    -1,    -1,
     706,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   246,   445,    -1,    -1,   706,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    -1,    -1,   394,   395,   396,   397,   398,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,    -1,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    70,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,    -1,   445,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
     706,    -1,    -1,    -1,   140,    -1,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   706,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,
      -1,    -1,    -1,    -1,    -1,   181,    90,    -1,    -1,   706,
     707,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   199,    -1,    -1,    -1,    -1,   706,    -1,
      -1,    -1,    -1,    90,    -1,   211,   212,    70,    -1,    -1,
      -1,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,    -1,   445,    -1,    -1,    90,    91,    -1,
      -1,    -1,    -1,   706,    -1,   706,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,    -1,   445,   140,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    -1,   445,
     706,   706,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,    -1,   445,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    -1,   199,   706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,   246,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    -1,   246,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,    -1,    -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,
     140,    -1,    -1,   706,   440,   441,    -1,    -1,    -1,    -1,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,   465,
     347,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   181,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,   706,    -1,    -1,    -1,   199,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   211,   212,    -1,    -1,    -1,    -1,   394,   395,   396,
     397,   398,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   394,   395,   396,   397,   398,   246,   706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     706,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   706,    -1,    -1,    -1,    -1,   432,
      -1,    -1,    -1,    -1,    -1,    -1,   706,   440,   441,    -1,
      -1,    -1,    -1,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,   465,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   706,    -1,    -1,   394,   395,   396,   397,   398,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   707,    -1,   709,   414,   711,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     4,     5,     6,    -1,
      -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,    90,    -1,
     440,   441,    -1,   706,    -1,    -1,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,   462,   463,   464,   465,    44,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,    56,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   706,   707,    -1,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   115,   116,   140,
      -1,    -1,    -1,   155,   156,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   131,   707,    -1,   709,    -1,   711,   171,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     181,    -1,    -1,   161,    -1,    -1,   164,    -1,   200,    -1,
     168,    -1,    -1,    -1,   246,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   184,    -1,    -1,    -1,
     211,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,
      -1,    -1,    90,    91,    -1,    -1,    -1,    -1,    -1,   217,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,   260,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    90,    91,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   706,    -1,    -1,    -1,    -1,   254,    -1,   256,    -1,
      -1,    -1,   140,   261,    -1,    -1,    -1,    -1,    -1,   301,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,    -1,    -1,    -1,    -1,    -1,   707,   140,    -1,
      -1,    -1,    -1,    -1,    -1,   293,   294,    -1,    -1,    -1,
      -1,    -1,    -1,   181,    -1,    -1,   338,    -1,    -1,    -1,
     342,    -1,   344,    -1,   346,    -1,    -1,    -1,    -1,    -1,
     706,   199,   394,   395,   396,   397,   398,    -1,    -1,   181,
      -1,    -1,    -1,   211,   212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   199,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,
     212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   424,   414,   246,    -1,    -1,    -1,    -1,    -1,
     252,    -1,    -1,    -1,   402,    -1,    -1,    -1,    -1,    -1,
      -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   440,
     441,    -1,    -1,    -1,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,   465,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,    -1,    -1,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   414,    -1,    -1,    -1,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   440,   441,    -1,    -1,    -1,    -1,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,   462,   463,   464,   465,   440,   441,
      -1,    -1,    -1,    -1,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,    -1,    -1,    -1,   460,   461,
     462,   463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   625,   626,   627,
      -1,    -1,    -1,    -1,   706,   707,    -1,    -1,    -1,    90,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    90,
      91,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    -1,   707,    -1,   709,    -1,
     711,    90,    91,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     181,   603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     211,   212,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
     199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,   212,    -1,   246,    -1,    -1,    -1,    -1,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   707,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    90,
      91,    -1,    -1,   252,    -1,   707,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     181,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
     211,   212,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     199,    -1,    90,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,   211,   212,    -1,   246,    -1,    -1,    -1,   440,
     441,   252,    -1,    -1,    -1,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,    -1,    -1,    -1,   460,
     461,   462,   463,    -1,    -1,    -1,    -1,   246,    -1,    90,
      -1,   440,   441,   252,    -1,    -1,    -1,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,    -1,    -1,
      -1,   460,   461,   462,   463,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    90,    -1,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,   246,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   603,    -1,    -1,   312,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,   440,
     441,    90,    -1,    -1,   603,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,    -1,    -1,    -1,   460,
     461,   462,   463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   440,   441,    -1,    -1,    -1,    -1,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,    -1,    90,
      -1,   460,   461,   462,   463,   706,   707,   394,   395,   396,
     397,   398,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   707,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   394,   395,   396,   397,
     398,   246,    -1,    -1,    -1,    -1,    -1,    -1,   707,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,   603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    90,    -1,    -1,   246,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   707,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    90,    -1,   707,    -1,
      -1,    -1,    -1,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   394,   395,   396,   397,   398,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     707,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    90,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,   707,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    -1,    -1,
      -1,    -1,   246,    -1,    -1,   706,   707,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   706,   707,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,   246,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,   706,   707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,   707,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,   246,    -1,    -1,   706,   707,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,   706,   707,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   394,   395,   396,   397,   398,   246,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    -1,    -1,   246,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,   706,   707,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,   706,   707,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   707,    -1,   394,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   707,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    -1,   394,   395,   396,   397,   398,   246,    -1,
      -1,    -1,    90,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,    -1,   246,    -1,    -1,    -1,   706,    -1,
      90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    90,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   706,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   706,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,   246,    -1,    -1,    -1,
     706,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,   246,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,   706,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   394,   395,   396,   397,   398,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,   706,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   706,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   706,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   394,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,
      -1,    -1,   422,   423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   706,    -1,    47,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,    -1,    47,
      -1,    70,    -1,    -1,    -1,   495,   496,   497,   498,   499,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   508,   509,
     510,    90,    47,    -1,   706,   515,   516,    -1,   518,   519,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,    90,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   543,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    70,    90,    -1,    -1,    -1,    -1,
      -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,    -1,   573,    90,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    -1,   616,    -1,    -1,   706,
     620,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     640,   641,   642,   643,   644,   645,   646,   647,   648,    -1,
     650,   651,   652,   653,   654,   655,   656,   706,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   246,    -1,    -1,
     507,   508,   509,   510,   511,   512,   513,   514,   515,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   543,   544,   545,   546,
     547,   246,    -1,    -1,    47,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,    -1,    -1,    -1,
     246,   568,   569,   570,    47,    -1,    -1,    -1,   317,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    90,    -1,   317,
      -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,   347,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   347,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,   640,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    -1,   394,   395,   396,   397,   398,
      -1,    -1,    47,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   347,    -1,    -1,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   347,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    90,    -1,    -1,    -1,    -1,
      -1,   347,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   246,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   246,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   246,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    51,    -1,    -1,    -1,    -1,
     347,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    90,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    90,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   246,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   246,    -1,    -1,   312,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,   396,
     397,   398,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     246,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     246,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   394,   395,   396,   397,   398,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    90,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    90,    -1,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   246,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    90,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   246,    90,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   246,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   246,    -1,   153,   154,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,   246,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   153,
     154,    -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   394,   395,   396,   397,   398,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,
     394,   395,   396,   397,   398,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    -1,    90,   394,   395,   396,
     397,   398,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   312,    -1,    -1,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   246,   140,    -1,    -1,    90,
      -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    -1,    -1,   246,    -1,   394,   395,   396,   397,   398,
      -1,   312,   153,   154,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,    90,
     140,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   394,   395,   396,   397,   398,   246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     394,   395,   396,   397,   398,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,   246,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   394,   395,   396,   397,   398,   154,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,    -1,    -1,    90,    -1,    -1,   246,    -1,
      -1,    -1,    -1,   394,   395,   396,   397,   398,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   394,   395,   396,   397,
     398,   246,    -1,    -1,    -1,    -1,    -1,    90,    -1,   154,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,    90,    -1,    -1,
     246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   394,   395,   396,   397,
     398,   246,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   395,
     396,   397,   398,   246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
     395,   396,   397,   398,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   394,   395,   396,   397,   398,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   394,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536
  };

  const short
  parser::yystos_[] =
  {
       0,    14,    15,    39,    40,    41,    42,    43,    47,    55,
      65,    66,    67,    71,    73,    74,    75,    76,    77,    87,
      88,    90,    97,   103,   119,   120,   121,   122,   131,   133,
     134,   147,   167,   176,   178,   207,   208,   209,   210,   213,
     224,   238,   246,   251,   271,   272,   274,   276,   277,   285,
     288,   290,   291,   295,   296,   299,   300,   325,   326,   329,
     330,   331,   332,   334,   335,   340,   343,   348,   349,   354,
     358,   359,   360,   363,   365,   366,   367,   368,   369,   394,
     395,   396,   397,   398,   400,   407,   408,   409,   411,   412,
     413,   415,   416,   417,   418,   419,   420,   421,   427,   428,
     433,   466,   500,   505,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   575,   576,   579,   580,   582,   583,   584,
     585,   586,   587,   595,   600,   601,   602,   608,   630,   631,
     663,   664,   703,   705,   715,   716,   717,   718,   719,   722,
     725,   728,   731,   734,   738,   743,   744,   745,   746,   747,
     757,   760,   761,   766,   767,   768,   771,   774,   777,   782,
     785,   788,   796,   807,   812,   815,   826,   827,   830,   833,
     836,   840,   843,   846,   849,   852,   855,   858,   861,   864,
     865,   868,   871,   874,   886,   892,   895,   898,   905,   906,
     909,   910,   911,   913,   925,   926,   927,   930,   931,   932,
     941,   944,   947,   948,   951,   954,   955,   957,   960,   961,
     962,   963,   964,   965,   968,   974,   977,   978,   979,   982,
     983,   986,   989,   992,   995,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1014,  1017,  1020,  1023,  1026,  1029,
    1032,  1035,  1038,  1041,  1042,  1053,  1056,  1059,  1062,  1063,
    1066,  1070,  1073,  1079,  1082,  1084,  1087,  1090,  1093,  1097,
    1598,   140,   707,   140,   707,   706,   707,   878,  1598,   707,
     706,   707,   707,   706,   707,   706,   707,   878,   140,   707,
     707,   706,   707,   706,   707,   878,   706,   706,   706,   707,
     706,   707,   707,   706,   707,   706,   707,   878,   707,   706,
     707,   707,   706,   706,   707,   706,   707,   707,   706,   707,
     707,   707,   706,   706,   707,   312,   707,   969,   973,  1598,
     706,   707,   706,   707,   706,   706,   706,   706,   707,   706,
     706,   706,   706,   707,   878,   878,   754,  1598,    72,   140,
     975,   707,   878,   706,   707,   706,   707,   706,   707,   706,
     707,   878,   707,   706,   707,   706,   707,   706,   707,   878,
     706,   707,    72,   706,   707,   706,   707,   706,   706,   707,
     706,   707,   878,   706,   707,   878,   706,   707,   706,   707,
     878,   706,   706,   707,   878,   706,   706,   707,   706,   707,
     706,   707,   706,   707,   878,   878,   707,   751,  1598,   752,
    1598,   753,  1598,   942,   945,   755,  1598,   707,   706,   707,
     878,   756,  1598,   706,   707,   706,   707,   706,   707,   706,
     707,   707,   707,   706,   707,   707,   706,   707,   706,   707,
     707,   706,   707,   878,   706,   707,   706,   707,   706,   707,
     706,   707,   706,   707,   706,   707,   816,   707,   706,   707,
     706,   707,   707,   707,   706,   706,   707,   706,   878,   713,
       0,   716,    72,   707,    72,    72,    72,   713,   706,    21,
      22,    23,    27,    28,    29,    30,    45,    56,    84,   254,
     255,   293,   294,   422,   423,  1011,  1012,  1013,  1151,  1157,
    1164,  1186,  1187,  1262,  1263,  1269,  1270,  1315,  1316,  1317,
    1318,  1319,  1320,  1321,   706,    33,    44,   103,  1012,  1015,
    1016,  1214,  1248,  1322,    82,    83,   149,   151,   168,   217,
     286,   564,   565,   566,   567,  1071,  1072,  1151,  1164,  1186,
    1240,  1252,  1255,  1257,  1262,  1263,  1264,  1276,  1378,  1446,
    1447,  1448,  1449,    51,   706,  1598,   285,   407,   408,   409,
     758,   118,   123,   124,   125,   155,   179,   182,   314,   344,
     842,   844,   845,  1101,  1124,  1132,  1135,  1142,  1373,  1374,
    1375,  1376,    44,    46,   288,   323,  1060,  1061,  1108,  1120,
    1216,  1377,  1378,   407,  1064,  1065,  1598,    19,    20,    26,
      31,    32,    95,   116,   157,   158,   256,   426,   457,   702,
     704,  1051,  1052,  1201,  1204,  1207,  1210,  1294,  1298,  1299,
    1302,  1303,  1304,  1307,  1312,  1314,  1517,   706,   140,   706,
     969,   969,   772,   773,  1598,    35,     3,     4,     6,     7,
       9,    13,    16,    18,    36,    44,    52,    53,    54,    60,
      61,    62,    78,    81,    84,    89,   115,   116,   117,   144,
     145,   146,   148,   150,   160,   161,   165,   166,   169,   170,
     173,   174,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   201,   202,   203,
     204,   205,   206,   215,   216,   218,   219,   220,   221,   222,
     223,   225,   226,   229,   230,   234,   239,   240,   241,   245,
     247,   250,   256,   258,   261,   262,   263,   269,   270,   273,
     275,   287,   292,   297,   303,   311,   315,   316,   322,   339,
     350,   351,   357,   404,   534,   572,   613,   614,   657,   658,
     683,   684,   685,   686,   687,   688,   933,   934,  1101,  1107,
    1110,  1114,  1115,  1142,  1151,  1155,  1156,  1157,  1161,  1162,
    1163,  1170,  1186,  1187,  1188,  1189,  1190,  1191,  1200,  1206,
    1215,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,
    1236,  1237,  1238,  1239,  1240,  1242,  1243,  1244,  1245,  1246,
    1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1257,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1280,
    1283,  1284,  1285,  1287,  1288,  1289,  1290,  1291,  1292,  1323,
    1324,  1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,
    1334,  1379,  1440,  1446,  1447,  1448,  1449,  1450,  1451,  1494,
    1496,  1497,  1498,  1499,  1500,  1501,  1503,  1504,  1505,  1518,
    1519,  1535,  1536,  1537,  1538,  1539,  1540,   706,    47,   317,
     347,   887,   888,   889,  1598,    47,   347,   896,   897,  1598,
      47,   347,   893,   894,  1598,    12,   129,   275,   345,   424,
    1080,  1081,  1120,  1121,  1122,  1123,  1512,    92,   903,   904,
     899,   900,  1598,    98,    99,   100,   101,   102,   783,   784,
    1057,  1058,  1120,  1190,  1200,  1206,  1215,   706,  1598,   775,
     776,  1598,    35,    58,    80,    84,    85,    86,   769,   770,
    1150,  1151,  1152,  1157,  1164,  1165,  1166,  1167,  1168,  1169,
    1054,  1055,  1598,     5,   152,   164,   278,   279,   302,   402,
     403,   471,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   966,   967,  1107,  1108,  1110,
    1120,  1189,  1190,  1200,  1206,  1235,  1247,  1255,  1258,  1276,
    1340,  1364,  1368,  1369,  1370,  1371,  1372,  1378,  1494,  1495,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,   772,    35,   769,  1088,  1089,  1598,  1253,
     969,   177,   786,   797,     8,    11,    34,    48,    69,   162,
     183,   253,   284,   401,   794,   795,  1106,  1134,  1137,   180,
    1259,   707,    51,   706,   969,   847,   848,   407,   810,   834,
     282,  1085,  1086,  1598,   952,   953,  1598,    70,   246,  1076,
    1077,  1074,  1075,  1323,  1324,   949,   950,  1598,   949,   956,
    1598,    17,    63,    64,    96,   104,   126,   127,   128,   155,
     182,   257,   259,   264,   265,   301,   310,   313,   324,   335,
     336,   337,   876,   958,   959,  1100,  1101,  1102,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1120,  1128,  1129,  1133,  1138,  1139,  1140,  1141,  1142,  1156,
    1161,  1190,  1200,  1206,  1224,  1247,  1251,  1253,  1260,  1261,
    1278,  1279,  1283,  1284,  1289,  1290,  1291,  1292,  1323,  1324,
    1429,  1430,  1440,  1501,  1502,  1535,  1536,  1537,  1538,  1539,
    1540,   706,   706,    51,   706,  1598,   393,   707,   749,   750,
     140,   706,    91,   140,   181,   199,   211,   212,   414,   432,
     440,   441,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   460,   461,   462,   463,   464,
     465,   707,   803,   881,   970,  1598,   288,   706,   850,   851,
    1120,  1151,   155,   156,   171,   182,   200,   260,   338,   342,
     346,   853,   854,  1101,  1103,  1104,  1105,  1125,  1130,  1131,
    1135,  1136,  1241,  1260,  1261,  1506,  1512,   856,   857,  1120,
    1151,   661,   854,   859,   860,  1520,   706,   969,    47,   407,
     808,   809,   810,   282,   662,   407,   813,   814,   282,   103,
     248,   261,   333,   426,   704,  1045,  1046,  1151,  1157,  1164,
    1186,  1193,  1194,  1195,  1209,  1240,  1257,  1262,  1263,  1276,
    1378,  1515,  1516,   706,   312,  1094,  1095,  1598,   246,   709,
     851,   854,   869,   870,   138,   139,   280,   281,   289,  1091,
    1092,  1507,  1508,  1509,  1510,  1511,  1067,   841,   842,   130,
     425,   504,   875,   876,   877,  1119,  1126,  1240,  1379,  1380,
     706,   103,   249,   294,   649,  1047,  1048,  1151,  1157,  1164,
    1193,  1196,  1197,  1198,  1199,  1209,  1378,  1515,  1516,   706,
     105,   361,   362,   998,   999,  1281,  1282,  1441,   876,  1000,
    1001,  1281,  1441,   706,   246,   980,   981,   182,   364,   996,
     997,  1001,  1127,  1493,   706,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   984,   985,
    1554,  1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,
    1564,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,   987,   988,  1554,  1555,  1556,  1557,  1558,
    1559,    80,   288,   335,   339,   990,   991,  1577,  1578,  1579,
    1580,   255,   993,   994,  1581,   706,   706,   175,   577,    51,
     706,  1598,   393,   750,    51,   706,  1598,   393,   750,    51,
     706,  1598,   393,   750,   943,  1598,   946,  1598,    51,   706,
    1598,    79,   268,   283,   410,   459,   574,   659,   739,   740,
      19,    20,    24,    25,    26,    31,    32,    37,    38,    95,
     116,   157,   158,   256,   261,   457,   505,   702,  1049,  1050,
    1192,  1202,  1203,  1205,  1208,  1293,  1295,  1296,  1297,  1300,
    1301,  1305,  1306,  1308,  1309,  1310,  1311,  1313,  1515,  1516,
     706,    51,   706,  1598,   393,   237,   237,   237,   268,   660,
     682,   729,   730,  1149,  1153,  1154,   735,   268,   328,   682,
     732,   733,  1158,  1159,  1160,   131,   467,   468,   469,   470,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   625,   626,   627,  1043,  1044,  1110,  1151,
    1157,  1164,  1186,  1187,  1189,  1190,  1200,  1206,  1215,  1217,
    1229,  1240,  1255,  1276,  1335,  1336,  1337,  1338,  1339,  1340,
    1341,  1342,  1343,  1344,  1345,  1346,  1347,  1348,  1349,  1350,
    1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,  1360,
    1361,  1362,  1363,  1365,  1366,  1367,  1368,  1369,  1494,  1495,
      57,    84,    86,   254,   907,   908,  1143,  1150,  1165,  1169,
    1171,  1262,  1263,  1098,  1099,  1598,   246,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   518,   519,   520,   521,   522,
     523,   524,   543,   544,   545,   546,   547,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   568,
     569,   570,   640,  1018,  1019,  1151,  1248,  1383,  1384,  1385,
    1386,  1387,  1388,  1389,  1390,  1391,  1392,  1393,  1394,  1395,
    1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,  1405,  1406,
    1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
    1417,  1418,  1419,  1420,  1421,  1422,  1423,  1424,  1425,  1426,
    1427,  1428,  1456,   578,   327,   352,   353,   573,   574,   615,
     616,   618,   619,   621,   622,   623,   628,   639,  1027,  1028,
    1452,  1453,  1455,  1472,  1480,  1481,  1482,  1485,  1486,  1487,
    1488,  1489,  1490,  1491,   706,   617,  1021,  1022,  1452,  1453,
    1455,  1472,  1480,  1481,  1482,  1484,  1485,  1486,  1487,  1488,
    1490,  1491,   516,   620,   641,   642,   643,   644,   645,   646,
     647,   648,   650,   651,   652,   653,   654,   655,   656,  1039,
    1040,  1151,  1262,  1263,  1383,  1384,  1385,  1386,  1387,  1393,
    1394,  1395,  1397,  1401,  1402,  1403,  1404,  1452,  1453,  1454,
    1456,  1457,  1458,  1459,  1460,  1461,  1462,  1463,  1464,  1465,
    1466,  1467,  1468,  1469,  1470,  1471,    64,   192,   267,   638,
    1036,  1037,  1381,  1382,  1452,  1453,  1472,  1473,  1474,   633,
     634,   635,   636,   637,  1033,  1034,  1452,  1453,  1455,  1475,
    1476,  1477,  1478,  1479,   629,  1030,  1031,  1452,  1453,  1482,
    1483,   624,  1024,  1025,  1452,  1453,  1455,  1472,  1480,  1481,
    1485,  1486,  1487,  1488,  1489,  1490,  1491,  1492,   706,   285,
     571,   596,   597,   598,   599,   828,   829,  1431,  1432,  1433,
    1434,  1435,  1436,   778,   604,   605,   607,   831,   832,  1431,
    1437,  1438,  1439,   609,   610,   611,   612,   872,   873,  1442,
    1443,  1444,  1445,   298,   632,   866,   867,  1513,  1514,   866,
     789,   172,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   675,   676,   677,   679,   681,   862,   863,  1107,  1141,
    1142,  1151,  1155,  1156,  1157,  1164,  1186,  1190,  1200,  1206,
    1224,  1230,  1231,  1232,  1233,  1234,  1235,  1242,  1247,  1258,
    1261,  1262,  1263,  1277,  1278,  1283,  1284,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,  1292,  1429,  1430,  1440,  1521,  1522,
    1523,  1524,  1525,  1526,  1527,  1528,  1529,  1530,  1531,  1532,
    1533,  1534,  1553,   706,   536,    47,   119,   911,  1598,   912,
    1213,  1598,    47,   119,   926,  1598,    47,   119,   931,  1598,
     132,   181,   199,   211,   212,   252,   440,   441,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   460,
     461,   462,   463,   707,   762,   881,   970,  1598,   153,   154,
     536,  1598,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    51,   708,    72,    72,    72,
      51,   708,    72,    72,    72,    72,   708,    51,  1598,   708,
      72,    72,    72,    72,    72,    72,    72,    72,    51,   708,
      72,    72,    72,    72,    51,   708,  1598,    70,  1065,    51,
      72,    72,    72,    72,    72,    72,    72,   708,    51,   706,
     708,   708,    70,   773,    72,   708,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    51,   708,  1598,  1598,    70,   888,
      51,   706,  1598,  1598,    70,   897,    51,  1598,  1598,    70,
     894,    51,   708,    72,    72,   708,    51,   440,   708,    70,
     900,    51,    72,    72,    72,    72,    72,    51,   708,    51,
     708,   708,    70,   776,   707,   708,    72,    72,    72,    72,
      72,    51,   708,    70,  1055,    51,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,   708,    51,    70,   708,   708,    70,  1089,
      51,   707,   708,   708,    72,   787,   803,   709,   711,   799,
     800,   803,   806,    72,    72,    72,    72,    72,    51,   708,
      72,   708,   881,   969,   707,    51,   708,  1598,    70,   810,
     708,    70,  1086,    51,    70,   953,   707,   706,    51,    70,
    1077,   708,    51,    70,   950,   707,    70,    70,  1598,    51,
     762,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    51,   708,  1598,   393,   750,   750,
      51,   748,  1598,    51,   708,   748,   706,   707,   707,   707,
     707,   707,   707,   803,   803,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   803,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   445,   976,   713,   804,   319,
     320,   321,    72,    51,   708,    72,    72,    72,    72,    72,
      51,   708,    51,   708,    51,   708,   708,  1598,  1598,    70,
     809,    51,   708,    51,   708,  1598,    70,   814,   708,    72,
      72,    72,    72,   708,    51,    72,    70,  1095,    72,    72,
     440,   441,   707,   838,   839,   881,   882,    51,   708,    72,
      72,    72,    72,    72,   708,    51,   709,  1068,  1069,  1598,
      51,   708,    72,    72,    51,   708,    72,    72,    72,    72,
     708,    51,    72,    72,    72,    51,   708,    51,   708,   436,
     437,   438,   439,    70,   981,    72,    72,    51,   708,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,   708,
      51,   708,    51,    72,    72,   708,    51,   708,    51,    72,
      72,  1598,   393,   750,   750,  1598,   393,   750,   750,  1598,
     393,   750,   750,    51,   706,  1598,    51,   706,  1598,  1598,
      72,    72,    72,    72,    72,    72,    72,    51,   708,    72,
      72,    72,    72,    72,    72,    72,    72,    72,   708,    51,
    1598,   393,   708,   708,   708,    72,    72,    51,   708,   268,
     283,   459,   581,   736,   737,  1144,  1145,  1146,  1147,    72,
      72,    72,    51,   708,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,   708,    51,    72,    72,    72,
      72,    51,   708,    70,  1099,    51,  1598,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    51,   708,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    51,   708,    51,   708,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    51,   708,    72,    72,    72,
      51,   708,    72,    72,    72,    72,    51,   708,    51,   708,
      72,    51,   708,   506,   589,   591,   592,   817,   818,    72,
      72,    72,    72,    72,    72,    51,   708,   246,   779,   780,
      72,    51,   708,    72,    72,    72,    72,    51,   708,    72,
      72,    51,   708,   708,   246,   790,   791,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,   708,    51,   916,
     707,   707,   706,   713,    51,   708,    72,   707,   707,   706,
     713,   707,   707,   706,   713,   707,   707,   707,   707,   762,
     762,   707,   707,   707,   707,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   762,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   445,   706,   763,
     707,   914,   713,   881,   882,   881,   140,   882,   140,   969,
     140,   140,   709,  1586,  1588,  1589,   140,   140,   312,  1598,
    1582,  1598,  1013,   140,   140,   881,   140,  1016,   140,  1589,
     140,   881,    68,   304,   305,   306,   307,   308,   309,   706,
     878,  1071,   759,  1598,   140,   140,   140,   881,   881,   140,
     881,   140,   845,   706,   881,   707,   140,   140,  1061,   706,
     706,   706,  1598,   969,   429,   430,   431,   531,   532,   533,
     535,   707,  1211,   904,   904,  1598,   140,   706,   878,  1051,
     706,   878,   706,   878,   706,   762,   706,   140,   312,   881,
    1598,   881,   881,   881,   140,   969,  1586,  1589,   707,  1211,
    1586,  1589,   140,   707,   881,   881,   140,   140,    59,    93,
      94,   341,   881,   881,   881,   881,   881,   881,   881,   881,
     140,   140,   969,   969,   969,   140,   132,   440,   441,   882,
     883,   884,   140,   140,   140,  1598,   969,   140,  1589,   709,
    1592,  1593,  1593,   537,   538,   539,   969,   140,   227,   228,
     535,   881,   231,   232,   233,   235,   236,   140,  1598,   242,
     243,   244,   242,   243,   244,   707,   140,   140,   881,   707,
     132,   881,   140,    93,    94,   881,   140,    49,    50,    93,
     707,   140,   140,   881,   140,   934,   706,   878,    51,   706,
      10,   114,   141,   142,   143,   266,   399,   549,   762,   765,
     890,   902,    51,    51,   706,   762,    51,    51,   706,   762,
     706,   140,   140,   706,  1080,   140,   706,   706,   762,   312,
     312,   312,   312,   312,   784,   706,  1058,   706,   878,   713,
     706,   140,   440,   441,   880,   706,  1598,   969,   904,   140,
     904,   140,   904,   770,   706,   706,   762,   882,   881,   140,
     140,   880,   140,   140,   140,   969,   140,   140,   140,   881,
     881,   881,   140,   140,   881,   706,   966,   706,   706,   706,
     706,  1598,   140,  1583,   706,   706,   723,    70,   803,   706,
     801,   802,  1598,  1598,    70,   800,   806,    72,   706,   881,
     881,   707,   140,   707,   794,   706,   159,   214,   973,   708,
     707,   881,   848,   706,   706,   706,   706,   706,  1598,   706,
     880,  1078,  1598,   706,   706,  1074,   706,   762,   706,   706,
      51,   762,  1598,   706,   881,   140,   140,   140,   969,   881,
     140,   140,   881,   140,   881,   140,   140,   140,   959,   706,
     878,   393,   750,   750,   748,    72,   708,   748,   803,   803,
     803,   803,  1598,  1598,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   880,   708,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   706,  1598,   707,   140,   851,
     706,   881,   881,   140,   881,   140,   854,   706,   857,   706,
     854,   706,   706,    51,    51,    72,   706,   706,   662,   706,
     282,   706,   706,   706,   706,   355,   356,   140,  1598,  1598,
     706,   878,  1045,  1096,  1598,   706,  1096,  1598,   881,   881,
     762,   706,   710,    51,   707,   882,   870,   706,   969,   707,
     969,   707,   140,   706,  1091,   878,    70,  1069,    72,   842,
     706,   881,  1589,   877,   706,   878,   140,  1586,  1589,   140,
    1589,   706,   878,  1047,   707,   762,   393,   999,   706,  1001,
     706,   878,   762,   762,   762,   762,   706,   140,   881,   997,
     706,   878,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   706,   984,   706,   878,   987,   969,  1586,  1589,
     706,   990,   706,   878,   993,   727,   726,   393,   750,   750,
     393,   750,   750,   393,   750,   750,  1598,  1598,   741,  1598,
     762,  1598,  1598,   140,  1584,   880,   740,   706,   969,   429,
     430,   431,   140,   140,   707,  1211,   904,   904,  1598,   140,
     706,   878,  1049,   393,   706,   706,   706,  1598,   709,  1590,
    1591,   730,   706,    72,    72,    72,  1148,    51,   708,  1598,
    1591,  1591,   733,   706,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   881,   140,   709,
    1596,  1597,   881,   881,   707,   707,   707,   140,   140,   707,
     881,   140,   881,   881,   881,   881,   881,   706,  1043,   969,
     140,   908,   706,   706,  1598,   706,  1598,   140,   593,   594,
     140,   140,   140,   140,   969,   140,   707,   140,   246,   591,
     592,   140,   140,   140,   140,   140,   881,   881,   140,   140,
     140,   140,   140,   140,   881,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,  1593,  1019,   706,   720,   140,   969,   140,
     969,   969,  1593,   140,   140,  1593,   882,   140,  1028,   706,
     878,  1022,   706,   517,   535,   881,   881,   881,   140,   881,
     140,   140,   881,   881,   140,   140,   140,   140,   881,   881,
    1040,   706,   140,   140,   140,  1037,   706,   140,   882,   882,
     140,  1034,   706,  1031,   706,   140,  1025,   706,   588,   590,
     606,   706,   706,    70,   818,   709,   709,  1593,  1595,   140,
     881,  1597,   140,   140,   829,   706,   781,    70,   780,  1586,
    1589,   832,   706,   312,   970,   971,   140,   971,   971,   873,
     706,   969,   140,   867,   706,   706,   312,    70,   791,   881,
     550,   551,   140,  1591,   881,   140,   140,  1589,   881,   140,
     706,   862,   707,  1598,  1598,  1213,   706,   904,  1598,  1598,
     536,  1598,  1598,  1598,   154,  1598,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   708,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   707,   135,   136,
     137,   928,   929,  1179,  1180,  1181,   707,   154,   536,    51,
     140,  1586,  1587,    51,   710,  1587,   712,   706,   706,   706,
      51,   706,  1598,   878,   288,   708,  1211,  1212,   706,   706,
     706,   706,   772,  1212,   878,   132,   132,    51,   882,    51,
     710,   882,   312,   935,   937,   938,   938,   312,   935,   939,
     940,   706,  1598,    51,   706,    51,  1598,   762,    51,  1598,
     762,   706,    70,   893,    51,   706,   153,   154,   536,  1598,
     140,   140,   708,   775,    51,   706,   772,    51,   708,   712,
     708,  1088,   803,   706,   706,    51,   710,    72,    72,   706,
     803,   878,   969,   972,   798,   706,   881,   708,   288,   834,
      51,   707,   708,    51,   706,    72,    70,  1076,   708,  1598,
     706,   762,   706,   750,   312,    51,    51,   708,   708,   708,
     708,   708,   708,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,    51,   708,   708,    51,   708,    51,   708,
     708,   708,   803,   805,   708,  1598,  1598,   762,   347,   708,
      70,   808,   708,   810,   811,   288,    70,   813,   706,    51,
     706,  1598,   706,   708,   708,   839,   706,   707,   882,   762,
     878,   878,   710,   706,   762,   706,   706,   878,   706,   706,
     706,   706,   706,   706,   706,   706,   803,   803,   750,   750,
     750,   803,   712,  1212,   706,    51,   312,    51,   312,   710,
    1598,  1598,  1598,    72,   737,   706,   884,   710,   884,   712,
     878,   879,   879,   879,   879,   706,   708,   878,   803,   706,
     140,   140,   706,   706,   878,  1593,  1594,    72,   706,   706,
     706,   106,   107,   108,   109,   110,   111,   112,   113,   318,
     923,   924,  1172,  1173,  1174,  1176,  1177,  1178,  1182,  1183,
    1185,  1489,    51,   708,   712,    51,   708,   713,    51,   708,
     713,    51,    51,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   708,   708,   708,   708,   708,    51,   708,
      51,   708,   762,   764,    72,    72,    72,    51,   708,   107,
     109,   921,   922,  1172,  1173,  1174,  1175,  1177,  1178,  1182,
    1183,  1184,  1489,   707,   915,  1587,   712,   710,  1587,  1598,
    1598,   708,   140,   835,   713,    51,   708,    70,   708,   708,
     882,   710,   882,    51,    51,   708,   708,    51,    51,   708,
     762,   765,   902,   765,   891,    51,    51,   762,    51,   706,
     706,    70,   762,   707,   917,   713,    72,    70,   762,    70,
     440,   441,   709,  1083,    51,   140,    51,    70,   708,   802,
     803,   312,   803,   706,   708,    51,   708,   799,   708,   835,
      70,  1083,   441,   880,  1585,    72,  1598,   882,   706,    70,
     706,   762,   706,   803,   803,   312,   803,   803,   707,    51,
     708,   878,    72,    72,   706,   762,   706,   706,    70,   706,
      70,   810,   835,   706,    70,  1598,   706,   762,   708,   708,
     708,    72,   706,   708,   708,   708,   132,   140,   708,   312,
     312,   710,   803,   708,   708,   708,   708,   706,   708,   708,
      51,   706,   710,    51,   710,   762,   395,   396,   397,   398,
     792,   793,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    51,   708,  1598,   713,   904,  1598,   713,   536,  1598,
     713,   154,   762,   762,   762,   762,    51,   708,  1597,   881,
     882,   929,   706,    72,    72,    51,   708,   928,   707,   140,
     712,    51,   140,   706,   153,   154,   536,  1598,  1211,   706,
      90,   312,   394,   882,   885,   937,   707,  1591,   939,    51,
      51,    51,   762,   762,   706,   762,   706,   706,   928,   707,
     154,   536,   762,   706,   706,   706,   762,   706,  1598,  1598,
     706,   724,  1598,    72,   706,   706,   969,    70,   706,   706,
     706,   707,   708,   712,   708,   762,    72,   706,   706,   708,
     708,    51,   708,    51,    51,   803,   803,   706,   762,   762,
     706,   811,   706,   811,   706,   706,   706,  1094,   708,   762,
     742,  1598,   742,  1098,   721,  1598,   819,   588,   821,  1593,
     706,   803,   803,   803,   803,   793,   882,  1593,   881,  1595,
     882,  1593,   519,   525,   526,   527,   528,   529,   530,   540,
     548,   901,  1593,  1593,   924,   706,   708,   708,   536,  1598,
     708,   154,  1598,   708,   708,    51,    51,   762,   882,   762,
     922,   706,   708,   921,   140,   140,   712,   405,   707,   919,
     713,   312,   935,   936,   765,   891,   765,    51,   706,   706,
     708,   921,   707,   918,   706,    51,    51,    51,    51,   706,
    1598,   393,   803,   706,   405,   880,    51,   880,    51,   706,
     882,   140,  1589,   803,   803,   708,   706,   706,    70,    70,
     405,   406,    70,   706,    51,   706,  1598,   393,   750,   706,
      70,    51,   706,  1598,   393,   440,   441,   603,   762,   823,
     824,   825,   140,   588,   706,   706,   706,   706,   713,   713,
     713,   713,   713,   762,   762,   706,   708,   712,   140,   707,
     837,   882,   928,   707,   154,   536,    51,    51,   708,    51,
      51,   762,   706,   708,   928,   707,   762,  1083,  1083,  1598,
     393,   706,   837,   712,  1083,  1083,   708,   708,   708,   708,
     706,   706,   837,   837,   706,  1598,   393,   750,   750,   706,
    1598,   393,   603,   603,   707,   442,    72,   762,   825,    51,
     140,   536,  1598,   536,   154,  1598,   154,   708,   708,   706,
     140,   762,    51,   706,   707,   882,   708,   921,   707,   920,
     935,   902,   765,   706,   706,   708,   921,   710,   706,   706,
     393,   706,   880,   706,   706,   706,   706,   393,   750,   750,
     393,   707,   707,  1598,   603,   820,   822,  1598,    51,   713,
     713,   708,   707,   882,   762,   706,   708,   928,   707,    51,
      51,   706,   708,   708,   750,  1598,  1598,    51,   707,   823,
      51,   706,   822,   536,   154,   762,   708,   706,   708,   921,
     891,   765,   706,    51,    51,   140,  1598,   706,  1598,   706,
     708,   706,   708,    51,   140,   140,   708,    51,   706,   762,
     708,   708,   140,   708
  };

  const short
  parser::yyr1_[] =
  {
       0,   714,   715,   715,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   716,   716,   716,   716,   717,   717,   718,   720,   719,
     721,   721,   721,   721,   721,   721,   723,   722,   724,   724,
     724,   724,   724,   724,   725,   726,   725,   727,   725,   728,
     729,   729,   730,   730,   730,   731,   732,   732,   733,   733,
     733,   735,   734,   736,   736,   737,   737,   737,   737,   738,
     739,   739,   740,   741,   740,   740,   740,   740,   740,   740,
     740,   742,   742,   742,   742,   742,   742,   742,   742,   742,
     742,   742,   742,   743,   744,   745,   746,   747,   748,   749,
     749,   749,   749,   750,   750,   751,   751,   751,   751,   751,
     751,   751,   751,   751,   751,   751,   751,   752,   752,   752,
     752,   752,   752,   752,   752,   752,   752,   752,   752,   753,
     753,   753,   753,   753,   753,   753,   753,   753,   753,   753,
     753,   754,   754,   754,   754,   754,   754,   754,   754,   754,
     754,   754,   754,   755,   755,   755,   756,   756,   756,   756,
     756,   756,   757,   758,   758,   758,   758,   759,   759,   759,
     760,   760,   761,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   763,   762,   762,   762,   762,
     762,   762,   762,   762,   764,   764,   765,   765,   766,   766,
     767,   768,   769,   769,   770,   770,   770,   770,   770,   770,
     770,   770,   770,   770,   771,   771,   772,   772,   773,   774,
     774,   775,   775,   776,   778,   777,   779,   779,   781,   780,
     782,   783,   783,   784,   784,   784,   784,   784,   786,   785,
     787,   787,   789,   788,   790,   790,   791,   792,   792,   793,
     793,   793,   793,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   795,   795,   797,   796,   798,   796,
     799,   799,   799,   799,   800,   800,   800,   800,   801,   801,
     802,   802,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   804,   803,   803,   803,   803,   803,
     803,   803,   805,   805,   806,   807,   807,   807,   807,   807,
     807,   808,   808,   809,   809,   809,   809,   809,   810,   811,
     811,   812,   812,   812,   813,   813,   814,   814,   816,   815,
     817,   817,   818,   818,   819,   820,   818,   818,   818,   821,
     821,   822,   822,   823,   823,   824,   824,   825,   825,   825,
     825,   826,   827,   828,   828,   829,   829,   829,   829,   829,
     829,   830,   831,   831,   832,   832,   832,   832,   833,   833,
     834,   834,   835,   835,   835,   835,   835,   835,   836,   837,
     837,   837,   837,   837,   837,   838,   838,   839,   839,   839,
     839,   839,   839,   840,   840,   841,   841,   842,   842,   842,
     842,   842,   842,   842,   842,   843,   843,   844,   844,   845,
     845,   846,   846,   847,   847,   848,   849,   849,   850,   850,
     851,   851,   852,   852,   853,   853,   854,   854,   854,   854,
     854,   854,   854,   854,   854,   854,   854,   854,   854,   854,
     855,   855,   856,   856,   857,   857,   858,   858,   859,   859,
     860,   860,   861,   861,   862,   862,   863,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   863,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   863,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   863,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   863,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   863,   863,   863,   863,
     863,   864,   865,   866,   866,   867,   867,   868,   868,   869,
     869,   870,   870,   871,   872,   872,   873,   873,   873,   873,
     874,   874,   874,   874,   875,   875,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   876,   877,   877,   877,   877,
     877,   877,   878,   878,   878,   879,   879,   880,   880,   880,
     881,   881,   882,   882,   882,   883,   883,   883,   884,   884,
     885,   885,   886,   887,   887,   888,   888,   889,   889,   889,
     889,   890,   890,   890,   890,   890,   891,   891,   891,   891,
     892,   892,   892,   893,   893,   894,   894,   894,   895,   896,
     896,   897,   897,   897,   898,   899,   899,   900,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   902,   902,   902,
     902,   902,   902,   902,   902,   903,   904,   904,   905,   906,
     907,   907,   908,   908,   908,   908,   908,   908,   908,   909,
     910,   911,   911,   911,   912,   912,   914,   913,   915,   913,
     916,   913,   917,   913,   918,   913,   919,   913,   920,   913,
     921,   921,   922,   922,   922,   922,   922,   922,   922,   922,
     922,   922,   923,   923,   924,   924,   924,   924,   924,   924,
     924,   924,   924,   924,   925,   926,   926,   926,   926,   926,
     926,   927,   927,   927,   927,   927,   927,   928,   928,   929,
     929,   929,   930,   931,   931,   931,   931,   931,   931,   932,
     932,   932,   932,   933,   933,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   935,   935,   936,   936,   937,   937,
     938,   938,   939,   939,   939,   940,   940,   942,   941,   943,
     943,   943,   945,   944,   946,   946,   946,   947,   948,   949,
     949,   950,   951,   952,   952,   953,   954,   955,   956,   956,
     956,   956,   957,   958,   958,   959,   959,   959,   959,   959,
     959,   959,   960,   960,   960,   960,   961,   961,   962,   962,
     963,   964,   965,   965,   966,   966,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   967,   967,   967,   967,   967,   967,   967,   967,
     967,   967,   968,   968,   969,   969,   970,   970,   971,   971,
     972,   972,   973,   973,   973,   973,   973,   973,   975,   976,
     974,   977,   977,   978,   978,   978,   978,   979,   980,   980,
     981,   981,   981,   981,   982,   983,   983,   984,   984,   985,
     985,   985,   985,   985,   985,   985,   985,   985,   985,   985,
     985,   985,   985,   985,   985,   985,   985,   985,   985,   985,
     985,   985,   986,   986,   986,   987,   987,   988,   988,   988,
     988,   988,   988,   989,   989,   990,   990,   991,   991,   991,
     991,   992,   992,   992,   992,   993,   993,   994,   995,   995,
     995,   995,   996,   996,   997,   997,   997,   998,   998,   999,
     999,   999,  1000,  1000,  1001,  1001,  1001,  1002,  1002,  1003,
    1003,  1004,  1004,  1005,  1006,  1006,  1006,  1006,  1007,  1007,
    1007,  1007,  1008,  1008,  1008,  1008,  1009,  1009,  1009,  1009,
    1010,  1010,  1011,  1011,  1011,  1011,  1011,  1011,  1011,  1012,
    1012,  1012,  1012,  1012,  1012,  1012,  1012,  1012,  1012,  1013,
    1013,  1014,  1014,  1015,  1015,  1015,  1015,  1016,  1016,  1017,
    1017,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1019,
    1019,  1020,  1020,  1021,  1021,  1021,  1021,  1021,  1021,  1021,
    1021,  1021,  1021,  1021,  1021,  1021,  1021,  1022,  1022,  1023,
    1023,  1024,  1024,  1024,  1024,  1024,  1024,  1024,  1024,  1024,
    1024,  1024,  1024,  1024,  1024,  1025,  1025,  1026,  1026,  1027,
    1027,  1027,  1027,  1027,  1027,  1027,  1027,  1027,  1027,  1027,
    1027,  1027,  1027,  1028,  1028,  1029,  1029,  1029,  1029,  1030,
    1030,  1030,  1030,  1031,  1031,  1032,  1032,  1033,  1033,  1033,
    1033,  1033,  1033,  1033,  1033,  1034,  1034,  1035,  1035,  1036,
    1036,  1036,  1036,  1036,  1036,  1036,  1037,  1037,  1038,  1038,
    1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,
    1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,
    1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,  1039,
    1039,  1039,  1039,  1039,  1039,  1040,  1040,  1041,  1041,  1042,
    1042,  1043,  1043,  1044,  1044,  1044,  1044,  1044,  1044,  1044,
    1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,
    1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,
    1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,
    1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,  1044,
    1044,  1044,  1044,  1044,  1044,  1045,  1045,  1046,  1046,  1046,
    1046,  1046,  1046,  1046,  1046,  1046,  1046,  1046,  1046,  1046,
    1046,  1046,  1046,  1047,  1047,  1048,  1048,  1048,  1048,  1048,
    1048,  1048,  1048,  1048,  1048,  1048,  1048,  1049,  1049,  1050,
    1050,  1050,  1050,  1050,  1050,  1050,  1050,  1050,  1050,  1050,
    1050,  1050,  1050,  1050,  1050,  1050,  1050,  1050,  1050,  1051,
    1051,  1052,  1052,  1052,  1052,  1052,  1052,  1052,  1052,  1052,
    1052,  1052,  1052,  1052,  1052,  1053,  1054,  1054,  1055,  1055,
    1056,  1056,  1056,  1056,  1057,  1057,  1058,  1058,  1058,  1058,
    1058,  1059,  1060,  1060,  1061,  1061,  1061,  1061,  1061,  1062,
    1062,  1063,  1064,  1064,  1065,  1067,  1066,  1068,  1068,  1069,
    1069,  1070,  1070,  1070,  1070,  1071,  1071,  1072,  1072,  1072,
    1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,  1072,
    1072,  1072,  1072,  1073,  1073,  1073,  1073,  1074,  1074,  1075,
    1075,  1076,  1076,  1077,  1078,  1078,  1079,  1079,  1080,  1080,
    1081,  1081,  1081,  1081,  1081,  1082,  1083,  1083,  1083,  1084,
    1085,  1085,  1086,  1086,  1086,  1087,  1087,  1088,  1088,  1089,
    1089,  1089,  1090,  1090,  1091,  1091,  1092,  1092,  1092,  1092,
    1092,  1093,  1093,  1094,  1094,  1095,  1095,  1096,  1096,  1096,
    1097,  1097,  1098,  1098,  1099,  1099,  1100,  1101,  1102,  1103,
    1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,
    1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,  1123,
    1124,  1125,  1126,  1126,  1127,  1128,  1129,  1130,  1131,  1132,
    1133,  1133,  1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,  1144,  1145,  1146,  1148,  1147,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1157,  1158,  1159,  1160,
    1161,  1161,  1162,  1162,  1163,  1164,  1165,  1166,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1190,  1191,  1191,  1192,  1193,  1194,  1195,  1195,
    1196,  1197,  1198,  1199,  1199,  1200,  1201,  1202,  1203,  1203,
    1204,  1205,  1206,  1206,  1207,  1207,  1208,  1208,  1209,  1210,
    1211,  1211,  1211,  1211,  1212,  1212,  1213,  1214,  1215,  1216,
    1217,  1218,  1219,  1220,  1221,  1222,  1222,  1223,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1230,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,
    1245,  1245,  1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,  1259,  1260,  1261,
    1262,  1262,  1263,  1264,  1265,  1266,  1267,  1268,  1269,  1270,
    1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1280,
    1281,  1282,  1283,  1283,  1284,  1285,  1285,  1285,  1285,  1286,
    1287,  1288,  1289,  1289,  1289,  1290,  1291,  1292,  1293,  1294,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,  1301,  1301,  1302,
    1302,  1302,  1303,  1304,  1305,  1306,  1307,  1308,  1309,  1310,
    1311,  1312,  1313,  1314,  1315,  1316,  1317,  1318,  1319,  1320,
    1321,  1322,  1323,  1324,  1325,  1326,  1327,  1327,  1327,  1328,
    1329,  1329,  1329,  1330,  1330,  1331,  1332,  1333,  1333,  1333,
    1334,  1334,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,
    1342,  1343,  1344,  1345,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,  1360,  1361,
    1362,  1363,  1364,  1364,  1365,  1366,  1367,  1368,  1369,  1370,
    1371,  1372,  1373,  1374,  1375,  1376,  1377,  1378,  1378,  1378,
    1378,  1378,  1378,  1378,  1379,  1380,  1381,  1382,  1383,  1383,
    1383,  1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,  1392,
    1392,  1392,  1393,  1394,  1395,  1396,  1397,  1398,  1399,  1400,
    1401,  1402,  1403,  1404,  1404,  1405,  1406,  1407,  1408,  1409,
    1410,  1411,  1412,  1413,  1414,  1415,  1416,  1417,  1418,  1419,
    1420,  1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,
    1430,  1431,  1432,  1433,  1433,  1434,  1435,  1436,  1437,  1438,
    1439,  1439,  1440,  1441,  1442,  1443,  1444,  1444,  1445,  1445,
    1446,  1447,  1448,  1449,  1450,  1451,  1452,  1453,  1454,  1455,
    1456,  1457,  1458,  1459,  1460,  1461,  1462,  1463,  1464,  1465,
    1466,  1467,  1468,  1469,  1470,  1471,  1472,  1473,  1474,  1475,
    1476,  1477,  1478,  1479,  1480,  1481,  1482,  1483,  1484,  1485,
    1486,  1487,  1488,  1489,  1489,  1490,  1491,  1492,  1493,  1494,
    1495,  1496,  1497,  1498,  1498,  1498,  1498,  1499,  1500,  1501,
    1502,  1503,  1504,  1505,  1506,  1507,  1508,  1509,  1510,  1511,
    1512,  1513,  1514,  1515,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,  1522,  1523,  1524,  1525,  1526,  1526,  1527,  1528,  1529,
    1530,  1531,  1532,  1533,  1534,  1535,  1536,  1537,  1538,  1539,
    1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,
    1560,  1561,  1562,  1563,  1564,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1577,  1578,
    1579,  1580,  1581,  1582,  1583,  1584,  1584,  1585,  1585,  1586,
    1587,  1587,  1588,  1588,  1588,  1588,  1589,  1589,  1590,  1590,
    1590,  1590,  1591,  1591,  1592,  1592,  1592,  1592,  1593,  1593,
    1594,  1594,  1595,  1595,  1596,  1596,  1597,  1598,  1598,  1598,
    1598,  1598,  1598,  1598,  1598,  1598,  1598,  1598,  1598,  1598,
    1598,  1598,  1598,  1598,  1598,  1598,  1598,  1598,  1598,  1598,
    1598,  1598,  1598
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     4,     3,     0,     9,
       2,     3,     1,     3,     4,     2,     0,     9,     2,     3,
       1,     3,     4,     2,     3,     0,     9,     0,     9,     5,
       3,     1,     1,     1,     1,     5,     3,     1,     1,     1,
       1,     0,     6,     3,     1,     1,     1,     1,     1,     5,
       1,     3,     3,     0,     4,     3,     3,     3,     3,     3,
       3,     2,     3,     1,     3,     4,     2,     3,     4,     2,
       4,     5,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     1,     3,     4,
       2,     3,     4,     2,     4,     5,     3,     2,     3,     1,
       3,     4,     2,     3,     4,     2,     4,     5,     3,     2,
       3,     1,     3,     4,     2,     3,     4,     2,     4,     5,
       3,     2,     3,     1,     3,     4,     2,     3,     4,     2,
       4,     5,     3,     2,     3,     1,     2,     3,     1,     3,
       4,     2,     6,     1,     1,     1,     1,     1,     2,     3,
       3,     4,     4,     3,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     6,     6,     0,     5,     8,     4,     8,
       4,     4,     1,     1,     1,     3,     0,     1,     5,     8,
       5,     5,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     8,     2,     1,     4,     5,
       8,     2,     1,     7,     0,     6,     2,     1,     0,     5,
       5,     3,     1,     3,     3,     3,     3,     3,     0,     6,
       2,     3,     0,     6,     1,     2,     4,     1,     2,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       5,     1,     5,     3,     3,     1,     0,     6,     0,     9,
       2,     2,     1,     1,     4,     2,     7,     5,     3,     1,
       3,     1,     3,     1,     2,     2,     2,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     7,
       4,     4,     2,     2,     4,     4,     6,     8,     8,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     6,     6,     0,     5,     8,     4,     8,     4,
       4,     4,     1,     3,     5,     5,     8,     7,     8,    10,
      10,     2,     1,     1,     6,     5,     7,     7,     9,     2,
       1,     5,     8,     7,     2,     1,     9,     9,     0,     6,
       2,     1,     5,     3,     0,     0,    10,     2,     2,     6,
       5,     3,     1,     1,     1,     1,     2,     6,     7,     7,
       8,     2,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     5,     3,     1,     1,     1,     1,     1,     5,     8,
       2,     1,     3,     2,     5,     4,     3,     1,     6,     5,
       4,     3,     3,     2,     1,     3,     1,     5,     3,     4,
       2,     3,     1,     2,     5,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     5,     3,     1,     1,
       1,     2,     5,     3,     1,     0,     2,     5,     3,     1,
       1,     1,     2,     5,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     5,     3,     1,     1,     1,     2,     5,     3,     1,
       1,     1,     2,     5,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     5,     3,     1,     1,     1,     2,     5,     3,
       1,     1,     1,     5,     3,     1,     1,     1,     1,     1,
       2,     5,     3,     6,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     2,     2,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     1,     5,     2,     1,     4,     2,     2,     1,     4,
       1,     3,     5,     9,     1,     5,     3,     5,     7,     9,
       5,     7,     8,     2,     1,     5,     7,     4,     5,     2,
       1,     7,     9,     6,     5,     2,     1,     6,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     5,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       4,     3,     6,     8,     3,     1,     0,     8,     0,    10,
       0,     8,     0,    11,     0,    13,     0,    13,     0,    15,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     5,     6,     8,     8,
      10,     7,     9,    10,    12,    12,    14,     3,     1,     1,
       1,     1,     4,     3,     5,     6,     8,     8,    10,     2,
       5,     3,     6,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     5,     1,     3,     0,     4,     2,
       3,     1,     0,     4,     2,     3,     1,     5,     5,     2,
       1,     5,     5,     2,     1,     7,     3,     5,     4,     6,
       3,     5,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     5,     3,     6,     5,     6,     5,     6,
       5,     5,     2,     5,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     6,     1,     1,     1,     3,     1,     1,
       1,     3,     1,     4,     2,     5,     3,     6,     0,     0,
       5,     2,     5,     2,     5,     3,     6,     5,     2,     1,
       4,     4,     4,     4,     2,     2,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     5,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     5,     3,     1,     1,     1,     1,
       1,     2,     5,     3,     6,     3,     1,     1,     2,     5,
       3,     6,     3,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     2,     5,     2,
       5,     2,     5,     2,     2,     5,     3,     6,     2,     5,
       3,     6,     2,     5,     3,     6,     2,     5,     3,     6,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     6,     1,     1,     1,     1,     3,     1,     3,
       6,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     5,     3,     6,     1,
       1,     1,     1,     3,     1,     2,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     5,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     5,     2,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     1,     2,     6,     4,
       2,     5,     3,     6,     1,     3,     1,     1,     1,     1,
       1,     5,     1,     3,     1,     1,     1,     1,     1,     3,
       8,     5,     1,     2,     9,     0,     6,     2,     1,     4,
       6,     2,     5,     3,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     5,     7,     8,     3,     1,     1,
       1,     2,     1,     4,     5,     3,     2,     5,     3,     1,
       1,     1,     1,     1,     1,     2,     5,     1,     1,     5,
       1,     2,     6,     9,     9,     5,     8,     1,     2,     6,
       9,     9,     2,     5,     3,     1,     1,     1,     1,     1,
       1,     5,    10,     2,     1,     4,     4,     3,     2,     1,
       5,    10,     2,     1,     3,     4,     3,     3,     3,     3,
       1,     1,     1,     3,     3,     3,     3,     1,     1,     1,
       3,     5,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     0,     4,     3,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     3,
       3,     3,     3,     5,     3,     5,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     5,     5,
       3,     1,     3,     3,     3,     3,     1,     3,     3,     3,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     3,     3,     3,     1,     3,     1,     1,
       1,     1,     3,     3,     3,     1,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     3,     3,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     1,
       3,     3,     1,     1,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     5,     5,     3,     3,     5,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     5,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     3,     3,
       3,     3,     3,     1,     1,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     3,     3,     3,     3,     3,     3,     5,     1,     1,
       3,     3,     1,     5,     3,     3,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     3,
       1,     3,     3,     3,     1,     3,     1,     1,     1,     3,
       3,     3,     3,     1,     3,     1,     3,     3,     3,     1,
       3,     1,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     1,     1,     1,     1,     3,     5,     3,     3,     5,
       1,     3,     3,     1,     3,     3,     3,     1,     1,     1,
       3,     3,     3,     1,     1,     3,     3,     1,     1,     3,
       3,     1,     3,     3,     3,     1,     1,     1,     3,     3,
       3,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     1,     1,
       1,     1,     3,     3,     1,     3,     1,     3,     1,     1,
       3,     3,     1,     3,     1,     1,     1,     3,     3,     3,
       1,     1,     1,     3,     3,     3,     3,     3,     6,     1,
       1,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       3,     1,     3,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "AIM_SOLVER",
  "ANALYTIC_DERIVATION", "ANALYTIC_DERIVATION_MODE", "AR",
  "POSTERIOR_SAMPLING_METHOD", "BALANCED_GROWTH_TEST_TOL", "BAYESIAN_IRF",
  "BETA_PDF", "BLOCK", "USE_CALIBRATION", "SILENT_OPTIMIZER",
  "BVAR_DENSITY", "BVAR_FORECAST", "NODECOMPOSITION", "DR_DISPLAY_TOL",
  "HUGE_NUMBER", "FIG_NAME", "WRITE_XLS", "BVAR_PRIOR_DECAY",
  "BVAR_PRIOR_FLAT", "BVAR_PRIOR_LAMBDA", "INTERACTIVE", "SCREEN_SHOCKS",
  "STEADYSTATE", "BVAR_PRIOR_MU", "BVAR_PRIOR_OMEGA", "BVAR_PRIOR_TAU",
  "BVAR_PRIOR_TRAIN", "DETAIL_PLOT", "TYPE", "BVAR_REPLIC", "BYTECODE",
  "ALL_VALUES_REQUIRED", "PROPOSAL_DISTRIBUTION", "REALTIME", "VINTAGE",
  "CALIB_SMOOTHER", "CHANGE_TYPE", "CHECK", "CONDITIONAL_FORECAST",
  "CONDITIONAL_FORECAST_PATHS", "CONF_SIG", "CONSTANT",
  "CONTROLLED_VAREXO", "CORR", "CUTOFF", "CYCLE_REDUCTION",
  "LOGARITHMIC_REDUCTION", "COMMA", "CONSIDER_ALL_ENDOGENOUS",
  "CONSIDER_ALL_ENDOGENOUS_AND_AUXILIARY", "CONSIDER_ONLY_OBSERVED",
  "INITIAL_CONDITION_DECOMPOSITION", "DATAFILE", "FILE", "SERIES",
  "DOUBLING", "DR_CYCLE_REDUCTION_TOL", "DR_LOGARITHMIC_REDUCTION_TOL",
  "DR_LOGARITHMIC_REDUCTION_MAXITER", "DR_ALGO", "DROP", "DSAMPLE",
  "DYNASAVE", "DYNATYPE", "CALIBRATION", "DIFFERENTIATE_FORWARD_VARS",
  "END", "ENDVAL", "EQUAL", "ESTIMATION", "ESTIMATED_PARAMS",
  "ESTIMATED_PARAMS_BOUNDS", "ESTIMATED_PARAMS_INIT", "EXTENDED_PATH",
  "ENDOGENOUS_PRIOR", "EXPRESSION", "FILENAME", "DIRNAME",
  "FILTER_STEP_AHEAD", "FILTERED_VARS", "FIRST_OBS",
  "FIRST_SIMULATION_PERIOD", "LAST_OBS", "SET_TIME", "OSR_PARAMS_BOUNDS",
  "KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED", "FALSE", "FLOAT_NUMBER",
  "DATES", "DEFAULT", "FIXED_POINT", "FLIP", "OPT_ALGO",
  "COMPILATION_SETUP", "COMPILER", "ADD_FLAGS", "SUBSTITUTE_FLAGS",
  "ADD_LIBS", "SUBSTITUTE_LIBS", "FORECAST", "K_ORDER_SOLVER",
  "INSTRUMENTS", "SHIFT", "MEAN", "STDEV", "VARIANCE", "MODE", "INTERVAL",
  "SHAPE", "DOMAINN", "GAMMA_PDF", "GRAPH", "GRAPH_FORMAT",
  "CONDITIONAL_VARIANCE_DECOMPOSITION", "NOCHECK", "STD", "HISTVAL",
  "HISTVAL_FILE", "HOMOTOPY_SETUP", "HOMOTOPY_MODE", "HOMOTOPY_STEPS",
  "HOMOTOPY_FORCE_CONTINUE", "HP_FILTER", "HP_NGRID",
  "FILTERED_THEORETICAL_MOMENTS_GRID", "HYBRID", "ONE_SIDED_HP_FILTER",
  "IDENTIFICATION", "INF_CONSTANT", "INITVAL", "INITVAL_FILE", "BOUNDS",
  "JSCALE", "INIT", "INFILE", "INVARS", "INT_NUMBER", "INV_GAMMA_PDF",
  "INV_GAMMA1_PDF", "INV_GAMMA2_PDF", "IRF", "IRF_SHOCKS",
  "IRF_PLOT_THRESHOLD", "IRF_CALIBRATION", "FAST_KALMAN_FILTER",
  "KALMAN_ALGO", "KALMAN_TOL", "DIFFUSE_KALMAN_TOL", "SCHUR_VEC_TOL",
  "SUBSAMPLES", "OPTIONS", "TOLF", "TOLX", "PLOT_INIT_DATE",
  "PLOT_END_DATE", "LAPLACE", "LIK_ALGO", "LIK_INIT", "LINEAR",
  "LINEAR_DECOMPOSITION", "LOAD_IDENT_FILES", "LOAD_MH_FILE",
  "LOAD_RESULTS_AFTER_LOAD_MH", "LOAD_PARAMS_AND_STEADY_STATE",
  "LOGLINEAR", "LOGDATA", "LYAPUNOV", "LINEAR_APPROXIMATION",
  "LYAPUNOV_COMPLEX_THRESHOLD", "LYAPUNOV_FIXED_POINT_TOL",
  "LYAPUNOV_DOUBLING_TOL", "LOG_DEFLATOR", "LOG_TREND_VAR",
  "LOG_GROWTH_FACTOR", "MATCHED_MOMENTS", "MARKOWITZ", "MARGINAL_DENSITY",
  "MAX", "MAXIT", "MFS", "MH_CONF_SIG", "MH_DROP", "MH_INIT_SCALE",
  "MH_JSCALE", "MH_TUNE_JSCALE", "MH_TUNE_GUESS",
  "MH_POSTERIOR_MODE_ESTIMATION", "MH_NBLOCKS", "MH_REPLIC", "MH_RECOVER",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_DIRECTORY",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_RECORD",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_PRIOR",
  "POSTERIOR_MAX_SUBSAMPLE_DRAWS", "MIN", "MINIMAL_SOLVING_PERIODS",
  "MODE_CHECK", "MODE_CHECK_NEIGHBOURHOOD_SIZE",
  "MODE_CHECK_SYMMETRIC_PLOTS", "MODE_CHECK_NUMBER_OF_POINTS",
  "MODE_COMPUTE", "MODE_FILE", "MODEL", "MODEL_COMPARISON", "MODEL_INFO",
  "MSHOCKS", "ABS", "SIGN", "MODEL_DIAGNOSTICS", "MODIFIEDHARMONICMEAN",
  "MOMENTS_VARENDO", "CONTEMPORANEOUS_CORRELATION", "DIFFUSE_FILTER",
  "SUB_DRAWS", "TAPER_STEPS", "GEWEKE_INTERVAL", "RAFTERY_LEWIS_QRS",
  "RAFTERY_LEWIS_DIAGNOSTICS", "MCMC_JUMPING_COVARIANCE",
  "MOMENT_CALIBRATION", "NUMBER_OF_PARTICLES", "RESAMPLING", "SYSTEMATIC",
  "GENERIC", "RESAMPLING_THRESHOLD", "RESAMPLING_METHOD", "KITAGAWA",
  "STRATIFIED", "SMOOTH", "CPF_WEIGHTS", "AMISANOTRISTANI",
  "MURRAYJONESPARSLOW", "WRITE_EQUATION_TAGS", "FILTER_INITIAL_STATE",
  "NONLINEAR_FILTER_INITIALIZATION", "FILTER_ALGORITHM",
  "PROPOSAL_APPROXIMATION", "CUBATURE", "UNSCENTED", "MONTECARLO",
  "DISTRIBUTION_APPROXIMATION", "NAME",
  "USE_PENALIZED_OBJECTIVE_FOR_HESSIAN", "INIT_STATE", "FAST_REALTIME",
  "RESCALE_PREDICTION_ERROR_COVARIANCE", "GENERATE_IRFS", "NAN_CONSTANT",
  "NO_STATIC", "NOBS", "NOCONSTANT", "NODISPLAY", "NOCORR", "NODIAGNOSTIC",
  "NOFUNCTIONS", "NO_HOMOTOPY", "NOGRAPH", "POSTERIOR_NOGRAPH",
  "POSTERIOR_GRAPH", "NOMOMENTS", "NOPRINT", "NORMAL_PDF", "SAVE_DRAWS",
  "MODEL_NAME", "STDERR_MULTIPLES", "DIAGONAL_ONLY",
  "DETERMINISTIC_TRENDS", "OBSERVATION_TRENDS", "OPTIM", "OPTIM_WEIGHTS",
  "ORDER", "OSR", "OSR_PARAMS", "MAX_DIM_COVA_GROUP", "ADVANCED",
  "OUTFILE", "OUTVARS", "OVERWRITE", "DISCOUNT", "PARALLEL_LOCAL_FILES",
  "PARAMETERS", "PARAMETER_SET", "PARTIAL_INFORMATION", "PERIODS",
  "PERIOD", "PLANNER_OBJECTIVE", "PLOT_CONDITIONAL_FORECAST",
  "PLOT_PRIORS", "PREFILTER", "PRESAMPLE", "PERFECT_FORESIGHT_SETUP",
  "PERFECT_FORESIGHT_SOLVER", "NO_POSTERIOR_KERNEL_DENSITY", "FUNCTION",
  "PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP",
  "PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER", "PRINT", "PRIOR_MC",
  "PRIOR_TRUNC", "PRIOR_MODE", "PRIOR_MEAN", "POSTERIOR_MODE",
  "POSTERIOR_MEAN", "POSTERIOR_MEDIAN", "MLE_MODE", "PRUNING",
  "PARTICLE_FILTER_OPTIONS", "QUOTED_STRING", "QZ_CRITERIUM",
  "QZ_ZERO_THRESHOLD", "DSGE_VAR", "DSGE_VARLAG", "DSGE_PRIOR_WEIGHT",
  "TRUNCATE", "PIPE_E", "PIPE_X", "PIPE_P", "RELATIVE_IRF", "REPLIC",
  "SIMUL_REPLIC", "RPLOT", "SAVE_PARAMS_AND_STEADY_STATE",
  "PARAMETER_UNCERTAINTY", "TARGETS", "SHOCKS", "HETEROSKEDASTIC_SHOCKS",
  "SHOCK_DECOMPOSITION", "SHOCK_GROUPS", "USE_SHOCK_GROUPS", "SIGMA_E",
  "SIMUL", "SIMUL_ALGO", "SIMUL_SEED", "ENDOGENOUS_TERMINAL_PERIOD",
  "SMOOTHER", "SMOOTHER2HISTVAL", "SQUARE_ROOT_SOLVER", "STACK_SOLVE_ALGO",
  "STEADY_STATE_MODEL", "SOLVE_ALGO", "SOLVER_PERIODS", "ROBUST_LIN_SOLVE",
  "STDERR", "STEADY", "STOCH_SIMUL", "SYLVESTER",
  "SYLVESTER_FIXED_POINT_TOL", "REGIMES", "REGIME",
  "REALTIME_SHOCK_DECOMPOSITION", "CONDITIONAL", "UNCONDITIONAL", "TEX",
  "RAMSEY_MODEL", "RAMSEY_POLICY", "RAMSEY_CONSTRAINTS",
  "PLANNER_DISCOUNT", "PLANNER_DISCOUNT_LATEX_NAME",
  "DISCRETIONARY_POLICY", "DISCRETIONARY_TOL",
  "EVALUATE_PLANNER_OBJECTIVE", "OCCBIN_SETUP", "OCCBIN_SOLVER",
  "OCCBIN_WRITE_REGIMES", "OCCBIN_GRAPH", "SIMUL_MAXIT",
  "LIKELIHOOD_MAXIT", "SMOOTHER_MAXIT", "SIMUL_PERIODS",
  "LIKELIHOOD_PERIODS", "SMOOTHER_PERIODS", "SIMUL_CURB_RETRENCH",
  "LIKELIHOOD_CURB_RETRENCH", "SMOOTHER_CURB_RETRENCH",
  "SIMUL_CHECK_AHEAD_PERIODS", "LIKELIHOOD_CHECK_AHEAD_PERIODS",
  "SMOOTHER_CHECK_AHEAD_PERIODS", "SIMUL_DEBUG", "SMOOTHER_DEBUG",
  "SIMUL_PERIODIC_SOLUTION", "LIKELIHOOD_PERIODIC_SOLUTION",
  "SMOOTHER_PERIODIC_SOLUTION", "LIKELIHOOD_INVERSION_FILTER",
  "SMOOTHER_INVERSION_FILTER", "FILTER_USE_RELEXATION",
  "LIKELIHOOD_PIECEWISE_KALMAN_FILTER", "SMOOTHER_PIECEWISE_KALMAN_FILTER",
  "LIKELIHOOD_MAX_KALMAN_ITERATIONS", "TEX_NAME", "TRUE", "BIND", "RELAX",
  "ERROR_BIND", "ERROR_RELAX", "UNIFORM_PDF", "UNIT_ROOT_VARS", "USE_DLL",
  "USEAUTOCORR", "GSA_SAMPLE_FILE",
  "USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED", "VALUES", "SCALES",
  "VAR", "VAREXO", "VAREXO_DET", "VARIABLE", "VAROBS", "VAREXOBS",
  "PREDETERMINED_VARIABLES", "VAR_EXPECTATION", "VAR_EXPECTATION_MODEL",
  "PLOT_SHOCK_DECOMPOSITION", "MODEL_LOCAL_VARIABLE",
  "WRITE_LATEX_DYNAMIC_MODEL", "WRITE_LATEX_STATIC_MODEL",
  "WRITE_LATEX_ORIGINAL_MODEL", "WRITE_LATEX_STEADY_STATE_MODEL",
  "XLS_SHEET", "XLS_RANGE", "LMMCP", "BANDPASS_FILTER", "COLORMAP",
  "VAR_MODEL", "PAC_MODEL", "QOQ", "YOY", "AOA", "PAC_EXPECTATION",
  "TREND_COMPONENT_MODEL", "EQUAL_EQUAL", "EXCLAMATION_EQUAL", "LESS",
  "GREATER", "LESS_EQUAL", "GREATER_EQUAL", "PLUS", "MINUS", "TIMES",
  "DIVIDE", "UNARY", "POWER", "EXP", "LOG", "LN", "LOG10", "SIN", "COS",
  "TAN", "ASIN", "ACOS", "ATAN", "ERF", "DIFF", "ADL",
  "AUXILIARY_MODEL_NAME", "SQRT", "CBRT", "NORMCDF", "NORMPDF",
  "STEADY_STATE", "EXPECTATION", "DYNARE_SENSITIVITY", "MORRIS", "STAB",
  "REDFORM", "PPRIOR", "PRIOR_RANGE", "PPOST", "ILPTAU", "MORRIS_NLIV",
  "MORRIS_NTRA", "NSAM", "LOAD_REDFORM", "LOAD_RMSE", "LOAD_STAB",
  "ALPHA2_STAB", "LOGTRANS_REDFORM", "THRESHOLD_REDFORM", "KSSTAT_REDFORM",
  "ALPHA2_REDFORM", "NAMENDO", "NAMLAGENDO", "NAMEXO", "RMSE", "LIK_ONLY",
  "VAR_RMSE", "PFILT_RMSE", "ISTART_RMSE", "ALPHA_RMSE", "ALPHA2_RMSE",
  "FREQ", "INITIAL_YEAR", "INITIAL_SUBPERIOD", "FINAL_YEAR",
  "FINAL_SUBPERIOD", "DATA", "VLIST", "VLISTLOG", "VLISTPER",
  "SPECTRAL_DENSITY", "INIT2SHOCKS", "RESTRICTION", "RESTRICTION_FNAME",
  "CROSS_RESTRICTIONS", "NLAGS", "CONTEMP_REDUCED_FORM",
  "REAL_PSEUDO_FORECAST", "DUMMY_OBS", "NSTATES", "INDXSCALESSTATES",
  "NO_BAYESIAN_PRIOR", "SPECIFICATION", "SIMS_ZHA", "ALPHA", "BETA",
  "ABAND", "NINV", "CMS", "NCMS", "CNUM", "GAMMA", "INV_GAMMA",
  "INV_GAMMA1", "INV_GAMMA2", "NORMAL", "UNIFORM", "EPS", "PDF", "FIG",
  "DR", "NONE", "PRIOR", "PRIOR_VARIANCE", "HESSIAN", "IDENTITY_MATRIX",
  "DIRICHLET", "DIAGONAL", "OPTIMAL", "GSIG2_LMDM", "Q_DIAG", "FLAT_PRIOR",
  "NCSK", "NSTD", "WEIBULL", "WEIBULL_PDF", "GMM", "SMM", "INDXPARR",
  "INDXOVR", "INDXAP", "APBAND", "INDXIMF", "INDXFORE", "FOREBAND",
  "INDXGFOREHAT", "INDXGIMFHAT", "INDXESTIMA", "INDXGDLS", "EQ_MS",
  "FILTER_COVARIANCE", "FILTER_DECOMPOSITION",
  "SMOOTHED_STATE_UNCERTAINTY", "SMOOTHER_REDUX", "EQ_CMS", "TLINDX",
  "TLNUMBER", "RESTRICTIONS", "POSTERIOR_SAMPLER_OPTIONS",
  "OUTPUT_FILE_TAG", "HORIZON", "SBVAR", "TREND_VAR", "DEFLATOR",
  "GROWTH_FACTOR", "MS_IRF", "MS_VARIANCE_DECOMPOSITION", "GROWTH",
  "MS_ESTIMATION", "MS_SIMULATION", "MS_COMPUTE_MDD",
  "MS_COMPUTE_PROBABILITIES", "MS_FORECAST", "SVAR_IDENTIFICATION",
  "EQUATION", "EXCLUSION", "LAG", "UPPER_CHOLESKY", "LOWER_CHOLESKY",
  "MONTHLY", "QUARTERLY", "MARKOV_SWITCHING", "CHAIN", "DURATION",
  "NUMBER_OF_REGIMES", "NUMBER_OF_LAGS", "EPILOGUE", "SVAR",
  "SVAR_GLOBAL_IDENTIFICATION_CHECK", "COEFF", "COEFFICIENTS", "VARIANCES",
  "CONSTANTS", "EQUATIONS", "EXTERNAL_FUNCTION", "EXT_FUNC_NAME",
  "EXT_FUNC_NARGS", "FIRST_DERIV_PROVIDED", "SECOND_DERIV_PROVIDED",
  "SELECTED_VARIABLES_ONLY", "COVA_COMPUTE", "SIMULATION_FILE_TAG",
  "FILE_TAG", "NO_ERROR_BANDS", "ERROR_BAND_PERCENTILES",
  "SHOCKS_PER_PARAMETER", "NO_CREATE_INIT", "SHOCK_DRAWS",
  "FREE_PARAMETERS", "MEDIAN", "DATA_OBS_NBR", "NEIGHBORHOOD_WIDTH",
  "PVALUE_KS", "PVALUE_CORR", "FILTERED_PROBABILITIES",
  "REAL_TIME_SMOOTHED", "PRIOR_FUNCTION", "POSTERIOR_FUNCTION",
  "SAMPLING_DRAWS", "PROPOSAL_TYPE", "PROPOSAL_UPPER_BOUND",
  "PROPOSAL_LOWER_BOUND", "PROPOSAL_DRAWS", "USE_MEAN_CENTER",
  "ADAPTIVE_MH_DRAWS", "THINNING_FACTOR",
  "COEFFICIENTS_PRIOR_HYPERPARAMETERS", "CONVERGENCE_STARTING_VALUE",
  "CONVERGENCE_ENDING_VALUE", "CONVERGENCE_INCREMENT_VALUE",
  "MAX_ITERATIONS_STARTING_VALUE", "MAX_ITERATIONS_INCREMENT_VALUE",
  "MAX_BLOCK_ITERATIONS", "MAX_REPEATED_OPTIMIZATION_RUNS",
  "FUNCTION_CONVERGENCE_CRITERION", "SAVE_REALTIME",
  "PARAMETER_CONVERGENCE_CRITERION", "NUMBER_OF_LARGE_PERTURBATIONS",
  "NUMBER_OF_SMALL_PERTURBATIONS",
  "NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION", "MAX_NUMBER_OF_STAGES",
  "RANDOM_FUNCTION_CONVERGENCE_CRITERION",
  "RANDOM_PARAMETER_CONVERGENCE_CRITERION",
  "NO_INIT_ESTIMATION_CHECK_FIRST_OBS", "HETEROSKEDASTIC_FILTER",
  "TIME_SHIFT", "STRUCTURAL", "TERMINAL_STEADY_STATE_AS_GUESS_VALUE",
  "SURPRISE", "OCCBIN_CONSTRAINTS", "METHOD_OF_MOMENTS", "MOM_METHOD",
  "BARTLETT_KERNEL_LAG", "WEIGHTING_MATRIX",
  "WEIGHTING_MATRIX_SCALING_FACTOR", "ANALYTIC_STANDARD_ERRORS",
  "ANALYTIC_JACOBIAN", "PENALIZED_ESTIMATOR", "VERBOSE",
  "SIMULATION_MULTIPLE", "MOM_SEED", "SEED", "BOUNDED_SHOCK_SUPPORT",
  "ADDITIONAL_OPTIMIZER_STEPS", "MOM_SE_TOLX", "SE_TOLX", "MOM_BURNIN",
  "BURNIN", "EQTAGS", "ANALYTICAL_GIRF", "IRF_IN_PERCENT", "EMAS_GIRF",
  "EMAS_DROP", "EMAS_TOLF", "EMAS_MAX_ITER", "NO_IDENTIFICATION_STRENGTH",
  "NO_IDENTIFICATION_REDUCEDFORM", "NO_IDENTIFICATION_MOMENTS",
  "NO_IDENTIFICATION_MINIMAL", "NO_IDENTIFICATION_SPECTRUM",
  "NORMALIZE_JACOBIANS", "GRID_NBR", "TOL_RANK", "TOL_DERIV", "TOL_SV",
  "CHECKS_VIA_SUBSETS", "MAX_DIM_SUBSETS_GROUPS", "ZERO_MOMENTS_TOLERANCE",
  "MAX_NROWS", "SQUEEZE_SHOCK_DECOMPOSITION", "WITH_EPILOGUE",
  "SYMBOL_VEC", "';'", "'('", "')'", "'['", "']'", "'#'", "':'", "'.'",
  "$accept", "statement_list", "statement", "dsample", "rplot",
  "trend_var", "$@1", "trend_var_list", "log_trend_var", "$@2",
  "log_trend_var_list", "var", "$@3", "$@4", "var_model",
  "var_model_options_list", "var_model_options", "trend_component_model",
  "trend_component_model_options_list", "trend_component_model_options",
  "pac_model", "$@5", "pac_model_options_list", "pac_model_options",
  "var_expectation_model", "var_expectation_model_options_list",
  "var_expectation_model_option", "$@6", "nonstationary_var_list",
  "varexo", "varexo_det", "predetermined_variables", "parameters",
  "model_local_variable", "named_var_elem", "named_var_1", "named_var",
  "var_list", "varexo_list", "varexo_det_list", "parameter_list",
  "predetermined_variables_list", "model_local_variable_list",
  "change_type", "change_type_arg", "change_type_var_list", "periods",
  "init_param", "expression", "$@7", "comma_expression",
  "expression_or_empty", "initval", "histval_file", "initval_file",
  "h_options_list", "h_options", "endval", "initval_list", "initval_elem",
  "histval", "histval_list", "histval_elem", "epilogue", "$@8",
  "epilogue_equation_list", "epilogue_equation", "$@9",
  "compilation_setup", "compilation_setup_options_list",
  "compilation_setup_option", "matched_moments", "$@10",
  "matched_moments_list", "occbin_constraints", "$@11",
  "occbin_constraints_regimes_list", "occbin_constraints_regime",
  "occbin_constraints_regime_options_list",
  "occbin_constraints_regime_option", "model_options",
  "model_options_list", "model", "$@12", "$@13", "equation_list",
  "equation", "tags_list", "tag_pair", "hand_side", "$@14",
  "comma_hand_side", "pound_expression", "shocks", "shock_list",
  "shock_elem", "det_shock_elem", "surprise_shock_list",
  "heteroskedastic_shocks", "heteroskedastic_shock_list",
  "heteroskedastic_shock_elem", "svar_identification", "$@15",
  "svar_identification_list", "svar_identification_elem", "$@16", "$@17",
  "svar_equation_list", "svar_var_list", "restriction_expression",
  "restriction_expression_1", "restriction_elem_expression",
  "svar_global_identification_check", "markov_switching",
  "ms_options_list", "ms_options", "svar", "svar_options_list",
  "svar_options", "mshocks", "mshock_list", "period_list", "sigma_e",
  "value_list", "triangular_matrix", "triangular_row", "steady",
  "steady_options_list", "steady_options", "check", "check_options_list",
  "check_options", "model_info", "model_info_options_list",
  "model_info_options", "perfect_foresight_setup",
  "perfect_foresight_setup_options_list",
  "perfect_foresight_setup_options", "perfect_foresight_solver",
  "perfect_foresight_solver_options_list",
  "perfect_foresight_solver_options",
  "perfect_foresight_with_expectation_errors_setup",
  "perfect_foresight_with_expectation_errors_setup_options_list",
  "perfect_foresight_with_expectation_errors_setup_options",
  "perfect_foresight_with_expectation_errors_solver",
  "perfect_foresight_with_expectation_errors_solver_options_list",
  "perfect_foresight_with_expectation_errors_solver_options",
  "method_of_moments", "method_of_moments_options_list",
  "method_of_moments_option", "prior_function", "posterior_function",
  "prior_posterior_function_options_list",
  "prior_posterior_function_options", "simul", "simul_options_list",
  "simul_options", "external_function", "external_function_options_list",
  "external_function_options", "stoch_simul", "stoch_simul_options_list",
  "stoch_simul_primary_options", "stoch_simul_options", "symbol_list",
  "symbol_list_ext", "signed_integer", "non_negative_number",
  "signed_number", "signed_inf", "signed_number_w_inf", "boolean",
  "estimated_params", "estimated_list", "estimated_elem",
  "estimated_elem1", "estimated_elem2", "estimated_elem3",
  "estimated_params_init", "estimated_init_list", "estimated_init_elem",
  "estimated_params_bounds", "estimated_bounds_list",
  "estimated_bounds_elem", "osr_params_bounds", "osr_bounds_list",
  "osr_bounds_elem", "prior_distribution", "prior_pdf", "date_str",
  "date_expr", "set_time", "data", "data_options_list", "data_options",
  "subsamples", "subsamples_eq", "subsamples_eq_opt",
  "subsamples_name_list", "prior", "$@18", "$@19", "$@20", "$@21", "$@22",
  "$@23", "$@24", "prior_options_list", "prior_options",
  "joint_prior_options_list", "joint_prior_options", "prior_eq",
  "prior_eq_opt", "options", "options_options_list", "options_options",
  "options_eq", "options_eq_opt", "estimation", "estimation_options_list",
  "estimation_options", "name_value_pair", "name_value_pair_list",
  "name_value_pair_with_boolean", "name_value_pair_with_boolean_list",
  "name_value_pair_with_suboptions",
  "name_value_pair_with_suboptions_list", "varobs", "$@25", "varobs_list",
  "varexobs", "$@26", "varexobs_list", "deterministic_trends",
  "observation_trends", "trend_list", "trend_element",
  "filter_initial_state", "filter_initial_state_list",
  "filter_initial_state_element", "unit_root_vars", "optim_weights",
  "optim_weights_list", "osr_params", "osr_options_list", "osr_options",
  "osr", "dynatype", "dynasave", "load_params_and_steady_state",
  "save_params_and_steady_state", "identification",
  "identification_options_list", "identification_option",
  "model_comparison", "filename", "namespace_qualified_symbol",
  "namespace_qualified_filename", "parallel_local_filename_list",
  "mc_filename_list", "planner_objective", "$@27", "$@28", "ramsey_model",
  "ramsey_policy", "ramsey_constraints", "ramsey_constraints_list",
  "ramsey_constraint", "evaluate_planner_objective", "occbin_setup",
  "occbin_setup_options_list", "occbin_setup_option", "occbin_solver",
  "occbin_solver_options_list", "occbin_solver_option",
  "occbin_write_regimes", "occbin_write_regimes_options_list",
  "occbin_write_regimes_option", "occbin_graph",
  "occbin_graph_options_list", "occbin_graph_option",
  "discretionary_policy", "discretionary_policy_options_list",
  "discretionary_policy_options", "ramsey_model_options_list",
  "ramsey_model_options", "ramsey_policy_options_list",
  "ramsey_policy_options", "write_latex_dynamic_model",
  "write_latex_static_model", "write_latex_original_model",
  "write_latex_steady_state_model", "shock_decomposition",
  "realtime_shock_decomposition", "plot_shock_decomposition",
  "initial_condition_decomposition", "squeeze_shock_decomposition",
  "bvar_prior_option", "bvar_common_option", "bvar_density_options_list",
  "bvar_density", "bvar_forecast_option", "bvar_forecast_options_list",
  "bvar_forecast", "sbvar_option", "sbvar_options_list", "sbvar",
  "ms_variance_decomposition_option",
  "ms_variance_decomposition_options_list", "ms_variance_decomposition",
  "ms_forecast_option", "ms_forecast_options_list", "ms_forecast",
  "ms_irf_option", "ms_irf_options_list", "ms_irf",
  "ms_compute_probabilities_option",
  "ms_compute_probabilities_options_list", "ms_compute_probabilities",
  "ms_compute_mdd_option", "ms_compute_mdd_options_list", "ms_compute_mdd",
  "ms_simulation_option", "ms_simulation_options_list", "ms_simulation",
  "ms_estimation_option", "ms_estimation_options_list", "ms_estimation",
  "dynare_sensitivity", "dynare_sensitivity_options_list",
  "dynare_sensitivity_option", "shock_decomposition_options_list",
  "shock_decomposition_option",
  "realtime_shock_decomposition_options_list",
  "realtime_shock_decomposition_option",
  "plot_shock_decomposition_options_list",
  "plot_shock_decomposition_option",
  "initial_condition_decomposition_options_list",
  "initial_condition_decomposition_option", "homotopy_setup",
  "homotopy_list", "homotopy_item", "forecast", "forecast_options",
  "forecast_option", "conditional_forecast",
  "conditional_forecast_options", "conditional_forecast_option",
  "plot_conditional_forecast", "conditional_forecast_paths",
  "conditional_forecast_paths_shock_list",
  "conditional_forecast_paths_shock_elem", "steady_state_model", "$@29",
  "steady_state_equation_list", "steady_state_equation", "calib_smoother",
  "calib_smoother_options_list", "calib_smoother_option", "generate_irfs",
  "generate_irfs_options_list", "generate_irfs_option",
  "generate_irfs_element_list", "generate_irfs_element",
  "generate_irfs_exog_element_list", "extended_path",
  "extended_path_options_list", "extended_path_option",
  "model_diagnostics", "calibration_range", "moment_calibration",
  "moment_calibration_list", "moment_calibration_item", "irf_calibration",
  "irf_calibration_list", "irf_calibration_item", "smoother2histval",
  "smoother2histval_options_list", "smoother2histval_option",
  "shock_groups", "shock_group_list", "shock_group_element",
  "shock_name_list", "init2shocks", "init2shocks_list",
  "init2shocks_element", "o_dr_algo", "o_solve_algo", "o_simul_algo",
  "o_stack_solve_algo", "o_robust_lin_solve",
  "o_endogenous_terminal_period", "o_linear", "o_order", "o_replic",
  "o_drop", "o_ar", "o_nocorr", "o_nofunctions", "o_nomoments", "o_irf",
  "o_irf_shocks", "o_hp_filter", "o_hp_ngrid",
  "o_filtered_theoretical_moments_grid", "o_one_sided_hp_filter",
  "o_periods", "o_solver_periods", "o_extended_path_order", "o_hybrid",
  "o_steady_maxit", "o_simul_maxit", "o_bandpass_filter", "o_dp_maxit",
  "o_osr_maxit", "o_osr_tolf", "o_pf_tolf", "o_pf_tolx", "o_steady_tolf",
  "o_opt_algo", "o_cutoff", "o_markowitz", "o_minimal_solving_periods",
  "o_mfs", "o_simul", "o_simul_replic", "o_simul_seed", "o_qz_criterium",
  "o_qz_zero_threshold", "o_file", "o_pac_name", "o_pac_aux_model_name",
  "o_pac_discount", "o_pac_growth", "$@30", "o_var_name", "o_series",
  "o_datafile", "o_filename", "o_var_eq_tags", "o_var_structural",
  "o_dirname", "o_huge_number", "o_nobs", "o_trend_component_model_name",
  "o_trend_component_model_targets", "o_trend_component_model_eq_tags",
  "o_conditional_variance_decomposition", "o_est_first_obs",
  "o_posterior_sampling_method", "o_first_obs", "o_data_first_obs",
  "o_first_simulation_period", "o_date_first_simulation_period",
  "o_last_obs", "o_data_last_obs",
  "o_keep_kalman_algo_if_singularity_is_detected", "o_data_nobs",
  "o_shift", "o_shape", "o_mode", "o_mean", "o_mean_vec", "o_truncate",
  "o_stdev", "o_jscale", "o_init", "o_bounds", "o_domain", "o_interval",
  "o_variance", "o_variance_mat", "o_prefilter", "o_presample",
  "o_lik_algo", "o_lik_init", "o_nograph", "o_posterior_nograph",
  "o_psd_nograph", "o_shock_decomposition_nograph", "o_init_state",
  "o_forecast_type", "o_shock_decomposition_presample",
  "o_shock_decomposition_forecast", "o_save_realtime", "o_fast_realtime",
  "o_nodisplay", "o_icd_nodisplay", "o_psd_nodisplay", "o_psd_init2shocks",
  "o_icd_max_nrows", "o_psd_max_nrows", "o_graph_format",
  "o_icd_graph_format", "o_psd_graph_format",
  "o_shock_decomposition_with_epilogue", "o_icd_with_epilogue",
  "allowed_graph_formats", "list_allowed_graph_formats",
  "o_subsample_name", "o_bvar_conf_sig", "o_forecasts_conf_sig",
  "o_conditional_forecast_conf_sig", "o_mh_conf_sig", "o_mh_replic",
  "o_posterior_max_subsample_draws", "o_mh_drop", "o_mh_jscale",
  "o_mh_tune_jscale", "o_mh_tune_guess", "o_optim",
  "o_posterior_sampler_options", "o_proposal_distribution",
  "o_no_posterior_kernel_density", "o_mh_init_scale", "o_mode_file",
  "o_mode_compute", "o_mode_check", "o_mode_check_neighbourhood_size",
  "o_mode_check_number_of_points", "o_mode_check_symmetric_plots",
  "o_prior_trunc", "o_mh_posterior_mode_estimation", "o_mh_nblocks",
  "o_load_mh_file", "o_load_results_after_load_mh", "o_loglinear",
  "o_linear_approximation", "o_logdata", "o_nodiagnostic",
  "o_bayesian_irf", "o_dsge_var", "o_dsge_varlag", "o_tex", "o_forecast",
  "o_smoother", "o_moments_varendo", "o_contemporaneous_correlation",
  "o_filtered_vars", "o_relative_irf", "o_fast_kalman_filter",
  "o_kalman_algo", "o_kalman_tol", "o_diffuse_kalman_tol",
  "o_schur_vec_tol", "o_marginal_density", "o_print", "o_noprint",
  "o_xls_sheet", "o_xls_range", "o_filter_step_ahead", "o_taper_steps",
  "o_geweke_interval", "o_raftery_lewis_diagnostics",
  "o_raftery_lewis_qrs", "o_constant", "o_noconstant", "o_mh_recover",
  "o_mh_initialize_from_previous_mcmc",
  "o_mh_initialize_from_previous_mcmc_directory",
  "o_mh_initialize_from_previous_mcmc_record",
  "o_mh_initialize_from_previous_mcmc_prior", "o_diffuse_filter",
  "o_plot_priors", "o_aim_solver", "o_partial_information", "o_sub_draws",
  "o_planner_discount", "o_planner_discount_latex_name", "o_sylvester",
  "o_sylvester_fixed_point_tol", "o_lyapunov",
  "o_lyapunov_complex_threshold", "o_lyapunov_fixed_point_tol",
  "o_lyapunov_doubling_tol", "o_dr", "o_dr_cycle_reduction_tol",
  "o_dr_logarithmic_reduction_tol", "o_dr_logarithmic_reduction_maxiter",
  "o_psd_detail_plot", "o_icd_detail_plot", "o_psd_interactive",
  "o_psd_screen_shocks", "o_psd_steadystate", "o_icd_steadystate",
  "o_icd_fig_name", "o_psd_fig_name", "o_psd_type", "o_icd_type",
  "o_icd_plot_init_date", "o_icd_plot_end_date", "o_psd_plot_init_date",
  "o_psd_plot_end_date", "o_icd_write_xls", "o_psd_write_xls",
  "o_psd_realtime", "o_psd_vintage", "o_psd_diff", "o_icd_diff",
  "o_psd_flip", "o_icd_flip", "o_bvar_prior_tau", "o_bvar_prior_decay",
  "o_bvar_prior_lambda", "o_bvar_prior_mu", "o_bvar_prior_omega",
  "o_bvar_prior_flat", "o_bvar_prior_train", "o_bvar_replic",
  "o_stderr_multiples", "o_diagonal_only", "o_number_of_particles",
  "o_particle_filter_options", "o_resampling", "o_resampling_threshold",
  "o_resampling_method", "o_cpf_weights", "o_filter_algorithm",
  "o_nonlinear_filter_initialization", "o_proposal_approximation",
  "o_distribution_approximation", "o_gsa_identification", "o_gsa_morris",
  "o_gsa_stab", "o_gsa_redform", "o_gsa_pprior", "o_gsa_prior_range",
  "o_gsa_ppost", "o_gsa_ilptau", "o_gsa_morris_nliv", "o_gsa_morris_ntra",
  "o_gsa_nsam", "o_gsa_load_redform", "o_gsa_load_rmse", "o_gsa_load_stab",
  "o_gsa_alpha2_stab", "o_gsa_logtrans_redform", "o_gsa_threshold_redform",
  "o_gsa_ksstat_redform", "o_gsa_alpha2_redform", "o_gsa_namendo",
  "o_gsa_namlagendo", "o_gsa_namexo", "o_gsa_rmse", "o_gsa_lik_only",
  "o_gsa_var_rmse", "o_gsa_pfilt_rmse", "o_gsa_istart_rmse",
  "o_gsa_alpha_rmse", "o_gsa_alpha2_rmse", "o_gsa_sample_file",
  "o_gsa_neighborhood_width", "o_gsa_pvalue_ks", "o_gsa_pvalue_corr",
  "o_load_ident_files", "o_useautocorr", "o_prior_mc", "o_advanced",
  "o_max_dim_cova_group", "o_homotopy_mode", "o_homotopy_steps",
  "o_homotopy_force_continue", "o_nocheck", "o_controlled_varexo",
  "o_parameter_set", "o_nodecomposition", "o_spectral_density",
  "o_ms_drop", "o_ms_mh_replic", "o_freq", "o_initial_year",
  "o_initial_subperiod", "o_final_year", "o_final_subperiod", "o_data",
  "o_vlist", "o_vlistlog", "o_vlistper", "o_restriction_fname", "o_nlags",
  "o_cross_restrictions", "o_contemp_reduced_form",
  "o_real_pseudo_forecast", "o_no_bayesian_prior", "o_dummy_obs",
  "o_nstates", "o_indxscalesstates", "o_alpha", "o_beta", "o_gsig2_lmdm",
  "o_specification", "o_q_diag", "o_flat_prior", "o_ncsk", "o_nstd",
  "o_ninv", "o_indxparr", "o_indxovr", "o_aband", "o_indxap", "o_apband",
  "o_indximf", "o_indxfore", "o_foreband", "o_indxgforhat",
  "o_indxgimfhat", "o_indxestima", "o_indxgdls", "o_eq_ms", "o_cms",
  "o_ncms", "o_eq_cms", "o_tlindx", "o_tlnumber", "o_cnum",
  "o_k_order_solver", "o_pruning", "o_chain", "o_restrictions",
  "o_duration", "o_number_of_regimes", "o_number_of_lags", "o_parameters",
  "o_coefficients", "o_variances", "o_equations", "o_silent_optimizer",
  "o_instruments", "o_ext_func_name", "o_ext_func_nargs",
  "o_first_deriv_provided", "o_second_deriv_provided",
  "o_filter_covariance", "o_filter_decomposition",
  "o_smoothed_state_uncertainty", "o_smoother_redux",
  "o_selected_variables_only", "o_cova_compute", "o_output_file_tag",
  "o_file_tag", "o_no_create_init", "o_simulation_file_tag",
  "o_coefficients_prior_hyperparameters", "o_convergence_starting_value",
  "o_convergence_ending_value", "o_convergence_increment_value",
  "o_max_iterations_starting_value", "o_max_iterations_increment_value",
  "o_max_block_iterations", "o_max_repeated_optimization_runs",
  "o_function_convergence_criterion", "o_parameter_convergence_criterion",
  "o_number_of_large_perturbations", "o_number_of_small_perturbations",
  "o_number_of_posterior_draws_after_perturbation",
  "o_max_number_of_stages", "o_random_function_convergence_criterion",
  "o_random_parameter_convergence_criterion", "o_thinning_factor",
  "o_adaptive_mh_draws", "o_save_draws", "o_proposal_draws",
  "o_use_mean_center", "o_proposal_type", "o_proposal_lower_bound",
  "o_proposal_upper_bound", "o_parameter_uncertainty", "o_horizon",
  "o_filtered_probabilities", "o_real_time_smoothed", "o_no_error_bands",
  "o_error_band_percentiles", "o_shock_draws", "o_shocks_per_parameter",
  "o_free_parameters", "o_median", "o_regimes", "o_regime",
  "o_data_obs_nbr", "o_discretionary_tol", "o_analytic_derivation",
  "o_analytic_derivation_mode", "o_endogenous_prior",
  "o_use_univariate_filters_if_singularity_is_detected",
  "o_mcmc_jumping_covariance", "o_rescale_prediction_error_covariance",
  "o_use_penalized_objective_for_hessian", "o_irf_plot_threshold",
  "o_dr_display_tol", "o_consider_all_endogenous",
  "o_consider_all_endogenous_and_auxiliary", "o_consider_only_observed",
  "o_no_homotopy", "o_infile", "o_invars", "o_period", "o_outfile",
  "o_outvars", "o_lmmcp", "o_function", "o_sampling_draws",
  "o_use_shock_groups", "o_colormap", "o_icd_colormap",
  "o_no_init_estimation_check_first_obs", "o_heteroskedastic_filter",
  "o_pfwee_terminal_steady_state_as_guess_value", "o_bartlett_kernel_lag",
  "o_weighting_matrix", "o_weighting_matrix_scaling_factor",
  "o_analytic_standard_errors", "o_analytic_jacobian", "o_mom_method",
  "o_penalized_estimator", "o_verbose", "o_simulation_multiple",
  "o_mom_burnin", "o_bounded_shock_support", "o_mom_seed",
  "o_additional_optimizer_steps", "o_mom_se_tolx", "o_analytical_girf",
  "o_irf_in_percent", "o_emas_girf", "o_emas_drop", "o_emas_tolf",
  "o_emas_max_iter", "o_no_identification_strength",
  "o_no_identification_reducedform", "o_no_identification_moments",
  "o_no_identification_minimal", "o_no_identification_spectrum",
  "o_normalize_jacobians", "o_grid_nbr", "o_tol_rank", "o_tol_deriv",
  "o_tol_sv", "o_checks_via_subsets", "o_max_dim_subsets_groups",
  "o_zero_moments_tolerance", "o_occbin_simul_maxit",
  "o_occbin_simul_periods", "o_occbin_simul_curb_retrench",
  "o_occbin_simul_check_ahead_periods", "o_occbin_simul_debug",
  "o_occbin_simul_periodic_solution",
  "o_occbin_likelihood_inversion_filter",
  "o_occbin_likelihood_piecewise_kalman_filter",
  "o_occbin_likelihood_maxit", "o_occbin_likelihood_periods",
  "o_occbin_likelihood_curb_retrench",
  "o_occbin_likelihood_check_ahead_periods",
  "o_occbin_likelihood_periodic_solution",
  "o_occbin_likelihood_max_kalman_iterations",
  "o_occbin_smoother_inversion_filter",
  "o_occbin_smoother_piecewise_kalman_filter", "o_occbin_smoother_maxit",
  "o_occbin_smoother_periods", "o_occbin_smoother_curb_retrench",
  "o_occbin_smoother_check_ahead_periods", "o_occbin_smoother_debug",
  "o_occbin_smoother_periodic_solution", "o_occbin_filter_use_relaxation",
  "o_occbin_write_regimes_periods", "o_occbin_write_regimes_filename",
  "o_occbin_write_regimes_smoother", "o_occbin_write_regimes_simul",
  "o_occbin_graph_noconstant", "range", "integer_range",
  "integer_range_w_inf", "signed_integer_range", "vec_int_number",
  "vec_int_elem", "vec_int_1", "vec_int", "vec_str_1", "vec_str",
  "vec_value_1", "vec_value", "vec_value_list", "vec_of_vec_value",
  "vec_value_1_w_inf", "vec_value_w_inf", "symbol", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   220,   220,   221,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   347,   349,   353,   355,   355,
     359,   361,   363,   365,   367,   369,   373,   373,   377,   379,
     381,   383,   385,   387,   391,   392,   392,   394,   394,   398,
     401,   402,   405,   406,   407,   410,   413,   414,   417,   418,
     419,   422,   422,   424,   425,   428,   429,   430,   431,   434,
     438,   439,   443,   445,   445,   450,   452,   454,   456,   458,
     460,   464,   466,   468,   470,   472,   474,   476,   478,   480,
     482,   484,   486,   490,   493,   495,   497,   500,   502,   505,
     507,   509,   514,   521,   522,   525,   527,   529,   531,   533,
     535,   537,   539,   541,   543,   545,   547,   551,   553,   555,
     557,   559,   561,   563,   565,   567,   569,   571,   573,   577,
     579,   581,   583,   585,   587,   589,   591,   593,   595,   597,
     599,   603,   605,   607,   609,   611,   613,   615,   617,   619,
     621,   623,   625,   629,   631,   633,   637,   639,   641,   643,
     645,   647,   651,   655,   657,   659,   661,   665,   667,   672,
     679,   681,   685,   687,   689,   691,   693,   695,   697,   699,
     701,   703,   705,   707,   709,   711,   713,   715,   717,   719,
     721,   723,   725,   727,   729,   731,   733,   735,   737,   739,
     741,   743,   745,   747,   749,   751,   751,   753,   755,   757,
     759,   761,   763,   765,   769,   771,   775,   777,   780,   782,
     786,   789,   792,   793,   796,   797,   798,   799,   800,   801,
     802,   803,   804,   805,   808,   810,   814,   815,   818,   820,
     822,   826,   827,   830,   832,   832,   836,   837,   840,   840,
     844,   846,   847,   850,   852,   854,   856,   858,   862,   862,
     866,   868,   875,   875,   880,   882,   889,   907,   909,   916,
     918,   920,   922,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   939,   940,   943,   943,   945,   945,
     949,   950,   951,   952,   955,   957,   959,   961,   965,   966,
     969,   971,   975,   977,   979,   981,   983,   985,   987,   989,
     991,   993,   995,   997,   999,  1001,  1003,  1005,  1007,  1009,
    1011,  1013,  1015,  1017,  1019,  1021,  1023,  1025,  1027,  1029,
    1031,  1033,  1035,  1037,  1039,  1041,  1043,  1045,  1047,  1049,
    1051,  1053,  1055,  1057,  1059,  1059,  1061,  1063,  1065,  1067,
    1069,  1071,  1075,  1077,  1081,  1084,  1085,  1086,  1087,  1088,
    1089,  1092,  1093,  1096,  1097,  1099,  1101,  1103,  1107,  1111,
    1112,  1115,  1117,  1119,  1123,  1124,  1127,  1129,  1133,  1133,
    1137,  1138,  1141,  1143,  1146,  1148,  1145,  1150,  1152,  1156,
    1158,  1162,  1164,  1168,  1169,  1172,  1173,  1176,  1178,  1180,
    1182,  1186,  1190,  1194,  1195,  1198,  1199,  1200,  1201,  1202,
    1203,  1206,  1210,  1211,  1214,  1215,  1216,  1217,  1220,  1221,
    1224,  1225,  1228,  1234,  1240,  1248,  1256,  1263,  1270,  1272,
    1277,  1282,  1284,  1291,  1298,  1306,  1308,  1312,  1314,  1316,
    1318,  1320,  1322,  1326,  1328,  1332,  1333,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1346,  1348,  1352,  1353,  1356,
    1357,  1360,  1362,  1366,  1367,  1369,  1371,  1373,  1377,  1378,
    1381,  1382,  1385,  1387,  1391,  1392,  1395,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1411,  1413,  1417,  1418,  1421,  1422,  1425,  1427,  1431,  1432,
    1435,  1436,  1439,  1441,  1445,  1446,  1449,  1450,  1451,  1452,
    1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460,  1461,  1462,
    1463,  1464,  1465,  1466,  1467,  1468,  1469,  1470,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,  1481,  1482,
    1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,  1492,
    1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,  1502,
    1503,  1506,  1510,  1514,  1515,  1518,  1519,  1522,  1524,  1528,
    1529,  1532,  1533,  1536,  1540,  1541,  1544,  1545,  1546,  1547,
    1550,  1552,  1554,  1556,  1560,  1561,  1564,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1616,  1617,  1618,  1619,
    1620,  1621,  1624,  1626,  1628,  1632,  1633,  1637,  1639,  1644,
    1647,  1648,  1651,  1653,  1658,  1661,  1663,  1665,  1669,  1670,
    1673,  1674,  1677,  1679,  1681,  1685,  1686,  1688,  1693,  1698,
    1704,  1711,  1715,  1720,  1727,  1731,  1739,  1744,  1750,  1757,
    1767,  1769,  1771,  1775,  1777,  1781,  1787,  1794,  1802,  1805,
    1807,  1811,  1818,  1826,  1835,  1838,  1840,  1844,  1852,  1854,
    1856,  1858,  1860,  1862,  1864,  1866,  1868,  1872,  1874,  1876,
    1878,  1880,  1882,  1884,  1886,  1890,  1892,  1893,  1897,  1901,
    1905,  1906,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1918,
    1922,  1926,  1928,  1930,  1934,  1935,  1938,  1938,  1940,  1940,
    1942,  1942,  1944,  1944,  1946,  1946,  1948,  1948,  1950,  1950,
    1954,  1955,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1970,  1971,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1986,  1991,  1993,  1995,  1997,  1999,
    2001,  2005,  2007,  2009,  2011,  2013,  2015,  2019,  2020,  2023,
    2024,  2025,  2028,  2033,  2035,  2037,  2039,  2041,  2043,  2047,
    2049,  2051,  2053,  2057,  2058,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,  2154,  2155,
    2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,  2165,
    2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,  2175,
    2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,
    2186,  2187,  2188,  2189,  2192,  2194,  2198,  2199,  2203,  2204,
    2208,  2209,  2214,  2215,  2226,  2230,  2231,  2235,  2235,  2237,
    2239,  2241,  2245,  2245,  2247,  2249,  2251,  2255,  2256,  2258,
    2259,  2262,  2264,  2266,  2267,  2270,  2272,  2274,  2276,  2278,
    2280,  2282,  2286,  2289,  2290,  2293,  2294,  2295,  2296,  2297,
    2298,  2299,  2302,  2304,  2306,  2308,  2312,  2314,  2318,  2320,
    2324,  2328,  2332,  2334,  2338,  2339,  2342,  2343,  2344,  2345,
    2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,
    2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,
    2376,  2377,  2380,  2382,  2386,  2387,  2390,  2391,  2395,  2396,
    2399,  2401,  2405,  2407,  2409,  2411,  2413,  2415,  2419,  2420,
    2419,  2422,  2424,  2428,  2430,  2432,  2434,  2438,  2442,  2443,
    2446,  2448,  2450,  2452,  2456,  2460,  2462,  2465,  2466,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,  2494,  2496,  2498,  2501,  2502,  2505,  2506,  2507,
    2508,  2509,  2510,  2513,  2515,  2518,  2519,  2522,  2523,  2524,
    2525,  2528,  2530,  2532,  2534,  2538,  2539,  2542,  2544,  2546,
    2548,  2550,  2554,  2555,  2558,  2559,  2560,  2563,  2564,  2567,
    2568,  2569,  2572,  2573,  2576,  2577,  2578,  2581,  2583,  2587,
    2589,  2593,  2595,  2599,  2603,  2605,  2607,  2609,  2613,  2615,
    2617,  2619,  2623,  2625,  2627,  2629,  2633,  2635,  2637,  2639,
    2643,  2645,  2649,  2650,  2651,  2652,  2653,  2654,  2655,  2658,
    2659,  2660,  2661,  2662,  2663,  2664,  2665,  2666,  2667,  2670,
    2671,  2674,  2676,  2680,  2681,  2682,  2683,  2686,  2687,  2690,
    2692,  2696,  2697,  2698,  2699,  2700,  2701,  2702,  2703,  2704,
    2705,  2706,  2707,  2708,  2709,  2710,  2711,  2712,  2713,  2714,
    2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,  2723,  2724,
    2725,  2726,  2727,  2728,  2729,  2730,  2731,  2732,  2733,  2734,
    2735,  2736,  2737,  2738,  2739,  2740,  2741,  2742,  2743,  2746,
    2747,  2750,  2752,  2756,  2757,  2758,  2759,  2760,  2761,  2762,
    2763,  2764,  2765,  2766,  2767,  2768,  2769,  2772,  2773,  2776,
    2778,  2782,  2783,  2784,  2785,  2786,  2787,  2788,  2789,  2790,
    2791,  2792,  2793,  2794,  2795,  2798,  2799,  2802,  2804,  2808,
    2809,  2810,  2811,  2812,  2813,  2814,  2815,  2816,  2817,  2818,
    2819,  2820,  2821,  2824,  2825,  2828,  2830,  2832,  2834,  2838,
    2839,  2840,  2841,  2844,  2845,  2848,  2850,  2854,  2855,  2856,
    2857,  2858,  2859,  2860,  2861,  2864,  2865,  2868,  2870,  2874,
    2875,  2876,  2877,  2878,  2879,  2880,  2883,  2884,  2887,  2889,
    2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,
    2903,  2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,  2912,
    2913,  2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,  2922,
    2923,  2924,  2925,  2926,  2927,  2930,  2931,  2934,  2936,  2940,
    2942,  2946,  2947,  2950,  2951,  2952,  2953,  2954,  2955,  2956,
    2957,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,
    2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,  2976,
    2977,  2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,  2986,
    2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,  2996,
    2997,  2998,  2999,  3000,  3001,  3004,  3005,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,
    3021,  3022,  3023,  3026,  3027,  3030,  3031,  3032,  3033,  3034,
    3035,  3036,  3037,  3038,  3039,  3040,  3041,  3044,  3045,  3048,
    3049,  3050,  3051,  3052,  3053,  3054,  3055,  3056,  3057,  3058,
    3059,  3060,  3061,  3062,  3063,  3064,  3065,  3066,  3067,  3070,
    3071,  3074,  3075,  3076,  3077,  3078,  3079,  3080,  3081,  3082,
    3083,  3084,  3085,  3086,  3087,  3090,  3093,  3094,  3097,  3099,
    3103,  3104,  3105,  3106,  3109,  3110,  3113,  3114,  3115,  3116,
    3117,  3120,  3124,  3125,  3128,  3129,  3130,  3131,  3132,  3135,
    3137,  3141,  3145,  3146,  3149,  3153,  3153,  3157,  3158,  3161,
    3163,  3167,  3169,  3171,  3173,  3177,  3178,  3181,  3182,  3183,
    3184,  3185,  3186,  3187,  3188,  3189,  3190,  3191,  3192,  3193,
    3194,  3195,  3196,  3199,  3201,  3203,  3205,  3209,  3210,  3213,
    3214,  3217,  3218,  3221,  3225,  3227,  3231,  3233,  3237,  3238,
    3241,  3242,  3243,  3244,  3245,  3248,  3252,  3254,  3256,  3260,
    3264,  3265,  3268,  3270,  3272,  3276,  3278,  3282,  3283,  3286,
    3288,  3290,  3294,  3296,  3300,  3301,  3304,  3305,  3306,  3307,
    3308,  3311,  3313,  3317,  3318,  3321,  3322,  3325,  3326,  3327,
    3330,  3332,  3336,  3337,  3340,  3341,  3344,  3350,  3351,  3357,
    3358,  3359,  3360,  3361,  3362,  3363,  3364,  3365,  3366,  3367,
    3368,  3369,  3370,  3371,  3375,  3376,  3377,  3378,  3379,  3380,
    3381,  3382,  3383,  3384,  3390,  3391,  3392,  3393,  3394,  3395,
    3396,  3397,  3399,  3400,  3401,  3402,  3403,  3404,  3405,  3406,
    3407,  3408,  3409,  3410,  3411,  3412,  3412,  3413,  3414,  3415,
    3416,  3417,  3418,  3419,  3420,  3421,  3423,  3426,  3427,  3428,
    3429,  3431,  3434,  3436,  3439,  3441,  3442,  3443,  3444,  3445,
    3446,  3447,  3448,  3449,  3450,  3451,  3452,  3453,  3454,  3455,
    3456,  3457,  3458,  3459,  3460,  3461,  3462,  3463,  3464,  3465,
    3466,  3467,  3469,  3472,  3474,  3477,  3478,  3479,  3480,  3482,
    3484,  3485,  3486,  3487,  3489,  3492,  3493,  3494,  3495,  3496,
    3498,  3499,  3500,  3502,  3505,  3507,  3510,  3512,  3515,  3516,
    3517,  3519,  3521,  3523,  3526,  3527,  3530,  3533,  3534,  3535,
    3536,  3537,  3538,  3539,  3540,  3541,  3543,  3544,  3545,  3546,
    3547,  3548,  3551,  3552,  3553,  3554,  3555,  3556,  3557,  3558,
    3559,  3560,  3561,  3562,  3563,  3564,  3565,  3566,  3567,  3568,
    3569,  3571,  3573,  3576,  3577,  3578,  3579,  3580,  3581,  3582,
    3583,  3584,  3585,  3586,  3587,  3588,  3589,  3591,  3594,  3595,
    3596,  3597,  3599,  3600,  3601,  3602,  3603,  3604,  3605,  3606,
    3607,  3608,  3609,  3610,  3611,  3612,  3613,  3614,  3615,  3616,
    3617,  3618,  3619,  3620,  3621,  3622,  3623,  3624,  3625,  3626,
    3627,  3628,  3629,  3630,  3631,  3632,  3633,  3634,  3635,  3636,
    3637,  3638,  3639,  3640,  3641,  3642,  3643,  3645,  3647,  3650,
    3652,  3654,  3657,  3658,  3659,  3660,  3661,  3662,  3663,  3664,
    3665,  3666,  3667,  3668,  3669,  3670,  3671,  3672,  3673,  3674,
    3675,  3676,  3677,  3678,  3679,  3680,  3681,  3682,  3683,  3684,
    3685,  3686,  3687,  3688,  3689,  3690,  3691,  3692,  3693,  3694,
    3695,  3696,  3697,  3698,  3699,  3700,  3701,  3702,  3703,  3704,
    3705,  3706,  3707,  3708,  3709,  3710,  3711,  3712,  3713,  3714,
    3715,  3716,  3717,  3718,  3719,  3720,  3721,  3722,  3723,  3724,
    3725,  3726,  3727,  3729,  3732,  3733,  3734,  3735,  3736,  3737,
    3738,  3739,  3741,  3742,  3743,  3744,  3746,  3747,  3749,  3751,
    3753,  3755,  3757,  3759,  3762,  3763,  3764,  3765,  3766,  3768,
    3770,  3773,  3774,  3775,  3776,  3777,  3778,  3779,  3780,  3781,
    3786,  3791,  3797,  3798,  3799,  3800,  3801,  3802,  3803,  3804,
    3805,  3806,  3807,  3808,  3810,  3813,  3814,  3815,  3816,  3817,
    3818,  3819,  3820,  3821,  3822,  3823,  3824,  3825,  3826,  3827,
    3828,  3829,  3830,  3831,  3832,  3833,  3834,  3835,  3836,  3837,
    3838,  3839,  3840,  3843,  3845,  3848,  3849,  3850,  3851,  3852,
    3853,  3855,  3858,  3859,  3861,  3862,  3863,  3865,  3868,  3870,
    3873,  3876,  3879,  3882,  3885,  3888,  3891,  3892,  3893,  3894,
    3895,  3897,  3899,  3901,  3903,  3905,  3907,  3909,  3911,  3913,
    3915,  3917,  3919,  3921,  3923,  3925,  3927,  3928,  3929,  3930,
    3931,  3932,  3933,  3934,  3935,  3936,  3937,  3938,  3939,  3940,
    3941,  3942,  3943,  3944,  3945,  3946,  3947,  3948,  3949,  3950,
    3951,  3952,  3953,  3954,  3955,  3957,  3959,  3962,  3963,  3964,
    3965,  3966,  3967,  3968,  3969,  3971,  3972,  3973,  3974,  3975,
    3976,  3977,  3978,  3979,  3980,  3982,  3983,  3984,  3985,  3986,
    3989,  3991,  3993,  3995,  3997,  3999,  4001,  4004,  4005,  4007,
    4008,  4009,  4010,  4011,  4013,  4015,  4016,  4017,  4018,  4019,
    4020,  4023,  4024,  4025,  4026,  4027,  4028,  4029,  4030,  4031,
    4032,  4033,  4034,  4035,  4039,  4040,  4041,  4042,  4043,  4044,
    4047,  4048,  4049,  4050,  4051,  4052,  4053,  4054,  4055,  4056,
    4057,  4058,  4059,  4060,  4061,  4062,  4063,  4066,  4068,  4070,
    4071,  4072,  4075,  4077,  4080,  4083,  4085,  4089,  4091,  4094,
    4098,  4099,  4107,  4109,  4111,  4116,  4123,  4124,  4127,  4129,
    4131,  4136,  4143,  4144,  4147,  4149,  4151,  4153,  4157,  4159,
    4163,  4165,  4168,  4170,  4173,  4175,  4179,  4182,  4183,  4184,
    4185,  4186,  4187,  4188,  4189,  4190,  4191,  4192,  4193,  4194,
    4195,  4196,  4197,  4198,  4199,  4200,  4201,  4202,  4203,  4204,
    4205,  4206,  4207
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::symbol_kind_type
  parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const short
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,   711,     2,     2,     2,     2,
     707,   708,     2,     2,     2,     2,   713,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   712,   706,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   709,     2,   710,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705
    };
    // Last valid token kind.
    const int code_max = 960;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 25 "DynareBison.yy"
} // Dynare
#line 16231 "DynareBison.cc"

#line 4210 "DynareBison.yy"


void
Dynare::parser::error(const Dynare::parser::location_type &l,
                      const string &m)
{
  driver.error(l, m);
}
